// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `EvictorStorage.ice'

#ifndef FREEZE_API_EXPORTS
#   define FREEZE_API_EXPORTS
#endif
#include <Freeze/EvictorStorage.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

bool
Freeze::Statistics::operator==(const Statistics& __rhs) const
{
    if(this == &__rhs)
    {
        return true;
    }
    if(creationTime != __rhs.creationTime)
    {
        return false;
    }
    if(lastSaveTime != __rhs.lastSaveTime)
    {
        return false;
    }
    if(avgSaveTime != __rhs.avgSaveTime)
    {
        return false;
    }
    return true;
}

bool
Freeze::Statistics::operator<(const Statistics& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(creationTime < __rhs.creationTime)
    {
        return true;
    }
    else if(__rhs.creationTime < creationTime)
    {
        return false;
    }
    if(lastSaveTime < __rhs.lastSaveTime)
    {
        return true;
    }
    else if(__rhs.lastSaveTime < lastSaveTime)
    {
        return false;
    }
    if(avgSaveTime < __rhs.avgSaveTime)
    {
        return true;
    }
    else if(__rhs.avgSaveTime < avgSaveTime)
    {
        return false;
    }
    return false;
}

void
Freeze::Statistics::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(creationTime);
    __os->write(lastSaveTime);
    __os->write(avgSaveTime);
}

void
Freeze::Statistics::__read(::IceInternal::BasicStream* __is)
{
    __is->read(creationTime);
    __is->read(lastSaveTime);
    __is->read(avgSaveTime);
}

bool
Freeze::ObjectRecord::operator==(const ObjectRecord& __rhs) const
{
    if(this == &__rhs)
    {
        return true;
    }
    if(servant != __rhs.servant)
    {
        return false;
    }
    if(stats != __rhs.stats)
    {
        return false;
    }
    return true;
}

bool
Freeze::ObjectRecord::operator<(const ObjectRecord& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(servant < __rhs.servant)
    {
        return true;
    }
    else if(__rhs.servant < servant)
    {
        return false;
    }
    if(stats < __rhs.stats)
    {
        return true;
    }
    else if(__rhs.stats < stats)
    {
        return false;
    }
    return false;
}

void
Freeze::ObjectRecord::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(servant);
    stats.__write(__os);
}

void
Freeze::ObjectRecord::__read(::IceInternal::BasicStream* __is)
{
    __is->read(::Ice::__patch__ObjectPtr, &servant);
    stats.__read(__is);
}
