// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `Exception.ice'

#ifndef FREEZE_API_EXPORTS
#   define FREEZE_API_EXPORTS
#endif
#include <Freeze/Exception.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

Freeze::DatabaseException::DatabaseException(const char* __file, int __line) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    LocalException(__file, __line)
#else
    ::Ice::LocalException(__file, __line)
#endif
{
}

Freeze::DatabaseException::DatabaseException(const char* __file, int __line, const ::std::string& __ice_message) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    LocalException(__file, __line),
#else
    ::Ice::LocalException(__file, __line),
#endif
    message(__ice_message)
{
}

Freeze::DatabaseException::~DatabaseException() throw()
{
}

static const char* __Freeze__DatabaseException_name = "Freeze::DatabaseException";

::std::string
Freeze::DatabaseException::ice_name() const
{
    return __Freeze__DatabaseException_name;
}

::Ice::Exception*
Freeze::DatabaseException::ice_clone() const
{
    return new DatabaseException(*this);
}

void
Freeze::DatabaseException::ice_throw() const
{
    throw *this;
}

Freeze::NotFoundException::NotFoundException(const char* __file, int __line) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    DatabaseException(__file, __line)
#else
    ::Freeze::DatabaseException(__file, __line)
#endif
{
}

Freeze::NotFoundException::NotFoundException(const char* __file, int __line, const ::std::string& __ice_message) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    DatabaseException(__file, __line, __ice_message)
#else
    ::Freeze::DatabaseException(__file, __line, __ice_message)
#endif
{
}

Freeze::NotFoundException::~NotFoundException() throw()
{
}

static const char* __Freeze__NotFoundException_name = "Freeze::NotFoundException";

::std::string
Freeze::NotFoundException::ice_name() const
{
    return __Freeze__NotFoundException_name;
}

::Ice::Exception*
Freeze::NotFoundException::ice_clone() const
{
    return new NotFoundException(*this);
}

void
Freeze::NotFoundException::ice_throw() const
{
    throw *this;
}

Freeze::DeadlockException::DeadlockException(const char* __file, int __line) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    DatabaseException(__file, __line)
#else
    ::Freeze::DatabaseException(__file, __line)
#endif
{
}

Freeze::DeadlockException::DeadlockException(const char* __file, int __line, const ::std::string& __ice_message, const ::Freeze::TransactionPtr& __ice_tx) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    DatabaseException(__file, __line, __ice_message),
#else
    ::Freeze::DatabaseException(__file, __line, __ice_message),
#endif
    tx(__ice_tx)
{
}

Freeze::DeadlockException::~DeadlockException() throw()
{
}

static const char* __Freeze__DeadlockException_name = "Freeze::DeadlockException";

::std::string
Freeze::DeadlockException::ice_name() const
{
    return __Freeze__DeadlockException_name;
}

::Ice::Exception*
Freeze::DeadlockException::ice_clone() const
{
    return new DeadlockException(*this);
}

void
Freeze::DeadlockException::ice_throw() const
{
    throw *this;
}

Freeze::InvalidPositionException::InvalidPositionException(const char* __file, int __line) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    LocalException(__file, __line)
#else
    ::Ice::LocalException(__file, __line)
#endif
{
}

Freeze::InvalidPositionException::~InvalidPositionException() throw()
{
}

static const char* __Freeze__InvalidPositionException_name = "Freeze::InvalidPositionException";

::std::string
Freeze::InvalidPositionException::ice_name() const
{
    return __Freeze__InvalidPositionException_name;
}

::Ice::Exception*
Freeze::InvalidPositionException::ice_clone() const
{
    return new InvalidPositionException(*this);
}

void
Freeze::InvalidPositionException::ice_throw() const
{
    throw *this;
}

Freeze::IndexNotFoundException::IndexNotFoundException(const char* __file, int __line) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    LocalException(__file, __line)
#else
    ::Ice::LocalException(__file, __line)
#endif
{
}

Freeze::IndexNotFoundException::IndexNotFoundException(const char* __file, int __line, const ::std::string& __ice_mapName, const ::std::string& __ice_indexName) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    LocalException(__file, __line),
#else
    ::Ice::LocalException(__file, __line),
#endif
    mapName(__ice_mapName),
    indexName(__ice_indexName)
{
}

Freeze::IndexNotFoundException::~IndexNotFoundException() throw()
{
}

static const char* __Freeze__IndexNotFoundException_name = "Freeze::IndexNotFoundException";

::std::string
Freeze::IndexNotFoundException::ice_name() const
{
    return __Freeze__IndexNotFoundException_name;
}

::Ice::Exception*
Freeze::IndexNotFoundException::ice_clone() const
{
    return new IndexNotFoundException(*this);
}

void
Freeze::IndexNotFoundException::ice_throw() const
{
    throw *this;
}
