// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `PingObject.ice'

#ifndef FREEZE_API_EXPORTS
#   define FREEZE_API_EXPORTS
#endif
#include <Freeze/PingObject.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

ICE_DECLSPEC_EXPORT ::Ice::Object* IceInternal::upCast(::Freeze::PingObject* p) { return p; }
ICE_DECLSPEC_EXPORT ::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Freeze::PingObject* p) { return p; }

void
Freeze::__read(::IceInternal::BasicStream* __is, ::Freeze::PingObjectPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Freeze::PingObject;
        v->__copyFrom(proxy);
    }
}
#ifdef __SUNPRO_CC
class ICE_DECLSPEC_EXPORT IceProxy::Freeze::PingObject;
#endif

const ::std::string&
IceProxy::Freeze::PingObject::ice_staticId()
{
    return ::Freeze::PingObject::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Freeze::PingObject::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Freeze::PingObject);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Freeze::PingObject::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Freeze::PingObject);
}

::IceProxy::Ice::Object*
IceProxy::Freeze::PingObject::__newInstance() const
{
    return new PingObject;
}

::Ice::ObjectPtr
Freeze::PingObject::ice_clone() const
{
    ::Freeze::PingObjectPtr __p = new ::Freeze::PingObject(*this);
    return __p;
}

static const ::std::string __Freeze__PingObject_ids[2] =
{
    "::Freeze::PingObject",
    "::Ice::Object"
};

bool
Freeze::PingObject::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Freeze__PingObject_ids, __Freeze__PingObject_ids + 2, _s);
}

::std::vector< ::std::string>
Freeze::PingObject::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Freeze__PingObject_ids[0], &__Freeze__PingObject_ids[2]);
}

const ::std::string&
Freeze::PingObject::ice_id(const ::Ice::Current&) const
{
    return __Freeze__PingObject_ids[0];
}

const ::std::string&
Freeze::PingObject::ice_staticId()
{
    return __Freeze__PingObject_ids[0];
}

void
Freeze::PingObject::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Freeze::PingObject::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Freeze::PingObject::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Freeze::PingObject was not generated with stream support";
    throw ex;
}

void
Freeze::PingObject::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Freeze::PingObject was not generated with stream support";
    throw ex;
}

class __F__Freeze__PingObject : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::Freeze::PingObject::ice_staticId());
        return new ::Freeze::PingObject;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__Freeze__PingObject_Ptr = new __F__Freeze__PingObject;

const ::Ice::ObjectFactoryPtr&
Freeze::PingObject::ice_factory()
{
    return __F__Freeze__PingObject_Ptr;
}

class __F__Freeze__PingObject__Init
{
public:

    __F__Freeze__PingObject__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::Freeze::PingObject::ice_staticId(), ::Freeze::PingObject::ice_factory());
    }

    ~__F__Freeze__PingObject__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::Freeze::PingObject::ice_staticId());
    }
};

static __F__Freeze__PingObject__Init __F__Freeze__PingObject__i;

#ifdef __APPLE__
extern "C" { void __F__Freeze__PingObject__initializer() {} }
#endif

void ICE_DECLSPEC_EXPORT 
Freeze::__patch__PingObjectPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Freeze::PingObjectPtr* p = static_cast< ::Freeze::PingObjectPtr*>(__addr);
    assert(p);
    *p = ::Freeze::PingObjectPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Freeze::PingObject::ice_staticId(), v->ice_id());
    }
}

bool
Freeze::operator==(const ::Freeze::PingObject& l, const ::Freeze::PingObject& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Freeze::operator<(const ::Freeze::PingObject& l, const ::Freeze::PingObject& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}
