// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `PermissionsVerifier.ice'

#ifndef GLACIER2_API_EXPORTS
#   define GLACIER2_API_EXPORTS
#endif
#include <Glacier2/PermissionsVerifier.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __Glacier2__PermissionsVerifier__checkPermissions_name = "checkPermissions";

static const ::std::string __Glacier2__SSLPermissionsVerifier__authorize_name = "authorize";

ICE_DECLSPEC_EXPORT ::Ice::Object* IceInternal::upCast(::Glacier2::PermissionsVerifier* p) { return p; }
ICE_DECLSPEC_EXPORT ::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Glacier2::PermissionsVerifier* p) { return p; }

ICE_DECLSPEC_EXPORT ::Ice::Object* IceInternal::upCast(::Glacier2::SSLPermissionsVerifier* p) { return p; }
ICE_DECLSPEC_EXPORT ::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Glacier2::SSLPermissionsVerifier* p) { return p; }

void
Glacier2::__read(::IceInternal::BasicStream* __is, ::Glacier2::PermissionsVerifierPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Glacier2::PermissionsVerifier;
        v->__copyFrom(proxy);
    }
}

void
Glacier2::__read(::IceInternal::BasicStream* __is, ::Glacier2::SSLPermissionsVerifierPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Glacier2::SSLPermissionsVerifier;
        v->__copyFrom(proxy);
    }
}

bool
Glacier2::AMI_PermissionsVerifier_checkPermissions::__invoke(const ::Glacier2::PermissionsVerifierPrx& __prx, const ::std::string& userId, const ::std::string& password, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prx->__checkTwowayOnly(__Glacier2__PermissionsVerifier__checkPermissions_name);
        __prepare(__prx, __Glacier2__PermissionsVerifier__checkPermissions_name, ::Ice::Nonmutating, __ctx);
        __os->write(userId);
        __os->write(password);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
Glacier2::AMI_PermissionsVerifier_checkPermissions::__response(bool __ok)
{
    ::std::string reason;
    bool __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->startReadEncaps();
        __is->read(reason);
        __is->read(__ret);
        __is->endReadEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response(__ret, reason);
    __releaseCallback();
}

bool
Glacier2::AMI_SSLPermissionsVerifier_authorize::__invoke(const ::Glacier2::SSLPermissionsVerifierPrx& __prx, const ::Glacier2::SSLInfo& info, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prx->__checkTwowayOnly(__Glacier2__SSLPermissionsVerifier__authorize_name);
        __prepare(__prx, __Glacier2__SSLPermissionsVerifier__authorize_name, ::Ice::Nonmutating, __ctx);
        info.__write(__os);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
Glacier2::AMI_SSLPermissionsVerifier_authorize::__response(bool __ok)
{
    ::std::string reason;
    bool __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->startReadEncaps();
        __is->read(reason);
        __is->read(__ret);
        __is->endReadEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response(__ret, reason);
    __releaseCallback();
}
#ifdef __SUNPRO_CC
class ICE_DECLSPEC_EXPORT IceProxy::Glacier2::PermissionsVerifier;
#endif

bool
IceProxy::Glacier2::PermissionsVerifier::checkPermissions(const ::std::string& userId, const ::std::string& password, ::std::string& reason, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Glacier2__PermissionsVerifier__checkPermissions_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Glacier2::PermissionsVerifier* __del = dynamic_cast< ::IceDelegate::Glacier2::PermissionsVerifier*>(__delBase.get());
            return __del->checkPermissions(userId, password, reason, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::Glacier2::PermissionsVerifier::checkPermissions_async(const ::Glacier2::AMI_PermissionsVerifier_checkPermissionsPtr& __cb, const ::std::string& userId, const ::std::string& password)
{
    return __cb->__invoke(this, userId, password, 0);
}

bool
IceProxy::Glacier2::PermissionsVerifier::checkPermissions_async(const ::Glacier2::AMI_PermissionsVerifier_checkPermissionsPtr& __cb, const ::std::string& userId, const ::std::string& password, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, userId, password, &__ctx);
}

const ::std::string&
IceProxy::Glacier2::PermissionsVerifier::ice_staticId()
{
    return ::Glacier2::PermissionsVerifier::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Glacier2::PermissionsVerifier::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Glacier2::PermissionsVerifier);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Glacier2::PermissionsVerifier::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Glacier2::PermissionsVerifier);
}

::IceProxy::Ice::Object*
IceProxy::Glacier2::PermissionsVerifier::__newInstance() const
{
    return new PermissionsVerifier;
}
#ifdef __SUNPRO_CC
class ICE_DECLSPEC_EXPORT IceProxy::Glacier2::SSLPermissionsVerifier;
#endif

bool
IceProxy::Glacier2::SSLPermissionsVerifier::authorize(const ::Glacier2::SSLInfo& info, ::std::string& reason, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Glacier2__SSLPermissionsVerifier__authorize_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Glacier2::SSLPermissionsVerifier* __del = dynamic_cast< ::IceDelegate::Glacier2::SSLPermissionsVerifier*>(__delBase.get());
            return __del->authorize(info, reason, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::Glacier2::SSLPermissionsVerifier::authorize_async(const ::Glacier2::AMI_SSLPermissionsVerifier_authorizePtr& __cb, const ::Glacier2::SSLInfo& info)
{
    return __cb->__invoke(this, info, 0);
}

bool
IceProxy::Glacier2::SSLPermissionsVerifier::authorize_async(const ::Glacier2::AMI_SSLPermissionsVerifier_authorizePtr& __cb, const ::Glacier2::SSLInfo& info, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, info, &__ctx);
}

const ::std::string&
IceProxy::Glacier2::SSLPermissionsVerifier::ice_staticId()
{
    return ::Glacier2::SSLPermissionsVerifier::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Glacier2::SSLPermissionsVerifier::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Glacier2::SSLPermissionsVerifier);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Glacier2::SSLPermissionsVerifier::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Glacier2::SSLPermissionsVerifier);
}

::IceProxy::Ice::Object*
IceProxy::Glacier2::SSLPermissionsVerifier::__newInstance() const
{
    return new SSLPermissionsVerifier;
}

bool
IceDelegateM::Glacier2::PermissionsVerifier::checkPermissions(const ::std::string& userId, const ::std::string& password, ::std::string& reason, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Glacier2__PermissionsVerifier__checkPermissions_name, ::Ice::Nonmutating, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(userId);
        __os->write(password);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    bool __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(reason);
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

bool
IceDelegateM::Glacier2::SSLPermissionsVerifier::authorize(const ::Glacier2::SSLInfo& info, ::std::string& reason, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Glacier2__SSLPermissionsVerifier__authorize_name, ::Ice::Nonmutating, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        info.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    bool __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(reason);
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

bool
IceDelegateD::Glacier2::PermissionsVerifier::checkPermissions(const ::std::string& userId, const ::std::string& password, ::std::string& reason, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(bool& __result, const ::std::string& userId, const ::std::string& password, ::std::string& reason, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_userId(userId),
            _m_password(password),
            _m_reason(reason)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Glacier2::PermissionsVerifier* servant = dynamic_cast< ::Glacier2::PermissionsVerifier*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->checkPermissions(_m_userId, _m_password, _m_reason, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        bool& _result;
        const ::std::string& _m_userId;
        const ::std::string& _m_password;
        ::std::string& _m_reason;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__PermissionsVerifier__checkPermissions_name, ::Ice::Nonmutating, __context);
    bool __result;
    try
    {
        _DirectI __direct(__result, userId, password, reason, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

bool
IceDelegateD::Glacier2::SSLPermissionsVerifier::authorize(const ::Glacier2::SSLInfo& info, ::std::string& reason, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(bool& __result, const ::Glacier2::SSLInfo& info, ::std::string& reason, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_info(info),
            _m_reason(reason)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Glacier2::SSLPermissionsVerifier* servant = dynamic_cast< ::Glacier2::SSLPermissionsVerifier*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->authorize(_m_info, _m_reason, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        bool& _result;
        const ::Glacier2::SSLInfo& _m_info;
        ::std::string& _m_reason;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__SSLPermissionsVerifier__authorize_name, ::Ice::Nonmutating, __context);
    bool __result;
    try
    {
        _DirectI __direct(__result, info, reason, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Ice::ObjectPtr
Glacier2::PermissionsVerifier::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Glacier2__PermissionsVerifier_ids[2] =
{
    "::Glacier2::PermissionsVerifier",
    "::Ice::Object"
};

bool
Glacier2::PermissionsVerifier::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Glacier2__PermissionsVerifier_ids, __Glacier2__PermissionsVerifier_ids + 2, _s);
}

::std::vector< ::std::string>
Glacier2::PermissionsVerifier::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Glacier2__PermissionsVerifier_ids[0], &__Glacier2__PermissionsVerifier_ids[2]);
}

const ::std::string&
Glacier2::PermissionsVerifier::ice_id(const ::Ice::Current&) const
{
    return __Glacier2__PermissionsVerifier_ids[0];
}

const ::std::string&
Glacier2::PermissionsVerifier::ice_staticId()
{
    return __Glacier2__PermissionsVerifier_ids[0];
}

::Ice::DispatchStatus
Glacier2::PermissionsVerifier::___checkPermissions(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string userId;
    ::std::string password;
    __is->read(userId);
    __is->read(password);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string reason;
    bool __ret = checkPermissions(userId, password, reason, __current);
    __os->write(reason);
    __os->write(__ret);
    return ::Ice::DispatchOK;
}

static ::std::string __Glacier2__PermissionsVerifier_all[] =
{
    "checkPermissions",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::Ice::DispatchStatus
Glacier2::PermissionsVerifier::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Glacier2__PermissionsVerifier_all, __Glacier2__PermissionsVerifier_all + 5, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __Glacier2__PermissionsVerifier_all)
    {
        case 0:
        {
            return ___checkPermissions(in, current);
        }
        case 1:
        {
            return ___ice_id(in, current);
        }
        case 2:
        {
            return ___ice_ids(in, current);
        }
        case 3:
        {
            return ___ice_isA(in, current);
        }
        case 4:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
Glacier2::PermissionsVerifier::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Glacier2::PermissionsVerifier::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Glacier2::PermissionsVerifier::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::PermissionsVerifier was not generated with stream support";
    throw ex;
}

void
Glacier2::PermissionsVerifier::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::PermissionsVerifier was not generated with stream support";
    throw ex;
}

void ICE_DECLSPEC_EXPORT 
Glacier2::__patch__PermissionsVerifierPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Glacier2::PermissionsVerifierPtr* p = static_cast< ::Glacier2::PermissionsVerifierPtr*>(__addr);
    assert(p);
    *p = ::Glacier2::PermissionsVerifierPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Glacier2::PermissionsVerifier::ice_staticId(), v->ice_id());
    }
}

bool
Glacier2::operator==(const ::Glacier2::PermissionsVerifier& l, const ::Glacier2::PermissionsVerifier& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<(const ::Glacier2::PermissionsVerifier& l, const ::Glacier2::PermissionsVerifier& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
Glacier2::SSLPermissionsVerifier::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Glacier2__SSLPermissionsVerifier_ids[2] =
{
    "::Glacier2::SSLPermissionsVerifier",
    "::Ice::Object"
};

bool
Glacier2::SSLPermissionsVerifier::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Glacier2__SSLPermissionsVerifier_ids, __Glacier2__SSLPermissionsVerifier_ids + 2, _s);
}

::std::vector< ::std::string>
Glacier2::SSLPermissionsVerifier::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Glacier2__SSLPermissionsVerifier_ids[0], &__Glacier2__SSLPermissionsVerifier_ids[2]);
}

const ::std::string&
Glacier2::SSLPermissionsVerifier::ice_id(const ::Ice::Current&) const
{
    return __Glacier2__SSLPermissionsVerifier_ids[0];
}

const ::std::string&
Glacier2::SSLPermissionsVerifier::ice_staticId()
{
    return __Glacier2__SSLPermissionsVerifier_ids[0];
}

::Ice::DispatchStatus
Glacier2::SSLPermissionsVerifier::___authorize(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Glacier2::SSLInfo info;
    info.__read(__is);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string reason;
    bool __ret = authorize(info, reason, __current);
    __os->write(reason);
    __os->write(__ret);
    return ::Ice::DispatchOK;
}

static ::std::string __Glacier2__SSLPermissionsVerifier_all[] =
{
    "authorize",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::Ice::DispatchStatus
Glacier2::SSLPermissionsVerifier::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Glacier2__SSLPermissionsVerifier_all, __Glacier2__SSLPermissionsVerifier_all + 5, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __Glacier2__SSLPermissionsVerifier_all)
    {
        case 0:
        {
            return ___authorize(in, current);
        }
        case 1:
        {
            return ___ice_id(in, current);
        }
        case 2:
        {
            return ___ice_ids(in, current);
        }
        case 3:
        {
            return ___ice_isA(in, current);
        }
        case 4:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
Glacier2::SSLPermissionsVerifier::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Glacier2::SSLPermissionsVerifier::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Glacier2::SSLPermissionsVerifier::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::SSLPermissionsVerifier was not generated with stream support";
    throw ex;
}

void
Glacier2::SSLPermissionsVerifier::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::SSLPermissionsVerifier was not generated with stream support";
    throw ex;
}

void ICE_DECLSPEC_EXPORT 
Glacier2::__patch__SSLPermissionsVerifierPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Glacier2::SSLPermissionsVerifierPtr* p = static_cast< ::Glacier2::SSLPermissionsVerifierPtr*>(__addr);
    assert(p);
    *p = ::Glacier2::SSLPermissionsVerifierPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Glacier2::SSLPermissionsVerifier::ice_staticId(), v->ice_id());
    }
}

bool
Glacier2::operator==(const ::Glacier2::SSLPermissionsVerifier& l, const ::Glacier2::SSLPermissionsVerifier& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<(const ::Glacier2::SSLPermissionsVerifier& l, const ::Glacier2::SSLPermissionsVerifier& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}
