// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `Router.ice'

#ifndef GLACIER2_API_EXPORTS
#   define GLACIER2_API_EXPORTS
#endif
#include <Glacier2/Router.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __Glacier2__Router__getCategoryForClient_name = "getCategoryForClient";

static const ::std::string __Glacier2__Router__createSession_name = "createSession";

static const ::std::string __Glacier2__Router__createSessionFromSecureConnection_name = "createSessionFromSecureConnection";

static const ::std::string __Glacier2__Router__destroySession_name = "destroySession";

static const ::std::string __Glacier2__Router__getSessionTimeout_name = "getSessionTimeout";

static const ::std::string __Glacier2__Admin__shutdown_name = "shutdown";

ICE_DECLSPEC_EXPORT ::Ice::Object* IceInternal::upCast(::Glacier2::Router* p) { return p; }
ICE_DECLSPEC_EXPORT ::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Glacier2::Router* p) { return p; }

ICE_DECLSPEC_EXPORT ::Ice::Object* IceInternal::upCast(::Glacier2::Admin* p) { return p; }
ICE_DECLSPEC_EXPORT ::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Glacier2::Admin* p) { return p; }

void
Glacier2::__read(::IceInternal::BasicStream* __is, ::Glacier2::RouterPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Glacier2::Router;
        v->__copyFrom(proxy);
    }
}

void
Glacier2::__read(::IceInternal::BasicStream* __is, ::Glacier2::AdminPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Glacier2::Admin;
        v->__copyFrom(proxy);
    }
}

Glacier2::PermissionDeniedException::PermissionDeniedException(const ::std::string& __ice_reason) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    reason(__ice_reason)
{
}

Glacier2::PermissionDeniedException::~PermissionDeniedException() throw()
{
}

static const char* __Glacier2__PermissionDeniedException_name = "Glacier2::PermissionDeniedException";

::std::string
Glacier2::PermissionDeniedException::ice_name() const
{
    return __Glacier2__PermissionDeniedException_name;
}

::Ice::Exception*
Glacier2::PermissionDeniedException::ice_clone() const
{
    return new PermissionDeniedException(*this);
}

void
Glacier2::PermissionDeniedException::ice_throw() const
{
    throw *this;
}

void
Glacier2::PermissionDeniedException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::Glacier2::PermissionDeniedException"), false);
    __os->startWriteSlice();
    __os->write(reason);
    __os->endWriteSlice();
}

void
Glacier2::PermissionDeniedException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(reason);
    __is->endReadSlice();
}

void
Glacier2::PermissionDeniedException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Glacier2::PermissionDeniedException was not generated with stream support";
    throw ex;
}

void
Glacier2::PermissionDeniedException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Glacier2::PermissionDeniedException was not generated with stream support";
    throw ex;
}

struct __F__Glacier2__PermissionDeniedException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::Glacier2::PermissionDeniedException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__Glacier2__PermissionDeniedException__Ptr = new __F__Glacier2__PermissionDeniedException;

const ::IceInternal::UserExceptionFactoryPtr&
Glacier2::PermissionDeniedException::ice_factory()
{
    return __F__Glacier2__PermissionDeniedException__Ptr;
}

class __F__Glacier2__PermissionDeniedException__Init
{
public:

    __F__Glacier2__PermissionDeniedException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::Glacier2::PermissionDeniedException", ::Glacier2::PermissionDeniedException::ice_factory());
    }

    ~__F__Glacier2__PermissionDeniedException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::Glacier2::PermissionDeniedException");
    }
};

static __F__Glacier2__PermissionDeniedException__Init __F__Glacier2__PermissionDeniedException__i;

#ifdef __APPLE__
extern "C" { void __F__Glacier2__PermissionDeniedException__initializer() {} }
#endif

Glacier2::SessionNotExistException::~SessionNotExistException() throw()
{
}

static const char* __Glacier2__SessionNotExistException_name = "Glacier2::SessionNotExistException";

::std::string
Glacier2::SessionNotExistException::ice_name() const
{
    return __Glacier2__SessionNotExistException_name;
}

::Ice::Exception*
Glacier2::SessionNotExistException::ice_clone() const
{
    return new SessionNotExistException(*this);
}

void
Glacier2::SessionNotExistException::ice_throw() const
{
    throw *this;
}

void
Glacier2::SessionNotExistException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::Glacier2::SessionNotExistException"), false);
    __os->startWriteSlice();
    __os->endWriteSlice();
}

void
Glacier2::SessionNotExistException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->endReadSlice();
}

void
Glacier2::SessionNotExistException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Glacier2::SessionNotExistException was not generated with stream support";
    throw ex;
}

void
Glacier2::SessionNotExistException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Glacier2::SessionNotExistException was not generated with stream support";
    throw ex;
}

struct __F__Glacier2__SessionNotExistException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::Glacier2::SessionNotExistException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__Glacier2__SessionNotExistException__Ptr = new __F__Glacier2__SessionNotExistException;

const ::IceInternal::UserExceptionFactoryPtr&
Glacier2::SessionNotExistException::ice_factory()
{
    return __F__Glacier2__SessionNotExistException__Ptr;
}

class __F__Glacier2__SessionNotExistException__Init
{
public:

    __F__Glacier2__SessionNotExistException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::Glacier2::SessionNotExistException", ::Glacier2::SessionNotExistException::ice_factory());
    }

    ~__F__Glacier2__SessionNotExistException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::Glacier2::SessionNotExistException");
    }
};

static __F__Glacier2__SessionNotExistException__Init __F__Glacier2__SessionNotExistException__i;

#ifdef __APPLE__
extern "C" { void __F__Glacier2__SessionNotExistException__initializer() {} }
#endif

bool
Glacier2::AMI_Router_destroySession::__invoke(const ::Glacier2::RouterPrx& __prx, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prx->__checkTwowayOnly(__Glacier2__Router__destroySession_name);
        __prepare(__prx, __Glacier2__Router__destroySession_name, ::Ice::Normal, __ctx);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
Glacier2::AMI_Router_destroySession::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Glacier2::SessionNotExistException& __ex)
            {
                __exception(__ex);
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}

IceAsync::Glacier2::AMD_Router_createSession::AMD_Router_createSession(::IceInternal::Incoming& in) :
    ::IceInternal::IncomingAsync(in)
{
}

void
IceAsync::Glacier2::AMD_Router_createSession::ice_response(const ::Glacier2::SessionPrx& __ret)
{
    if(__validateResponse(true))
    {
        try
        {
            ::IceInternal::BasicStream* __os = this->__os();
            __os->write(::Ice::ObjectPrx(::IceInternal::upCast(__ret.get())));
        }
        catch(const ::Ice::Exception& __ex)
        {
            __exception(__ex);
            return;
        }
        __response(true);
    }
}

void
IceAsync::Glacier2::AMD_Router_createSession::ice_exception(const ::std::exception& ex)
{
    if(const ::Glacier2::CannotCreateSessionException* __ex = dynamic_cast<const ::Glacier2::CannotCreateSessionException*>(&ex))
    {
        if(__validateResponse(false))
        {
            __os()->write(*__ex);
            __response(false);
        }
    }
    else if(const ::Glacier2::PermissionDeniedException* __ex = dynamic_cast<const ::Glacier2::PermissionDeniedException*>(&ex))
    {
        if(__validateResponse(false))
        {
            __os()->write(*__ex);
            __response(false);
        }
    }
    else
    {
        if(__validateException(ex))
        {
            __exception(ex);
        }
    }
}

void
IceAsync::Glacier2::AMD_Router_createSession::ice_exception()
{
    if(__validateException())
    {
        __exception();
    }
}

IceAsync::Glacier2::AMD_Router_createSessionFromSecureConnection::AMD_Router_createSessionFromSecureConnection(::IceInternal::Incoming& in) :
    ::IceInternal::IncomingAsync(in)
{
}

void
IceAsync::Glacier2::AMD_Router_createSessionFromSecureConnection::ice_response(const ::Glacier2::SessionPrx& __ret)
{
    if(__validateResponse(true))
    {
        try
        {
            ::IceInternal::BasicStream* __os = this->__os();
            __os->write(::Ice::ObjectPrx(::IceInternal::upCast(__ret.get())));
        }
        catch(const ::Ice::Exception& __ex)
        {
            __exception(__ex);
            return;
        }
        __response(true);
    }
}

void
IceAsync::Glacier2::AMD_Router_createSessionFromSecureConnection::ice_exception(const ::std::exception& ex)
{
    if(const ::Glacier2::CannotCreateSessionException* __ex = dynamic_cast<const ::Glacier2::CannotCreateSessionException*>(&ex))
    {
        if(__validateResponse(false))
        {
            __os()->write(*__ex);
            __response(false);
        }
    }
    else if(const ::Glacier2::PermissionDeniedException* __ex = dynamic_cast<const ::Glacier2::PermissionDeniedException*>(&ex))
    {
        if(__validateResponse(false))
        {
            __os()->write(*__ex);
            __response(false);
        }
    }
    else
    {
        if(__validateException(ex))
        {
            __exception(ex);
        }
    }
}

void
IceAsync::Glacier2::AMD_Router_createSessionFromSecureConnection::ice_exception()
{
    if(__validateException())
    {
        __exception();
    }
}
#ifdef __SUNPRO_CC
class ICE_DECLSPEC_EXPORT IceProxy::Glacier2::Router;
#endif

::std::string
IceProxy::Glacier2::Router::getCategoryForClient(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Glacier2__Router__getCategoryForClient_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Glacier2::Router* __del = dynamic_cast< ::IceDelegate::Glacier2::Router*>(__delBase.get());
            return __del->getCategoryForClient(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::Glacier2::SessionPrx
IceProxy::Glacier2::Router::createSession(const ::std::string& userId, const ::std::string& password, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Glacier2__Router__createSession_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Glacier2::Router* __del = dynamic_cast< ::IceDelegate::Glacier2::Router*>(__delBase.get());
            return __del->createSession(userId, password, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::Glacier2::SessionPrx
IceProxy::Glacier2::Router::createSessionFromSecureConnection(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Glacier2__Router__createSessionFromSecureConnection_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Glacier2::Router* __del = dynamic_cast< ::IceDelegate::Glacier2::Router*>(__delBase.get());
            return __del->createSessionFromSecureConnection(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::Glacier2::Router::destroySession(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Glacier2__Router__destroySession_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Glacier2::Router* __del = dynamic_cast< ::IceDelegate::Glacier2::Router*>(__delBase.get());
            __del->destroySession(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::Glacier2::Router::destroySession_async(const ::Glacier2::AMI_Router_destroySessionPtr& __cb)
{
    return __cb->__invoke(this, 0);
}

bool
IceProxy::Glacier2::Router::destroySession_async(const ::Glacier2::AMI_Router_destroySessionPtr& __cb, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, &__ctx);
}

::Ice::Long
IceProxy::Glacier2::Router::getSessionTimeout(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Glacier2__Router__getSessionTimeout_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Glacier2::Router* __del = dynamic_cast< ::IceDelegate::Glacier2::Router*>(__delBase.get());
            return __del->getSessionTimeout(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::Glacier2::Router::ice_staticId()
{
    return ::Glacier2::Router::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Glacier2::Router::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Glacier2::Router);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Glacier2::Router::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Glacier2::Router);
}

::IceProxy::Ice::Object*
IceProxy::Glacier2::Router::__newInstance() const
{
    return new Router;
}
#ifdef __SUNPRO_CC
class ICE_DECLSPEC_EXPORT IceProxy::Glacier2::Admin;
#endif

void
IceProxy::Glacier2::Admin::shutdown(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::Glacier2::Admin* __del = dynamic_cast< ::IceDelegate::Glacier2::Admin*>(__delBase.get());
            __del->shutdown(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::Glacier2::Admin::ice_staticId()
{
    return ::Glacier2::Admin::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Glacier2::Admin::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Glacier2::Admin);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Glacier2::Admin::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Glacier2::Admin);
}

::IceProxy::Ice::Object*
IceProxy::Glacier2::Admin::__newInstance() const
{
    return new Admin;
}

::std::string
IceDelegateM::Glacier2::Router::getCategoryForClient(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Glacier2__Router__getCategoryForClient_name, ::Ice::Nonmutating, __context);
    bool __ok = __og.invoke();
    ::std::string __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Glacier2::SessionPrx
IceDelegateM::Glacier2::Router::createSession(const ::std::string& userId, const ::std::string& password, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Glacier2__Router__createSession_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(userId);
        __os->write(password);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    ::Glacier2::SessionPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Glacier2::CannotCreateSessionException&)
            {
                throw;
            }
            catch(const ::Glacier2::PermissionDeniedException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::Glacier2::__read(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Glacier2::SessionPrx
IceDelegateM::Glacier2::Router::createSessionFromSecureConnection(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Glacier2__Router__createSessionFromSecureConnection_name, ::Ice::Normal, __context);
    bool __ok = __og.invoke();
    ::Glacier2::SessionPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Glacier2::CannotCreateSessionException&)
            {
                throw;
            }
            catch(const ::Glacier2::PermissionDeniedException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::Glacier2::__read(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::Glacier2::Router::destroySession(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Glacier2__Router__destroySession_name, ::Ice::Normal, __context);
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Glacier2::SessionNotExistException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        __og.is()->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::Long
IceDelegateM::Glacier2::Router::getSessionTimeout(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Glacier2__Router__getSessionTimeout_name, ::Ice::Nonmutating, __context);
    bool __ok = __og.invoke();
    ::Ice::Long __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::Glacier2::Admin::shutdown(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Glacier2__Admin__shutdown_name, ::Ice::Normal, __context);
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

::std::string
IceDelegateD::Glacier2::Router::getCategoryForClient(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::std::string& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Glacier2::Router* servant = dynamic_cast< ::Glacier2::Router*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->getCategoryForClient(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::std::string& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__Router__getCategoryForClient_name, ::Ice::Nonmutating, __context);
    ::std::string __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Glacier2::SessionPrx
IceDelegateD::Glacier2::Router::createSession(const ::std::string&, const ::std::string&, const ::Ice::Context*)
{
    throw ::Ice::CollocationOptimizationException(__FILE__, __LINE__);
    return ::Glacier2::SessionPrx(); // to avoid a warning with some compilers;
}

::Glacier2::SessionPrx
IceDelegateD::Glacier2::Router::createSessionFromSecureConnection(const ::Ice::Context*)
{
    throw ::Ice::CollocationOptimizationException(__FILE__, __LINE__);
    return ::Glacier2::SessionPrx(); // to avoid a warning with some compilers;
}

void
IceDelegateD::Glacier2::Router::destroySession(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Glacier2::Router* servant = dynamic_cast< ::Glacier2::Router*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                servant->destroySession(_current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__Router__destroySession_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(__current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Glacier2::SessionNotExistException&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

::Ice::Long
IceDelegateD::Glacier2::Router::getSessionTimeout(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Ice::Long& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Glacier2::Router* servant = dynamic_cast< ::Glacier2::Router*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->getSessionTimeout(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::Ice::Long& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__Router__getSessionTimeout_name, ::Ice::Nonmutating, __context);
    ::Ice::Long __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

void
IceDelegateD::Glacier2::Admin::shutdown(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Glacier2::Admin* servant = dynamic_cast< ::Glacier2::Admin*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->shutdown(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__Admin__shutdown_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(__current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

::Ice::ObjectPtr
Glacier2::Router::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Glacier2__Router_ids[3] =
{
    "::Glacier2::Router",
    "::Ice::Object",
    "::Ice::Router"
};

bool
Glacier2::Router::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Glacier2__Router_ids, __Glacier2__Router_ids + 3, _s);
}

::std::vector< ::std::string>
Glacier2::Router::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Glacier2__Router_ids[0], &__Glacier2__Router_ids[3]);
}

const ::std::string&
Glacier2::Router::ice_id(const ::Ice::Current&) const
{
    return __Glacier2__Router_ids[0];
}

const ::std::string&
Glacier2::Router::ice_staticId()
{
    return __Glacier2__Router_ids[0];
}

::Ice::DispatchStatus
Glacier2::Router::___getCategoryForClient(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string __ret = getCategoryForClient(__current);
    __os->write(__ret);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Glacier2::Router::___createSession(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string userId;
    ::std::string password;
    __is->read(userId);
    __is->read(password);
    __is->endReadEncaps();
    ::Glacier2::AMD_Router_createSessionPtr __cb = new IceAsync::Glacier2::AMD_Router_createSession(__inS);
    try
    {
        createSession_async(__cb, userId, password, __current);
    }
    catch(const ::std::exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(...)
    {
        __cb->ice_exception();
    }
    return ::Ice::DispatchAsync;
}

::Ice::DispatchStatus
Glacier2::Router::___createSessionFromSecureConnection(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::Glacier2::AMD_Router_createSessionFromSecureConnectionPtr __cb = new IceAsync::Glacier2::AMD_Router_createSessionFromSecureConnection(__inS);
    try
    {
        createSessionFromSecureConnection_async(__cb, __current);
    }
    catch(const ::std::exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(...)
    {
        __cb->ice_exception();
    }
    return ::Ice::DispatchAsync;
}

::Ice::DispatchStatus
Glacier2::Router::___destroySession(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        destroySession(__current);
    }
    catch(const ::Glacier2::SessionNotExistException& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Glacier2::Router::___getSessionTimeout(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::Long __ret = getSessionTimeout(__current);
    __os->write(__ret);
    return ::Ice::DispatchOK;
}

static ::std::string __Glacier2__Router_all[] =
{
    "addProxies",
    "addProxy",
    "createSession",
    "createSessionFromSecureConnection",
    "destroySession",
    "getCategoryForClient",
    "getClientProxy",
    "getServerProxy",
    "getSessionTimeout",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::Ice::DispatchStatus
Glacier2::Router::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Glacier2__Router_all, __Glacier2__Router_all + 13, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __Glacier2__Router_all)
    {
        case 0:
        {
            return ___addProxies(in, current);
        }
        case 1:
        {
            return ___addProxy(in, current);
        }
        case 2:
        {
            return ___createSession(in, current);
        }
        case 3:
        {
            return ___createSessionFromSecureConnection(in, current);
        }
        case 4:
        {
            return ___destroySession(in, current);
        }
        case 5:
        {
            return ___getCategoryForClient(in, current);
        }
        case 6:
        {
            return ___getClientProxy(in, current);
        }
        case 7:
        {
            return ___getServerProxy(in, current);
        }
        case 8:
        {
            return ___getSessionTimeout(in, current);
        }
        case 9:
        {
            return ___ice_id(in, current);
        }
        case 10:
        {
            return ___ice_ids(in, current);
        }
        case 11:
        {
            return ___ice_isA(in, current);
        }
        case 12:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
Glacier2::Router::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Glacier2::Router::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Glacier2::Router::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::Router was not generated with stream support";
    throw ex;
}

void
Glacier2::Router::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::Router was not generated with stream support";
    throw ex;
}

void ICE_DECLSPEC_EXPORT 
Glacier2::__patch__RouterPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Glacier2::RouterPtr* p = static_cast< ::Glacier2::RouterPtr*>(__addr);
    assert(p);
    *p = ::Glacier2::RouterPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Glacier2::Router::ice_staticId(), v->ice_id());
    }
}

bool
Glacier2::operator==(const ::Glacier2::Router& l, const ::Glacier2::Router& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<(const ::Glacier2::Router& l, const ::Glacier2::Router& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
Glacier2::Admin::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Glacier2__Admin_ids[2] =
{
    "::Glacier2::Admin",
    "::Ice::Object"
};

bool
Glacier2::Admin::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Glacier2__Admin_ids, __Glacier2__Admin_ids + 2, _s);
}

::std::vector< ::std::string>
Glacier2::Admin::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Glacier2__Admin_ids[0], &__Glacier2__Admin_ids[2]);
}

const ::std::string&
Glacier2::Admin::ice_id(const ::Ice::Current&) const
{
    return __Glacier2__Admin_ids[0];
}

const ::std::string&
Glacier2::Admin::ice_staticId()
{
    return __Glacier2__Admin_ids[0];
}

::Ice::DispatchStatus
Glacier2::Admin::___shutdown(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    __inS.is()->skipEmptyEncaps();
    shutdown(__current);
    return ::Ice::DispatchOK;
}

static ::std::string __Glacier2__Admin_all[] =
{
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "shutdown"
};

::Ice::DispatchStatus
Glacier2::Admin::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Glacier2__Admin_all, __Glacier2__Admin_all + 5, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __Glacier2__Admin_all)
    {
        case 0:
        {
            return ___ice_id(in, current);
        }
        case 1:
        {
            return ___ice_ids(in, current);
        }
        case 2:
        {
            return ___ice_isA(in, current);
        }
        case 3:
        {
            return ___ice_ping(in, current);
        }
        case 4:
        {
            return ___shutdown(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
Glacier2::Admin::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Glacier2::Admin::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Glacier2::Admin::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::Admin was not generated with stream support";
    throw ex;
}

void
Glacier2::Admin::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::Admin was not generated with stream support";
    throw ex;
}

void ICE_DECLSPEC_EXPORT 
Glacier2::__patch__AdminPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Glacier2::AdminPtr* p = static_cast< ::Glacier2::AdminPtr*>(__addr);
    assert(p);
    *p = ::Glacier2::AdminPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Glacier2::Admin::ice_staticId(), v->ice_id());
    }
}

bool
Glacier2::operator==(const ::Glacier2::Admin& l, const ::Glacier2::Admin& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<(const ::Glacier2::Admin& l, const ::Glacier2::Admin& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}
