// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `SSLInfo.ice'

#ifndef GLACIER2_API_EXPORTS
#   define GLACIER2_API_EXPORTS
#endif
#include <Glacier2/SSLInfo.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

bool
Glacier2::SSLInfo::operator==(const SSLInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return true;
    }
    if(remoteHost != __rhs.remoteHost)
    {
        return false;
    }
    if(remotePort != __rhs.remotePort)
    {
        return false;
    }
    if(localHost != __rhs.localHost)
    {
        return false;
    }
    if(localPort != __rhs.localPort)
    {
        return false;
    }
    if(cipher != __rhs.cipher)
    {
        return false;
    }
    if(certs != __rhs.certs)
    {
        return false;
    }
    return true;
}

bool
Glacier2::SSLInfo::operator<(const SSLInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(remoteHost < __rhs.remoteHost)
    {
        return true;
    }
    else if(__rhs.remoteHost < remoteHost)
    {
        return false;
    }
    if(remotePort < __rhs.remotePort)
    {
        return true;
    }
    else if(__rhs.remotePort < remotePort)
    {
        return false;
    }
    if(localHost < __rhs.localHost)
    {
        return true;
    }
    else if(__rhs.localHost < localHost)
    {
        return false;
    }
    if(localPort < __rhs.localPort)
    {
        return true;
    }
    else if(__rhs.localPort < localPort)
    {
        return false;
    }
    if(cipher < __rhs.cipher)
    {
        return true;
    }
    else if(__rhs.cipher < cipher)
    {
        return false;
    }
    if(certs < __rhs.certs)
    {
        return true;
    }
    else if(__rhs.certs < certs)
    {
        return false;
    }
    return false;
}

void
Glacier2::SSLInfo::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(remoteHost);
    __os->write(remotePort);
    __os->write(localHost);
    __os->write(localPort);
    __os->write(cipher);
    if(certs.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        __os->write(&certs[0], &certs[0] + certs.size());
    }
}

void
Glacier2::SSLInfo::__read(::IceInternal::BasicStream* __is)
{
    __is->read(remoteHost);
    __is->read(remotePort);
    __is->read(localHost);
    __is->read(localPort);
    __is->read(cipher);
    __is->read(certs);
}
