// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `Session.ice'

#ifndef GLACIER2_API_EXPORTS
#   define GLACIER2_API_EXPORTS
#endif
#include <Glacier2/Session.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __Glacier2__Session__destroy_name = "destroy";

static const ::std::string __Glacier2__StringSet__add_name = "add";

static const ::std::string __Glacier2__StringSet__remove_name = "remove";

static const ::std::string __Glacier2__StringSet__get_name = "get";

static const ::std::string __Glacier2__IdentitySet__add_name = "add";

static const ::std::string __Glacier2__IdentitySet__remove_name = "remove";

static const ::std::string __Glacier2__IdentitySet__get_name = "get";

static const ::std::string __Glacier2__SessionControl__categories_name = "categories";

static const ::std::string __Glacier2__SessionControl__adapterIds_name = "adapterIds";

static const ::std::string __Glacier2__SessionControl__identities_name = "identities";

static const ::std::string __Glacier2__SessionControl__getSessionTimeout_name = "getSessionTimeout";

static const ::std::string __Glacier2__SessionControl__destroy_name = "destroy";

static const ::std::string __Glacier2__SessionManager__create_name = "create";

static const ::std::string __Glacier2__SSLSessionManager__create_name = "create";

ICE_DECLSPEC_EXPORT ::Ice::Object* IceInternal::upCast(::Glacier2::Session* p) { return p; }
ICE_DECLSPEC_EXPORT ::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Glacier2::Session* p) { return p; }

ICE_DECLSPEC_EXPORT ::Ice::Object* IceInternal::upCast(::Glacier2::StringSet* p) { return p; }
ICE_DECLSPEC_EXPORT ::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Glacier2::StringSet* p) { return p; }

ICE_DECLSPEC_EXPORT ::Ice::Object* IceInternal::upCast(::Glacier2::IdentitySet* p) { return p; }
ICE_DECLSPEC_EXPORT ::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Glacier2::IdentitySet* p) { return p; }

ICE_DECLSPEC_EXPORT ::Ice::Object* IceInternal::upCast(::Glacier2::SessionControl* p) { return p; }
ICE_DECLSPEC_EXPORT ::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Glacier2::SessionControl* p) { return p; }

ICE_DECLSPEC_EXPORT ::Ice::Object* IceInternal::upCast(::Glacier2::SessionManager* p) { return p; }
ICE_DECLSPEC_EXPORT ::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Glacier2::SessionManager* p) { return p; }

ICE_DECLSPEC_EXPORT ::Ice::Object* IceInternal::upCast(::Glacier2::SSLSessionManager* p) { return p; }
ICE_DECLSPEC_EXPORT ::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Glacier2::SSLSessionManager* p) { return p; }

void
Glacier2::__read(::IceInternal::BasicStream* __is, ::Glacier2::SessionPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Glacier2::Session;
        v->__copyFrom(proxy);
    }
}

void
Glacier2::__read(::IceInternal::BasicStream* __is, ::Glacier2::StringSetPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Glacier2::StringSet;
        v->__copyFrom(proxy);
    }
}

void
Glacier2::__read(::IceInternal::BasicStream* __is, ::Glacier2::IdentitySetPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Glacier2::IdentitySet;
        v->__copyFrom(proxy);
    }
}

void
Glacier2::__read(::IceInternal::BasicStream* __is, ::Glacier2::SessionControlPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Glacier2::SessionControl;
        v->__copyFrom(proxy);
    }
}

void
Glacier2::__read(::IceInternal::BasicStream* __is, ::Glacier2::SessionManagerPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Glacier2::SessionManager;
        v->__copyFrom(proxy);
    }
}

void
Glacier2::__read(::IceInternal::BasicStream* __is, ::Glacier2::SSLSessionManagerPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Glacier2::SSLSessionManager;
        v->__copyFrom(proxy);
    }
}

Glacier2::CannotCreateSessionException::CannotCreateSessionException(const ::std::string& __ice_reason) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    reason(__ice_reason)
{
}

Glacier2::CannotCreateSessionException::~CannotCreateSessionException() throw()
{
}

static const char* __Glacier2__CannotCreateSessionException_name = "Glacier2::CannotCreateSessionException";

::std::string
Glacier2::CannotCreateSessionException::ice_name() const
{
    return __Glacier2__CannotCreateSessionException_name;
}

::Ice::Exception*
Glacier2::CannotCreateSessionException::ice_clone() const
{
    return new CannotCreateSessionException(*this);
}

void
Glacier2::CannotCreateSessionException::ice_throw() const
{
    throw *this;
}

void
Glacier2::CannotCreateSessionException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::Glacier2::CannotCreateSessionException"), false);
    __os->startWriteSlice();
    __os->write(reason);
    __os->endWriteSlice();
}

void
Glacier2::CannotCreateSessionException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(reason);
    __is->endReadSlice();
}

void
Glacier2::CannotCreateSessionException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Glacier2::CannotCreateSessionException was not generated with stream support";
    throw ex;
}

void
Glacier2::CannotCreateSessionException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Glacier2::CannotCreateSessionException was not generated with stream support";
    throw ex;
}

struct __F__Glacier2__CannotCreateSessionException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::Glacier2::CannotCreateSessionException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__Glacier2__CannotCreateSessionException__Ptr = new __F__Glacier2__CannotCreateSessionException;

const ::IceInternal::UserExceptionFactoryPtr&
Glacier2::CannotCreateSessionException::ice_factory()
{
    return __F__Glacier2__CannotCreateSessionException__Ptr;
}

class __F__Glacier2__CannotCreateSessionException__Init
{
public:

    __F__Glacier2__CannotCreateSessionException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::Glacier2::CannotCreateSessionException", ::Glacier2::CannotCreateSessionException::ice_factory());
    }

    ~__F__Glacier2__CannotCreateSessionException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::Glacier2::CannotCreateSessionException");
    }
};

static __F__Glacier2__CannotCreateSessionException__Init __F__Glacier2__CannotCreateSessionException__i;

#ifdef __APPLE__
extern "C" { void __F__Glacier2__CannotCreateSessionException__initializer() {} }
#endif

bool
Glacier2::AMI_Session_destroy::__invoke(const ::Glacier2::SessionPrx& __prx, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prepare(__prx, __Glacier2__Session__destroy_name, ::Ice::Normal, __ctx);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
Glacier2::AMI_Session_destroy::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}

bool
Glacier2::AMI_SessionControl_destroy::__invoke(const ::Glacier2::SessionControlPrx& __prx, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prepare(__prx, __Glacier2__SessionControl__destroy_name, ::Ice::Normal, __ctx);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
Glacier2::AMI_SessionControl_destroy::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}

bool
Glacier2::AMI_SessionManager_create::__invoke(const ::Glacier2::SessionManagerPrx& __prx, const ::std::string& userId, const ::Glacier2::SessionControlPrx& control, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prx->__checkTwowayOnly(__Glacier2__SessionManager__create_name);
        __prepare(__prx, __Glacier2__SessionManager__create_name, ::Ice::Normal, __ctx);
        __os->write(userId);
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(control.get())));
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
Glacier2::AMI_SessionManager_create::__response(bool __ok)
{
    ::Glacier2::SessionPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Glacier2::CannotCreateSessionException& __ex)
            {
                __exception(__ex);
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->startReadEncaps();
        ::Glacier2::__read(__is, __ret);
        __is->endReadEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response(__ret);
    __releaseCallback();
}

bool
Glacier2::AMI_SSLSessionManager_create::__invoke(const ::Glacier2::SSLSessionManagerPrx& __prx, const ::Glacier2::SSLInfo& info, const ::Glacier2::SessionControlPrx& control, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prx->__checkTwowayOnly(__Glacier2__SSLSessionManager__create_name);
        __prepare(__prx, __Glacier2__SSLSessionManager__create_name, ::Ice::Normal, __ctx);
        info.__write(__os);
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(control.get())));
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
Glacier2::AMI_SSLSessionManager_create::__response(bool __ok)
{
    ::Glacier2::SessionPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Glacier2::CannotCreateSessionException& __ex)
            {
                __exception(__ex);
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->startReadEncaps();
        ::Glacier2::__read(__is, __ret);
        __is->endReadEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response(__ret);
    __releaseCallback();
}
#ifdef __SUNPRO_CC
class ICE_DECLSPEC_EXPORT IceProxy::Glacier2::Session;
#endif

void
IceProxy::Glacier2::Session::destroy(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::Glacier2::Session* __del = dynamic_cast< ::IceDelegate::Glacier2::Session*>(__delBase.get());
            __del->destroy(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::Glacier2::Session::destroy_async(const ::Glacier2::AMI_Session_destroyPtr& __cb)
{
    return __cb->__invoke(this, 0);
}

bool
IceProxy::Glacier2::Session::destroy_async(const ::Glacier2::AMI_Session_destroyPtr& __cb, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, &__ctx);
}

const ::std::string&
IceProxy::Glacier2::Session::ice_staticId()
{
    return ::Glacier2::Session::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Glacier2::Session::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Glacier2::Session);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Glacier2::Session::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Glacier2::Session);
}

::IceProxy::Ice::Object*
IceProxy::Glacier2::Session::__newInstance() const
{
    return new Session;
}
#ifdef __SUNPRO_CC
class ICE_DECLSPEC_EXPORT IceProxy::Glacier2::StringSet;
#endif

void
IceProxy::Glacier2::StringSet::add(const ::Ice::StringSeq& additions, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::Glacier2::StringSet* __del = dynamic_cast< ::IceDelegate::Glacier2::StringSet*>(__delBase.get());
            __del->add(additions, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::Glacier2::StringSet::remove(const ::Ice::StringSeq& deletions, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::Glacier2::StringSet* __del = dynamic_cast< ::IceDelegate::Glacier2::StringSet*>(__delBase.get());
            __del->remove(deletions, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::Ice::StringSeq
IceProxy::Glacier2::StringSet::get(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Glacier2__StringSet__get_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Glacier2::StringSet* __del = dynamic_cast< ::IceDelegate::Glacier2::StringSet*>(__delBase.get());
            return __del->get(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::Glacier2::StringSet::ice_staticId()
{
    return ::Glacier2::StringSet::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Glacier2::StringSet::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Glacier2::StringSet);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Glacier2::StringSet::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Glacier2::StringSet);
}

::IceProxy::Ice::Object*
IceProxy::Glacier2::StringSet::__newInstance() const
{
    return new StringSet;
}
#ifdef __SUNPRO_CC
class ICE_DECLSPEC_EXPORT IceProxy::Glacier2::IdentitySet;
#endif

void
IceProxy::Glacier2::IdentitySet::add(const ::Ice::IdentitySeq& additions, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::Glacier2::IdentitySet* __del = dynamic_cast< ::IceDelegate::Glacier2::IdentitySet*>(__delBase.get());
            __del->add(additions, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::Glacier2::IdentitySet::remove(const ::Ice::IdentitySeq& deletions, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::Glacier2::IdentitySet* __del = dynamic_cast< ::IceDelegate::Glacier2::IdentitySet*>(__delBase.get());
            __del->remove(deletions, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::Ice::IdentitySeq
IceProxy::Glacier2::IdentitySet::get(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Glacier2__IdentitySet__get_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Glacier2::IdentitySet* __del = dynamic_cast< ::IceDelegate::Glacier2::IdentitySet*>(__delBase.get());
            return __del->get(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::Glacier2::IdentitySet::ice_staticId()
{
    return ::Glacier2::IdentitySet::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Glacier2::IdentitySet::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Glacier2::IdentitySet);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Glacier2::IdentitySet::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Glacier2::IdentitySet);
}

::IceProxy::Ice::Object*
IceProxy::Glacier2::IdentitySet::__newInstance() const
{
    return new IdentitySet;
}
#ifdef __SUNPRO_CC
class ICE_DECLSPEC_EXPORT IceProxy::Glacier2::SessionControl;
#endif

::Glacier2::StringSetPrx
IceProxy::Glacier2::SessionControl::categories(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Glacier2__SessionControl__categories_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Glacier2::SessionControl* __del = dynamic_cast< ::IceDelegate::Glacier2::SessionControl*>(__delBase.get());
            return __del->categories(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::Glacier2::StringSetPrx
IceProxy::Glacier2::SessionControl::adapterIds(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Glacier2__SessionControl__adapterIds_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Glacier2::SessionControl* __del = dynamic_cast< ::IceDelegate::Glacier2::SessionControl*>(__delBase.get());
            return __del->adapterIds(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::Glacier2::IdentitySetPrx
IceProxy::Glacier2::SessionControl::identities(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Glacier2__SessionControl__identities_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Glacier2::SessionControl* __del = dynamic_cast< ::IceDelegate::Glacier2::SessionControl*>(__delBase.get());
            return __del->identities(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::Ice::Int
IceProxy::Glacier2::SessionControl::getSessionTimeout(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Glacier2__SessionControl__getSessionTimeout_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Glacier2::SessionControl* __del = dynamic_cast< ::IceDelegate::Glacier2::SessionControl*>(__delBase.get());
            return __del->getSessionTimeout(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::Glacier2::SessionControl::destroy(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::Glacier2::SessionControl* __del = dynamic_cast< ::IceDelegate::Glacier2::SessionControl*>(__delBase.get());
            __del->destroy(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::Glacier2::SessionControl::destroy_async(const ::Glacier2::AMI_SessionControl_destroyPtr& __cb)
{
    return __cb->__invoke(this, 0);
}

bool
IceProxy::Glacier2::SessionControl::destroy_async(const ::Glacier2::AMI_SessionControl_destroyPtr& __cb, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, &__ctx);
}

const ::std::string&
IceProxy::Glacier2::SessionControl::ice_staticId()
{
    return ::Glacier2::SessionControl::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Glacier2::SessionControl::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Glacier2::SessionControl);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Glacier2::SessionControl::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Glacier2::SessionControl);
}

::IceProxy::Ice::Object*
IceProxy::Glacier2::SessionControl::__newInstance() const
{
    return new SessionControl;
}
#ifdef __SUNPRO_CC
class ICE_DECLSPEC_EXPORT IceProxy::Glacier2::SessionManager;
#endif

::Glacier2::SessionPrx
IceProxy::Glacier2::SessionManager::create(const ::std::string& userId, const ::Glacier2::SessionControlPrx& control, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Glacier2__SessionManager__create_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Glacier2::SessionManager* __del = dynamic_cast< ::IceDelegate::Glacier2::SessionManager*>(__delBase.get());
            return __del->create(userId, control, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::Glacier2::SessionManager::create_async(const ::Glacier2::AMI_SessionManager_createPtr& __cb, const ::std::string& userId, const ::Glacier2::SessionControlPrx& control)
{
    return __cb->__invoke(this, userId, control, 0);
}

bool
IceProxy::Glacier2::SessionManager::create_async(const ::Glacier2::AMI_SessionManager_createPtr& __cb, const ::std::string& userId, const ::Glacier2::SessionControlPrx& control, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, userId, control, &__ctx);
}

const ::std::string&
IceProxy::Glacier2::SessionManager::ice_staticId()
{
    return ::Glacier2::SessionManager::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Glacier2::SessionManager::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Glacier2::SessionManager);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Glacier2::SessionManager::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Glacier2::SessionManager);
}

::IceProxy::Ice::Object*
IceProxy::Glacier2::SessionManager::__newInstance() const
{
    return new SessionManager;
}
#ifdef __SUNPRO_CC
class ICE_DECLSPEC_EXPORT IceProxy::Glacier2::SSLSessionManager;
#endif

::Glacier2::SessionPrx
IceProxy::Glacier2::SSLSessionManager::create(const ::Glacier2::SSLInfo& info, const ::Glacier2::SessionControlPrx& control, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Glacier2__SSLSessionManager__create_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Glacier2::SSLSessionManager* __del = dynamic_cast< ::IceDelegate::Glacier2::SSLSessionManager*>(__delBase.get());
            return __del->create(info, control, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::Glacier2::SSLSessionManager::create_async(const ::Glacier2::AMI_SSLSessionManager_createPtr& __cb, const ::Glacier2::SSLInfo& info, const ::Glacier2::SessionControlPrx& control)
{
    return __cb->__invoke(this, info, control, 0);
}

bool
IceProxy::Glacier2::SSLSessionManager::create_async(const ::Glacier2::AMI_SSLSessionManager_createPtr& __cb, const ::Glacier2::SSLInfo& info, const ::Glacier2::SessionControlPrx& control, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, info, control, &__ctx);
}

const ::std::string&
IceProxy::Glacier2::SSLSessionManager::ice_staticId()
{
    return ::Glacier2::SSLSessionManager::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Glacier2::SSLSessionManager::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Glacier2::SSLSessionManager);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Glacier2::SSLSessionManager::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Glacier2::SSLSessionManager);
}

::IceProxy::Ice::Object*
IceProxy::Glacier2::SSLSessionManager::__newInstance() const
{
    return new SSLSessionManager;
}

void
IceDelegateM::Glacier2::Session::destroy(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Glacier2__Session__destroy_name, ::Ice::Normal, __context);
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::Glacier2::StringSet::add(const ::Ice::StringSeq& additions, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Glacier2__StringSet__add_name, ::Ice::Idempotent, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(additions.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            __os->write(&additions[0], &additions[0] + additions.size());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::Glacier2::StringSet::remove(const ::Ice::StringSeq& deletions, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Glacier2__StringSet__remove_name, ::Ice::Idempotent, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(deletions.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            __os->write(&deletions[0], &deletions[0] + deletions.size());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

::Ice::StringSeq
IceDelegateM::Glacier2::StringSet::get(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Glacier2__StringSet__get_name, ::Ice::Idempotent, __context);
    bool __ok = __og.invoke();
    ::Ice::StringSeq __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::Glacier2::IdentitySet::add(const ::Ice::IdentitySeq& additions, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Glacier2__IdentitySet__add_name, ::Ice::Idempotent, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(additions.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::Ice::__writeIdentitySeq(__os, &additions[0], &additions[0] + additions.size());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::Glacier2::IdentitySet::remove(const ::Ice::IdentitySeq& deletions, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Glacier2__IdentitySet__remove_name, ::Ice::Idempotent, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(deletions.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::Ice::__writeIdentitySeq(__os, &deletions[0], &deletions[0] + deletions.size());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

::Ice::IdentitySeq
IceDelegateM::Glacier2::IdentitySet::get(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Glacier2__IdentitySet__get_name, ::Ice::Idempotent, __context);
    bool __ok = __og.invoke();
    ::Ice::IdentitySeq __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::Ice::__readIdentitySeq(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Glacier2::StringSetPrx
IceDelegateM::Glacier2::SessionControl::categories(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Glacier2__SessionControl__categories_name, ::Ice::Normal, __context);
    bool __ok = __og.invoke();
    ::Glacier2::StringSetPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::Glacier2::__read(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Glacier2::StringSetPrx
IceDelegateM::Glacier2::SessionControl::adapterIds(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Glacier2__SessionControl__adapterIds_name, ::Ice::Normal, __context);
    bool __ok = __og.invoke();
    ::Glacier2::StringSetPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::Glacier2::__read(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Glacier2::IdentitySetPrx
IceDelegateM::Glacier2::SessionControl::identities(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Glacier2__SessionControl__identities_name, ::Ice::Normal, __context);
    bool __ok = __og.invoke();
    ::Glacier2::IdentitySetPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::Glacier2::__read(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::Int
IceDelegateM::Glacier2::SessionControl::getSessionTimeout(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Glacier2__SessionControl__getSessionTimeout_name, ::Ice::Idempotent, __context);
    bool __ok = __og.invoke();
    ::Ice::Int __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::Glacier2::SessionControl::destroy(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Glacier2__SessionControl__destroy_name, ::Ice::Normal, __context);
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

::Glacier2::SessionPrx
IceDelegateM::Glacier2::SessionManager::create(const ::std::string& userId, const ::Glacier2::SessionControlPrx& control, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Glacier2__SessionManager__create_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(userId);
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(control.get())));
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    ::Glacier2::SessionPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Glacier2::CannotCreateSessionException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::Glacier2::__read(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Glacier2::SessionPrx
IceDelegateM::Glacier2::SSLSessionManager::create(const ::Glacier2::SSLInfo& info, const ::Glacier2::SessionControlPrx& control, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Glacier2__SSLSessionManager__create_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        info.__write(__os);
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(control.get())));
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    ::Glacier2::SessionPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Glacier2::CannotCreateSessionException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::Glacier2::__read(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateD::Glacier2::Session::destroy(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Glacier2::Session* servant = dynamic_cast< ::Glacier2::Session*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->destroy(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__Session__destroy_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(__current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::Glacier2::StringSet::add(const ::Ice::StringSeq& additions, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Ice::StringSeq& additions, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_additions(additions)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Glacier2::StringSet* servant = dynamic_cast< ::Glacier2::StringSet*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->add(_m_additions, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::Ice::StringSeq& _m_additions;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__StringSet__add_name, ::Ice::Idempotent, __context);
    try
    {
        _DirectI __direct(additions, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::Glacier2::StringSet::remove(const ::Ice::StringSeq& deletions, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Ice::StringSeq& deletions, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_deletions(deletions)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Glacier2::StringSet* servant = dynamic_cast< ::Glacier2::StringSet*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->remove(_m_deletions, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::Ice::StringSeq& _m_deletions;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__StringSet__remove_name, ::Ice::Idempotent, __context);
    try
    {
        _DirectI __direct(deletions, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

::Ice::StringSeq
IceDelegateD::Glacier2::StringSet::get(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Ice::StringSeq& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Glacier2::StringSet* servant = dynamic_cast< ::Glacier2::StringSet*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->get(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::Ice::StringSeq& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__StringSet__get_name, ::Ice::Idempotent, __context);
    ::Ice::StringSeq __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

void
IceDelegateD::Glacier2::IdentitySet::add(const ::Ice::IdentitySeq& additions, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Ice::IdentitySeq& additions, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_additions(additions)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Glacier2::IdentitySet* servant = dynamic_cast< ::Glacier2::IdentitySet*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->add(_m_additions, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::Ice::IdentitySeq& _m_additions;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__IdentitySet__add_name, ::Ice::Idempotent, __context);
    try
    {
        _DirectI __direct(additions, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::Glacier2::IdentitySet::remove(const ::Ice::IdentitySeq& deletions, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Ice::IdentitySeq& deletions, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_deletions(deletions)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Glacier2::IdentitySet* servant = dynamic_cast< ::Glacier2::IdentitySet*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->remove(_m_deletions, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::Ice::IdentitySeq& _m_deletions;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__IdentitySet__remove_name, ::Ice::Idempotent, __context);
    try
    {
        _DirectI __direct(deletions, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

::Ice::IdentitySeq
IceDelegateD::Glacier2::IdentitySet::get(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Ice::IdentitySeq& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Glacier2::IdentitySet* servant = dynamic_cast< ::Glacier2::IdentitySet*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->get(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::Ice::IdentitySeq& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__IdentitySet__get_name, ::Ice::Idempotent, __context);
    ::Ice::IdentitySeq __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Glacier2::StringSetPrx
IceDelegateD::Glacier2::SessionControl::categories(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Glacier2::StringSetPrx& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Glacier2::SessionControl* servant = dynamic_cast< ::Glacier2::SessionControl*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->categories(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::Glacier2::StringSetPrx& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__SessionControl__categories_name, ::Ice::Normal, __context);
    ::Glacier2::StringSetPrx __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Glacier2::StringSetPrx
IceDelegateD::Glacier2::SessionControl::adapterIds(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Glacier2::StringSetPrx& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Glacier2::SessionControl* servant = dynamic_cast< ::Glacier2::SessionControl*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->adapterIds(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::Glacier2::StringSetPrx& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__SessionControl__adapterIds_name, ::Ice::Normal, __context);
    ::Glacier2::StringSetPrx __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Glacier2::IdentitySetPrx
IceDelegateD::Glacier2::SessionControl::identities(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Glacier2::IdentitySetPrx& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Glacier2::SessionControl* servant = dynamic_cast< ::Glacier2::SessionControl*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->identities(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::Glacier2::IdentitySetPrx& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__SessionControl__identities_name, ::Ice::Normal, __context);
    ::Glacier2::IdentitySetPrx __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Ice::Int
IceDelegateD::Glacier2::SessionControl::getSessionTimeout(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Ice::Int& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Glacier2::SessionControl* servant = dynamic_cast< ::Glacier2::SessionControl*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->getSessionTimeout(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::Ice::Int& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__SessionControl__getSessionTimeout_name, ::Ice::Idempotent, __context);
    ::Ice::Int __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

void
IceDelegateD::Glacier2::SessionControl::destroy(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Glacier2::SessionControl* servant = dynamic_cast< ::Glacier2::SessionControl*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->destroy(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__SessionControl__destroy_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(__current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

::Glacier2::SessionPrx
IceDelegateD::Glacier2::SessionManager::create(const ::std::string& userId, const ::Glacier2::SessionControlPrx& control, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Glacier2::SessionPrx& __result, const ::std::string& userId, const ::Glacier2::SessionControlPrx& control, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_userId(userId),
            _m_control(control)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Glacier2::SessionManager* servant = dynamic_cast< ::Glacier2::SessionManager*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                _result = servant->create(_m_userId, _m_control, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        ::Glacier2::SessionPrx& _result;
        const ::std::string& _m_userId;
        const ::Glacier2::SessionControlPrx& _m_control;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__SessionManager__create_name, ::Ice::Normal, __context);
    ::Glacier2::SessionPrx __result;
    try
    {
        _DirectI __direct(__result, userId, control, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Glacier2::CannotCreateSessionException&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Glacier2::SessionPrx
IceDelegateD::Glacier2::SSLSessionManager::create(const ::Glacier2::SSLInfo& info, const ::Glacier2::SessionControlPrx& control, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Glacier2::SessionPrx& __result, const ::Glacier2::SSLInfo& info, const ::Glacier2::SessionControlPrx& control, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_info(info),
            _m_control(control)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Glacier2::SSLSessionManager* servant = dynamic_cast< ::Glacier2::SSLSessionManager*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                _result = servant->create(_m_info, _m_control, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        ::Glacier2::SessionPrx& _result;
        const ::Glacier2::SSLInfo& _m_info;
        const ::Glacier2::SessionControlPrx& _m_control;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__SSLSessionManager__create_name, ::Ice::Normal, __context);
    ::Glacier2::SessionPrx __result;
    try
    {
        _DirectI __direct(__result, info, control, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Glacier2::CannotCreateSessionException&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Ice::ObjectPtr
Glacier2::Session::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Glacier2__Session_ids[2] =
{
    "::Glacier2::Session",
    "::Ice::Object"
};

bool
Glacier2::Session::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Glacier2__Session_ids, __Glacier2__Session_ids + 2, _s);
}

::std::vector< ::std::string>
Glacier2::Session::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Glacier2__Session_ids[0], &__Glacier2__Session_ids[2]);
}

const ::std::string&
Glacier2::Session::ice_id(const ::Ice::Current&) const
{
    return __Glacier2__Session_ids[0];
}

const ::std::string&
Glacier2::Session::ice_staticId()
{
    return __Glacier2__Session_ids[0];
}

::Ice::DispatchStatus
Glacier2::Session::___destroy(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    __inS.is()->skipEmptyEncaps();
    destroy(__current);
    return ::Ice::DispatchOK;
}

static ::std::string __Glacier2__Session_all[] =
{
    "destroy",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::Ice::DispatchStatus
Glacier2::Session::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Glacier2__Session_all, __Glacier2__Session_all + 5, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __Glacier2__Session_all)
    {
        case 0:
        {
            return ___destroy(in, current);
        }
        case 1:
        {
            return ___ice_id(in, current);
        }
        case 2:
        {
            return ___ice_ids(in, current);
        }
        case 3:
        {
            return ___ice_isA(in, current);
        }
        case 4:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
Glacier2::Session::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Glacier2::Session::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Glacier2::Session::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::Session was not generated with stream support";
    throw ex;
}

void
Glacier2::Session::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::Session was not generated with stream support";
    throw ex;
}

void ICE_DECLSPEC_EXPORT 
Glacier2::__patch__SessionPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Glacier2::SessionPtr* p = static_cast< ::Glacier2::SessionPtr*>(__addr);
    assert(p);
    *p = ::Glacier2::SessionPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Glacier2::Session::ice_staticId(), v->ice_id());
    }
}

bool
Glacier2::operator==(const ::Glacier2::Session& l, const ::Glacier2::Session& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<(const ::Glacier2::Session& l, const ::Glacier2::Session& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
Glacier2::StringSet::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Glacier2__StringSet_ids[2] =
{
    "::Glacier2::StringSet",
    "::Ice::Object"
};

bool
Glacier2::StringSet::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Glacier2__StringSet_ids, __Glacier2__StringSet_ids + 2, _s);
}

::std::vector< ::std::string>
Glacier2::StringSet::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Glacier2__StringSet_ids[0], &__Glacier2__StringSet_ids[2]);
}

const ::std::string&
Glacier2::StringSet::ice_id(const ::Ice::Current&) const
{
    return __Glacier2__StringSet_ids[0];
}

const ::std::string&
Glacier2::StringSet::ice_staticId()
{
    return __Glacier2__StringSet_ids[0];
}

::Ice::DispatchStatus
Glacier2::StringSet::___add(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Ice::StringSeq additions;
    __is->read(additions);
    __is->endReadEncaps();
    add(additions, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Glacier2::StringSet::___remove(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Ice::StringSeq deletions;
    __is->read(deletions);
    __is->endReadEncaps();
    remove(deletions, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Glacier2::StringSet::___get(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::StringSeq __ret = get(__current);
    if(__ret.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        __os->write(&__ret[0], &__ret[0] + __ret.size());
    }
    return ::Ice::DispatchOK;
}

static ::std::string __Glacier2__StringSet_all[] =
{
    "add",
    "get",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "remove"
};

::Ice::DispatchStatus
Glacier2::StringSet::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Glacier2__StringSet_all, __Glacier2__StringSet_all + 7, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __Glacier2__StringSet_all)
    {
        case 0:
        {
            return ___add(in, current);
        }
        case 1:
        {
            return ___get(in, current);
        }
        case 2:
        {
            return ___ice_id(in, current);
        }
        case 3:
        {
            return ___ice_ids(in, current);
        }
        case 4:
        {
            return ___ice_isA(in, current);
        }
        case 5:
        {
            return ___ice_ping(in, current);
        }
        case 6:
        {
            return ___remove(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
Glacier2::StringSet::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Glacier2::StringSet::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Glacier2::StringSet::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::StringSet was not generated with stream support";
    throw ex;
}

void
Glacier2::StringSet::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::StringSet was not generated with stream support";
    throw ex;
}

void ICE_DECLSPEC_EXPORT 
Glacier2::__patch__StringSetPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Glacier2::StringSetPtr* p = static_cast< ::Glacier2::StringSetPtr*>(__addr);
    assert(p);
    *p = ::Glacier2::StringSetPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Glacier2::StringSet::ice_staticId(), v->ice_id());
    }
}

bool
Glacier2::operator==(const ::Glacier2::StringSet& l, const ::Glacier2::StringSet& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<(const ::Glacier2::StringSet& l, const ::Glacier2::StringSet& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
Glacier2::IdentitySet::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Glacier2__IdentitySet_ids[2] =
{
    "::Glacier2::IdentitySet",
    "::Ice::Object"
};

bool
Glacier2::IdentitySet::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Glacier2__IdentitySet_ids, __Glacier2__IdentitySet_ids + 2, _s);
}

::std::vector< ::std::string>
Glacier2::IdentitySet::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Glacier2__IdentitySet_ids[0], &__Glacier2__IdentitySet_ids[2]);
}

const ::std::string&
Glacier2::IdentitySet::ice_id(const ::Ice::Current&) const
{
    return __Glacier2__IdentitySet_ids[0];
}

const ::std::string&
Glacier2::IdentitySet::ice_staticId()
{
    return __Glacier2__IdentitySet_ids[0];
}

::Ice::DispatchStatus
Glacier2::IdentitySet::___add(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Ice::IdentitySeq additions;
    ::Ice::__readIdentitySeq(__is, additions);
    __is->endReadEncaps();
    add(additions, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Glacier2::IdentitySet::___remove(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Ice::IdentitySeq deletions;
    ::Ice::__readIdentitySeq(__is, deletions);
    __is->endReadEncaps();
    remove(deletions, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Glacier2::IdentitySet::___get(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::IdentitySeq __ret = get(__current);
    if(__ret.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::Ice::__writeIdentitySeq(__os, &__ret[0], &__ret[0] + __ret.size());
    }
    return ::Ice::DispatchOK;
}

static ::std::string __Glacier2__IdentitySet_all[] =
{
    "add",
    "get",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "remove"
};

::Ice::DispatchStatus
Glacier2::IdentitySet::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Glacier2__IdentitySet_all, __Glacier2__IdentitySet_all + 7, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __Glacier2__IdentitySet_all)
    {
        case 0:
        {
            return ___add(in, current);
        }
        case 1:
        {
            return ___get(in, current);
        }
        case 2:
        {
            return ___ice_id(in, current);
        }
        case 3:
        {
            return ___ice_ids(in, current);
        }
        case 4:
        {
            return ___ice_isA(in, current);
        }
        case 5:
        {
            return ___ice_ping(in, current);
        }
        case 6:
        {
            return ___remove(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
Glacier2::IdentitySet::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Glacier2::IdentitySet::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Glacier2::IdentitySet::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::IdentitySet was not generated with stream support";
    throw ex;
}

void
Glacier2::IdentitySet::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::IdentitySet was not generated with stream support";
    throw ex;
}

void ICE_DECLSPEC_EXPORT 
Glacier2::__patch__IdentitySetPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Glacier2::IdentitySetPtr* p = static_cast< ::Glacier2::IdentitySetPtr*>(__addr);
    assert(p);
    *p = ::Glacier2::IdentitySetPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Glacier2::IdentitySet::ice_staticId(), v->ice_id());
    }
}

bool
Glacier2::operator==(const ::Glacier2::IdentitySet& l, const ::Glacier2::IdentitySet& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<(const ::Glacier2::IdentitySet& l, const ::Glacier2::IdentitySet& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
Glacier2::SessionControl::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Glacier2__SessionControl_ids[2] =
{
    "::Glacier2::SessionControl",
    "::Ice::Object"
};

bool
Glacier2::SessionControl::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Glacier2__SessionControl_ids, __Glacier2__SessionControl_ids + 2, _s);
}

::std::vector< ::std::string>
Glacier2::SessionControl::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Glacier2__SessionControl_ids[0], &__Glacier2__SessionControl_ids[2]);
}

const ::std::string&
Glacier2::SessionControl::ice_id(const ::Ice::Current&) const
{
    return __Glacier2__SessionControl_ids[0];
}

const ::std::string&
Glacier2::SessionControl::ice_staticId()
{
    return __Glacier2__SessionControl_ids[0];
}

::Ice::DispatchStatus
Glacier2::SessionControl::___categories(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Glacier2::StringSetPrx __ret = categories(__current);
    __os->write(::Ice::ObjectPrx(::IceInternal::upCast(__ret.get())));
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Glacier2::SessionControl::___adapterIds(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Glacier2::StringSetPrx __ret = adapterIds(__current);
    __os->write(::Ice::ObjectPrx(::IceInternal::upCast(__ret.get())));
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Glacier2::SessionControl::___identities(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Glacier2::IdentitySetPrx __ret = identities(__current);
    __os->write(::Ice::ObjectPrx(::IceInternal::upCast(__ret.get())));
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Glacier2::SessionControl::___getSessionTimeout(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::Int __ret = getSessionTimeout(__current);
    __os->write(__ret);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Glacier2::SessionControl::___destroy(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    __inS.is()->skipEmptyEncaps();
    destroy(__current);
    return ::Ice::DispatchOK;
}

static ::std::string __Glacier2__SessionControl_all[] =
{
    "adapterIds",
    "categories",
    "destroy",
    "getSessionTimeout",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "identities"
};

::Ice::DispatchStatus
Glacier2::SessionControl::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Glacier2__SessionControl_all, __Glacier2__SessionControl_all + 9, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __Glacier2__SessionControl_all)
    {
        case 0:
        {
            return ___adapterIds(in, current);
        }
        case 1:
        {
            return ___categories(in, current);
        }
        case 2:
        {
            return ___destroy(in, current);
        }
        case 3:
        {
            return ___getSessionTimeout(in, current);
        }
        case 4:
        {
            return ___ice_id(in, current);
        }
        case 5:
        {
            return ___ice_ids(in, current);
        }
        case 6:
        {
            return ___ice_isA(in, current);
        }
        case 7:
        {
            return ___ice_ping(in, current);
        }
        case 8:
        {
            return ___identities(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
Glacier2::SessionControl::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Glacier2::SessionControl::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Glacier2::SessionControl::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::SessionControl was not generated with stream support";
    throw ex;
}

void
Glacier2::SessionControl::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::SessionControl was not generated with stream support";
    throw ex;
}

void ICE_DECLSPEC_EXPORT 
Glacier2::__patch__SessionControlPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Glacier2::SessionControlPtr* p = static_cast< ::Glacier2::SessionControlPtr*>(__addr);
    assert(p);
    *p = ::Glacier2::SessionControlPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Glacier2::SessionControl::ice_staticId(), v->ice_id());
    }
}

bool
Glacier2::operator==(const ::Glacier2::SessionControl& l, const ::Glacier2::SessionControl& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<(const ::Glacier2::SessionControl& l, const ::Glacier2::SessionControl& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
Glacier2::SessionManager::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Glacier2__SessionManager_ids[2] =
{
    "::Glacier2::SessionManager",
    "::Ice::Object"
};

bool
Glacier2::SessionManager::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Glacier2__SessionManager_ids, __Glacier2__SessionManager_ids + 2, _s);
}

::std::vector< ::std::string>
Glacier2::SessionManager::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Glacier2__SessionManager_ids[0], &__Glacier2__SessionManager_ids[2]);
}

const ::std::string&
Glacier2::SessionManager::ice_id(const ::Ice::Current&) const
{
    return __Glacier2__SessionManager_ids[0];
}

const ::std::string&
Glacier2::SessionManager::ice_staticId()
{
    return __Glacier2__SessionManager_ids[0];
}

::Ice::DispatchStatus
Glacier2::SessionManager::___create(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string userId;
    ::Glacier2::SessionControlPrx control;
    __is->read(userId);
    ::Glacier2::__read(__is, control);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        ::Glacier2::SessionPrx __ret = create(userId, control, __current);
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(__ret.get())));
    }
    catch(const ::Glacier2::CannotCreateSessionException& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

static ::std::string __Glacier2__SessionManager_all[] =
{
    "create",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::Ice::DispatchStatus
Glacier2::SessionManager::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Glacier2__SessionManager_all, __Glacier2__SessionManager_all + 5, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __Glacier2__SessionManager_all)
    {
        case 0:
        {
            return ___create(in, current);
        }
        case 1:
        {
            return ___ice_id(in, current);
        }
        case 2:
        {
            return ___ice_ids(in, current);
        }
        case 3:
        {
            return ___ice_isA(in, current);
        }
        case 4:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
Glacier2::SessionManager::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Glacier2::SessionManager::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Glacier2::SessionManager::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::SessionManager was not generated with stream support";
    throw ex;
}

void
Glacier2::SessionManager::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::SessionManager was not generated with stream support";
    throw ex;
}

void ICE_DECLSPEC_EXPORT 
Glacier2::__patch__SessionManagerPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Glacier2::SessionManagerPtr* p = static_cast< ::Glacier2::SessionManagerPtr*>(__addr);
    assert(p);
    *p = ::Glacier2::SessionManagerPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Glacier2::SessionManager::ice_staticId(), v->ice_id());
    }
}

bool
Glacier2::operator==(const ::Glacier2::SessionManager& l, const ::Glacier2::SessionManager& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<(const ::Glacier2::SessionManager& l, const ::Glacier2::SessionManager& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
Glacier2::SSLSessionManager::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Glacier2__SSLSessionManager_ids[2] =
{
    "::Glacier2::SSLSessionManager",
    "::Ice::Object"
};

bool
Glacier2::SSLSessionManager::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Glacier2__SSLSessionManager_ids, __Glacier2__SSLSessionManager_ids + 2, _s);
}

::std::vector< ::std::string>
Glacier2::SSLSessionManager::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Glacier2__SSLSessionManager_ids[0], &__Glacier2__SSLSessionManager_ids[2]);
}

const ::std::string&
Glacier2::SSLSessionManager::ice_id(const ::Ice::Current&) const
{
    return __Glacier2__SSLSessionManager_ids[0];
}

const ::std::string&
Glacier2::SSLSessionManager::ice_staticId()
{
    return __Glacier2__SSLSessionManager_ids[0];
}

::Ice::DispatchStatus
Glacier2::SSLSessionManager::___create(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Glacier2::SSLInfo info;
    ::Glacier2::SessionControlPrx control;
    info.__read(__is);
    ::Glacier2::__read(__is, control);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        ::Glacier2::SessionPrx __ret = create(info, control, __current);
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(__ret.get())));
    }
    catch(const ::Glacier2::CannotCreateSessionException& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

static ::std::string __Glacier2__SSLSessionManager_all[] =
{
    "create",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::Ice::DispatchStatus
Glacier2::SSLSessionManager::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Glacier2__SSLSessionManager_all, __Glacier2__SSLSessionManager_all + 5, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __Glacier2__SSLSessionManager_all)
    {
        case 0:
        {
            return ___create(in, current);
        }
        case 1:
        {
            return ___ice_id(in, current);
        }
        case 2:
        {
            return ___ice_ids(in, current);
        }
        case 3:
        {
            return ___ice_isA(in, current);
        }
        case 4:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
Glacier2::SSLSessionManager::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Glacier2::SSLSessionManager::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Glacier2::SSLSessionManager::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::SSLSessionManager was not generated with stream support";
    throw ex;
}

void
Glacier2::SSLSessionManager::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::SSLSessionManager was not generated with stream support";
    throw ex;
}

void ICE_DECLSPEC_EXPORT 
Glacier2::__patch__SSLSessionManagerPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Glacier2::SSLSessionManagerPtr* p = static_cast< ::Glacier2::SSLSessionManagerPtr*>(__addr);
    assert(p);
    *p = ::Glacier2::SSLSessionManagerPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Glacier2::SSLSessionManager::ice_staticId(), v->ice_id());
    }
}

bool
Glacier2::operator==(const ::Glacier2::SSLSessionManager& l, const ::Glacier2::SSLSessionManager& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<(const ::Glacier2::SSLSessionManager& l, const ::Glacier2::SSLSessionManager& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}
