// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `BuiltinSequences.ice'

#ifndef ICE_API_EXPORTS
#   define ICE_API_EXPORTS
#endif
#include <Ice/BuiltinSequences.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <Ice/LocalException.h>
#include <Ice/Stream.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

void
Ice::__writeObjectSeq(::IceInternal::BasicStream* __os, const ::Ice::ObjectPtr* begin, const ::Ice::ObjectPtr* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        __os->write(begin[i]);
    }
}

void
Ice::__readObjectSeq(::IceInternal::BasicStream* __is, ::Ice::ObjectSeq& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 4);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        __is->read(::Ice::__patch__ObjectPtr, &v[i]);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

void
Ice::ice_writeObjectSeq(const ::Ice::OutputStreamPtr& __outS, const ::Ice::ObjectSeq& v)
{
    __outS->writeSize(::Ice::Int(v.size()));
    ::Ice::ObjectSeq::const_iterator p;
    for(p = v.begin(); p != v.end(); ++p)
    {
        ::Ice::ice_writeObject(__outS, (*p));
    }
}

void
Ice::ice_readObjectSeq(const ::Ice::InputStreamPtr& __inS, ::Ice::ObjectSeq& v)
{
    ::Ice::Int sz = __inS->readSize();
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        ::Ice::ice_readObject(__inS, v[i]);
    }
}

void
Ice::__writeObjectProxySeq(::IceInternal::BasicStream* __os, const ::Ice::ObjectPrx* begin, const ::Ice::ObjectPrx* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        __os->write(begin[i]);
    }
}

void
Ice::__readObjectProxySeq(::IceInternal::BasicStream* __is, ::Ice::ObjectProxySeq& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 2);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        __is->read(v[i]);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

void
Ice::ice_writeObjectProxySeq(const ::Ice::OutputStreamPtr& __outS, const ::Ice::ObjectProxySeq& v)
{
    __outS->writeSize(::Ice::Int(v.size()));
    ::Ice::ObjectProxySeq::const_iterator p;
    for(p = v.begin(); p != v.end(); ++p)
    {
        __outS->writeProxy((*p));
    }
}

void
Ice::ice_readObjectProxySeq(const ::Ice::InputStreamPtr& __inS, ::Ice::ObjectProxySeq& v)
{
    ::Ice::Int sz = __inS->readSize();
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        v[i] = __inS->readProxy();
    }
}
