// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `Exception.ice'

#ifndef ICE_GRID_API_EXPORTS
#   define ICE_GRID_API_EXPORTS
#endif
#include <IceGrid/Exception.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <Ice/LocalException.h>
#include <Ice/SliceChecksums.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

IceGrid::ApplicationNotExistException::ApplicationNotExistException(const ::std::string& __ice_name) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    name(__ice_name)
{
}

IceGrid::ApplicationNotExistException::~ApplicationNotExistException() throw()
{
}

static const char* __IceGrid__ApplicationNotExistException_name = "IceGrid::ApplicationNotExistException";

::std::string
IceGrid::ApplicationNotExistException::ice_name() const
{
    return __IceGrid__ApplicationNotExistException_name;
}

::Ice::Exception*
IceGrid::ApplicationNotExistException::ice_clone() const
{
    return new ApplicationNotExistException(*this);
}

void
IceGrid::ApplicationNotExistException::ice_throw() const
{
    throw *this;
}

void
IceGrid::ApplicationNotExistException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::ApplicationNotExistException"), false);
    __os->startWriteSlice();
    __os->write(name);
    __os->endWriteSlice();
}

void
IceGrid::ApplicationNotExistException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(name);
    __is->endReadSlice();
}

void
IceGrid::ApplicationNotExistException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::ApplicationNotExistException was not generated with stream support";
    throw ex;
}

void
IceGrid::ApplicationNotExistException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::ApplicationNotExistException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__ApplicationNotExistException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::ApplicationNotExistException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__ApplicationNotExistException__Ptr = new __F__IceGrid__ApplicationNotExistException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::ApplicationNotExistException::ice_factory()
{
    return __F__IceGrid__ApplicationNotExistException__Ptr;
}

class __F__IceGrid__ApplicationNotExistException__Init
{
public:

    __F__IceGrid__ApplicationNotExistException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::ApplicationNotExistException", ::IceGrid::ApplicationNotExistException::ice_factory());
    }

    ~__F__IceGrid__ApplicationNotExistException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::ApplicationNotExistException");
    }
};

static __F__IceGrid__ApplicationNotExistException__Init __F__IceGrid__ApplicationNotExistException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__ApplicationNotExistException__initializer() {} }
#endif

IceGrid::ServerNotExistException::ServerNotExistException(const ::std::string& __ice_id) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    id(__ice_id)
{
}

IceGrid::ServerNotExistException::~ServerNotExistException() throw()
{
}

static const char* __IceGrid__ServerNotExistException_name = "IceGrid::ServerNotExistException";

::std::string
IceGrid::ServerNotExistException::ice_name() const
{
    return __IceGrid__ServerNotExistException_name;
}

::Ice::Exception*
IceGrid::ServerNotExistException::ice_clone() const
{
    return new ServerNotExistException(*this);
}

void
IceGrid::ServerNotExistException::ice_throw() const
{
    throw *this;
}

void
IceGrid::ServerNotExistException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::ServerNotExistException"), false);
    __os->startWriteSlice();
    __os->write(id);
    __os->endWriteSlice();
}

void
IceGrid::ServerNotExistException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(id);
    __is->endReadSlice();
}

void
IceGrid::ServerNotExistException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::ServerNotExistException was not generated with stream support";
    throw ex;
}

void
IceGrid::ServerNotExistException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::ServerNotExistException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__ServerNotExistException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::ServerNotExistException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__ServerNotExistException__Ptr = new __F__IceGrid__ServerNotExistException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::ServerNotExistException::ice_factory()
{
    return __F__IceGrid__ServerNotExistException__Ptr;
}

class __F__IceGrid__ServerNotExistException__Init
{
public:

    __F__IceGrid__ServerNotExistException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::ServerNotExistException", ::IceGrid::ServerNotExistException::ice_factory());
    }

    ~__F__IceGrid__ServerNotExistException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::ServerNotExistException");
    }
};

static __F__IceGrid__ServerNotExistException__Init __F__IceGrid__ServerNotExistException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__ServerNotExistException__initializer() {} }
#endif

IceGrid::ServerStartException::ServerStartException(const ::std::string& __ice_id, const ::std::string& __ice_reason) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    id(__ice_id),
    reason(__ice_reason)
{
}

IceGrid::ServerStartException::~ServerStartException() throw()
{
}

static const char* __IceGrid__ServerStartException_name = "IceGrid::ServerStartException";

::std::string
IceGrid::ServerStartException::ice_name() const
{
    return __IceGrid__ServerStartException_name;
}

::Ice::Exception*
IceGrid::ServerStartException::ice_clone() const
{
    return new ServerStartException(*this);
}

void
IceGrid::ServerStartException::ice_throw() const
{
    throw *this;
}

void
IceGrid::ServerStartException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::ServerStartException"), false);
    __os->startWriteSlice();
    __os->write(id);
    __os->write(reason);
    __os->endWriteSlice();
}

void
IceGrid::ServerStartException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(id);
    __is->read(reason);
    __is->endReadSlice();
}

void
IceGrid::ServerStartException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::ServerStartException was not generated with stream support";
    throw ex;
}

void
IceGrid::ServerStartException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::ServerStartException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__ServerStartException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::ServerStartException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__ServerStartException__Ptr = new __F__IceGrid__ServerStartException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::ServerStartException::ice_factory()
{
    return __F__IceGrid__ServerStartException__Ptr;
}

class __F__IceGrid__ServerStartException__Init
{
public:

    __F__IceGrid__ServerStartException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::ServerStartException", ::IceGrid::ServerStartException::ice_factory());
    }

    ~__F__IceGrid__ServerStartException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::ServerStartException");
    }
};

static __F__IceGrid__ServerStartException__Init __F__IceGrid__ServerStartException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__ServerStartException__initializer() {} }
#endif

IceGrid::ServerStopException::ServerStopException(const ::std::string& __ice_id, const ::std::string& __ice_reason) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    id(__ice_id),
    reason(__ice_reason)
{
}

IceGrid::ServerStopException::~ServerStopException() throw()
{
}

static const char* __IceGrid__ServerStopException_name = "IceGrid::ServerStopException";

::std::string
IceGrid::ServerStopException::ice_name() const
{
    return __IceGrid__ServerStopException_name;
}

::Ice::Exception*
IceGrid::ServerStopException::ice_clone() const
{
    return new ServerStopException(*this);
}

void
IceGrid::ServerStopException::ice_throw() const
{
    throw *this;
}

void
IceGrid::ServerStopException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::ServerStopException"), false);
    __os->startWriteSlice();
    __os->write(id);
    __os->write(reason);
    __os->endWriteSlice();
}

void
IceGrid::ServerStopException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(id);
    __is->read(reason);
    __is->endReadSlice();
}

void
IceGrid::ServerStopException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::ServerStopException was not generated with stream support";
    throw ex;
}

void
IceGrid::ServerStopException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::ServerStopException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__ServerStopException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::ServerStopException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__ServerStopException__Ptr = new __F__IceGrid__ServerStopException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::ServerStopException::ice_factory()
{
    return __F__IceGrid__ServerStopException__Ptr;
}

class __F__IceGrid__ServerStopException__Init
{
public:

    __F__IceGrid__ServerStopException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::ServerStopException", ::IceGrid::ServerStopException::ice_factory());
    }

    ~__F__IceGrid__ServerStopException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::ServerStopException");
    }
};

static __F__IceGrid__ServerStopException__Init __F__IceGrid__ServerStopException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__ServerStopException__initializer() {} }
#endif

IceGrid::AdapterNotExistException::AdapterNotExistException(const ::std::string& __ice_id) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    id(__ice_id)
{
}

IceGrid::AdapterNotExistException::~AdapterNotExistException() throw()
{
}

static const char* __IceGrid__AdapterNotExistException_name = "IceGrid::AdapterNotExistException";

::std::string
IceGrid::AdapterNotExistException::ice_name() const
{
    return __IceGrid__AdapterNotExistException_name;
}

::Ice::Exception*
IceGrid::AdapterNotExistException::ice_clone() const
{
    return new AdapterNotExistException(*this);
}

void
IceGrid::AdapterNotExistException::ice_throw() const
{
    throw *this;
}

void
IceGrid::AdapterNotExistException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::AdapterNotExistException"), false);
    __os->startWriteSlice();
    __os->write(id);
    __os->endWriteSlice();
}

void
IceGrid::AdapterNotExistException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(id);
    __is->endReadSlice();
}

void
IceGrid::AdapterNotExistException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::AdapterNotExistException was not generated with stream support";
    throw ex;
}

void
IceGrid::AdapterNotExistException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::AdapterNotExistException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__AdapterNotExistException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::AdapterNotExistException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__AdapterNotExistException__Ptr = new __F__IceGrid__AdapterNotExistException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::AdapterNotExistException::ice_factory()
{
    return __F__IceGrid__AdapterNotExistException__Ptr;
}

class __F__IceGrid__AdapterNotExistException__Init
{
public:

    __F__IceGrid__AdapterNotExistException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::AdapterNotExistException", ::IceGrid::AdapterNotExistException::ice_factory());
    }

    ~__F__IceGrid__AdapterNotExistException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::AdapterNotExistException");
    }
};

static __F__IceGrid__AdapterNotExistException__Init __F__IceGrid__AdapterNotExistException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__AdapterNotExistException__initializer() {} }
#endif

IceGrid::ObjectExistsException::ObjectExistsException(const ::Ice::Identity& __ice_id) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    id(__ice_id)
{
}

IceGrid::ObjectExistsException::~ObjectExistsException() throw()
{
}

static const char* __IceGrid__ObjectExistsException_name = "IceGrid::ObjectExistsException";

::std::string
IceGrid::ObjectExistsException::ice_name() const
{
    return __IceGrid__ObjectExistsException_name;
}

::Ice::Exception*
IceGrid::ObjectExistsException::ice_clone() const
{
    return new ObjectExistsException(*this);
}

void
IceGrid::ObjectExistsException::ice_throw() const
{
    throw *this;
}

void
IceGrid::ObjectExistsException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::ObjectExistsException"), false);
    __os->startWriteSlice();
    id.__write(__os);
    __os->endWriteSlice();
}

void
IceGrid::ObjectExistsException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    id.__read(__is);
    __is->endReadSlice();
}

void
IceGrid::ObjectExistsException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::ObjectExistsException was not generated with stream support";
    throw ex;
}

void
IceGrid::ObjectExistsException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::ObjectExistsException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__ObjectExistsException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::ObjectExistsException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__ObjectExistsException__Ptr = new __F__IceGrid__ObjectExistsException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::ObjectExistsException::ice_factory()
{
    return __F__IceGrid__ObjectExistsException__Ptr;
}

class __F__IceGrid__ObjectExistsException__Init
{
public:

    __F__IceGrid__ObjectExistsException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::ObjectExistsException", ::IceGrid::ObjectExistsException::ice_factory());
    }

    ~__F__IceGrid__ObjectExistsException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::ObjectExistsException");
    }
};

static __F__IceGrid__ObjectExistsException__Init __F__IceGrid__ObjectExistsException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__ObjectExistsException__initializer() {} }
#endif

IceGrid::ObjectNotRegisteredException::ObjectNotRegisteredException(const ::Ice::Identity& __ice_id) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    id(__ice_id)
{
}

IceGrid::ObjectNotRegisteredException::~ObjectNotRegisteredException() throw()
{
}

static const char* __IceGrid__ObjectNotRegisteredException_name = "IceGrid::ObjectNotRegisteredException";

::std::string
IceGrid::ObjectNotRegisteredException::ice_name() const
{
    return __IceGrid__ObjectNotRegisteredException_name;
}

::Ice::Exception*
IceGrid::ObjectNotRegisteredException::ice_clone() const
{
    return new ObjectNotRegisteredException(*this);
}

void
IceGrid::ObjectNotRegisteredException::ice_throw() const
{
    throw *this;
}

void
IceGrid::ObjectNotRegisteredException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::ObjectNotRegisteredException"), false);
    __os->startWriteSlice();
    id.__write(__os);
    __os->endWriteSlice();
}

void
IceGrid::ObjectNotRegisteredException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    id.__read(__is);
    __is->endReadSlice();
}

void
IceGrid::ObjectNotRegisteredException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::ObjectNotRegisteredException was not generated with stream support";
    throw ex;
}

void
IceGrid::ObjectNotRegisteredException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::ObjectNotRegisteredException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__ObjectNotRegisteredException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::ObjectNotRegisteredException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__ObjectNotRegisteredException__Ptr = new __F__IceGrid__ObjectNotRegisteredException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::ObjectNotRegisteredException::ice_factory()
{
    return __F__IceGrid__ObjectNotRegisteredException__Ptr;
}

class __F__IceGrid__ObjectNotRegisteredException__Init
{
public:

    __F__IceGrid__ObjectNotRegisteredException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::ObjectNotRegisteredException", ::IceGrid::ObjectNotRegisteredException::ice_factory());
    }

    ~__F__IceGrid__ObjectNotRegisteredException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::ObjectNotRegisteredException");
    }
};

static __F__IceGrid__ObjectNotRegisteredException__Init __F__IceGrid__ObjectNotRegisteredException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__ObjectNotRegisteredException__initializer() {} }
#endif

IceGrid::NodeNotExistException::NodeNotExistException(const ::std::string& __ice_name) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    name(__ice_name)
{
}

IceGrid::NodeNotExistException::~NodeNotExistException() throw()
{
}

static const char* __IceGrid__NodeNotExistException_name = "IceGrid::NodeNotExistException";

::std::string
IceGrid::NodeNotExistException::ice_name() const
{
    return __IceGrid__NodeNotExistException_name;
}

::Ice::Exception*
IceGrid::NodeNotExistException::ice_clone() const
{
    return new NodeNotExistException(*this);
}

void
IceGrid::NodeNotExistException::ice_throw() const
{
    throw *this;
}

void
IceGrid::NodeNotExistException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::NodeNotExistException"), false);
    __os->startWriteSlice();
    __os->write(name);
    __os->endWriteSlice();
}

void
IceGrid::NodeNotExistException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(name);
    __is->endReadSlice();
}

void
IceGrid::NodeNotExistException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::NodeNotExistException was not generated with stream support";
    throw ex;
}

void
IceGrid::NodeNotExistException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::NodeNotExistException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__NodeNotExistException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::NodeNotExistException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__NodeNotExistException__Ptr = new __F__IceGrid__NodeNotExistException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::NodeNotExistException::ice_factory()
{
    return __F__IceGrid__NodeNotExistException__Ptr;
}

class __F__IceGrid__NodeNotExistException__Init
{
public:

    __F__IceGrid__NodeNotExistException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::NodeNotExistException", ::IceGrid::NodeNotExistException::ice_factory());
    }

    ~__F__IceGrid__NodeNotExistException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::NodeNotExistException");
    }
};

static __F__IceGrid__NodeNotExistException__Init __F__IceGrid__NodeNotExistException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__NodeNotExistException__initializer() {} }
#endif

IceGrid::RegistryNotExistException::RegistryNotExistException(const ::std::string& __ice_name) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    name(__ice_name)
{
}

IceGrid::RegistryNotExistException::~RegistryNotExistException() throw()
{
}

static const char* __IceGrid__RegistryNotExistException_name = "IceGrid::RegistryNotExistException";

::std::string
IceGrid::RegistryNotExistException::ice_name() const
{
    return __IceGrid__RegistryNotExistException_name;
}

::Ice::Exception*
IceGrid::RegistryNotExistException::ice_clone() const
{
    return new RegistryNotExistException(*this);
}

void
IceGrid::RegistryNotExistException::ice_throw() const
{
    throw *this;
}

void
IceGrid::RegistryNotExistException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::RegistryNotExistException"), false);
    __os->startWriteSlice();
    __os->write(name);
    __os->endWriteSlice();
}

void
IceGrid::RegistryNotExistException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(name);
    __is->endReadSlice();
}

void
IceGrid::RegistryNotExistException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::RegistryNotExistException was not generated with stream support";
    throw ex;
}

void
IceGrid::RegistryNotExistException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::RegistryNotExistException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__RegistryNotExistException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::RegistryNotExistException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__RegistryNotExistException__Ptr = new __F__IceGrid__RegistryNotExistException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::RegistryNotExistException::ice_factory()
{
    return __F__IceGrid__RegistryNotExistException__Ptr;
}

class __F__IceGrid__RegistryNotExistException__Init
{
public:

    __F__IceGrid__RegistryNotExistException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::RegistryNotExistException", ::IceGrid::RegistryNotExistException::ice_factory());
    }

    ~__F__IceGrid__RegistryNotExistException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::RegistryNotExistException");
    }
};

static __F__IceGrid__RegistryNotExistException__Init __F__IceGrid__RegistryNotExistException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__RegistryNotExistException__initializer() {} }
#endif

IceGrid::DeploymentException::DeploymentException(const ::std::string& __ice_reason) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    reason(__ice_reason)
{
}

IceGrid::DeploymentException::~DeploymentException() throw()
{
}

static const char* __IceGrid__DeploymentException_name = "IceGrid::DeploymentException";

::std::string
IceGrid::DeploymentException::ice_name() const
{
    return __IceGrid__DeploymentException_name;
}

::Ice::Exception*
IceGrid::DeploymentException::ice_clone() const
{
    return new DeploymentException(*this);
}

void
IceGrid::DeploymentException::ice_throw() const
{
    throw *this;
}

void
IceGrid::DeploymentException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::DeploymentException"), false);
    __os->startWriteSlice();
    __os->write(reason);
    __os->endWriteSlice();
}

void
IceGrid::DeploymentException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(reason);
    __is->endReadSlice();
}

void
IceGrid::DeploymentException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::DeploymentException was not generated with stream support";
    throw ex;
}

void
IceGrid::DeploymentException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::DeploymentException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__DeploymentException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::DeploymentException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__DeploymentException__Ptr = new __F__IceGrid__DeploymentException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::DeploymentException::ice_factory()
{
    return __F__IceGrid__DeploymentException__Ptr;
}

class __F__IceGrid__DeploymentException__Init
{
public:

    __F__IceGrid__DeploymentException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::DeploymentException", ::IceGrid::DeploymentException::ice_factory());
    }

    ~__F__IceGrid__DeploymentException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::DeploymentException");
    }
};

static __F__IceGrid__DeploymentException__Init __F__IceGrid__DeploymentException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__DeploymentException__initializer() {} }
#endif

IceGrid::NodeUnreachableException::NodeUnreachableException(const ::std::string& __ice_name, const ::std::string& __ice_reason) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    name(__ice_name),
    reason(__ice_reason)
{
}

IceGrid::NodeUnreachableException::~NodeUnreachableException() throw()
{
}

static const char* __IceGrid__NodeUnreachableException_name = "IceGrid::NodeUnreachableException";

::std::string
IceGrid::NodeUnreachableException::ice_name() const
{
    return __IceGrid__NodeUnreachableException_name;
}

::Ice::Exception*
IceGrid::NodeUnreachableException::ice_clone() const
{
    return new NodeUnreachableException(*this);
}

void
IceGrid::NodeUnreachableException::ice_throw() const
{
    throw *this;
}

void
IceGrid::NodeUnreachableException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::NodeUnreachableException"), false);
    __os->startWriteSlice();
    __os->write(name);
    __os->write(reason);
    __os->endWriteSlice();
}

void
IceGrid::NodeUnreachableException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(name);
    __is->read(reason);
    __is->endReadSlice();
}

void
IceGrid::NodeUnreachableException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::NodeUnreachableException was not generated with stream support";
    throw ex;
}

void
IceGrid::NodeUnreachableException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::NodeUnreachableException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__NodeUnreachableException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::NodeUnreachableException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__NodeUnreachableException__Ptr = new __F__IceGrid__NodeUnreachableException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::NodeUnreachableException::ice_factory()
{
    return __F__IceGrid__NodeUnreachableException__Ptr;
}

class __F__IceGrid__NodeUnreachableException__Init
{
public:

    __F__IceGrid__NodeUnreachableException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::NodeUnreachableException", ::IceGrid::NodeUnreachableException::ice_factory());
    }

    ~__F__IceGrid__NodeUnreachableException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::NodeUnreachableException");
    }
};

static __F__IceGrid__NodeUnreachableException__Init __F__IceGrid__NodeUnreachableException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__NodeUnreachableException__initializer() {} }
#endif

IceGrid::ServerUnreachableException::ServerUnreachableException(const ::std::string& __ice_name, const ::std::string& __ice_reason) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    name(__ice_name),
    reason(__ice_reason)
{
}

IceGrid::ServerUnreachableException::~ServerUnreachableException() throw()
{
}

static const char* __IceGrid__ServerUnreachableException_name = "IceGrid::ServerUnreachableException";

::std::string
IceGrid::ServerUnreachableException::ice_name() const
{
    return __IceGrid__ServerUnreachableException_name;
}

::Ice::Exception*
IceGrid::ServerUnreachableException::ice_clone() const
{
    return new ServerUnreachableException(*this);
}

void
IceGrid::ServerUnreachableException::ice_throw() const
{
    throw *this;
}

void
IceGrid::ServerUnreachableException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::ServerUnreachableException"), false);
    __os->startWriteSlice();
    __os->write(name);
    __os->write(reason);
    __os->endWriteSlice();
}

void
IceGrid::ServerUnreachableException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(name);
    __is->read(reason);
    __is->endReadSlice();
}

void
IceGrid::ServerUnreachableException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::ServerUnreachableException was not generated with stream support";
    throw ex;
}

void
IceGrid::ServerUnreachableException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::ServerUnreachableException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__ServerUnreachableException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::ServerUnreachableException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__ServerUnreachableException__Ptr = new __F__IceGrid__ServerUnreachableException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::ServerUnreachableException::ice_factory()
{
    return __F__IceGrid__ServerUnreachableException__Ptr;
}

class __F__IceGrid__ServerUnreachableException__Init
{
public:

    __F__IceGrid__ServerUnreachableException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::ServerUnreachableException", ::IceGrid::ServerUnreachableException::ice_factory());
    }

    ~__F__IceGrid__ServerUnreachableException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::ServerUnreachableException");
    }
};

static __F__IceGrid__ServerUnreachableException__Init __F__IceGrid__ServerUnreachableException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__ServerUnreachableException__initializer() {} }
#endif

IceGrid::RegistryUnreachableException::RegistryUnreachableException(const ::std::string& __ice_name, const ::std::string& __ice_reason) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    name(__ice_name),
    reason(__ice_reason)
{
}

IceGrid::RegistryUnreachableException::~RegistryUnreachableException() throw()
{
}

static const char* __IceGrid__RegistryUnreachableException_name = "IceGrid::RegistryUnreachableException";

::std::string
IceGrid::RegistryUnreachableException::ice_name() const
{
    return __IceGrid__RegistryUnreachableException_name;
}

::Ice::Exception*
IceGrid::RegistryUnreachableException::ice_clone() const
{
    return new RegistryUnreachableException(*this);
}

void
IceGrid::RegistryUnreachableException::ice_throw() const
{
    throw *this;
}

void
IceGrid::RegistryUnreachableException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::RegistryUnreachableException"), false);
    __os->startWriteSlice();
    __os->write(name);
    __os->write(reason);
    __os->endWriteSlice();
}

void
IceGrid::RegistryUnreachableException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(name);
    __is->read(reason);
    __is->endReadSlice();
}

void
IceGrid::RegistryUnreachableException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::RegistryUnreachableException was not generated with stream support";
    throw ex;
}

void
IceGrid::RegistryUnreachableException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::RegistryUnreachableException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__RegistryUnreachableException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::RegistryUnreachableException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__RegistryUnreachableException__Ptr = new __F__IceGrid__RegistryUnreachableException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::RegistryUnreachableException::ice_factory()
{
    return __F__IceGrid__RegistryUnreachableException__Ptr;
}

class __F__IceGrid__RegistryUnreachableException__Init
{
public:

    __F__IceGrid__RegistryUnreachableException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::RegistryUnreachableException", ::IceGrid::RegistryUnreachableException::ice_factory());
    }

    ~__F__IceGrid__RegistryUnreachableException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::RegistryUnreachableException");
    }
};

static __F__IceGrid__RegistryUnreachableException__Init __F__IceGrid__RegistryUnreachableException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__RegistryUnreachableException__initializer() {} }
#endif

IceGrid::BadSignalException::BadSignalException(const ::std::string& __ice_reason) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    reason(__ice_reason)
{
}

IceGrid::BadSignalException::~BadSignalException() throw()
{
}

static const char* __IceGrid__BadSignalException_name = "IceGrid::BadSignalException";

::std::string
IceGrid::BadSignalException::ice_name() const
{
    return __IceGrid__BadSignalException_name;
}

::Ice::Exception*
IceGrid::BadSignalException::ice_clone() const
{
    return new BadSignalException(*this);
}

void
IceGrid::BadSignalException::ice_throw() const
{
    throw *this;
}

void
IceGrid::BadSignalException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::BadSignalException"), false);
    __os->startWriteSlice();
    __os->write(reason);
    __os->endWriteSlice();
}

void
IceGrid::BadSignalException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(reason);
    __is->endReadSlice();
}

void
IceGrid::BadSignalException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::BadSignalException was not generated with stream support";
    throw ex;
}

void
IceGrid::BadSignalException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::BadSignalException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__BadSignalException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::BadSignalException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__BadSignalException__Ptr = new __F__IceGrid__BadSignalException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::BadSignalException::ice_factory()
{
    return __F__IceGrid__BadSignalException__Ptr;
}

class __F__IceGrid__BadSignalException__Init
{
public:

    __F__IceGrid__BadSignalException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::BadSignalException", ::IceGrid::BadSignalException::ice_factory());
    }

    ~__F__IceGrid__BadSignalException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::BadSignalException");
    }
};

static __F__IceGrid__BadSignalException__Init __F__IceGrid__BadSignalException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__BadSignalException__initializer() {} }
#endif

IceGrid::PatchException::PatchException(const ::Ice::StringSeq& __ice_reasons) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    reasons(__ice_reasons)
{
}

IceGrid::PatchException::~PatchException() throw()
{
}

static const char* __IceGrid__PatchException_name = "IceGrid::PatchException";

::std::string
IceGrid::PatchException::ice_name() const
{
    return __IceGrid__PatchException_name;
}

::Ice::Exception*
IceGrid::PatchException::ice_clone() const
{
    return new PatchException(*this);
}

void
IceGrid::PatchException::ice_throw() const
{
    throw *this;
}

void
IceGrid::PatchException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::PatchException"), false);
    __os->startWriteSlice();
    if(reasons.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        __os->write(&reasons[0], &reasons[0] + reasons.size());
    }
    __os->endWriteSlice();
}

void
IceGrid::PatchException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(reasons);
    __is->endReadSlice();
}

void
IceGrid::PatchException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::PatchException was not generated with stream support";
    throw ex;
}

void
IceGrid::PatchException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::PatchException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__PatchException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::PatchException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__PatchException__Ptr = new __F__IceGrid__PatchException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::PatchException::ice_factory()
{
    return __F__IceGrid__PatchException__Ptr;
}

class __F__IceGrid__PatchException__Init
{
public:

    __F__IceGrid__PatchException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::PatchException", ::IceGrid::PatchException::ice_factory());
    }

    ~__F__IceGrid__PatchException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::PatchException");
    }
};

static __F__IceGrid__PatchException__Init __F__IceGrid__PatchException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__PatchException__initializer() {} }
#endif

IceGrid::AccessDeniedException::AccessDeniedException(const ::std::string& __ice_lockUserId) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    lockUserId(__ice_lockUserId)
{
}

IceGrid::AccessDeniedException::~AccessDeniedException() throw()
{
}

static const char* __IceGrid__AccessDeniedException_name = "IceGrid::AccessDeniedException";

::std::string
IceGrid::AccessDeniedException::ice_name() const
{
    return __IceGrid__AccessDeniedException_name;
}

::Ice::Exception*
IceGrid::AccessDeniedException::ice_clone() const
{
    return new AccessDeniedException(*this);
}

void
IceGrid::AccessDeniedException::ice_throw() const
{
    throw *this;
}

void
IceGrid::AccessDeniedException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::AccessDeniedException"), false);
    __os->startWriteSlice();
    __os->write(lockUserId);
    __os->endWriteSlice();
}

void
IceGrid::AccessDeniedException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(lockUserId);
    __is->endReadSlice();
}

void
IceGrid::AccessDeniedException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::AccessDeniedException was not generated with stream support";
    throw ex;
}

void
IceGrid::AccessDeniedException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::AccessDeniedException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__AccessDeniedException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::AccessDeniedException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__AccessDeniedException__Ptr = new __F__IceGrid__AccessDeniedException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::AccessDeniedException::ice_factory()
{
    return __F__IceGrid__AccessDeniedException__Ptr;
}

class __F__IceGrid__AccessDeniedException__Init
{
public:

    __F__IceGrid__AccessDeniedException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::AccessDeniedException", ::IceGrid::AccessDeniedException::ice_factory());
    }

    ~__F__IceGrid__AccessDeniedException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::AccessDeniedException");
    }
};

static __F__IceGrid__AccessDeniedException__Init __F__IceGrid__AccessDeniedException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__AccessDeniedException__initializer() {} }
#endif

IceGrid::AllocationException::AllocationException(const ::std::string& __ice_reason) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    reason(__ice_reason)
{
}

IceGrid::AllocationException::~AllocationException() throw()
{
}

static const char* __IceGrid__AllocationException_name = "IceGrid::AllocationException";

::std::string
IceGrid::AllocationException::ice_name() const
{
    return __IceGrid__AllocationException_name;
}

::Ice::Exception*
IceGrid::AllocationException::ice_clone() const
{
    return new AllocationException(*this);
}

void
IceGrid::AllocationException::ice_throw() const
{
    throw *this;
}

void
IceGrid::AllocationException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::AllocationException"), false);
    __os->startWriteSlice();
    __os->write(reason);
    __os->endWriteSlice();
}

void
IceGrid::AllocationException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(reason);
    __is->endReadSlice();
}

void
IceGrid::AllocationException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::AllocationException was not generated with stream support";
    throw ex;
}

void
IceGrid::AllocationException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::AllocationException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__AllocationException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::AllocationException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__AllocationException__Ptr = new __F__IceGrid__AllocationException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::AllocationException::ice_factory()
{
    return __F__IceGrid__AllocationException__Ptr;
}

class __F__IceGrid__AllocationException__Init
{
public:

    __F__IceGrid__AllocationException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::AllocationException", ::IceGrid::AllocationException::ice_factory());
    }

    ~__F__IceGrid__AllocationException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::AllocationException");
    }
};

static __F__IceGrid__AllocationException__Init __F__IceGrid__AllocationException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__AllocationException__initializer() {} }
#endif

IceGrid::AllocationTimeoutException::AllocationTimeoutException(const ::std::string& __ice_reason) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    AllocationException(__ice_reason)
#else
    ::IceGrid::AllocationException(__ice_reason)
#endif
{
}

IceGrid::AllocationTimeoutException::~AllocationTimeoutException() throw()
{
}

static const char* __IceGrid__AllocationTimeoutException_name = "IceGrid::AllocationTimeoutException";

::std::string
IceGrid::AllocationTimeoutException::ice_name() const
{
    return __IceGrid__AllocationTimeoutException_name;
}

::Ice::Exception*
IceGrid::AllocationTimeoutException::ice_clone() const
{
    return new AllocationTimeoutException(*this);
}

void
IceGrid::AllocationTimeoutException::ice_throw() const
{
    throw *this;
}

void
IceGrid::AllocationTimeoutException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::AllocationTimeoutException"), false);
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    AllocationException::__write(__os);
#else
    ::IceGrid::AllocationException::__write(__os);
#endif
}

void
IceGrid::AllocationTimeoutException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    AllocationException::__read(__is, true);
#else
    ::IceGrid::AllocationException::__read(__is, true);
#endif
}

void
IceGrid::AllocationTimeoutException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::AllocationTimeoutException was not generated with stream support";
    throw ex;
}

void
IceGrid::AllocationTimeoutException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::AllocationTimeoutException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__AllocationTimeoutException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::AllocationTimeoutException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__AllocationTimeoutException__Ptr = new __F__IceGrid__AllocationTimeoutException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::AllocationTimeoutException::ice_factory()
{
    return __F__IceGrid__AllocationTimeoutException__Ptr;
}

class __F__IceGrid__AllocationTimeoutException__Init
{
public:

    __F__IceGrid__AllocationTimeoutException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::AllocationTimeoutException", ::IceGrid::AllocationTimeoutException::ice_factory());
    }

    ~__F__IceGrid__AllocationTimeoutException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::AllocationTimeoutException");
    }
};

static __F__IceGrid__AllocationTimeoutException__Init __F__IceGrid__AllocationTimeoutException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__AllocationTimeoutException__initializer() {} }
#endif

IceGrid::PermissionDeniedException::PermissionDeniedException(const ::std::string& __ice_reason) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    reason(__ice_reason)
{
}

IceGrid::PermissionDeniedException::~PermissionDeniedException() throw()
{
}

static const char* __IceGrid__PermissionDeniedException_name = "IceGrid::PermissionDeniedException";

::std::string
IceGrid::PermissionDeniedException::ice_name() const
{
    return __IceGrid__PermissionDeniedException_name;
}

::Ice::Exception*
IceGrid::PermissionDeniedException::ice_clone() const
{
    return new PermissionDeniedException(*this);
}

void
IceGrid::PermissionDeniedException::ice_throw() const
{
    throw *this;
}

void
IceGrid::PermissionDeniedException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::PermissionDeniedException"), false);
    __os->startWriteSlice();
    __os->write(reason);
    __os->endWriteSlice();
}

void
IceGrid::PermissionDeniedException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(reason);
    __is->endReadSlice();
}

void
IceGrid::PermissionDeniedException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::PermissionDeniedException was not generated with stream support";
    throw ex;
}

void
IceGrid::PermissionDeniedException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::PermissionDeniedException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__PermissionDeniedException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::PermissionDeniedException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__PermissionDeniedException__Ptr = new __F__IceGrid__PermissionDeniedException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::PermissionDeniedException::ice_factory()
{
    return __F__IceGrid__PermissionDeniedException__Ptr;
}

class __F__IceGrid__PermissionDeniedException__Init
{
public:

    __F__IceGrid__PermissionDeniedException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::PermissionDeniedException", ::IceGrid::PermissionDeniedException::ice_factory());
    }

    ~__F__IceGrid__PermissionDeniedException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::PermissionDeniedException");
    }
};

static __F__IceGrid__PermissionDeniedException__Init __F__IceGrid__PermissionDeniedException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__PermissionDeniedException__initializer() {} }
#endif

IceGrid::ObserverAlreadyRegisteredException::ObserverAlreadyRegisteredException(const ::Ice::Identity& __ice_id) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    id(__ice_id)
{
}

IceGrid::ObserverAlreadyRegisteredException::~ObserverAlreadyRegisteredException() throw()
{
}

static const char* __IceGrid__ObserverAlreadyRegisteredException_name = "IceGrid::ObserverAlreadyRegisteredException";

::std::string
IceGrid::ObserverAlreadyRegisteredException::ice_name() const
{
    return __IceGrid__ObserverAlreadyRegisteredException_name;
}

::Ice::Exception*
IceGrid::ObserverAlreadyRegisteredException::ice_clone() const
{
    return new ObserverAlreadyRegisteredException(*this);
}

void
IceGrid::ObserverAlreadyRegisteredException::ice_throw() const
{
    throw *this;
}

void
IceGrid::ObserverAlreadyRegisteredException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::ObserverAlreadyRegisteredException"), false);
    __os->startWriteSlice();
    id.__write(__os);
    __os->endWriteSlice();
}

void
IceGrid::ObserverAlreadyRegisteredException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    id.__read(__is);
    __is->endReadSlice();
}

void
IceGrid::ObserverAlreadyRegisteredException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::ObserverAlreadyRegisteredException was not generated with stream support";
    throw ex;
}

void
IceGrid::ObserverAlreadyRegisteredException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::ObserverAlreadyRegisteredException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__ObserverAlreadyRegisteredException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::ObserverAlreadyRegisteredException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__ObserverAlreadyRegisteredException__Ptr = new __F__IceGrid__ObserverAlreadyRegisteredException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::ObserverAlreadyRegisteredException::ice_factory()
{
    return __F__IceGrid__ObserverAlreadyRegisteredException__Ptr;
}

class __F__IceGrid__ObserverAlreadyRegisteredException__Init
{
public:

    __F__IceGrid__ObserverAlreadyRegisteredException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::ObserverAlreadyRegisteredException", ::IceGrid::ObserverAlreadyRegisteredException::ice_factory());
    }

    ~__F__IceGrid__ObserverAlreadyRegisteredException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::ObserverAlreadyRegisteredException");
    }
};

static __F__IceGrid__ObserverAlreadyRegisteredException__Init __F__IceGrid__ObserverAlreadyRegisteredException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__ObserverAlreadyRegisteredException__initializer() {} }
#endif

IceGrid::FileNotAvailableException::FileNotAvailableException(const ::std::string& __ice_reason) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    reason(__ice_reason)
{
}

IceGrid::FileNotAvailableException::~FileNotAvailableException() throw()
{
}

static const char* __IceGrid__FileNotAvailableException_name = "IceGrid::FileNotAvailableException";

::std::string
IceGrid::FileNotAvailableException::ice_name() const
{
    return __IceGrid__FileNotAvailableException_name;
}

::Ice::Exception*
IceGrid::FileNotAvailableException::ice_clone() const
{
    return new FileNotAvailableException(*this);
}

void
IceGrid::FileNotAvailableException::ice_throw() const
{
    throw *this;
}

void
IceGrid::FileNotAvailableException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::FileNotAvailableException"), false);
    __os->startWriteSlice();
    __os->write(reason);
    __os->endWriteSlice();
}

void
IceGrid::FileNotAvailableException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(reason);
    __is->endReadSlice();
}

void
IceGrid::FileNotAvailableException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::FileNotAvailableException was not generated with stream support";
    throw ex;
}

void
IceGrid::FileNotAvailableException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::FileNotAvailableException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__FileNotAvailableException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::FileNotAvailableException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__FileNotAvailableException__Ptr = new __F__IceGrid__FileNotAvailableException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::FileNotAvailableException::ice_factory()
{
    return __F__IceGrid__FileNotAvailableException__Ptr;
}

class __F__IceGrid__FileNotAvailableException__Init
{
public:

    __F__IceGrid__FileNotAvailableException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::FileNotAvailableException", ::IceGrid::FileNotAvailableException::ice_factory());
    }

    ~__F__IceGrid__FileNotAvailableException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::FileNotAvailableException");
    }
};

static __F__IceGrid__FileNotAvailableException__Init __F__IceGrid__FileNotAvailableException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__FileNotAvailableException__initializer() {} }
#endif

static const char* __sliceChecksums[] =
{
    "::IceGrid::AccessDeniedException", "e39e5ad60577c1e7b52e190e1d906b",
    "::IceGrid::AdapterNotExistException", "cee552cb69227f723030cd78b0cccc97",
    "::IceGrid::AllocationException", "ea85a8e5e5f281709bf6aa88d742",
    "::IceGrid::AllocationTimeoutException", "6695f5713499ac6de0626277e167f553",
    "::IceGrid::ApplicationNotExistException", "93fdaabe25dcf75485ffd4972223610",
    "::IceGrid::BadSignalException", "13e67e2d3f46a84aa73fd56d5812caf1",
    "::IceGrid::DeploymentException", "e316fdba8e93ef72d58bd61bbfe29e4",
    "::IceGrid::FileNotAvailableException", "a3e88ae3be93ecd4c82797ad26d6076",
    "::IceGrid::NodeNotExistException", "f07ddace1aa3cb1bbed37c3fbf862dff",
    "::IceGrid::NodeUnreachableException", "8f894a5022704f4dde30bb2a3ea326f9",
    "::IceGrid::ObjectExistsException", "833f69d3ebc872974a9f096352d2ddb",
    "::IceGrid::ObjectNotRegisteredException", "cb181c92b4dfb6e6b97f4ca806899e7",
    "::IceGrid::ObserverAlreadyRegisteredException", "e1267578f9666e2bda9952d7106fd12c",
    "::IceGrid::PatchException", "c28994d76c834b99b94cf4535a13d3",
    "::IceGrid::PermissionDeniedException", "27def8d4569ab203b629b9162d530ba",
    "::IceGrid::RegistryNotExistException", "9e1c1b717e9c5ef72886f16dbfce56f",
    "::IceGrid::RegistryUnreachableException", "514020cac28c588ae487a628e227699",
    "::IceGrid::ServerNotExistException", "6df151f3ce87bd522ed095f7ad97a941",
    "::IceGrid::ServerStartException", "ce92acafa218dd1d1e8aafab20d1",
    "::IceGrid::ServerStopException", "edb57abb5393b8b31b41f3a8e5bd111",
    "::IceGrid::ServerUnreachableException", "f3233583ef7ad8eac2f961aedafdd64",
    0
};
static IceInternal::SliceChecksumInit __sliceChecksumInit(__sliceChecksums);
