// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `FileParser.ice'

#ifndef ICE_GRID_API_EXPORTS
#   define ICE_GRID_API_EXPORTS
#endif
#include <IceGrid/FileParser.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <Ice/SliceChecksums.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __IceGrid__FileParser__parse_name = "parse";

ICE_DECLSPEC_EXPORT ::Ice::Object* IceInternal::upCast(::IceGrid::FileParser* p) { return p; }
ICE_DECLSPEC_EXPORT ::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceGrid::FileParser* p) { return p; }

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::FileParserPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::FileParser;
        v->__copyFrom(proxy);
    }
}

IceGrid::ParseException::ParseException(const ::std::string& __ice_reason) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    reason(__ice_reason)
{
}

IceGrid::ParseException::~ParseException() throw()
{
}

static const char* __IceGrid__ParseException_name = "IceGrid::ParseException";

::std::string
IceGrid::ParseException::ice_name() const
{
    return __IceGrid__ParseException_name;
}

::Ice::Exception*
IceGrid::ParseException::ice_clone() const
{
    return new ParseException(*this);
}

void
IceGrid::ParseException::ice_throw() const
{
    throw *this;
}

void
IceGrid::ParseException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::ParseException"), false);
    __os->startWriteSlice();
    __os->write(reason);
    __os->endWriteSlice();
}

void
IceGrid::ParseException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(reason);
    __is->endReadSlice();
}

void
IceGrid::ParseException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::ParseException was not generated with stream support";
    throw ex;
}

void
IceGrid::ParseException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::ParseException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__ParseException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::ParseException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__ParseException__Ptr = new __F__IceGrid__ParseException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::ParseException::ice_factory()
{
    return __F__IceGrid__ParseException__Ptr;
}

class __F__IceGrid__ParseException__Init
{
public:

    __F__IceGrid__ParseException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::ParseException", ::IceGrid::ParseException::ice_factory());
    }

    ~__F__IceGrid__ParseException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::ParseException");
    }
};

static __F__IceGrid__ParseException__Init __F__IceGrid__ParseException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__ParseException__initializer() {} }
#endif
#ifdef __SUNPRO_CC
class ICE_DECLSPEC_EXPORT IceProxy::IceGrid::FileParser;
#endif

::IceGrid::ApplicationDescriptor
IceProxy::IceGrid::FileParser::parse(const ::std::string& xmlFile, const ::IceGrid::AdminPrx& adminProxy, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__FileParser__parse_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::FileParser* __del = dynamic_cast< ::IceDelegate::IceGrid::FileParser*>(__delBase.get());
            return __del->parse(xmlFile, adminProxy, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::FileParser::ice_staticId()
{
    return ::IceGrid::FileParser::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::FileParser::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::FileParser);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::FileParser::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::FileParser);
}

::IceProxy::Ice::Object*
IceProxy::IceGrid::FileParser::__newInstance() const
{
    return new FileParser;
}

::IceGrid::ApplicationDescriptor
IceDelegateM::IceGrid::FileParser::parse(const ::std::string& xmlFile, const ::IceGrid::AdminPrx& adminProxy, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__FileParser__parse_name, ::Ice::Idempotent, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(xmlFile);
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(adminProxy.get())));
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    ::IceGrid::ApplicationDescriptor __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::IceGrid::ParseException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __ret.__read(__is);
        __is->readPendingObjects();
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceGrid::ApplicationDescriptor
IceDelegateD::IceGrid::FileParser::parse(const ::std::string& xmlFile, const ::IceGrid::AdminPrx& adminProxy, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::IceGrid::ApplicationDescriptor& __result, const ::std::string& xmlFile, const ::IceGrid::AdminPrx& adminProxy, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_xmlFile(xmlFile),
            _m_adminProxy(adminProxy)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::FileParser* servant = dynamic_cast< ::IceGrid::FileParser*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                _result = servant->parse(_m_xmlFile, _m_adminProxy, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        ::IceGrid::ApplicationDescriptor& _result;
        const ::std::string& _m_xmlFile;
        const ::IceGrid::AdminPrx& _m_adminProxy;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__FileParser__parse_name, ::Ice::Idempotent, __context);
    ::IceGrid::ApplicationDescriptor __result;
    try
    {
        _DirectI __direct(__result, xmlFile, adminProxy, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::IceGrid::ParseException&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Ice::ObjectPtr
IceGrid::FileParser::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__FileParser_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::FileParser"
};

bool
IceGrid::FileParser::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__FileParser_ids, __IceGrid__FileParser_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::FileParser::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__FileParser_ids[0], &__IceGrid__FileParser_ids[2]);
}

const ::std::string&
IceGrid::FileParser::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__FileParser_ids[1];
}

const ::std::string&
IceGrid::FileParser::ice_staticId()
{
    return __IceGrid__FileParser_ids[1];
}

::Ice::DispatchStatus
IceGrid::FileParser::___parse(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string xmlFile;
    ::IceGrid::AdminPrx adminProxy;
    __is->read(xmlFile);
    ::IceGrid::__read(__is, adminProxy);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        ::IceGrid::ApplicationDescriptor __ret = parse(xmlFile, adminProxy, __current);
        __ret.__write(__os);
        __os->writePendingObjects();
    }
    catch(const ::IceGrid::ParseException& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

static ::std::string __IceGrid__FileParser_all[] =
{
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "parse"
};

::Ice::DispatchStatus
IceGrid::FileParser::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__FileParser_all, __IceGrid__FileParser_all + 5, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __IceGrid__FileParser_all)
    {
        case 0:
        {
            return ___ice_id(in, current);
        }
        case 1:
        {
            return ___ice_ids(in, current);
        }
        case 2:
        {
            return ___ice_isA(in, current);
        }
        case 3:
        {
            return ___ice_ping(in, current);
        }
        case 4:
        {
            return ___parse(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
IceGrid::FileParser::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::FileParser::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::FileParser::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::FileParser was not generated with stream support";
    throw ex;
}

void
IceGrid::FileParser::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::FileParser was not generated with stream support";
    throw ex;
}

void ICE_DECLSPEC_EXPORT 
IceGrid::__patch__FileParserPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::FileParserPtr* p = static_cast< ::IceGrid::FileParserPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::FileParserPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceGrid::FileParser::ice_staticId(), v->ice_id());
    }
}

bool
IceGrid::operator==(const ::IceGrid::FileParser& l, const ::IceGrid::FileParser& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::FileParser& l, const ::IceGrid::FileParser& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

static const char* __sliceChecksums[] =
{
    "::IceGrid::FileParser", "b847ccf3e3db7cbba649ec7cc464faf",
    "::IceGrid::ParseException", "dec9aacba8b3ba76afc5de1cc3489598",
    0
};
static IceInternal::SliceChecksumInit __sliceChecksumInit(__sliceChecksums);
