// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `Observer.ice'

#ifndef ICE_GRID_API_EXPORTS
#   define ICE_GRID_API_EXPORTS
#endif
#include <IceGrid/Observer.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <Ice/SliceChecksums.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __IceGrid__NodeObserver__nodeInit_name = "nodeInit";

static const ::std::string __IceGrid__NodeObserver__nodeUp_name = "nodeUp";

static const ::std::string __IceGrid__NodeObserver__nodeDown_name = "nodeDown";

static const ::std::string __IceGrid__NodeObserver__updateServer_name = "updateServer";

static const ::std::string __IceGrid__NodeObserver__updateAdapter_name = "updateAdapter";

static const ::std::string __IceGrid__ApplicationObserver__applicationInit_name = "applicationInit";

static const ::std::string __IceGrid__ApplicationObserver__applicationAdded_name = "applicationAdded";

static const ::std::string __IceGrid__ApplicationObserver__applicationRemoved_name = "applicationRemoved";

static const ::std::string __IceGrid__ApplicationObserver__applicationUpdated_name = "applicationUpdated";

static const ::std::string __IceGrid__AdapterObserver__adapterInit_name = "adapterInit";

static const ::std::string __IceGrid__AdapterObserver__adapterAdded_name = "adapterAdded";

static const ::std::string __IceGrid__AdapterObserver__adapterUpdated_name = "adapterUpdated";

static const ::std::string __IceGrid__AdapterObserver__adapterRemoved_name = "adapterRemoved";

static const ::std::string __IceGrid__ObjectObserver__objectInit_name = "objectInit";

static const ::std::string __IceGrid__ObjectObserver__objectAdded_name = "objectAdded";

static const ::std::string __IceGrid__ObjectObserver__objectUpdated_name = "objectUpdated";

static const ::std::string __IceGrid__ObjectObserver__objectRemoved_name = "objectRemoved";

static const ::std::string __IceGrid__RegistryObserver__registryInit_name = "registryInit";

static const ::std::string __IceGrid__RegistryObserver__registryUp_name = "registryUp";

static const ::std::string __IceGrid__RegistryObserver__registryDown_name = "registryDown";

ICE_DECLSPEC_EXPORT ::Ice::Object* IceInternal::upCast(::IceGrid::NodeObserver* p) { return p; }
ICE_DECLSPEC_EXPORT ::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceGrid::NodeObserver* p) { return p; }

ICE_DECLSPEC_EXPORT ::Ice::Object* IceInternal::upCast(::IceGrid::ApplicationObserver* p) { return p; }
ICE_DECLSPEC_EXPORT ::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceGrid::ApplicationObserver* p) { return p; }

ICE_DECLSPEC_EXPORT ::Ice::Object* IceInternal::upCast(::IceGrid::AdapterObserver* p) { return p; }
ICE_DECLSPEC_EXPORT ::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceGrid::AdapterObserver* p) { return p; }

ICE_DECLSPEC_EXPORT ::Ice::Object* IceInternal::upCast(::IceGrid::ObjectObserver* p) { return p; }
ICE_DECLSPEC_EXPORT ::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceGrid::ObjectObserver* p) { return p; }

ICE_DECLSPEC_EXPORT ::Ice::Object* IceInternal::upCast(::IceGrid::RegistryObserver* p) { return p; }
ICE_DECLSPEC_EXPORT ::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceGrid::RegistryObserver* p) { return p; }

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::NodeObserverPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::NodeObserver;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::ApplicationObserverPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::ApplicationObserver;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::AdapterObserverPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::AdapterObserver;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::ObjectObserverPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::ObjectObserver;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::RegistryObserverPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::RegistryObserver;
        v->__copyFrom(proxy);
    }
}

bool
IceGrid::ServerDynamicInfo::operator==(const ServerDynamicInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return true;
    }
    if(id != __rhs.id)
    {
        return false;
    }
    if(state != __rhs.state)
    {
        return false;
    }
    if(pid != __rhs.pid)
    {
        return false;
    }
    if(enabled != __rhs.enabled)
    {
        return false;
    }
    return true;
}

bool
IceGrid::ServerDynamicInfo::operator<(const ServerDynamicInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(id < __rhs.id)
    {
        return true;
    }
    else if(__rhs.id < id)
    {
        return false;
    }
    if(state < __rhs.state)
    {
        return true;
    }
    else if(__rhs.state < state)
    {
        return false;
    }
    if(pid < __rhs.pid)
    {
        return true;
    }
    else if(__rhs.pid < pid)
    {
        return false;
    }
    if(enabled < __rhs.enabled)
    {
        return true;
    }
    else if(__rhs.enabled < enabled)
    {
        return false;
    }
    return false;
}

void
IceGrid::ServerDynamicInfo::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(id);
    ::IceGrid::__write(__os, state);
    __os->write(pid);
    __os->write(enabled);
}

void
IceGrid::ServerDynamicInfo::__read(::IceInternal::BasicStream* __is)
{
    __is->read(id);
    ::IceGrid::__read(__is, state);
    __is->read(pid);
    __is->read(enabled);
}

void
IceGrid::__writeServerDynamicInfoSeq(::IceInternal::BasicStream* __os, const ::IceGrid::ServerDynamicInfo* begin, const ::IceGrid::ServerDynamicInfo* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        begin[i].__write(__os);
    }
}

void
IceGrid::__readServerDynamicInfoSeq(::IceInternal::BasicStream* __is, ::IceGrid::ServerDynamicInfoSeq& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 7);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        v[i].__read(__is);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

bool
IceGrid::AdapterDynamicInfo::operator==(const AdapterDynamicInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return true;
    }
    if(id != __rhs.id)
    {
        return false;
    }
    if(proxy != __rhs.proxy)
    {
        return false;
    }
    return true;
}

bool
IceGrid::AdapterDynamicInfo::operator<(const AdapterDynamicInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(id < __rhs.id)
    {
        return true;
    }
    else if(__rhs.id < id)
    {
        return false;
    }
    if(proxy < __rhs.proxy)
    {
        return true;
    }
    else if(__rhs.proxy < proxy)
    {
        return false;
    }
    return false;
}

void
IceGrid::AdapterDynamicInfo::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(id);
    __os->write(proxy);
}

void
IceGrid::AdapterDynamicInfo::__read(::IceInternal::BasicStream* __is)
{
    __is->read(id);
    __is->read(proxy);
}

void
IceGrid::__writeAdapterDynamicInfoSeq(::IceInternal::BasicStream* __os, const ::IceGrid::AdapterDynamicInfo* begin, const ::IceGrid::AdapterDynamicInfo* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        begin[i].__write(__os);
    }
}

void
IceGrid::__readAdapterDynamicInfoSeq(::IceInternal::BasicStream* __is, ::IceGrid::AdapterDynamicInfoSeq& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 3);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        v[i].__read(__is);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

bool
IceGrid::NodeDynamicInfo::operator==(const NodeDynamicInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return true;
    }
    if(info != __rhs.info)
    {
        return false;
    }
    if(servers != __rhs.servers)
    {
        return false;
    }
    if(adapters != __rhs.adapters)
    {
        return false;
    }
    return true;
}

bool
IceGrid::NodeDynamicInfo::operator<(const NodeDynamicInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(info < __rhs.info)
    {
        return true;
    }
    else if(__rhs.info < info)
    {
        return false;
    }
    if(servers < __rhs.servers)
    {
        return true;
    }
    else if(__rhs.servers < servers)
    {
        return false;
    }
    if(adapters < __rhs.adapters)
    {
        return true;
    }
    else if(__rhs.adapters < adapters)
    {
        return false;
    }
    return false;
}

void
IceGrid::NodeDynamicInfo::__write(::IceInternal::BasicStream* __os) const
{
    info.__write(__os);
    if(servers.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::IceGrid::__writeServerDynamicInfoSeq(__os, &servers[0], &servers[0] + servers.size());
    }
    if(adapters.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::IceGrid::__writeAdapterDynamicInfoSeq(__os, &adapters[0], &adapters[0] + adapters.size());
    }
}

void
IceGrid::NodeDynamicInfo::__read(::IceInternal::BasicStream* __is)
{
    info.__read(__is);
    ::IceGrid::__readServerDynamicInfoSeq(__is, servers);
    ::IceGrid::__readAdapterDynamicInfoSeq(__is, adapters);
}

void
IceGrid::__writeNodeDynamicInfoSeq(::IceInternal::BasicStream* __os, const ::IceGrid::NodeDynamicInfo* begin, const ::IceGrid::NodeDynamicInfo* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        begin[i].__write(__os);
    }
}

void
IceGrid::__readNodeDynamicInfoSeq(::IceInternal::BasicStream* __is, ::IceGrid::NodeDynamicInfoSeq& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 13);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        v[i].__read(__is);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

bool
IceGrid::AMI_NodeObserver_nodeInit::__invoke(const ::IceGrid::NodeObserverPrx& __prx, const ::IceGrid::NodeDynamicInfoSeq& nodes, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prepare(__prx, __IceGrid__NodeObserver__nodeInit_name, ::Ice::Normal, __ctx);
        if(nodes.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceGrid::__writeNodeDynamicInfoSeq(__os, &nodes[0], &nodes[0] + nodes.size());
        }
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceGrid::AMI_NodeObserver_nodeInit::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}

bool
IceGrid::AMI_NodeObserver_nodeUp::__invoke(const ::IceGrid::NodeObserverPrx& __prx, const ::IceGrid::NodeDynamicInfo& node, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prepare(__prx, __IceGrid__NodeObserver__nodeUp_name, ::Ice::Normal, __ctx);
        node.__write(__os);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceGrid::AMI_NodeObserver_nodeUp::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}

bool
IceGrid::AMI_NodeObserver_nodeDown::__invoke(const ::IceGrid::NodeObserverPrx& __prx, const ::std::string& name, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prepare(__prx, __IceGrid__NodeObserver__nodeDown_name, ::Ice::Normal, __ctx);
        __os->write(name);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceGrid::AMI_NodeObserver_nodeDown::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}

bool
IceGrid::AMI_NodeObserver_updateServer::__invoke(const ::IceGrid::NodeObserverPrx& __prx, const ::std::string& node, const ::IceGrid::ServerDynamicInfo& updatedInfo, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prepare(__prx, __IceGrid__NodeObserver__updateServer_name, ::Ice::Normal, __ctx);
        __os->write(node);
        updatedInfo.__write(__os);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceGrid::AMI_NodeObserver_updateServer::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}

bool
IceGrid::AMI_NodeObserver_updateAdapter::__invoke(const ::IceGrid::NodeObserverPrx& __prx, const ::std::string& node, const ::IceGrid::AdapterDynamicInfo& updatedInfo, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prepare(__prx, __IceGrid__NodeObserver__updateAdapter_name, ::Ice::Normal, __ctx);
        __os->write(node);
        updatedInfo.__write(__os);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceGrid::AMI_NodeObserver_updateAdapter::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}

bool
IceGrid::AMI_ApplicationObserver_applicationInit::__invoke(const ::IceGrid::ApplicationObserverPrx& __prx, ::Ice::Int serial, const ::IceGrid::ApplicationInfoSeq& applications, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prepare(__prx, __IceGrid__ApplicationObserver__applicationInit_name, ::Ice::Normal, __ctx);
        __os->write(serial);
        if(applications.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceGrid::__writeApplicationInfoSeq(__os, &applications[0], &applications[0] + applications.size());
        }
        __os->writePendingObjects();
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceGrid::AMI_ApplicationObserver_applicationInit::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}

bool
IceGrid::AMI_AdapterObserver_adapterInit::__invoke(const ::IceGrid::AdapterObserverPrx& __prx, const ::IceGrid::AdapterInfoSeq& adpts, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prepare(__prx, __IceGrid__AdapterObserver__adapterInit_name, ::Ice::Normal, __ctx);
        if(adpts.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceGrid::__writeAdapterInfoSeq(__os, &adpts[0], &adpts[0] + adpts.size());
        }
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceGrid::AMI_AdapterObserver_adapterInit::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}

bool
IceGrid::AMI_ObjectObserver_objectInit::__invoke(const ::IceGrid::ObjectObserverPrx& __prx, const ::IceGrid::ObjectInfoSeq& objects, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prepare(__prx, __IceGrid__ObjectObserver__objectInit_name, ::Ice::Normal, __ctx);
        if(objects.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceGrid::__writeObjectInfoSeq(__os, &objects[0], &objects[0] + objects.size());
        }
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceGrid::AMI_ObjectObserver_objectInit::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}

bool
IceGrid::AMI_RegistryObserver_registryInit::__invoke(const ::IceGrid::RegistryObserverPrx& __prx, const ::IceGrid::RegistryInfoSeq& registries, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prepare(__prx, __IceGrid__RegistryObserver__registryInit_name, ::Ice::Normal, __ctx);
        if(registries.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceGrid::__writeRegistryInfoSeq(__os, &registries[0], &registries[0] + registries.size());
        }
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceGrid::AMI_RegistryObserver_registryInit::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}
#ifdef __SUNPRO_CC
class ICE_DECLSPEC_EXPORT IceProxy::IceGrid::NodeObserver;
#endif

void
IceProxy::IceGrid::NodeObserver::nodeInit(const ::IceGrid::NodeDynamicInfoSeq& nodes, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::NodeObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::NodeObserver*>(__delBase.get());
            __del->nodeInit(nodes, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::NodeObserver::nodeInit_async(const ::IceGrid::AMI_NodeObserver_nodeInitPtr& __cb, const ::IceGrid::NodeDynamicInfoSeq& nodes)
{
    return __cb->__invoke(this, nodes, 0);
}

bool
IceProxy::IceGrid::NodeObserver::nodeInit_async(const ::IceGrid::AMI_NodeObserver_nodeInitPtr& __cb, const ::IceGrid::NodeDynamicInfoSeq& nodes, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, nodes, &__ctx);
}

void
IceProxy::IceGrid::NodeObserver::nodeUp(const ::IceGrid::NodeDynamicInfo& node, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::NodeObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::NodeObserver*>(__delBase.get());
            __del->nodeUp(node, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::NodeObserver::nodeUp_async(const ::IceGrid::AMI_NodeObserver_nodeUpPtr& __cb, const ::IceGrid::NodeDynamicInfo& node)
{
    return __cb->__invoke(this, node, 0);
}

bool
IceProxy::IceGrid::NodeObserver::nodeUp_async(const ::IceGrid::AMI_NodeObserver_nodeUpPtr& __cb, const ::IceGrid::NodeDynamicInfo& node, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, node, &__ctx);
}

void
IceProxy::IceGrid::NodeObserver::nodeDown(const ::std::string& name, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::NodeObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::NodeObserver*>(__delBase.get());
            __del->nodeDown(name, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::NodeObserver::nodeDown_async(const ::IceGrid::AMI_NodeObserver_nodeDownPtr& __cb, const ::std::string& name)
{
    return __cb->__invoke(this, name, 0);
}

bool
IceProxy::IceGrid::NodeObserver::nodeDown_async(const ::IceGrid::AMI_NodeObserver_nodeDownPtr& __cb, const ::std::string& name, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, name, &__ctx);
}

void
IceProxy::IceGrid::NodeObserver::updateServer(const ::std::string& node, const ::IceGrid::ServerDynamicInfo& updatedInfo, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::NodeObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::NodeObserver*>(__delBase.get());
            __del->updateServer(node, updatedInfo, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::NodeObserver::updateServer_async(const ::IceGrid::AMI_NodeObserver_updateServerPtr& __cb, const ::std::string& node, const ::IceGrid::ServerDynamicInfo& updatedInfo)
{
    return __cb->__invoke(this, node, updatedInfo, 0);
}

bool
IceProxy::IceGrid::NodeObserver::updateServer_async(const ::IceGrid::AMI_NodeObserver_updateServerPtr& __cb, const ::std::string& node, const ::IceGrid::ServerDynamicInfo& updatedInfo, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, node, updatedInfo, &__ctx);
}

void
IceProxy::IceGrid::NodeObserver::updateAdapter(const ::std::string& node, const ::IceGrid::AdapterDynamicInfo& updatedInfo, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::NodeObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::NodeObserver*>(__delBase.get());
            __del->updateAdapter(node, updatedInfo, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::NodeObserver::updateAdapter_async(const ::IceGrid::AMI_NodeObserver_updateAdapterPtr& __cb, const ::std::string& node, const ::IceGrid::AdapterDynamicInfo& updatedInfo)
{
    return __cb->__invoke(this, node, updatedInfo, 0);
}

bool
IceProxy::IceGrid::NodeObserver::updateAdapter_async(const ::IceGrid::AMI_NodeObserver_updateAdapterPtr& __cb, const ::std::string& node, const ::IceGrid::AdapterDynamicInfo& updatedInfo, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, node, updatedInfo, &__ctx);
}

const ::std::string&
IceProxy::IceGrid::NodeObserver::ice_staticId()
{
    return ::IceGrid::NodeObserver::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::NodeObserver::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::NodeObserver);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::NodeObserver::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::NodeObserver);
}

::IceProxy::Ice::Object*
IceProxy::IceGrid::NodeObserver::__newInstance() const
{
    return new NodeObserver;
}
#ifdef __SUNPRO_CC
class ICE_DECLSPEC_EXPORT IceProxy::IceGrid::ApplicationObserver;
#endif

void
IceProxy::IceGrid::ApplicationObserver::applicationInit(::Ice::Int serial, const ::IceGrid::ApplicationInfoSeq& applications, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::ApplicationObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::ApplicationObserver*>(__delBase.get());
            __del->applicationInit(serial, applications, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::ApplicationObserver::applicationInit_async(const ::IceGrid::AMI_ApplicationObserver_applicationInitPtr& __cb, ::Ice::Int serial, const ::IceGrid::ApplicationInfoSeq& applications)
{
    return __cb->__invoke(this, serial, applications, 0);
}

bool
IceProxy::IceGrid::ApplicationObserver::applicationInit_async(const ::IceGrid::AMI_ApplicationObserver_applicationInitPtr& __cb, ::Ice::Int serial, const ::IceGrid::ApplicationInfoSeq& applications, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, serial, applications, &__ctx);
}

void
IceProxy::IceGrid::ApplicationObserver::applicationAdded(::Ice::Int serial, const ::IceGrid::ApplicationInfo& desc, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::ApplicationObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::ApplicationObserver*>(__delBase.get());
            __del->applicationAdded(serial, desc, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceGrid::ApplicationObserver::applicationRemoved(::Ice::Int serial, const ::std::string& name, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::ApplicationObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::ApplicationObserver*>(__delBase.get());
            __del->applicationRemoved(serial, name, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceGrid::ApplicationObserver::applicationUpdated(::Ice::Int serial, const ::IceGrid::ApplicationUpdateInfo& desc, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::ApplicationObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::ApplicationObserver*>(__delBase.get());
            __del->applicationUpdated(serial, desc, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::ApplicationObserver::ice_staticId()
{
    return ::IceGrid::ApplicationObserver::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::ApplicationObserver::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::ApplicationObserver);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::ApplicationObserver::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::ApplicationObserver);
}

::IceProxy::Ice::Object*
IceProxy::IceGrid::ApplicationObserver::__newInstance() const
{
    return new ApplicationObserver;
}
#ifdef __SUNPRO_CC
class ICE_DECLSPEC_EXPORT IceProxy::IceGrid::AdapterObserver;
#endif

void
IceProxy::IceGrid::AdapterObserver::adapterInit(const ::IceGrid::AdapterInfoSeq& adpts, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::AdapterObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::AdapterObserver*>(__delBase.get());
            __del->adapterInit(adpts, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::AdapterObserver::adapterInit_async(const ::IceGrid::AMI_AdapterObserver_adapterInitPtr& __cb, const ::IceGrid::AdapterInfoSeq& adpts)
{
    return __cb->__invoke(this, adpts, 0);
}

bool
IceProxy::IceGrid::AdapterObserver::adapterInit_async(const ::IceGrid::AMI_AdapterObserver_adapterInitPtr& __cb, const ::IceGrid::AdapterInfoSeq& adpts, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, adpts, &__ctx);
}

void
IceProxy::IceGrid::AdapterObserver::adapterAdded(const ::IceGrid::AdapterInfo& info, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::AdapterObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::AdapterObserver*>(__delBase.get());
            __del->adapterAdded(info, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceGrid::AdapterObserver::adapterUpdated(const ::IceGrid::AdapterInfo& info, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::AdapterObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::AdapterObserver*>(__delBase.get());
            __del->adapterUpdated(info, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceGrid::AdapterObserver::adapterRemoved(const ::std::string& id, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::AdapterObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::AdapterObserver*>(__delBase.get());
            __del->adapterRemoved(id, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::AdapterObserver::ice_staticId()
{
    return ::IceGrid::AdapterObserver::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::AdapterObserver::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::AdapterObserver);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::AdapterObserver::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::AdapterObserver);
}

::IceProxy::Ice::Object*
IceProxy::IceGrid::AdapterObserver::__newInstance() const
{
    return new AdapterObserver;
}
#ifdef __SUNPRO_CC
class ICE_DECLSPEC_EXPORT IceProxy::IceGrid::ObjectObserver;
#endif

void
IceProxy::IceGrid::ObjectObserver::objectInit(const ::IceGrid::ObjectInfoSeq& objects, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::ObjectObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::ObjectObserver*>(__delBase.get());
            __del->objectInit(objects, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::ObjectObserver::objectInit_async(const ::IceGrid::AMI_ObjectObserver_objectInitPtr& __cb, const ::IceGrid::ObjectInfoSeq& objects)
{
    return __cb->__invoke(this, objects, 0);
}

bool
IceProxy::IceGrid::ObjectObserver::objectInit_async(const ::IceGrid::AMI_ObjectObserver_objectInitPtr& __cb, const ::IceGrid::ObjectInfoSeq& objects, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, objects, &__ctx);
}

void
IceProxy::IceGrid::ObjectObserver::objectAdded(const ::IceGrid::ObjectInfo& info, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::ObjectObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::ObjectObserver*>(__delBase.get());
            __del->objectAdded(info, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceGrid::ObjectObserver::objectUpdated(const ::IceGrid::ObjectInfo& info, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::ObjectObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::ObjectObserver*>(__delBase.get());
            __del->objectUpdated(info, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceGrid::ObjectObserver::objectRemoved(const ::Ice::Identity& id, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::ObjectObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::ObjectObserver*>(__delBase.get());
            __del->objectRemoved(id, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::ObjectObserver::ice_staticId()
{
    return ::IceGrid::ObjectObserver::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::ObjectObserver::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::ObjectObserver);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::ObjectObserver::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::ObjectObserver);
}

::IceProxy::Ice::Object*
IceProxy::IceGrid::ObjectObserver::__newInstance() const
{
    return new ObjectObserver;
}
#ifdef __SUNPRO_CC
class ICE_DECLSPEC_EXPORT IceProxy::IceGrid::RegistryObserver;
#endif

void
IceProxy::IceGrid::RegistryObserver::registryInit(const ::IceGrid::RegistryInfoSeq& registries, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::RegistryObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::RegistryObserver*>(__delBase.get());
            __del->registryInit(registries, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::RegistryObserver::registryInit_async(const ::IceGrid::AMI_RegistryObserver_registryInitPtr& __cb, const ::IceGrid::RegistryInfoSeq& registries)
{
    return __cb->__invoke(this, registries, 0);
}

bool
IceProxy::IceGrid::RegistryObserver::registryInit_async(const ::IceGrid::AMI_RegistryObserver_registryInitPtr& __cb, const ::IceGrid::RegistryInfoSeq& registries, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, registries, &__ctx);
}

void
IceProxy::IceGrid::RegistryObserver::registryUp(const ::IceGrid::RegistryInfo& node, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::RegistryObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::RegistryObserver*>(__delBase.get());
            __del->registryUp(node, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceGrid::RegistryObserver::registryDown(const ::std::string& name, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::RegistryObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::RegistryObserver*>(__delBase.get());
            __del->registryDown(name, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::RegistryObserver::ice_staticId()
{
    return ::IceGrid::RegistryObserver::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::RegistryObserver::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::RegistryObserver);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::RegistryObserver::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::RegistryObserver);
}

::IceProxy::Ice::Object*
IceProxy::IceGrid::RegistryObserver::__newInstance() const
{
    return new RegistryObserver;
}

void
IceDelegateM::IceGrid::NodeObserver::nodeInit(const ::IceGrid::NodeDynamicInfoSeq& nodes, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__NodeObserver__nodeInit_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(nodes.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceGrid::__writeNodeDynamicInfoSeq(__os, &nodes[0], &nodes[0] + nodes.size());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::NodeObserver::nodeUp(const ::IceGrid::NodeDynamicInfo& node, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__NodeObserver__nodeUp_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        node.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::NodeObserver::nodeDown(const ::std::string& name, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__NodeObserver__nodeDown_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(name);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::NodeObserver::updateServer(const ::std::string& node, const ::IceGrid::ServerDynamicInfo& updatedInfo, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__NodeObserver__updateServer_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(node);
        updatedInfo.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::NodeObserver::updateAdapter(const ::std::string& node, const ::IceGrid::AdapterDynamicInfo& updatedInfo, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__NodeObserver__updateAdapter_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(node);
        updatedInfo.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::ApplicationObserver::applicationInit(::Ice::Int serial, const ::IceGrid::ApplicationInfoSeq& applications, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__ApplicationObserver__applicationInit_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(serial);
        if(applications.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceGrid::__writeApplicationInfoSeq(__os, &applications[0], &applications[0] + applications.size());
        }
        __os->writePendingObjects();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::ApplicationObserver::applicationAdded(::Ice::Int serial, const ::IceGrid::ApplicationInfo& desc, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__ApplicationObserver__applicationAdded_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(serial);
        desc.__write(__os);
        __os->writePendingObjects();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::ApplicationObserver::applicationRemoved(::Ice::Int serial, const ::std::string& name, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__ApplicationObserver__applicationRemoved_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(serial);
        __os->write(name);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::ApplicationObserver::applicationUpdated(::Ice::Int serial, const ::IceGrid::ApplicationUpdateInfo& desc, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__ApplicationObserver__applicationUpdated_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(serial);
        desc.__write(__os);
        __os->writePendingObjects();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::AdapterObserver::adapterInit(const ::IceGrid::AdapterInfoSeq& adpts, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__AdapterObserver__adapterInit_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(adpts.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceGrid::__writeAdapterInfoSeq(__os, &adpts[0], &adpts[0] + adpts.size());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::AdapterObserver::adapterAdded(const ::IceGrid::AdapterInfo& info, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__AdapterObserver__adapterAdded_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        info.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::AdapterObserver::adapterUpdated(const ::IceGrid::AdapterInfo& info, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__AdapterObserver__adapterUpdated_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        info.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::AdapterObserver::adapterRemoved(const ::std::string& id, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__AdapterObserver__adapterRemoved_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(id);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::ObjectObserver::objectInit(const ::IceGrid::ObjectInfoSeq& objects, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__ObjectObserver__objectInit_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(objects.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceGrid::__writeObjectInfoSeq(__os, &objects[0], &objects[0] + objects.size());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::ObjectObserver::objectAdded(const ::IceGrid::ObjectInfo& info, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__ObjectObserver__objectAdded_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        info.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::ObjectObserver::objectUpdated(const ::IceGrid::ObjectInfo& info, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__ObjectObserver__objectUpdated_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        info.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::ObjectObserver::objectRemoved(const ::Ice::Identity& id, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__ObjectObserver__objectRemoved_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        id.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::RegistryObserver::registryInit(const ::IceGrid::RegistryInfoSeq& registries, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__RegistryObserver__registryInit_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(registries.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceGrid::__writeRegistryInfoSeq(__os, &registries[0], &registries[0] + registries.size());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::RegistryObserver::registryUp(const ::IceGrid::RegistryInfo& node, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__RegistryObserver__registryUp_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        node.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::RegistryObserver::registryDown(const ::std::string& name, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__RegistryObserver__registryDown_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(name);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateD::IceGrid::NodeObserver::nodeInit(const ::IceGrid::NodeDynamicInfoSeq& nodes, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::IceGrid::NodeDynamicInfoSeq& nodes, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_nodes(nodes)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::NodeObserver* servant = dynamic_cast< ::IceGrid::NodeObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->nodeInit(_m_nodes, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::IceGrid::NodeDynamicInfoSeq& _m_nodes;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__NodeObserver__nodeInit_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(nodes, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::NodeObserver::nodeUp(const ::IceGrid::NodeDynamicInfo& node, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::IceGrid::NodeDynamicInfo& node, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_node(node)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::NodeObserver* servant = dynamic_cast< ::IceGrid::NodeObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->nodeUp(_m_node, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::IceGrid::NodeDynamicInfo& _m_node;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__NodeObserver__nodeUp_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(node, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::NodeObserver::nodeDown(const ::std::string& name, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::std::string& name, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_name(name)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::NodeObserver* servant = dynamic_cast< ::IceGrid::NodeObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->nodeDown(_m_name, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::std::string& _m_name;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__NodeObserver__nodeDown_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(name, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::NodeObserver::updateServer(const ::std::string& node, const ::IceGrid::ServerDynamicInfo& updatedInfo, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::std::string& node, const ::IceGrid::ServerDynamicInfo& updatedInfo, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_node(node),
            _m_updatedInfo(updatedInfo)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::NodeObserver* servant = dynamic_cast< ::IceGrid::NodeObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->updateServer(_m_node, _m_updatedInfo, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::std::string& _m_node;
        const ::IceGrid::ServerDynamicInfo& _m_updatedInfo;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__NodeObserver__updateServer_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(node, updatedInfo, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::NodeObserver::updateAdapter(const ::std::string& node, const ::IceGrid::AdapterDynamicInfo& updatedInfo, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::std::string& node, const ::IceGrid::AdapterDynamicInfo& updatedInfo, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_node(node),
            _m_updatedInfo(updatedInfo)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::NodeObserver* servant = dynamic_cast< ::IceGrid::NodeObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->updateAdapter(_m_node, _m_updatedInfo, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::std::string& _m_node;
        const ::IceGrid::AdapterDynamicInfo& _m_updatedInfo;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__NodeObserver__updateAdapter_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(node, updatedInfo, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::ApplicationObserver::applicationInit(::Ice::Int serial, const ::IceGrid::ApplicationInfoSeq& applications, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Ice::Int serial, const ::IceGrid::ApplicationInfoSeq& applications, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_serial(serial),
            _m_applications(applications)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::ApplicationObserver* servant = dynamic_cast< ::IceGrid::ApplicationObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->applicationInit(_m_serial, _m_applications, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::Ice::Int _m_serial;
        const ::IceGrid::ApplicationInfoSeq& _m_applications;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ApplicationObserver__applicationInit_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(serial, applications, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::ApplicationObserver::applicationAdded(::Ice::Int serial, const ::IceGrid::ApplicationInfo& desc, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Ice::Int serial, const ::IceGrid::ApplicationInfo& desc, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_serial(serial),
            _m_desc(desc)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::ApplicationObserver* servant = dynamic_cast< ::IceGrid::ApplicationObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->applicationAdded(_m_serial, _m_desc, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::Ice::Int _m_serial;
        const ::IceGrid::ApplicationInfo& _m_desc;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ApplicationObserver__applicationAdded_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(serial, desc, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::ApplicationObserver::applicationRemoved(::Ice::Int serial, const ::std::string& name, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Ice::Int serial, const ::std::string& name, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_serial(serial),
            _m_name(name)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::ApplicationObserver* servant = dynamic_cast< ::IceGrid::ApplicationObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->applicationRemoved(_m_serial, _m_name, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::Ice::Int _m_serial;
        const ::std::string& _m_name;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ApplicationObserver__applicationRemoved_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(serial, name, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::ApplicationObserver::applicationUpdated(::Ice::Int serial, const ::IceGrid::ApplicationUpdateInfo& desc, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Ice::Int serial, const ::IceGrid::ApplicationUpdateInfo& desc, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_serial(serial),
            _m_desc(desc)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::ApplicationObserver* servant = dynamic_cast< ::IceGrid::ApplicationObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->applicationUpdated(_m_serial, _m_desc, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::Ice::Int _m_serial;
        const ::IceGrid::ApplicationUpdateInfo& _m_desc;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ApplicationObserver__applicationUpdated_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(serial, desc, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::AdapterObserver::adapterInit(const ::IceGrid::AdapterInfoSeq& adpts, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::IceGrid::AdapterInfoSeq& adpts, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_adpts(adpts)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::AdapterObserver* servant = dynamic_cast< ::IceGrid::AdapterObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->adapterInit(_m_adpts, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::IceGrid::AdapterInfoSeq& _m_adpts;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__AdapterObserver__adapterInit_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(adpts, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::AdapterObserver::adapterAdded(const ::IceGrid::AdapterInfo& info, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::IceGrid::AdapterInfo& info, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_info(info)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::AdapterObserver* servant = dynamic_cast< ::IceGrid::AdapterObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->adapterAdded(_m_info, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::IceGrid::AdapterInfo& _m_info;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__AdapterObserver__adapterAdded_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(info, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::AdapterObserver::adapterUpdated(const ::IceGrid::AdapterInfo& info, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::IceGrid::AdapterInfo& info, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_info(info)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::AdapterObserver* servant = dynamic_cast< ::IceGrid::AdapterObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->adapterUpdated(_m_info, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::IceGrid::AdapterInfo& _m_info;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__AdapterObserver__adapterUpdated_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(info, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::AdapterObserver::adapterRemoved(const ::std::string& id, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::std::string& id, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_id(id)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::AdapterObserver* servant = dynamic_cast< ::IceGrid::AdapterObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->adapterRemoved(_m_id, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::std::string& _m_id;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__AdapterObserver__adapterRemoved_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(id, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::ObjectObserver::objectInit(const ::IceGrid::ObjectInfoSeq& objects, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::IceGrid::ObjectInfoSeq& objects, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_objects(objects)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::ObjectObserver* servant = dynamic_cast< ::IceGrid::ObjectObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->objectInit(_m_objects, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::IceGrid::ObjectInfoSeq& _m_objects;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ObjectObserver__objectInit_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(objects, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::ObjectObserver::objectAdded(const ::IceGrid::ObjectInfo& info, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::IceGrid::ObjectInfo& info, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_info(info)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::ObjectObserver* servant = dynamic_cast< ::IceGrid::ObjectObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->objectAdded(_m_info, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::IceGrid::ObjectInfo& _m_info;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ObjectObserver__objectAdded_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(info, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::ObjectObserver::objectUpdated(const ::IceGrid::ObjectInfo& info, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::IceGrid::ObjectInfo& info, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_info(info)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::ObjectObserver* servant = dynamic_cast< ::IceGrid::ObjectObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->objectUpdated(_m_info, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::IceGrid::ObjectInfo& _m_info;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ObjectObserver__objectUpdated_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(info, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::ObjectObserver::objectRemoved(const ::Ice::Identity& id, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Ice::Identity& id, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_id(id)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::ObjectObserver* servant = dynamic_cast< ::IceGrid::ObjectObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->objectRemoved(_m_id, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::Ice::Identity& _m_id;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ObjectObserver__objectRemoved_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(id, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::RegistryObserver::registryInit(const ::IceGrid::RegistryInfoSeq& registries, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::IceGrid::RegistryInfoSeq& registries, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_registries(registries)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::RegistryObserver* servant = dynamic_cast< ::IceGrid::RegistryObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->registryInit(_m_registries, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::IceGrid::RegistryInfoSeq& _m_registries;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__RegistryObserver__registryInit_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(registries, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::RegistryObserver::registryUp(const ::IceGrid::RegistryInfo& node, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::IceGrid::RegistryInfo& node, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_node(node)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::RegistryObserver* servant = dynamic_cast< ::IceGrid::RegistryObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->registryUp(_m_node, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::IceGrid::RegistryInfo& _m_node;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__RegistryObserver__registryUp_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(node, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::RegistryObserver::registryDown(const ::std::string& name, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::std::string& name, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_name(name)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::RegistryObserver* servant = dynamic_cast< ::IceGrid::RegistryObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->registryDown(_m_name, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::std::string& _m_name;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__RegistryObserver__registryDown_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(name, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

::Ice::ObjectPtr
IceGrid::NodeObserver::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__NodeObserver_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::NodeObserver"
};

bool
IceGrid::NodeObserver::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__NodeObserver_ids, __IceGrid__NodeObserver_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::NodeObserver::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__NodeObserver_ids[0], &__IceGrid__NodeObserver_ids[2]);
}

const ::std::string&
IceGrid::NodeObserver::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__NodeObserver_ids[1];
}

const ::std::string&
IceGrid::NodeObserver::ice_staticId()
{
    return __IceGrid__NodeObserver_ids[1];
}

::Ice::DispatchStatus
IceGrid::NodeObserver::___nodeInit(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceGrid::NodeDynamicInfoSeq nodes;
    ::IceGrid::__readNodeDynamicInfoSeq(__is, nodes);
    __is->endReadEncaps();
    nodeInit(nodes, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::NodeObserver::___nodeUp(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceGrid::NodeDynamicInfo node;
    node.__read(__is);
    __is->endReadEncaps();
    nodeUp(node, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::NodeObserver::___nodeDown(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string name;
    __is->read(name);
    __is->endReadEncaps();
    nodeDown(name, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::NodeObserver::___updateServer(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string node;
    ::IceGrid::ServerDynamicInfo updatedInfo;
    __is->read(node);
    updatedInfo.__read(__is);
    __is->endReadEncaps();
    updateServer(node, updatedInfo, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::NodeObserver::___updateAdapter(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string node;
    ::IceGrid::AdapterDynamicInfo updatedInfo;
    __is->read(node);
    updatedInfo.__read(__is);
    __is->endReadEncaps();
    updateAdapter(node, updatedInfo, __current);
    return ::Ice::DispatchOK;
}

static ::std::string __IceGrid__NodeObserver_all[] =
{
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "nodeDown",
    "nodeInit",
    "nodeUp",
    "updateAdapter",
    "updateServer"
};

::Ice::DispatchStatus
IceGrid::NodeObserver::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__NodeObserver_all, __IceGrid__NodeObserver_all + 9, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __IceGrid__NodeObserver_all)
    {
        case 0:
        {
            return ___ice_id(in, current);
        }
        case 1:
        {
            return ___ice_ids(in, current);
        }
        case 2:
        {
            return ___ice_isA(in, current);
        }
        case 3:
        {
            return ___ice_ping(in, current);
        }
        case 4:
        {
            return ___nodeDown(in, current);
        }
        case 5:
        {
            return ___nodeInit(in, current);
        }
        case 6:
        {
            return ___nodeUp(in, current);
        }
        case 7:
        {
            return ___updateAdapter(in, current);
        }
        case 8:
        {
            return ___updateServer(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
IceGrid::NodeObserver::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::NodeObserver::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::NodeObserver::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::NodeObserver was not generated with stream support";
    throw ex;
}

void
IceGrid::NodeObserver::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::NodeObserver was not generated with stream support";
    throw ex;
}

void ICE_DECLSPEC_EXPORT 
IceGrid::__patch__NodeObserverPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::NodeObserverPtr* p = static_cast< ::IceGrid::NodeObserverPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::NodeObserverPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceGrid::NodeObserver::ice_staticId(), v->ice_id());
    }
}

bool
IceGrid::operator==(const ::IceGrid::NodeObserver& l, const ::IceGrid::NodeObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::NodeObserver& l, const ::IceGrid::NodeObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
IceGrid::ApplicationObserver::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__ApplicationObserver_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::ApplicationObserver"
};

bool
IceGrid::ApplicationObserver::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__ApplicationObserver_ids, __IceGrid__ApplicationObserver_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::ApplicationObserver::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__ApplicationObserver_ids[0], &__IceGrid__ApplicationObserver_ids[2]);
}

const ::std::string&
IceGrid::ApplicationObserver::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__ApplicationObserver_ids[1];
}

const ::std::string&
IceGrid::ApplicationObserver::ice_staticId()
{
    return __IceGrid__ApplicationObserver_ids[1];
}

::Ice::DispatchStatus
IceGrid::ApplicationObserver::___applicationInit(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Ice::Int serial;
    ::IceGrid::ApplicationInfoSeq applications;
    __is->read(serial);
    ::IceGrid::__readApplicationInfoSeq(__is, applications);
    __is->readPendingObjects();
    __is->endReadEncaps();
    applicationInit(serial, applications, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::ApplicationObserver::___applicationAdded(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Ice::Int serial;
    ::IceGrid::ApplicationInfo desc;
    __is->read(serial);
    desc.__read(__is);
    __is->readPendingObjects();
    __is->endReadEncaps();
    applicationAdded(serial, desc, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::ApplicationObserver::___applicationRemoved(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Ice::Int serial;
    ::std::string name;
    __is->read(serial);
    __is->read(name);
    __is->endReadEncaps();
    applicationRemoved(serial, name, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::ApplicationObserver::___applicationUpdated(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Ice::Int serial;
    ::IceGrid::ApplicationUpdateInfo desc;
    __is->read(serial);
    desc.__read(__is);
    __is->readPendingObjects();
    __is->endReadEncaps();
    applicationUpdated(serial, desc, __current);
    return ::Ice::DispatchOK;
}

static ::std::string __IceGrid__ApplicationObserver_all[] =
{
    "applicationAdded",
    "applicationInit",
    "applicationRemoved",
    "applicationUpdated",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::Ice::DispatchStatus
IceGrid::ApplicationObserver::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__ApplicationObserver_all, __IceGrid__ApplicationObserver_all + 8, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __IceGrid__ApplicationObserver_all)
    {
        case 0:
        {
            return ___applicationAdded(in, current);
        }
        case 1:
        {
            return ___applicationInit(in, current);
        }
        case 2:
        {
            return ___applicationRemoved(in, current);
        }
        case 3:
        {
            return ___applicationUpdated(in, current);
        }
        case 4:
        {
            return ___ice_id(in, current);
        }
        case 5:
        {
            return ___ice_ids(in, current);
        }
        case 6:
        {
            return ___ice_isA(in, current);
        }
        case 7:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
IceGrid::ApplicationObserver::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::ApplicationObserver::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::ApplicationObserver::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::ApplicationObserver was not generated with stream support";
    throw ex;
}

void
IceGrid::ApplicationObserver::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::ApplicationObserver was not generated with stream support";
    throw ex;
}

void ICE_DECLSPEC_EXPORT 
IceGrid::__patch__ApplicationObserverPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::ApplicationObserverPtr* p = static_cast< ::IceGrid::ApplicationObserverPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::ApplicationObserverPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceGrid::ApplicationObserver::ice_staticId(), v->ice_id());
    }
}

bool
IceGrid::operator==(const ::IceGrid::ApplicationObserver& l, const ::IceGrid::ApplicationObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::ApplicationObserver& l, const ::IceGrid::ApplicationObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
IceGrid::AdapterObserver::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__AdapterObserver_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::AdapterObserver"
};

bool
IceGrid::AdapterObserver::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__AdapterObserver_ids, __IceGrid__AdapterObserver_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::AdapterObserver::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__AdapterObserver_ids[0], &__IceGrid__AdapterObserver_ids[2]);
}

const ::std::string&
IceGrid::AdapterObserver::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__AdapterObserver_ids[1];
}

const ::std::string&
IceGrid::AdapterObserver::ice_staticId()
{
    return __IceGrid__AdapterObserver_ids[1];
}

::Ice::DispatchStatus
IceGrid::AdapterObserver::___adapterInit(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceGrid::AdapterInfoSeq adpts;
    ::IceGrid::__readAdapterInfoSeq(__is, adpts);
    __is->endReadEncaps();
    adapterInit(adpts, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::AdapterObserver::___adapterAdded(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceGrid::AdapterInfo info;
    info.__read(__is);
    __is->endReadEncaps();
    adapterAdded(info, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::AdapterObserver::___adapterUpdated(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceGrid::AdapterInfo info;
    info.__read(__is);
    __is->endReadEncaps();
    adapterUpdated(info, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::AdapterObserver::___adapterRemoved(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string id;
    __is->read(id);
    __is->endReadEncaps();
    adapterRemoved(id, __current);
    return ::Ice::DispatchOK;
}

static ::std::string __IceGrid__AdapterObserver_all[] =
{
    "adapterAdded",
    "adapterInit",
    "adapterRemoved",
    "adapterUpdated",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::Ice::DispatchStatus
IceGrid::AdapterObserver::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__AdapterObserver_all, __IceGrid__AdapterObserver_all + 8, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __IceGrid__AdapterObserver_all)
    {
        case 0:
        {
            return ___adapterAdded(in, current);
        }
        case 1:
        {
            return ___adapterInit(in, current);
        }
        case 2:
        {
            return ___adapterRemoved(in, current);
        }
        case 3:
        {
            return ___adapterUpdated(in, current);
        }
        case 4:
        {
            return ___ice_id(in, current);
        }
        case 5:
        {
            return ___ice_ids(in, current);
        }
        case 6:
        {
            return ___ice_isA(in, current);
        }
        case 7:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
IceGrid::AdapterObserver::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::AdapterObserver::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::AdapterObserver::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::AdapterObserver was not generated with stream support";
    throw ex;
}

void
IceGrid::AdapterObserver::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::AdapterObserver was not generated with stream support";
    throw ex;
}

void ICE_DECLSPEC_EXPORT 
IceGrid::__patch__AdapterObserverPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::AdapterObserverPtr* p = static_cast< ::IceGrid::AdapterObserverPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::AdapterObserverPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceGrid::AdapterObserver::ice_staticId(), v->ice_id());
    }
}

bool
IceGrid::operator==(const ::IceGrid::AdapterObserver& l, const ::IceGrid::AdapterObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::AdapterObserver& l, const ::IceGrid::AdapterObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
IceGrid::ObjectObserver::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__ObjectObserver_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::ObjectObserver"
};

bool
IceGrid::ObjectObserver::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__ObjectObserver_ids, __IceGrid__ObjectObserver_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::ObjectObserver::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__ObjectObserver_ids[0], &__IceGrid__ObjectObserver_ids[2]);
}

const ::std::string&
IceGrid::ObjectObserver::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__ObjectObserver_ids[1];
}

const ::std::string&
IceGrid::ObjectObserver::ice_staticId()
{
    return __IceGrid__ObjectObserver_ids[1];
}

::Ice::DispatchStatus
IceGrid::ObjectObserver::___objectInit(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceGrid::ObjectInfoSeq objects;
    ::IceGrid::__readObjectInfoSeq(__is, objects);
    __is->endReadEncaps();
    objectInit(objects, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::ObjectObserver::___objectAdded(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceGrid::ObjectInfo info;
    info.__read(__is);
    __is->endReadEncaps();
    objectAdded(info, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::ObjectObserver::___objectUpdated(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceGrid::ObjectInfo info;
    info.__read(__is);
    __is->endReadEncaps();
    objectUpdated(info, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::ObjectObserver::___objectRemoved(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Ice::Identity id;
    id.__read(__is);
    __is->endReadEncaps();
    objectRemoved(id, __current);
    return ::Ice::DispatchOK;
}

static ::std::string __IceGrid__ObjectObserver_all[] =
{
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "objectAdded",
    "objectInit",
    "objectRemoved",
    "objectUpdated"
};

::Ice::DispatchStatus
IceGrid::ObjectObserver::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__ObjectObserver_all, __IceGrid__ObjectObserver_all + 8, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __IceGrid__ObjectObserver_all)
    {
        case 0:
        {
            return ___ice_id(in, current);
        }
        case 1:
        {
            return ___ice_ids(in, current);
        }
        case 2:
        {
            return ___ice_isA(in, current);
        }
        case 3:
        {
            return ___ice_ping(in, current);
        }
        case 4:
        {
            return ___objectAdded(in, current);
        }
        case 5:
        {
            return ___objectInit(in, current);
        }
        case 6:
        {
            return ___objectRemoved(in, current);
        }
        case 7:
        {
            return ___objectUpdated(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
IceGrid::ObjectObserver::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::ObjectObserver::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::ObjectObserver::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::ObjectObserver was not generated with stream support";
    throw ex;
}

void
IceGrid::ObjectObserver::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::ObjectObserver was not generated with stream support";
    throw ex;
}

void ICE_DECLSPEC_EXPORT 
IceGrid::__patch__ObjectObserverPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::ObjectObserverPtr* p = static_cast< ::IceGrid::ObjectObserverPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::ObjectObserverPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceGrid::ObjectObserver::ice_staticId(), v->ice_id());
    }
}

bool
IceGrid::operator==(const ::IceGrid::ObjectObserver& l, const ::IceGrid::ObjectObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::ObjectObserver& l, const ::IceGrid::ObjectObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
IceGrid::RegistryObserver::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__RegistryObserver_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::RegistryObserver"
};

bool
IceGrid::RegistryObserver::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__RegistryObserver_ids, __IceGrid__RegistryObserver_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::RegistryObserver::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__RegistryObserver_ids[0], &__IceGrid__RegistryObserver_ids[2]);
}

const ::std::string&
IceGrid::RegistryObserver::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__RegistryObserver_ids[1];
}

const ::std::string&
IceGrid::RegistryObserver::ice_staticId()
{
    return __IceGrid__RegistryObserver_ids[1];
}

::Ice::DispatchStatus
IceGrid::RegistryObserver::___registryInit(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceGrid::RegistryInfoSeq registries;
    ::IceGrid::__readRegistryInfoSeq(__is, registries);
    __is->endReadEncaps();
    registryInit(registries, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::RegistryObserver::___registryUp(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceGrid::RegistryInfo node;
    node.__read(__is);
    __is->endReadEncaps();
    registryUp(node, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::RegistryObserver::___registryDown(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string name;
    __is->read(name);
    __is->endReadEncaps();
    registryDown(name, __current);
    return ::Ice::DispatchOK;
}

static ::std::string __IceGrid__RegistryObserver_all[] =
{
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "registryDown",
    "registryInit",
    "registryUp"
};

::Ice::DispatchStatus
IceGrid::RegistryObserver::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__RegistryObserver_all, __IceGrid__RegistryObserver_all + 7, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __IceGrid__RegistryObserver_all)
    {
        case 0:
        {
            return ___ice_id(in, current);
        }
        case 1:
        {
            return ___ice_ids(in, current);
        }
        case 2:
        {
            return ___ice_isA(in, current);
        }
        case 3:
        {
            return ___ice_ping(in, current);
        }
        case 4:
        {
            return ___registryDown(in, current);
        }
        case 5:
        {
            return ___registryInit(in, current);
        }
        case 6:
        {
            return ___registryUp(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
IceGrid::RegistryObserver::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::RegistryObserver::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::RegistryObserver::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::RegistryObserver was not generated with stream support";
    throw ex;
}

void
IceGrid::RegistryObserver::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::RegistryObserver was not generated with stream support";
    throw ex;
}

void ICE_DECLSPEC_EXPORT 
IceGrid::__patch__RegistryObserverPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::RegistryObserverPtr* p = static_cast< ::IceGrid::RegistryObserverPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::RegistryObserverPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceGrid::RegistryObserver::ice_staticId(), v->ice_id());
    }
}

bool
IceGrid::operator==(const ::IceGrid::RegistryObserver& l, const ::IceGrid::RegistryObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::RegistryObserver& l, const ::IceGrid::RegistryObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

static const char* __sliceChecksums[] =
{
    "::IceGrid::AdapterDynamicInfo", "b371e9a58f115e6ebfbcda735fee57f7",
    "::IceGrid::AdapterDynamicInfoSeq", "54465843167a2f93fa96d13b7f41ea32",
    "::IceGrid::AdapterObserver", "7f4ed59e236da9d6c35ad7e6ad9cb0",
    "::IceGrid::ApplicationObserver", "2862cdcba54714282f68b13a8fb4ae",
    "::IceGrid::NodeDynamicInfo", "3ad52341f32973212d26a9a6dda08b",
    "::IceGrid::NodeDynamicInfoSeq", "f61633c5e3992f718dba78b7f165c2",
    "::IceGrid::NodeObserver", "e06c1ad6807d2876de9e818855a65738",
    "::IceGrid::ObjectObserver", "5364683a872f127e46cc5e215d98c3c",
    "::IceGrid::RegistryObserver", "fd83b1558e7c77f2d322b25449518",
    "::IceGrid::ServerDynamicInfo", "fd4b9177ca54ae4688b51fa51d6870",
    "::IceGrid::ServerDynamicInfoSeq", "e3fda58997d5cd946e78cae739174cb",
    0
};
static IceInternal::SliceChecksumInit __sliceChecksumInit(__sliceChecksums);
