// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `Query.ice'

#ifndef ICE_GRID_API_EXPORTS
#   define ICE_GRID_API_EXPORTS
#endif
#include <IceGrid/Query.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <Ice/SliceChecksums.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __IceGrid__Query__findObjectById_name = "findObjectById";

static const ::std::string __IceGrid__Query__findObjectByType_name = "findObjectByType";

static const ::std::string __IceGrid__Query__findObjectByTypeOnLeastLoadedNode_name = "findObjectByTypeOnLeastLoadedNode";

static const ::std::string __IceGrid__Query__findAllObjectsByType_name = "findAllObjectsByType";

static const ::std::string __IceGrid__Query__findAllReplicas_name = "findAllReplicas";

ICE_DECLSPEC_EXPORT ::Ice::Object* IceInternal::upCast(::IceGrid::Query* p) { return p; }
ICE_DECLSPEC_EXPORT ::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceGrid::Query* p) { return p; }

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::QueryPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::Query;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, ::IceGrid::LoadSample v)
{
    __os->write(static_cast< ::Ice::Byte>(v), 3);
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::LoadSample& v)
{
    ::Ice::Byte val;
    __is->read(val, 3);
    v = static_cast< ::IceGrid::LoadSample>(val);
}

bool
IceGrid::AMI_Query_findObjectById::__invoke(const ::IceGrid::QueryPrx& __prx, const ::Ice::Identity& id, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prx->__checkTwowayOnly(__IceGrid__Query__findObjectById_name);
        __prepare(__prx, __IceGrid__Query__findObjectById_name, ::Ice::Nonmutating, __ctx);
        id.__write(__os);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceGrid::AMI_Query_findObjectById::__response(bool __ok)
{
    ::Ice::ObjectPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response(__ret);
    __releaseCallback();
}

bool
IceGrid::AMI_Query_findObjectByType::__invoke(const ::IceGrid::QueryPrx& __prx, const ::std::string& type, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prx->__checkTwowayOnly(__IceGrid__Query__findObjectByType_name);
        __prepare(__prx, __IceGrid__Query__findObjectByType_name, ::Ice::Nonmutating, __ctx);
        __os->write(type);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceGrid::AMI_Query_findObjectByType::__response(bool __ok)
{
    ::Ice::ObjectPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response(__ret);
    __releaseCallback();
}

bool
IceGrid::AMI_Query_findObjectByTypeOnLeastLoadedNode::__invoke(const ::IceGrid::QueryPrx& __prx, const ::std::string& type, ::IceGrid::LoadSample sample, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prx->__checkTwowayOnly(__IceGrid__Query__findObjectByTypeOnLeastLoadedNode_name);
        __prepare(__prx, __IceGrid__Query__findObjectByTypeOnLeastLoadedNode_name, ::Ice::Nonmutating, __ctx);
        __os->write(type);
        ::IceGrid::__write(__os, sample);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceGrid::AMI_Query_findObjectByTypeOnLeastLoadedNode::__response(bool __ok)
{
    ::Ice::ObjectPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response(__ret);
    __releaseCallback();
}

bool
IceGrid::AMI_Query_findAllObjectsByType::__invoke(const ::IceGrid::QueryPrx& __prx, const ::std::string& type, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prx->__checkTwowayOnly(__IceGrid__Query__findAllObjectsByType_name);
        __prepare(__prx, __IceGrid__Query__findAllObjectsByType_name, ::Ice::Nonmutating, __ctx);
        __os->write(type);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceGrid::AMI_Query_findAllObjectsByType::__response(bool __ok)
{
    ::Ice::ObjectProxySeq __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->startReadEncaps();
        ::Ice::__readObjectProxySeq(__is, __ret);
        __is->endReadEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response(__ret);
    __releaseCallback();
}

bool
IceGrid::AMI_Query_findAllReplicas::__invoke(const ::IceGrid::QueryPrx& __prx, const ::Ice::ObjectPrx& proxy, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prx->__checkTwowayOnly(__IceGrid__Query__findAllReplicas_name);
        __prepare(__prx, __IceGrid__Query__findAllReplicas_name, ::Ice::Idempotent, __ctx);
        __os->write(proxy);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceGrid::AMI_Query_findAllReplicas::__response(bool __ok)
{
    ::Ice::ObjectProxySeq __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->startReadEncaps();
        ::Ice::__readObjectProxySeq(__is, __ret);
        __is->endReadEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response(__ret);
    __releaseCallback();
}
#ifdef __SUNPRO_CC
class ICE_DECLSPEC_EXPORT IceProxy::IceGrid::Query;
#endif

::Ice::ObjectPrx
IceProxy::IceGrid::Query::findObjectById(const ::Ice::Identity& id, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__Query__findObjectById_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::Query* __del = dynamic_cast< ::IceDelegate::IceGrid::Query*>(__delBase.get());
            return __del->findObjectById(id, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::Query::findObjectById_async(const ::IceGrid::AMI_Query_findObjectByIdPtr& __cb, const ::Ice::Identity& id)
{
    return __cb->__invoke(this, id, 0);
}

bool
IceProxy::IceGrid::Query::findObjectById_async(const ::IceGrid::AMI_Query_findObjectByIdPtr& __cb, const ::Ice::Identity& id, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, id, &__ctx);
}

::Ice::ObjectPrx
IceProxy::IceGrid::Query::findObjectByType(const ::std::string& type, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__Query__findObjectByType_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::Query* __del = dynamic_cast< ::IceDelegate::IceGrid::Query*>(__delBase.get());
            return __del->findObjectByType(type, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::Query::findObjectByType_async(const ::IceGrid::AMI_Query_findObjectByTypePtr& __cb, const ::std::string& type)
{
    return __cb->__invoke(this, type, 0);
}

bool
IceProxy::IceGrid::Query::findObjectByType_async(const ::IceGrid::AMI_Query_findObjectByTypePtr& __cb, const ::std::string& type, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, type, &__ctx);
}

::Ice::ObjectPrx
IceProxy::IceGrid::Query::findObjectByTypeOnLeastLoadedNode(const ::std::string& type, ::IceGrid::LoadSample sample, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__Query__findObjectByTypeOnLeastLoadedNode_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::Query* __del = dynamic_cast< ::IceDelegate::IceGrid::Query*>(__delBase.get());
            return __del->findObjectByTypeOnLeastLoadedNode(type, sample, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::Query::findObjectByTypeOnLeastLoadedNode_async(const ::IceGrid::AMI_Query_findObjectByTypeOnLeastLoadedNodePtr& __cb, const ::std::string& type, ::IceGrid::LoadSample sample)
{
    return __cb->__invoke(this, type, sample, 0);
}

bool
IceProxy::IceGrid::Query::findObjectByTypeOnLeastLoadedNode_async(const ::IceGrid::AMI_Query_findObjectByTypeOnLeastLoadedNodePtr& __cb, const ::std::string& type, ::IceGrid::LoadSample sample, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, type, sample, &__ctx);
}

::Ice::ObjectProxySeq
IceProxy::IceGrid::Query::findAllObjectsByType(const ::std::string& type, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__Query__findAllObjectsByType_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::Query* __del = dynamic_cast< ::IceDelegate::IceGrid::Query*>(__delBase.get());
            return __del->findAllObjectsByType(type, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::Query::findAllObjectsByType_async(const ::IceGrid::AMI_Query_findAllObjectsByTypePtr& __cb, const ::std::string& type)
{
    return __cb->__invoke(this, type, 0);
}

bool
IceProxy::IceGrid::Query::findAllObjectsByType_async(const ::IceGrid::AMI_Query_findAllObjectsByTypePtr& __cb, const ::std::string& type, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, type, &__ctx);
}

::Ice::ObjectProxySeq
IceProxy::IceGrid::Query::findAllReplicas(const ::Ice::ObjectPrx& proxy, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__Query__findAllReplicas_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::Query* __del = dynamic_cast< ::IceDelegate::IceGrid::Query*>(__delBase.get());
            return __del->findAllReplicas(proxy, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::Query::findAllReplicas_async(const ::IceGrid::AMI_Query_findAllReplicasPtr& __cb, const ::Ice::ObjectPrx& proxy)
{
    return __cb->__invoke(this, proxy, 0);
}

bool
IceProxy::IceGrid::Query::findAllReplicas_async(const ::IceGrid::AMI_Query_findAllReplicasPtr& __cb, const ::Ice::ObjectPrx& proxy, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, proxy, &__ctx);
}

const ::std::string&
IceProxy::IceGrid::Query::ice_staticId()
{
    return ::IceGrid::Query::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::Query::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::Query);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::Query::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::Query);
}

::IceProxy::Ice::Object*
IceProxy::IceGrid::Query::__newInstance() const
{
    return new Query;
}

::Ice::ObjectPrx
IceDelegateM::IceGrid::Query::findObjectById(const ::Ice::Identity& id, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__Query__findObjectById_name, ::Ice::Nonmutating, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        id.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    ::Ice::ObjectPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::ObjectPrx
IceDelegateM::IceGrid::Query::findObjectByType(const ::std::string& type, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__Query__findObjectByType_name, ::Ice::Nonmutating, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(type);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    ::Ice::ObjectPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::ObjectPrx
IceDelegateM::IceGrid::Query::findObjectByTypeOnLeastLoadedNode(const ::std::string& type, ::IceGrid::LoadSample sample, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__Query__findObjectByTypeOnLeastLoadedNode_name, ::Ice::Nonmutating, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(type);
        ::IceGrid::__write(__os, sample);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    ::Ice::ObjectPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::ObjectProxySeq
IceDelegateM::IceGrid::Query::findAllObjectsByType(const ::std::string& type, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__Query__findAllObjectsByType_name, ::Ice::Nonmutating, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(type);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    ::Ice::ObjectProxySeq __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::Ice::__readObjectProxySeq(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::ObjectProxySeq
IceDelegateM::IceGrid::Query::findAllReplicas(const ::Ice::ObjectPrx& proxy, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__Query__findAllReplicas_name, ::Ice::Idempotent, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(proxy);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    ::Ice::ObjectProxySeq __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::Ice::__readObjectProxySeq(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::ObjectPrx
IceDelegateD::IceGrid::Query::findObjectById(const ::Ice::Identity& id, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Ice::ObjectPrx& __result, const ::Ice::Identity& id, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_id(id)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::Query* servant = dynamic_cast< ::IceGrid::Query*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->findObjectById(_m_id, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::Ice::ObjectPrx& _result;
        const ::Ice::Identity& _m_id;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Query__findObjectById_name, ::Ice::Nonmutating, __context);
    ::Ice::ObjectPrx __result;
    try
    {
        _DirectI __direct(__result, id, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Ice::ObjectPrx
IceDelegateD::IceGrid::Query::findObjectByType(const ::std::string& type, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Ice::ObjectPrx& __result, const ::std::string& type, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_type(type)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::Query* servant = dynamic_cast< ::IceGrid::Query*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->findObjectByType(_m_type, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::Ice::ObjectPrx& _result;
        const ::std::string& _m_type;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Query__findObjectByType_name, ::Ice::Nonmutating, __context);
    ::Ice::ObjectPrx __result;
    try
    {
        _DirectI __direct(__result, type, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Ice::ObjectPrx
IceDelegateD::IceGrid::Query::findObjectByTypeOnLeastLoadedNode(const ::std::string& type, ::IceGrid::LoadSample sample, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Ice::ObjectPrx& __result, const ::std::string& type, ::IceGrid::LoadSample sample, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_type(type),
            _m_sample(sample)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::Query* servant = dynamic_cast< ::IceGrid::Query*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->findObjectByTypeOnLeastLoadedNode(_m_type, _m_sample, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::Ice::ObjectPrx& _result;
        const ::std::string& _m_type;
        ::IceGrid::LoadSample _m_sample;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Query__findObjectByTypeOnLeastLoadedNode_name, ::Ice::Nonmutating, __context);
    ::Ice::ObjectPrx __result;
    try
    {
        _DirectI __direct(__result, type, sample, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Ice::ObjectProxySeq
IceDelegateD::IceGrid::Query::findAllObjectsByType(const ::std::string& type, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Ice::ObjectProxySeq& __result, const ::std::string& type, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_type(type)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::Query* servant = dynamic_cast< ::IceGrid::Query*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->findAllObjectsByType(_m_type, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::Ice::ObjectProxySeq& _result;
        const ::std::string& _m_type;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Query__findAllObjectsByType_name, ::Ice::Nonmutating, __context);
    ::Ice::ObjectProxySeq __result;
    try
    {
        _DirectI __direct(__result, type, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Ice::ObjectProxySeq
IceDelegateD::IceGrid::Query::findAllReplicas(const ::Ice::ObjectPrx& proxy, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Ice::ObjectProxySeq& __result, const ::Ice::ObjectPrx& proxy, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_proxy(proxy)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::Query* servant = dynamic_cast< ::IceGrid::Query*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->findAllReplicas(_m_proxy, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::Ice::ObjectProxySeq& _result;
        const ::Ice::ObjectPrx& _m_proxy;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Query__findAllReplicas_name, ::Ice::Idempotent, __context);
    ::Ice::ObjectProxySeq __result;
    try
    {
        _DirectI __direct(__result, proxy, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Ice::ObjectPtr
IceGrid::Query::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__Query_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::Query"
};

bool
IceGrid::Query::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__Query_ids, __IceGrid__Query_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::Query::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__Query_ids[0], &__IceGrid__Query_ids[2]);
}

const ::std::string&
IceGrid::Query::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__Query_ids[1];
}

const ::std::string&
IceGrid::Query::ice_staticId()
{
    return __IceGrid__Query_ids[1];
}

::Ice::DispatchStatus
IceGrid::Query::___findObjectById(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Ice::Identity id;
    id.__read(__is);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::ObjectPrx __ret = findObjectById(id, __current);
    __os->write(__ret);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::Query::___findObjectByType(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string type;
    __is->read(type);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::ObjectPrx __ret = findObjectByType(type, __current);
    __os->write(__ret);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::Query::___findObjectByTypeOnLeastLoadedNode(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string type;
    ::IceGrid::LoadSample sample;
    __is->read(type);
    ::IceGrid::__read(__is, sample);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::ObjectPrx __ret = findObjectByTypeOnLeastLoadedNode(type, sample, __current);
    __os->write(__ret);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::Query::___findAllObjectsByType(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string type;
    __is->read(type);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::ObjectProxySeq __ret = findAllObjectsByType(type, __current);
    if(__ret.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::Ice::__writeObjectProxySeq(__os, &__ret[0], &__ret[0] + __ret.size());
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::Query::___findAllReplicas(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::ObjectProxySeq __ret = findAllReplicas(proxy, __current);
    if(__ret.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::Ice::__writeObjectProxySeq(__os, &__ret[0], &__ret[0] + __ret.size());
    }
    return ::Ice::DispatchOK;
}

static ::std::string __IceGrid__Query_all[] =
{
    "findAllObjectsByType",
    "findAllReplicas",
    "findObjectById",
    "findObjectByType",
    "findObjectByTypeOnLeastLoadedNode",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::Ice::DispatchStatus
IceGrid::Query::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__Query_all, __IceGrid__Query_all + 9, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __IceGrid__Query_all)
    {
        case 0:
        {
            return ___findAllObjectsByType(in, current);
        }
        case 1:
        {
            return ___findAllReplicas(in, current);
        }
        case 2:
        {
            return ___findObjectById(in, current);
        }
        case 3:
        {
            return ___findObjectByType(in, current);
        }
        case 4:
        {
            return ___findObjectByTypeOnLeastLoadedNode(in, current);
        }
        case 5:
        {
            return ___ice_id(in, current);
        }
        case 6:
        {
            return ___ice_ids(in, current);
        }
        case 7:
        {
            return ___ice_isA(in, current);
        }
        case 8:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
IceGrid::Query::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::Query::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::Query::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::Query was not generated with stream support";
    throw ex;
}

void
IceGrid::Query::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::Query was not generated with stream support";
    throw ex;
}

void ICE_DECLSPEC_EXPORT 
IceGrid::__patch__QueryPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::QueryPtr* p = static_cast< ::IceGrid::QueryPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::QueryPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceGrid::Query::ice_staticId(), v->ice_id());
    }
}

bool
IceGrid::operator==(const ::IceGrid::Query& l, const ::IceGrid::Query& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::Query& l, const ::IceGrid::Query& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

static const char* __sliceChecksums[] =
{
    "::IceGrid::LoadSample", "ec48c06fa099138a5fbbce121a9a290",
    "::IceGrid::Query", "39dbe5f62c19aa42c2e0fbaf220b4f1",
    0
};
static IceInternal::SliceChecksumInit __sliceChecksumInit(__sliceChecksums);
