// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `Election.ice'

#include <IceStorm/Election.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __IceStormElection__ReplicaObserver__init_name = "init";

static const ::std::string __IceStormElection__ReplicaObserver__createTopic_name = "createTopic";

static const ::std::string __IceStormElection__ReplicaObserver__destroyTopic_name = "destroyTopic";

static const ::std::string __IceStormElection__ReplicaObserver__addSubscriber_name = "addSubscriber";

static const ::std::string __IceStormElection__ReplicaObserver__removeSubscriber_name = "removeSubscriber";

static const ::std::string __IceStormElection__TopicManagerSync__getContent_name = "getContent";

static const ::std::string __IceStormElection__Node__invitation_name = "invitation";

static const ::std::string __IceStormElection__Node__ready_name = "ready";

static const ::std::string __IceStormElection__Node__accept_name = "accept";

static const ::std::string __IceStormElection__Node__areYouCoordinator_name = "areYouCoordinator";

static const ::std::string __IceStormElection__Node__areYouThere_name = "areYouThere";

static const ::std::string __IceStormElection__Node__sync_name = "sync";

static const ::std::string __IceStormElection__Node__nodes_name = "nodes";

static const ::std::string __IceStormElection__Node__query_name = "query";

::Ice::Object* IceInternal::upCast(::IceStormElection::ReplicaObserver* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceStormElection::ReplicaObserver* p) { return p; }

::Ice::Object* IceInternal::upCast(::IceStormElection::TopicManagerSync* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceStormElection::TopicManagerSync* p) { return p; }

::Ice::Object* IceInternal::upCast(::IceStormElection::Node* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceStormElection::Node* p) { return p; }

void
IceStormElection::__read(::IceInternal::BasicStream* __is, ::IceStormElection::ReplicaObserverPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceStormElection::ReplicaObserver;
        v->__copyFrom(proxy);
    }
}

void
IceStormElection::__read(::IceInternal::BasicStream* __is, ::IceStormElection::TopicManagerSyncPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceStormElection::TopicManagerSync;
        v->__copyFrom(proxy);
    }
}

void
IceStormElection::__read(::IceInternal::BasicStream* __is, ::IceStormElection::NodePrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceStormElection::Node;
        v->__copyFrom(proxy);
    }
}

bool
IceStormElection::LogUpdate::operator==(const LogUpdate& __rhs) const
{
    if(this == &__rhs)
    {
        return true;
    }
    if(generation != __rhs.generation)
    {
        return false;
    }
    if(iteration != __rhs.iteration)
    {
        return false;
    }
    return true;
}

bool
IceStormElection::LogUpdate::operator<(const LogUpdate& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(generation < __rhs.generation)
    {
        return true;
    }
    else if(__rhs.generation < generation)
    {
        return false;
    }
    if(iteration < __rhs.iteration)
    {
        return true;
    }
    else if(__rhs.iteration < iteration)
    {
        return false;
    }
    return false;
}

void
IceStormElection::LogUpdate::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(generation);
    __os->write(iteration);
}

void
IceStormElection::LogUpdate::__read(::IceInternal::BasicStream* __is)
{
    __is->read(generation);
    __is->read(iteration);
}

bool
IceStormElection::TopicContent::operator==(const TopicContent& __rhs) const
{
    if(this == &__rhs)
    {
        return true;
    }
    if(id != __rhs.id)
    {
        return false;
    }
    if(records != __rhs.records)
    {
        return false;
    }
    return true;
}

bool
IceStormElection::TopicContent::operator<(const TopicContent& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(id < __rhs.id)
    {
        return true;
    }
    else if(__rhs.id < id)
    {
        return false;
    }
    if(records < __rhs.records)
    {
        return true;
    }
    else if(__rhs.records < records)
    {
        return false;
    }
    return false;
}

void
IceStormElection::TopicContent::__write(::IceInternal::BasicStream* __os) const
{
    id.__write(__os);
    if(records.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::IceStorm::__writeSubscriberRecordSeq(__os, &records[0], &records[0] + records.size());
    }
}

void
IceStormElection::TopicContent::__read(::IceInternal::BasicStream* __is)
{
    id.__read(__is);
    ::IceStorm::__readSubscriberRecordSeq(__is, records);
}

void
IceStormElection::__writeTopicContentSeq(::IceInternal::BasicStream* __os, const ::IceStormElection::TopicContent* begin, const ::IceStormElection::TopicContent* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        begin[i].__write(__os);
    }
}

void
IceStormElection::__readTopicContentSeq(::IceInternal::BasicStream* __is, ::IceStormElection::TopicContentSeq& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 3);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        v[i].__read(__is);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

IceStormElection::ObserverInconsistencyException::ObserverInconsistencyException(const ::std::string& __ice_reason) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    reason(__ice_reason)
{
}

IceStormElection::ObserverInconsistencyException::~ObserverInconsistencyException() throw()
{
}

static const char* __IceStormElection__ObserverInconsistencyException_name = "IceStormElection::ObserverInconsistencyException";

::std::string
IceStormElection::ObserverInconsistencyException::ice_name() const
{
    return __IceStormElection__ObserverInconsistencyException_name;
}

::Ice::Exception*
IceStormElection::ObserverInconsistencyException::ice_clone() const
{
    return new ObserverInconsistencyException(*this);
}

void
IceStormElection::ObserverInconsistencyException::ice_throw() const
{
    throw *this;
}

void
IceStormElection::ObserverInconsistencyException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceStormElection::ObserverInconsistencyException"), false);
    __os->startWriteSlice();
    __os->write(reason);
    __os->endWriteSlice();
}

void
IceStormElection::ObserverInconsistencyException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(reason);
    __is->endReadSlice();
}

void
IceStormElection::ObserverInconsistencyException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceStormElection::ObserverInconsistencyException was not generated with stream support";
    throw ex;
}

void
IceStormElection::ObserverInconsistencyException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceStormElection::ObserverInconsistencyException was not generated with stream support";
    throw ex;
}

struct __F__IceStormElection__ObserverInconsistencyException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceStormElection::ObserverInconsistencyException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceStormElection__ObserverInconsistencyException__Ptr = new __F__IceStormElection__ObserverInconsistencyException;

const ::IceInternal::UserExceptionFactoryPtr&
IceStormElection::ObserverInconsistencyException::ice_factory()
{
    return __F__IceStormElection__ObserverInconsistencyException__Ptr;
}

class __F__IceStormElection__ObserverInconsistencyException__Init
{
public:

    __F__IceStormElection__ObserverInconsistencyException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceStormElection::ObserverInconsistencyException", ::IceStormElection::ObserverInconsistencyException::ice_factory());
    }

    ~__F__IceStormElection__ObserverInconsistencyException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceStormElection::ObserverInconsistencyException");
    }
};

static __F__IceStormElection__ObserverInconsistencyException__Init __F__IceStormElection__ObserverInconsistencyException__i;

#ifdef __APPLE__
extern "C" { void __F__IceStormElection__ObserverInconsistencyException__initializer() {} }
#endif

void
IceStormElection::__write(::IceInternal::BasicStream* __os, ::IceStormElection::NodeState v)
{
    __os->write(static_cast< ::Ice::Byte>(v), 4);
}

void
IceStormElection::__read(::IceInternal::BasicStream* __is, ::IceStormElection::NodeState& v)
{
    ::Ice::Byte val;
    __is->read(val, 4);
    v = static_cast< ::IceStormElection::NodeState>(val);
}

bool
IceStormElection::NodeInfo::operator==(const NodeInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return true;
    }
    if(id != __rhs.id)
    {
        return false;
    }
    if(n != __rhs.n)
    {
        return false;
    }
    return true;
}

bool
IceStormElection::NodeInfo::operator<(const NodeInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(id < __rhs.id)
    {
        return true;
    }
    else if(__rhs.id < id)
    {
        return false;
    }
    if(n < __rhs.n)
    {
        return true;
    }
    else if(__rhs.n < n)
    {
        return false;
    }
    return false;
}

void
IceStormElection::NodeInfo::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(id);
    __os->write(::Ice::ObjectPrx(::IceInternal::upCast(n.get())));
}

void
IceStormElection::NodeInfo::__read(::IceInternal::BasicStream* __is)
{
    __is->read(id);
    ::IceStormElection::__read(__is, n);
}

void
IceStormElection::__writeNodeInfoSeq(::IceInternal::BasicStream* __os, const ::IceStormElection::NodeInfo* begin, const ::IceStormElection::NodeInfo* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        begin[i].__write(__os);
    }
}

void
IceStormElection::__readNodeInfoSeq(::IceInternal::BasicStream* __is, ::IceStormElection::NodeInfoSeq& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 6);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        v[i].__read(__is);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

bool
IceStormElection::GroupInfo::operator==(const GroupInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return true;
    }
    if(id != __rhs.id)
    {
        return false;
    }
    if(llu != __rhs.llu)
    {
        return false;
    }
    return true;
}

bool
IceStormElection::GroupInfo::operator<(const GroupInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(id < __rhs.id)
    {
        return true;
    }
    else if(__rhs.id < id)
    {
        return false;
    }
    if(llu < __rhs.llu)
    {
        return true;
    }
    else if(__rhs.llu < llu)
    {
        return false;
    }
    return false;
}

void
IceStormElection::GroupInfo::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(id);
    llu.__write(__os);
}

void
IceStormElection::GroupInfo::__read(::IceInternal::BasicStream* __is)
{
    __is->read(id);
    llu.__read(__is);
}

void
IceStormElection::__writeGroupInfoSeq(::IceInternal::BasicStream* __os, const ::IceStormElection::GroupInfo* begin, const ::IceStormElection::GroupInfo* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        begin[i].__write(__os);
    }
}

void
IceStormElection::__readGroupInfoSeq(::IceInternal::BasicStream* __is, ::IceStormElection::GroupInfoSeq& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->checkFixedSeq(sz, 20);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        v[i].__read(__is);
    }
}

bool
IceStormElection::QueryInfo::operator==(const QueryInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return true;
    }
    if(id != __rhs.id)
    {
        return false;
    }
    if(coord != __rhs.coord)
    {
        return false;
    }
    if(group != __rhs.group)
    {
        return false;
    }
    if(replica != __rhs.replica)
    {
        return false;
    }
    if(state != __rhs.state)
    {
        return false;
    }
    if(up != __rhs.up)
    {
        return false;
    }
    if(max != __rhs.max)
    {
        return false;
    }
    return true;
}

bool
IceStormElection::QueryInfo::operator<(const QueryInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(id < __rhs.id)
    {
        return true;
    }
    else if(__rhs.id < id)
    {
        return false;
    }
    if(coord < __rhs.coord)
    {
        return true;
    }
    else if(__rhs.coord < coord)
    {
        return false;
    }
    if(group < __rhs.group)
    {
        return true;
    }
    else if(__rhs.group < group)
    {
        return false;
    }
    if(replica < __rhs.replica)
    {
        return true;
    }
    else if(__rhs.replica < replica)
    {
        return false;
    }
    if(state < __rhs.state)
    {
        return true;
    }
    else if(__rhs.state < state)
    {
        return false;
    }
    if(up < __rhs.up)
    {
        return true;
    }
    else if(__rhs.up < up)
    {
        return false;
    }
    if(max < __rhs.max)
    {
        return true;
    }
    else if(__rhs.max < max)
    {
        return false;
    }
    return false;
}

void
IceStormElection::QueryInfo::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(id);
    __os->write(coord);
    __os->write(group);
    __os->write(replica);
    ::IceStormElection::__write(__os, state);
    if(up.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::IceStormElection::__writeGroupInfoSeq(__os, &up[0], &up[0] + up.size());
    }
    __os->write(max);
}

void
IceStormElection::QueryInfo::__read(::IceInternal::BasicStream* __is)
{
    __is->read(id);
    __is->read(coord);
    __is->read(group);
    __is->read(replica);
    ::IceStormElection::__read(__is, state);
    ::IceStormElection::__readGroupInfoSeq(__is, up);
    __is->read(max);
}

bool
IceStormElection::AMI_ReplicaObserver_createTopic::__invoke(const ::IceStormElection::ReplicaObserverPrx& __prx, const ::IceStormElection::LogUpdate& llu, const ::std::string& name, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prx->__checkTwowayOnly(__IceStormElection__ReplicaObserver__createTopic_name);
        __prepare(__prx, __IceStormElection__ReplicaObserver__createTopic_name, ::Ice::Normal, __ctx);
        llu.__write(__os);
        __os->write(name);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceStormElection::AMI_ReplicaObserver_createTopic::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::IceStormElection::ObserverInconsistencyException& __ex)
            {
                __exception(__ex);
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}

bool
IceStormElection::AMI_ReplicaObserver_destroyTopic::__invoke(const ::IceStormElection::ReplicaObserverPrx& __prx, const ::IceStormElection::LogUpdate& llu, const ::std::string& name, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prx->__checkTwowayOnly(__IceStormElection__ReplicaObserver__destroyTopic_name);
        __prepare(__prx, __IceStormElection__ReplicaObserver__destroyTopic_name, ::Ice::Normal, __ctx);
        llu.__write(__os);
        __os->write(name);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceStormElection::AMI_ReplicaObserver_destroyTopic::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::IceStormElection::ObserverInconsistencyException& __ex)
            {
                __exception(__ex);
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}

bool
IceStormElection::AMI_ReplicaObserver_addSubscriber::__invoke(const ::IceStormElection::ReplicaObserverPrx& __prx, const ::IceStormElection::LogUpdate& llu, const ::std::string& topic, const ::IceStorm::SubscriberRecord& record, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prx->__checkTwowayOnly(__IceStormElection__ReplicaObserver__addSubscriber_name);
        __prepare(__prx, __IceStormElection__ReplicaObserver__addSubscriber_name, ::Ice::Normal, __ctx);
        llu.__write(__os);
        __os->write(topic);
        record.__write(__os);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceStormElection::AMI_ReplicaObserver_addSubscriber::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::IceStormElection::ObserverInconsistencyException& __ex)
            {
                __exception(__ex);
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}

bool
IceStormElection::AMI_ReplicaObserver_removeSubscriber::__invoke(const ::IceStormElection::ReplicaObserverPrx& __prx, const ::IceStormElection::LogUpdate& llu, const ::std::string& topic, const ::Ice::IdentitySeq& subscribers, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prx->__checkTwowayOnly(__IceStormElection__ReplicaObserver__removeSubscriber_name);
        __prepare(__prx, __IceStormElection__ReplicaObserver__removeSubscriber_name, ::Ice::Normal, __ctx);
        llu.__write(__os);
        __os->write(topic);
        if(subscribers.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::Ice::__writeIdentitySeq(__os, &subscribers[0], &subscribers[0] + subscribers.size());
        }
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceStormElection::AMI_ReplicaObserver_removeSubscriber::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::IceStormElection::ObserverInconsistencyException& __ex)
            {
                __exception(__ex);
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}

void
IceProxy::IceStormElection::ReplicaObserver::init(const ::IceStormElection::LogUpdate& llu, const ::IceStormElection::TopicContentSeq& content, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceStormElection__ReplicaObserver__init_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceStormElection::ReplicaObserver* __del = dynamic_cast< ::IceDelegate::IceStormElection::ReplicaObserver*>(__delBase.get());
            __del->init(llu, content, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceStormElection::ReplicaObserver::createTopic(const ::IceStormElection::LogUpdate& llu, const ::std::string& name, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceStormElection__ReplicaObserver__createTopic_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceStormElection::ReplicaObserver* __del = dynamic_cast< ::IceDelegate::IceStormElection::ReplicaObserver*>(__delBase.get());
            __del->createTopic(llu, name, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceStormElection::ReplicaObserver::createTopic_async(const ::IceStormElection::AMI_ReplicaObserver_createTopicPtr& __cb, const ::IceStormElection::LogUpdate& llu, const ::std::string& name)
{
    return __cb->__invoke(this, llu, name, 0);
}

bool
IceProxy::IceStormElection::ReplicaObserver::createTopic_async(const ::IceStormElection::AMI_ReplicaObserver_createTopicPtr& __cb, const ::IceStormElection::LogUpdate& llu, const ::std::string& name, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, llu, name, &__ctx);
}

void
IceProxy::IceStormElection::ReplicaObserver::destroyTopic(const ::IceStormElection::LogUpdate& llu, const ::std::string& name, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceStormElection__ReplicaObserver__destroyTopic_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceStormElection::ReplicaObserver* __del = dynamic_cast< ::IceDelegate::IceStormElection::ReplicaObserver*>(__delBase.get());
            __del->destroyTopic(llu, name, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceStormElection::ReplicaObserver::destroyTopic_async(const ::IceStormElection::AMI_ReplicaObserver_destroyTopicPtr& __cb, const ::IceStormElection::LogUpdate& llu, const ::std::string& name)
{
    return __cb->__invoke(this, llu, name, 0);
}

bool
IceProxy::IceStormElection::ReplicaObserver::destroyTopic_async(const ::IceStormElection::AMI_ReplicaObserver_destroyTopicPtr& __cb, const ::IceStormElection::LogUpdate& llu, const ::std::string& name, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, llu, name, &__ctx);
}

void
IceProxy::IceStormElection::ReplicaObserver::addSubscriber(const ::IceStormElection::LogUpdate& llu, const ::std::string& topic, const ::IceStorm::SubscriberRecord& record, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceStormElection__ReplicaObserver__addSubscriber_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceStormElection::ReplicaObserver* __del = dynamic_cast< ::IceDelegate::IceStormElection::ReplicaObserver*>(__delBase.get());
            __del->addSubscriber(llu, topic, record, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceStormElection::ReplicaObserver::addSubscriber_async(const ::IceStormElection::AMI_ReplicaObserver_addSubscriberPtr& __cb, const ::IceStormElection::LogUpdate& llu, const ::std::string& topic, const ::IceStorm::SubscriberRecord& record)
{
    return __cb->__invoke(this, llu, topic, record, 0);
}

bool
IceProxy::IceStormElection::ReplicaObserver::addSubscriber_async(const ::IceStormElection::AMI_ReplicaObserver_addSubscriberPtr& __cb, const ::IceStormElection::LogUpdate& llu, const ::std::string& topic, const ::IceStorm::SubscriberRecord& record, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, llu, topic, record, &__ctx);
}

void
IceProxy::IceStormElection::ReplicaObserver::removeSubscriber(const ::IceStormElection::LogUpdate& llu, const ::std::string& topic, const ::Ice::IdentitySeq& subscribers, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceStormElection__ReplicaObserver__removeSubscriber_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceStormElection::ReplicaObserver* __del = dynamic_cast< ::IceDelegate::IceStormElection::ReplicaObserver*>(__delBase.get());
            __del->removeSubscriber(llu, topic, subscribers, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceStormElection::ReplicaObserver::removeSubscriber_async(const ::IceStormElection::AMI_ReplicaObserver_removeSubscriberPtr& __cb, const ::IceStormElection::LogUpdate& llu, const ::std::string& topic, const ::Ice::IdentitySeq& subscribers)
{
    return __cb->__invoke(this, llu, topic, subscribers, 0);
}

bool
IceProxy::IceStormElection::ReplicaObserver::removeSubscriber_async(const ::IceStormElection::AMI_ReplicaObserver_removeSubscriberPtr& __cb, const ::IceStormElection::LogUpdate& llu, const ::std::string& topic, const ::Ice::IdentitySeq& subscribers, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, llu, topic, subscribers, &__ctx);
}

const ::std::string&
IceProxy::IceStormElection::ReplicaObserver::ice_staticId()
{
    return ::IceStormElection::ReplicaObserver::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceStormElection::ReplicaObserver::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceStormElection::ReplicaObserver);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceStormElection::ReplicaObserver::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceStormElection::ReplicaObserver);
}

::IceProxy::Ice::Object*
IceProxy::IceStormElection::ReplicaObserver::__newInstance() const
{
    return new ReplicaObserver;
}

void
IceProxy::IceStormElection::TopicManagerSync::getContent(::IceStormElection::LogUpdate& llu, ::IceStormElection::TopicContentSeq& content, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceStormElection__TopicManagerSync__getContent_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceStormElection::TopicManagerSync* __del = dynamic_cast< ::IceDelegate::IceStormElection::TopicManagerSync*>(__delBase.get());
            __del->getContent(llu, content, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceStormElection::TopicManagerSync::ice_staticId()
{
    return ::IceStormElection::TopicManagerSync::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceStormElection::TopicManagerSync::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceStormElection::TopicManagerSync);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceStormElection::TopicManagerSync::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceStormElection::TopicManagerSync);
}

::IceProxy::Ice::Object*
IceProxy::IceStormElection::TopicManagerSync::__newInstance() const
{
    return new TopicManagerSync;
}

void
IceProxy::IceStormElection::Node::invitation(::Ice::Int j, const ::std::string& gn, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceStormElection::Node* __del = dynamic_cast< ::IceDelegate::IceStormElection::Node*>(__delBase.get());
            __del->invitation(j, gn, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceStormElection::Node::ready(::Ice::Int j, const ::std::string& gn, const ::Ice::ObjectPrx& coordinator, ::Ice::Int max, ::Ice::Long generation, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceStormElection::Node* __del = dynamic_cast< ::IceDelegate::IceStormElection::Node*>(__delBase.get());
            __del->ready(j, gn, coordinator, max, generation, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceStormElection::Node::accept(::Ice::Int j, const ::std::string& gn, const ::Ice::IntSeq& forwardedInvites, const ::Ice::ObjectPrx& observer, const ::IceStormElection::LogUpdate& llu, ::Ice::Int max, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceStormElection::Node* __del = dynamic_cast< ::IceDelegate::IceStormElection::Node*>(__delBase.get());
            __del->accept(j, gn, forwardedInvites, observer, llu, max, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceStormElection::Node::areYouCoordinator(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceStormElection__Node__areYouCoordinator_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceStormElection::Node* __del = dynamic_cast< ::IceDelegate::IceStormElection::Node*>(__delBase.get());
            return __del->areYouCoordinator(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceStormElection::Node::areYouThere(const ::std::string& gn, ::Ice::Int j, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceStormElection__Node__areYouThere_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceStormElection::Node* __del = dynamic_cast< ::IceDelegate::IceStormElection::Node*>(__delBase.get());
            return __del->areYouThere(gn, j, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::Ice::ObjectPrx
IceProxy::IceStormElection::Node::sync(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceStormElection__Node__sync_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceStormElection::Node* __del = dynamic_cast< ::IceDelegate::IceStormElection::Node*>(__delBase.get());
            return __del->sync(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::IceStormElection::NodeInfoSeq
IceProxy::IceStormElection::Node::nodes(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceStormElection__Node__nodes_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceStormElection::Node* __del = dynamic_cast< ::IceDelegate::IceStormElection::Node*>(__delBase.get());
            return __del->nodes(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::IceStormElection::QueryInfo
IceProxy::IceStormElection::Node::query(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceStormElection__Node__query_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceStormElection::Node* __del = dynamic_cast< ::IceDelegate::IceStormElection::Node*>(__delBase.get());
            return __del->query(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceStormElection::Node::ice_staticId()
{
    return ::IceStormElection::Node::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceStormElection::Node::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceStormElection::Node);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceStormElection::Node::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceStormElection::Node);
}

::IceProxy::Ice::Object*
IceProxy::IceStormElection::Node::__newInstance() const
{
    return new Node;
}

void
IceDelegateM::IceStormElection::ReplicaObserver::init(const ::IceStormElection::LogUpdate& llu, const ::IceStormElection::TopicContentSeq& content, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceStormElection__ReplicaObserver__init_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        llu.__write(__os);
        if(content.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceStormElection::__writeTopicContentSeq(__os, &content[0], &content[0] + content.size());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::IceStormElection::ObserverInconsistencyException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        __og.is()->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceStormElection::ReplicaObserver::createTopic(const ::IceStormElection::LogUpdate& llu, const ::std::string& name, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceStormElection__ReplicaObserver__createTopic_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        llu.__write(__os);
        __os->write(name);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::IceStormElection::ObserverInconsistencyException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        __og.is()->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceStormElection::ReplicaObserver::destroyTopic(const ::IceStormElection::LogUpdate& llu, const ::std::string& name, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceStormElection__ReplicaObserver__destroyTopic_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        llu.__write(__os);
        __os->write(name);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::IceStormElection::ObserverInconsistencyException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        __og.is()->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceStormElection::ReplicaObserver::addSubscriber(const ::IceStormElection::LogUpdate& llu, const ::std::string& topic, const ::IceStorm::SubscriberRecord& record, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceStormElection__ReplicaObserver__addSubscriber_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        llu.__write(__os);
        __os->write(topic);
        record.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::IceStormElection::ObserverInconsistencyException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        __og.is()->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceStormElection::ReplicaObserver::removeSubscriber(const ::IceStormElection::LogUpdate& llu, const ::std::string& topic, const ::Ice::IdentitySeq& subscribers, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceStormElection__ReplicaObserver__removeSubscriber_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        llu.__write(__os);
        __os->write(topic);
        if(subscribers.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::Ice::__writeIdentitySeq(__os, &subscribers[0], &subscribers[0] + subscribers.size());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::IceStormElection::ObserverInconsistencyException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        __og.is()->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceStormElection::TopicManagerSync::getContent(::IceStormElection::LogUpdate& llu, ::IceStormElection::TopicContentSeq& content, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceStormElection__TopicManagerSync__getContent_name, ::Ice::Normal, __context);
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        llu.__read(__is);
        ::IceStormElection::__readTopicContentSeq(__is, content);
        __is->endReadEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceStormElection::Node::invitation(::Ice::Int j, const ::std::string& gn, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceStormElection__Node__invitation_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(j);
        __os->write(gn);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceStormElection::Node::ready(::Ice::Int j, const ::std::string& gn, const ::Ice::ObjectPrx& coordinator, ::Ice::Int max, ::Ice::Long generation, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceStormElection__Node__ready_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(j);
        __os->write(gn);
        __os->write(coordinator);
        __os->write(max);
        __os->write(generation);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceStormElection::Node::accept(::Ice::Int j, const ::std::string& gn, const ::Ice::IntSeq& forwardedInvites, const ::Ice::ObjectPrx& observer, const ::IceStormElection::LogUpdate& llu, ::Ice::Int max, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceStormElection__Node__accept_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(j);
        __os->write(gn);
        if(forwardedInvites.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            __os->write(&forwardedInvites[0], &forwardedInvites[0] + forwardedInvites.size());
        }
        __os->write(observer);
        llu.__write(__os);
        __os->write(max);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

bool
IceDelegateM::IceStormElection::Node::areYouCoordinator(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceStormElection__Node__areYouCoordinator_name, ::Ice::Idempotent, __context);
    bool __ok = __og.invoke();
    bool __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

bool
IceDelegateM::IceStormElection::Node::areYouThere(const ::std::string& gn, ::Ice::Int j, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceStormElection__Node__areYouThere_name, ::Ice::Idempotent, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(gn);
        __os->write(j);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    bool __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::ObjectPrx
IceDelegateM::IceStormElection::Node::sync(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceStormElection__Node__sync_name, ::Ice::Idempotent, __context);
    bool __ok = __og.invoke();
    ::Ice::ObjectPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceStormElection::NodeInfoSeq
IceDelegateM::IceStormElection::Node::nodes(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceStormElection__Node__nodes_name, ::Ice::Idempotent, __context);
    bool __ok = __og.invoke();
    ::IceStormElection::NodeInfoSeq __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::IceStormElection::__readNodeInfoSeq(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceStormElection::QueryInfo
IceDelegateM::IceStormElection::Node::query(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceStormElection__Node__query_name, ::Ice::Idempotent, __context);
    bool __ok = __og.invoke();
    ::IceStormElection::QueryInfo __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __ret.__read(__is);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateD::IceStormElection::ReplicaObserver::init(const ::IceStormElection::LogUpdate& llu, const ::IceStormElection::TopicContentSeq& content, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::IceStormElection::LogUpdate& llu, const ::IceStormElection::TopicContentSeq& content, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_llu(llu),
            _m_content(content)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceStormElection::ReplicaObserver* servant = dynamic_cast< ::IceStormElection::ReplicaObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                servant->init(_m_llu, _m_content, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        const ::IceStormElection::LogUpdate& _m_llu;
        const ::IceStormElection::TopicContentSeq& _m_content;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceStormElection__ReplicaObserver__init_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(llu, content, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::IceStormElection::ObserverInconsistencyException&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceStormElection::ReplicaObserver::createTopic(const ::IceStormElection::LogUpdate& llu, const ::std::string& name, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::IceStormElection::LogUpdate& llu, const ::std::string& name, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_llu(llu),
            _m_name(name)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceStormElection::ReplicaObserver* servant = dynamic_cast< ::IceStormElection::ReplicaObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                servant->createTopic(_m_llu, _m_name, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        const ::IceStormElection::LogUpdate& _m_llu;
        const ::std::string& _m_name;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceStormElection__ReplicaObserver__createTopic_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(llu, name, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::IceStormElection::ObserverInconsistencyException&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceStormElection::ReplicaObserver::destroyTopic(const ::IceStormElection::LogUpdate& llu, const ::std::string& name, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::IceStormElection::LogUpdate& llu, const ::std::string& name, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_llu(llu),
            _m_name(name)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceStormElection::ReplicaObserver* servant = dynamic_cast< ::IceStormElection::ReplicaObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                servant->destroyTopic(_m_llu, _m_name, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        const ::IceStormElection::LogUpdate& _m_llu;
        const ::std::string& _m_name;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceStormElection__ReplicaObserver__destroyTopic_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(llu, name, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::IceStormElection::ObserverInconsistencyException&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceStormElection::ReplicaObserver::addSubscriber(const ::IceStormElection::LogUpdate& llu, const ::std::string& topic, const ::IceStorm::SubscriberRecord& record, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::IceStormElection::LogUpdate& llu, const ::std::string& topic, const ::IceStorm::SubscriberRecord& record, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_llu(llu),
            _m_topic(topic),
            _m_record(record)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceStormElection::ReplicaObserver* servant = dynamic_cast< ::IceStormElection::ReplicaObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                servant->addSubscriber(_m_llu, _m_topic, _m_record, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        const ::IceStormElection::LogUpdate& _m_llu;
        const ::std::string& _m_topic;
        const ::IceStorm::SubscriberRecord& _m_record;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceStormElection__ReplicaObserver__addSubscriber_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(llu, topic, record, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::IceStormElection::ObserverInconsistencyException&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceStormElection::ReplicaObserver::removeSubscriber(const ::IceStormElection::LogUpdate& llu, const ::std::string& topic, const ::Ice::IdentitySeq& subscribers, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::IceStormElection::LogUpdate& llu, const ::std::string& topic, const ::Ice::IdentitySeq& subscribers, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_llu(llu),
            _m_topic(topic),
            _m_subscribers(subscribers)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceStormElection::ReplicaObserver* servant = dynamic_cast< ::IceStormElection::ReplicaObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                servant->removeSubscriber(_m_llu, _m_topic, _m_subscribers, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        const ::IceStormElection::LogUpdate& _m_llu;
        const ::std::string& _m_topic;
        const ::Ice::IdentitySeq& _m_subscribers;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceStormElection__ReplicaObserver__removeSubscriber_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(llu, topic, subscribers, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::IceStormElection::ObserverInconsistencyException&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceStormElection::TopicManagerSync::getContent(::IceStormElection::LogUpdate& llu, ::IceStormElection::TopicContentSeq& content, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::IceStormElection::LogUpdate& llu, ::IceStormElection::TopicContentSeq& content, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_llu(llu),
            _m_content(content)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceStormElection::TopicManagerSync* servant = dynamic_cast< ::IceStormElection::TopicManagerSync*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->getContent(_m_llu, _m_content, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::IceStormElection::LogUpdate& _m_llu;
        ::IceStormElection::TopicContentSeq& _m_content;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceStormElection__TopicManagerSync__getContent_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(llu, content, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceStormElection::Node::invitation(::Ice::Int j, const ::std::string& gn, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Ice::Int j, const ::std::string& gn, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_j(j),
            _m_gn(gn)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceStormElection::Node* servant = dynamic_cast< ::IceStormElection::Node*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->invitation(_m_j, _m_gn, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::Ice::Int _m_j;
        const ::std::string& _m_gn;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceStormElection__Node__invitation_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(j, gn, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceStormElection::Node::ready(::Ice::Int j, const ::std::string& gn, const ::Ice::ObjectPrx& coordinator, ::Ice::Int max, ::Ice::Long generation, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Ice::Int j, const ::std::string& gn, const ::Ice::ObjectPrx& coordinator, ::Ice::Int max, ::Ice::Long generation, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_j(j),
            _m_gn(gn),
            _m_coordinator(coordinator),
            _m_max(max),
            _m_generation(generation)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceStormElection::Node* servant = dynamic_cast< ::IceStormElection::Node*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->ready(_m_j, _m_gn, _m_coordinator, _m_max, _m_generation, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::Ice::Int _m_j;
        const ::std::string& _m_gn;
        const ::Ice::ObjectPrx& _m_coordinator;
        ::Ice::Int _m_max;
        ::Ice::Long _m_generation;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceStormElection__Node__ready_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(j, gn, coordinator, max, generation, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceStormElection::Node::accept(::Ice::Int j, const ::std::string& gn, const ::Ice::IntSeq& forwardedInvites, const ::Ice::ObjectPrx& observer, const ::IceStormElection::LogUpdate& llu, ::Ice::Int max, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Ice::Int j, const ::std::string& gn, const ::Ice::IntSeq& forwardedInvites, const ::Ice::ObjectPrx& observer, const ::IceStormElection::LogUpdate& llu, ::Ice::Int max, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_j(j),
            _m_gn(gn),
            _m_forwardedInvites(forwardedInvites),
            _m_observer(observer),
            _m_llu(llu),
            _m_max(max)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceStormElection::Node* servant = dynamic_cast< ::IceStormElection::Node*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->accept(_m_j, _m_gn, _m_forwardedInvites, _m_observer, _m_llu, _m_max, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::Ice::Int _m_j;
        const ::std::string& _m_gn;
        const ::Ice::IntSeq& _m_forwardedInvites;
        const ::Ice::ObjectPrx& _m_observer;
        const ::IceStormElection::LogUpdate& _m_llu;
        ::Ice::Int _m_max;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceStormElection__Node__accept_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(j, gn, forwardedInvites, observer, llu, max, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

bool
IceDelegateD::IceStormElection::Node::areYouCoordinator(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(bool& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceStormElection::Node* servant = dynamic_cast< ::IceStormElection::Node*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->areYouCoordinator(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        bool& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceStormElection__Node__areYouCoordinator_name, ::Ice::Idempotent, __context);
    bool __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

bool
IceDelegateD::IceStormElection::Node::areYouThere(const ::std::string& gn, ::Ice::Int j, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(bool& __result, const ::std::string& gn, ::Ice::Int j, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_gn(gn),
            _m_j(j)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceStormElection::Node* servant = dynamic_cast< ::IceStormElection::Node*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->areYouThere(_m_gn, _m_j, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        bool& _result;
        const ::std::string& _m_gn;
        ::Ice::Int _m_j;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceStormElection__Node__areYouThere_name, ::Ice::Idempotent, __context);
    bool __result;
    try
    {
        _DirectI __direct(__result, gn, j, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Ice::ObjectPrx
IceDelegateD::IceStormElection::Node::sync(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Ice::ObjectPrx& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceStormElection::Node* servant = dynamic_cast< ::IceStormElection::Node*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->sync(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::Ice::ObjectPrx& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceStormElection__Node__sync_name, ::Ice::Idempotent, __context);
    ::Ice::ObjectPrx __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::IceStormElection::NodeInfoSeq
IceDelegateD::IceStormElection::Node::nodes(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::IceStormElection::NodeInfoSeq& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceStormElection::Node* servant = dynamic_cast< ::IceStormElection::Node*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->nodes(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::IceStormElection::NodeInfoSeq& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceStormElection__Node__nodes_name, ::Ice::Idempotent, __context);
    ::IceStormElection::NodeInfoSeq __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::IceStormElection::QueryInfo
IceDelegateD::IceStormElection::Node::query(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::IceStormElection::QueryInfo& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceStormElection::Node* servant = dynamic_cast< ::IceStormElection::Node*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->query(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::IceStormElection::QueryInfo& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceStormElection__Node__query_name, ::Ice::Idempotent, __context);
    ::IceStormElection::QueryInfo __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Ice::ObjectPtr
IceStormElection::ReplicaObserver::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceStormElection__ReplicaObserver_ids[2] =
{
    "::Ice::Object",
    "::IceStormElection::ReplicaObserver"
};

bool
IceStormElection::ReplicaObserver::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceStormElection__ReplicaObserver_ids, __IceStormElection__ReplicaObserver_ids + 2, _s);
}

::std::vector< ::std::string>
IceStormElection::ReplicaObserver::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceStormElection__ReplicaObserver_ids[0], &__IceStormElection__ReplicaObserver_ids[2]);
}

const ::std::string&
IceStormElection::ReplicaObserver::ice_id(const ::Ice::Current&) const
{
    return __IceStormElection__ReplicaObserver_ids[1];
}

const ::std::string&
IceStormElection::ReplicaObserver::ice_staticId()
{
    return __IceStormElection__ReplicaObserver_ids[1];
}

::Ice::DispatchStatus
IceStormElection::ReplicaObserver::___init(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceStormElection::LogUpdate llu;
    ::IceStormElection::TopicContentSeq content;
    llu.__read(__is);
    ::IceStormElection::__readTopicContentSeq(__is, content);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        init(llu, content, __current);
    }
    catch(const ::IceStormElection::ObserverInconsistencyException& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceStormElection::ReplicaObserver::___createTopic(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceStormElection::LogUpdate llu;
    ::std::string name;
    llu.__read(__is);
    __is->read(name);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        createTopic(llu, name, __current);
    }
    catch(const ::IceStormElection::ObserverInconsistencyException& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceStormElection::ReplicaObserver::___destroyTopic(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceStormElection::LogUpdate llu;
    ::std::string name;
    llu.__read(__is);
    __is->read(name);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        destroyTopic(llu, name, __current);
    }
    catch(const ::IceStormElection::ObserverInconsistencyException& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceStormElection::ReplicaObserver::___addSubscriber(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceStormElection::LogUpdate llu;
    ::std::string topic;
    ::IceStorm::SubscriberRecord record;
    llu.__read(__is);
    __is->read(topic);
    record.__read(__is);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        addSubscriber(llu, topic, record, __current);
    }
    catch(const ::IceStormElection::ObserverInconsistencyException& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceStormElection::ReplicaObserver::___removeSubscriber(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceStormElection::LogUpdate llu;
    ::std::string topic;
    ::Ice::IdentitySeq subscribers;
    llu.__read(__is);
    __is->read(topic);
    ::Ice::__readIdentitySeq(__is, subscribers);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        removeSubscriber(llu, topic, subscribers, __current);
    }
    catch(const ::IceStormElection::ObserverInconsistencyException& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

static ::std::string __IceStormElection__ReplicaObserver_all[] =
{
    "addSubscriber",
    "createTopic",
    "destroyTopic",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "init",
    "removeSubscriber"
};

::Ice::DispatchStatus
IceStormElection::ReplicaObserver::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceStormElection__ReplicaObserver_all, __IceStormElection__ReplicaObserver_all + 9, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __IceStormElection__ReplicaObserver_all)
    {
        case 0:
        {
            return ___addSubscriber(in, current);
        }
        case 1:
        {
            return ___createTopic(in, current);
        }
        case 2:
        {
            return ___destroyTopic(in, current);
        }
        case 3:
        {
            return ___ice_id(in, current);
        }
        case 4:
        {
            return ___ice_ids(in, current);
        }
        case 5:
        {
            return ___ice_isA(in, current);
        }
        case 6:
        {
            return ___ice_ping(in, current);
        }
        case 7:
        {
            return ___init(in, current);
        }
        case 8:
        {
            return ___removeSubscriber(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
IceStormElection::ReplicaObserver::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceStormElection::ReplicaObserver::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceStormElection::ReplicaObserver::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceStormElection::ReplicaObserver was not generated with stream support";
    throw ex;
}

void
IceStormElection::ReplicaObserver::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceStormElection::ReplicaObserver was not generated with stream support";
    throw ex;
}

void 
IceStormElection::__patch__ReplicaObserverPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceStormElection::ReplicaObserverPtr* p = static_cast< ::IceStormElection::ReplicaObserverPtr*>(__addr);
    assert(p);
    *p = ::IceStormElection::ReplicaObserverPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceStormElection::ReplicaObserver::ice_staticId(), v->ice_id());
    }
}

bool
IceStormElection::operator==(const ::IceStormElection::ReplicaObserver& l, const ::IceStormElection::ReplicaObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceStormElection::operator<(const ::IceStormElection::ReplicaObserver& l, const ::IceStormElection::ReplicaObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
IceStormElection::TopicManagerSync::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceStormElection__TopicManagerSync_ids[2] =
{
    "::Ice::Object",
    "::IceStormElection::TopicManagerSync"
};

bool
IceStormElection::TopicManagerSync::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceStormElection__TopicManagerSync_ids, __IceStormElection__TopicManagerSync_ids + 2, _s);
}

::std::vector< ::std::string>
IceStormElection::TopicManagerSync::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceStormElection__TopicManagerSync_ids[0], &__IceStormElection__TopicManagerSync_ids[2]);
}

const ::std::string&
IceStormElection::TopicManagerSync::ice_id(const ::Ice::Current&) const
{
    return __IceStormElection__TopicManagerSync_ids[1];
}

const ::std::string&
IceStormElection::TopicManagerSync::ice_staticId()
{
    return __IceStormElection__TopicManagerSync_ids[1];
}

::Ice::DispatchStatus
IceStormElection::TopicManagerSync::___getContent(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::IceStormElection::LogUpdate llu;
    ::IceStormElection::TopicContentSeq content;
    getContent(llu, content, __current);
    llu.__write(__os);
    if(content.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::IceStormElection::__writeTopicContentSeq(__os, &content[0], &content[0] + content.size());
    }
    return ::Ice::DispatchOK;
}

static ::std::string __IceStormElection__TopicManagerSync_all[] =
{
    "getContent",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::Ice::DispatchStatus
IceStormElection::TopicManagerSync::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceStormElection__TopicManagerSync_all, __IceStormElection__TopicManagerSync_all + 5, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __IceStormElection__TopicManagerSync_all)
    {
        case 0:
        {
            return ___getContent(in, current);
        }
        case 1:
        {
            return ___ice_id(in, current);
        }
        case 2:
        {
            return ___ice_ids(in, current);
        }
        case 3:
        {
            return ___ice_isA(in, current);
        }
        case 4:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
IceStormElection::TopicManagerSync::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceStormElection::TopicManagerSync::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceStormElection::TopicManagerSync::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceStormElection::TopicManagerSync was not generated with stream support";
    throw ex;
}

void
IceStormElection::TopicManagerSync::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceStormElection::TopicManagerSync was not generated with stream support";
    throw ex;
}

void 
IceStormElection::__patch__TopicManagerSyncPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceStormElection::TopicManagerSyncPtr* p = static_cast< ::IceStormElection::TopicManagerSyncPtr*>(__addr);
    assert(p);
    *p = ::IceStormElection::TopicManagerSyncPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceStormElection::TopicManagerSync::ice_staticId(), v->ice_id());
    }
}

bool
IceStormElection::operator==(const ::IceStormElection::TopicManagerSync& l, const ::IceStormElection::TopicManagerSync& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceStormElection::operator<(const ::IceStormElection::TopicManagerSync& l, const ::IceStormElection::TopicManagerSync& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
IceStormElection::Node::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceStormElection__Node_ids[2] =
{
    "::Ice::Object",
    "::IceStormElection::Node"
};

bool
IceStormElection::Node::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceStormElection__Node_ids, __IceStormElection__Node_ids + 2, _s);
}

::std::vector< ::std::string>
IceStormElection::Node::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceStormElection__Node_ids[0], &__IceStormElection__Node_ids[2]);
}

const ::std::string&
IceStormElection::Node::ice_id(const ::Ice::Current&) const
{
    return __IceStormElection__Node_ids[1];
}

const ::std::string&
IceStormElection::Node::ice_staticId()
{
    return __IceStormElection__Node_ids[1];
}

::Ice::DispatchStatus
IceStormElection::Node::___invitation(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Ice::Int j;
    ::std::string gn;
    __is->read(j);
    __is->read(gn);
    __is->endReadEncaps();
    invitation(j, gn, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceStormElection::Node::___ready(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Ice::Int j;
    ::std::string gn;
    ::Ice::ObjectPrx coordinator;
    ::Ice::Int max;
    ::Ice::Long generation;
    __is->read(j);
    __is->read(gn);
    __is->read(coordinator);
    __is->read(max);
    __is->read(generation);
    __is->endReadEncaps();
    ready(j, gn, coordinator, max, generation, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceStormElection::Node::___accept(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Ice::Int j;
    ::std::string gn;
    ::Ice::IntSeq forwardedInvites;
    ::Ice::ObjectPrx observer;
    ::IceStormElection::LogUpdate llu;
    ::Ice::Int max;
    __is->read(j);
    __is->read(gn);
    __is->read(forwardedInvites);
    __is->read(observer);
    llu.__read(__is);
    __is->read(max);
    __is->endReadEncaps();
    accept(j, gn, forwardedInvites, observer, llu, max, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceStormElection::Node::___areYouCoordinator(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    bool __ret = areYouCoordinator(__current);
    __os->write(__ret);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceStormElection::Node::___areYouThere(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string gn;
    ::Ice::Int j;
    __is->read(gn);
    __is->read(j);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    bool __ret = areYouThere(gn, j, __current);
    __os->write(__ret);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceStormElection::Node::___sync(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::ObjectPrx __ret = sync(__current);
    __os->write(__ret);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceStormElection::Node::___nodes(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::IceStormElection::NodeInfoSeq __ret = nodes(__current);
    if(__ret.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::IceStormElection::__writeNodeInfoSeq(__os, &__ret[0], &__ret[0] + __ret.size());
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceStormElection::Node::___query(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::IceStormElection::QueryInfo __ret = query(__current);
    __ret.__write(__os);
    return ::Ice::DispatchOK;
}

static ::std::string __IceStormElection__Node_all[] =
{
    "accept",
    "areYouCoordinator",
    "areYouThere",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "invitation",
    "nodes",
    "query",
    "ready",
    "sync"
};

::Ice::DispatchStatus
IceStormElection::Node::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceStormElection__Node_all, __IceStormElection__Node_all + 12, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __IceStormElection__Node_all)
    {
        case 0:
        {
            return ___accept(in, current);
        }
        case 1:
        {
            return ___areYouCoordinator(in, current);
        }
        case 2:
        {
            return ___areYouThere(in, current);
        }
        case 3:
        {
            return ___ice_id(in, current);
        }
        case 4:
        {
            return ___ice_ids(in, current);
        }
        case 5:
        {
            return ___ice_isA(in, current);
        }
        case 6:
        {
            return ___ice_ping(in, current);
        }
        case 7:
        {
            return ___invitation(in, current);
        }
        case 8:
        {
            return ___nodes(in, current);
        }
        case 9:
        {
            return ___query(in, current);
        }
        case 10:
        {
            return ___ready(in, current);
        }
        case 11:
        {
            return ___sync(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
IceStormElection::Node::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceStormElection::Node::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceStormElection::Node::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceStormElection::Node was not generated with stream support";
    throw ex;
}

void
IceStormElection::Node::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceStormElection::Node was not generated with stream support";
    throw ex;
}

void 
IceStormElection::__patch__NodePtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceStormElection::NodePtr* p = static_cast< ::IceStormElection::NodePtr*>(__addr);
    assert(p);
    *p = ::IceStormElection::NodePtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceStormElection::Node::ice_staticId(), v->ice_id());
    }
}

bool
IceStormElection::operator==(const ::IceStormElection::Node& l, const ::IceStormElection::Node& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceStormElection::operator<(const ::IceStormElection::Node& l, const ::IceStormElection::Node& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}
