// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `IceStormInternal.ice'

#include <IceStorm/IceStormInternal.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __IceStorm__TopicLink__forward_name = "forward";

static const ::std::string __IceStorm__TopicInternal__getLinkProxy_name = "getLinkProxy";

static const ::std::string __IceStorm__TopicInternal__reap_name = "reap";

static const ::std::string __IceStorm__TopicManagerInternal__getReplicaNode_name = "getReplicaNode";

::Ice::Object* IceInternal::upCast(::IceStorm::TopicLink* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceStorm::TopicLink* p) { return p; }

::Ice::Object* IceInternal::upCast(::IceStorm::TopicInternal* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceStorm::TopicInternal* p) { return p; }

::Ice::Object* IceInternal::upCast(::IceStorm::TopicManagerInternal* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceStorm::TopicManagerInternal* p) { return p; }

void
IceStorm::__read(::IceInternal::BasicStream* __is, ::IceStorm::TopicLinkPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceStorm::TopicLink;
        v->__copyFrom(proxy);
    }
}

void
IceStorm::__read(::IceInternal::BasicStream* __is, ::IceStorm::TopicInternalPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceStorm::TopicInternal;
        v->__copyFrom(proxy);
    }
}

void
IceStorm::__read(::IceInternal::BasicStream* __is, ::IceStorm::TopicManagerInternalPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceStorm::TopicManagerInternal;
        v->__copyFrom(proxy);
    }
}

IceStorm::EventData::EventData(const ::std::string& __ice_op, ::Ice::OperationMode __ice_mode, const ::Ice::ByteSeq& __ice_data, const ::Ice::Context& __ice_context) :op(__ice_op),
    mode(__ice_mode),
    data(__ice_data),
    context(__ice_context)
{
}

bool
IceStorm::EventData::operator==(const EventData& __rhs) const
{
    if(this == &__rhs)
    {
        return true;
    }
    if(op != __rhs.op)
    {
        return false;
    }
    if(mode != __rhs.mode)
    {
        return false;
    }
    if(data != __rhs.data)
    {
        return false;
    }
    if(context != __rhs.context)
    {
        return false;
    }
    return true;
}

bool
IceStorm::EventData::operator<(const EventData& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(op < __rhs.op)
    {
        return true;
    }
    else if(__rhs.op < op)
    {
        return false;
    }
    if(mode < __rhs.mode)
    {
        return true;
    }
    else if(__rhs.mode < mode)
    {
        return false;
    }
    if(data < __rhs.data)
    {
        return true;
    }
    else if(__rhs.data < data)
    {
        return false;
    }
    if(context < __rhs.context)
    {
        return true;
    }
    else if(__rhs.context < context)
    {
        return false;
    }
    return false;
}

void
IceStorm::EventData::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(op);
    ::Ice::__write(__os, mode);
    if(data.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        __os->write(&data[0], &data[0] + data.size());
    }
    ::Ice::__writeContext(__os, context);
}

void
IceStorm::EventData::__read(::IceInternal::BasicStream* __is)
{
    __is->read(op);
    ::Ice::__read(__is, mode);
    ::std::pair<const ::Ice::Byte*, const ::Ice::Byte*> ___data;
    __is->read(___data);
    ::std::vector< ::Ice::Byte>(___data.first, ___data.second).swap(data);
    ::Ice::__readContext(__is, context);
}

void
IceStorm::__writeEventDataSeq(::IceInternal::BasicStream* __os, const ::IceStorm::EventDataSeq& v)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(v.size());
    __os->writeSize(size);
    for(EventDataSeq::const_iterator p = v.begin(); p != v.end(); ++p)
    {
        (*p)->__write(__os);
    }
}

void
IceStorm::__readEventDataSeq(::IceInternal::BasicStream* __is, ::IceStorm::EventDataSeq& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    EventDataSeq(sz).swap(v);
    __is->startSeq(sz, 4);
    for(EventDataSeq::iterator p = v.begin(); p != v.end(); ++p)
    {
        (*p) = new ::IceStorm::EventData;
        (*p)->__read(__is);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

IceStorm::ReapWouldBlock::~ReapWouldBlock() throw()
{
}

static const char* __IceStorm__ReapWouldBlock_name = "IceStorm::ReapWouldBlock";

::std::string
IceStorm::ReapWouldBlock::ice_name() const
{
    return __IceStorm__ReapWouldBlock_name;
}

::Ice::Exception*
IceStorm::ReapWouldBlock::ice_clone() const
{
    return new ReapWouldBlock(*this);
}

void
IceStorm::ReapWouldBlock::ice_throw() const
{
    throw *this;
}

void
IceStorm::ReapWouldBlock::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceStorm::ReapWouldBlock"), false);
    __os->startWriteSlice();
    __os->endWriteSlice();
}

void
IceStorm::ReapWouldBlock::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->endReadSlice();
}

void
IceStorm::ReapWouldBlock::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceStorm::ReapWouldBlock was not generated with stream support";
    throw ex;
}

void
IceStorm::ReapWouldBlock::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceStorm::ReapWouldBlock was not generated with stream support";
    throw ex;
}

struct __F__IceStorm__ReapWouldBlock : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceStorm::ReapWouldBlock();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceStorm__ReapWouldBlock__Ptr = new __F__IceStorm__ReapWouldBlock;

const ::IceInternal::UserExceptionFactoryPtr&
IceStorm::ReapWouldBlock::ice_factory()
{
    return __F__IceStorm__ReapWouldBlock__Ptr;
}

class __F__IceStorm__ReapWouldBlock__Init
{
public:

    __F__IceStorm__ReapWouldBlock__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceStorm::ReapWouldBlock", ::IceStorm::ReapWouldBlock::ice_factory());
    }

    ~__F__IceStorm__ReapWouldBlock__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceStorm::ReapWouldBlock");
    }
};

static __F__IceStorm__ReapWouldBlock__Init __F__IceStorm__ReapWouldBlock__i;

#ifdef __APPLE__
extern "C" { void __F__IceStorm__ReapWouldBlock__initializer() {} }
#endif

bool
IceStorm::AMI_TopicLink_forward::__invoke(const ::IceStorm::TopicLinkPrx& __prx, const ::IceStorm::EventDataSeq& events, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prepare(__prx, __IceStorm__TopicLink__forward_name, ::Ice::Normal, __ctx);
        ::IceStorm::__writeEventDataSeq(__os, events);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceStorm::AMI_TopicLink_forward::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}

bool
IceStorm::AMI_TopicInternal_reap::__invoke(const ::IceStorm::TopicInternalPrx& __prx, const ::Ice::IdentitySeq& id, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prx->__checkTwowayOnly(__IceStorm__TopicInternal__reap_name);
        __prepare(__prx, __IceStorm__TopicInternal__reap_name, ::Ice::Normal, __ctx);
        if(id.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::Ice::__writeIdentitySeq(__os, &id[0], &id[0] + id.size());
        }
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceStorm::AMI_TopicInternal_reap::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::IceStorm::ReapWouldBlock& __ex)
            {
                __exception(__ex);
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}

void
IceProxy::IceStorm::TopicLink::forward(const ::IceStorm::EventDataSeq& events, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceStorm::TopicLink* __del = dynamic_cast< ::IceDelegate::IceStorm::TopicLink*>(__delBase.get());
            __del->forward(events, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceStorm::TopicLink::forward_async(const ::IceStorm::AMI_TopicLink_forwardPtr& __cb, const ::IceStorm::EventDataSeq& events)
{
    return __cb->__invoke(this, events, 0);
}

bool
IceProxy::IceStorm::TopicLink::forward_async(const ::IceStorm::AMI_TopicLink_forwardPtr& __cb, const ::IceStorm::EventDataSeq& events, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, events, &__ctx);
}

const ::std::string&
IceProxy::IceStorm::TopicLink::ice_staticId()
{
    return ::IceStorm::TopicLink::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceStorm::TopicLink::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceStorm::TopicLink);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceStorm::TopicLink::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceStorm::TopicLink);
}

::IceProxy::Ice::Object*
IceProxy::IceStorm::TopicLink::__newInstance() const
{
    return new TopicLink;
}

::IceStorm::TopicLinkPrx
IceProxy::IceStorm::TopicInternal::getLinkProxy(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceStorm__TopicInternal__getLinkProxy_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceStorm::TopicInternal* __del = dynamic_cast< ::IceDelegate::IceStorm::TopicInternal*>(__delBase.get());
            return __del->getLinkProxy(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceStorm::TopicInternal::reap(const ::Ice::IdentitySeq& id, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceStorm__TopicInternal__reap_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceStorm::TopicInternal* __del = dynamic_cast< ::IceDelegate::IceStorm::TopicInternal*>(__delBase.get());
            __del->reap(id, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceStorm::TopicInternal::reap_async(const ::IceStorm::AMI_TopicInternal_reapPtr& __cb, const ::Ice::IdentitySeq& id)
{
    return __cb->__invoke(this, id, 0);
}

bool
IceProxy::IceStorm::TopicInternal::reap_async(const ::IceStorm::AMI_TopicInternal_reapPtr& __cb, const ::Ice::IdentitySeq& id, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, id, &__ctx);
}

const ::std::string&
IceProxy::IceStorm::TopicInternal::ice_staticId()
{
    return ::IceStorm::TopicInternal::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceStorm::TopicInternal::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceStorm::TopicInternal);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceStorm::TopicInternal::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceStorm::TopicInternal);
}

::IceProxy::Ice::Object*
IceProxy::IceStorm::TopicInternal::__newInstance() const
{
    return new TopicInternal;
}

::IceStormElection::NodePrx
IceProxy::IceStorm::TopicManagerInternal::getReplicaNode(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceStorm__TopicManagerInternal__getReplicaNode_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceStorm::TopicManagerInternal* __del = dynamic_cast< ::IceDelegate::IceStorm::TopicManagerInternal*>(__delBase.get());
            return __del->getReplicaNode(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceStorm::TopicManagerInternal::ice_staticId()
{
    return ::IceStorm::TopicManagerInternal::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceStorm::TopicManagerInternal::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceStorm::TopicManagerInternal);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceStorm::TopicManagerInternal::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceStorm::TopicManagerInternal);
}

::IceProxy::Ice::Object*
IceProxy::IceStorm::TopicManagerInternal::__newInstance() const
{
    return new TopicManagerInternal;
}

void
IceDelegateM::IceStorm::TopicLink::forward(const ::IceStorm::EventDataSeq& events, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceStorm__TopicLink__forward_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        ::IceStorm::__writeEventDataSeq(__os, events);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

::IceStorm::TopicLinkPrx
IceDelegateM::IceStorm::TopicInternal::getLinkProxy(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceStorm__TopicInternal__getLinkProxy_name, ::Ice::Idempotent, __context);
    bool __ok = __og.invoke();
    ::IceStorm::TopicLinkPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::IceStorm::__read(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceStorm::TopicInternal::reap(const ::Ice::IdentitySeq& id, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceStorm__TopicInternal__reap_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(id.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::Ice::__writeIdentitySeq(__os, &id[0], &id[0] + id.size());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::IceStorm::ReapWouldBlock&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        __og.is()->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceStormElection::NodePrx
IceDelegateM::IceStorm::TopicManagerInternal::getReplicaNode(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceStorm__TopicManagerInternal__getReplicaNode_name, ::Ice::Idempotent, __context);
    bool __ok = __og.invoke();
    ::IceStormElection::NodePrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::IceStormElection::__read(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateD::IceStorm::TopicLink::forward(const ::IceStorm::EventDataSeq& events, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::IceStorm::EventDataSeq& events, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_events(events)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceStorm::TopicLink* servant = dynamic_cast< ::IceStorm::TopicLink*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->forward(_m_events, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::IceStorm::EventDataSeq& _m_events;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceStorm__TopicLink__forward_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(events, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

::IceStorm::TopicLinkPrx
IceDelegateD::IceStorm::TopicInternal::getLinkProxy(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::IceStorm::TopicLinkPrx& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceStorm::TopicInternal* servant = dynamic_cast< ::IceStorm::TopicInternal*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->getLinkProxy(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::IceStorm::TopicLinkPrx& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceStorm__TopicInternal__getLinkProxy_name, ::Ice::Idempotent, __context);
    ::IceStorm::TopicLinkPrx __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

void
IceDelegateD::IceStorm::TopicInternal::reap(const ::Ice::IdentitySeq& id, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Ice::IdentitySeq& id, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_id(id)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceStorm::TopicInternal* servant = dynamic_cast< ::IceStorm::TopicInternal*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                servant->reap(_m_id, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        const ::Ice::IdentitySeq& _m_id;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceStorm__TopicInternal__reap_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(id, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::IceStorm::ReapWouldBlock&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

::IceStormElection::NodePrx
IceDelegateD::IceStorm::TopicManagerInternal::getReplicaNode(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::IceStormElection::NodePrx& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceStorm::TopicManagerInternal* servant = dynamic_cast< ::IceStorm::TopicManagerInternal*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->getReplicaNode(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::IceStormElection::NodePrx& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceStorm__TopicManagerInternal__getReplicaNode_name, ::Ice::Idempotent, __context);
    ::IceStormElection::NodePrx __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Ice::ObjectPtr
IceStorm::TopicLink::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceStorm__TopicLink_ids[2] =
{
    "::Ice::Object",
    "::IceStorm::TopicLink"
};

bool
IceStorm::TopicLink::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceStorm__TopicLink_ids, __IceStorm__TopicLink_ids + 2, _s);
}

::std::vector< ::std::string>
IceStorm::TopicLink::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceStorm__TopicLink_ids[0], &__IceStorm__TopicLink_ids[2]);
}

const ::std::string&
IceStorm::TopicLink::ice_id(const ::Ice::Current&) const
{
    return __IceStorm__TopicLink_ids[1];
}

const ::std::string&
IceStorm::TopicLink::ice_staticId()
{
    return __IceStorm__TopicLink_ids[1];
}

::Ice::DispatchStatus
IceStorm::TopicLink::___forward(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceStorm::EventDataSeq events;
    ::IceStorm::__readEventDataSeq(__is, events);
    __is->endReadEncaps();
    forward(events, __current);
    return ::Ice::DispatchOK;
}

static ::std::string __IceStorm__TopicLink_all[] =
{
    "forward",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::Ice::DispatchStatus
IceStorm::TopicLink::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceStorm__TopicLink_all, __IceStorm__TopicLink_all + 5, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __IceStorm__TopicLink_all)
    {
        case 0:
        {
            return ___forward(in, current);
        }
        case 1:
        {
            return ___ice_id(in, current);
        }
        case 2:
        {
            return ___ice_ids(in, current);
        }
        case 3:
        {
            return ___ice_isA(in, current);
        }
        case 4:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
IceStorm::TopicLink::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceStorm::TopicLink::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceStorm::TopicLink::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceStorm::TopicLink was not generated with stream support";
    throw ex;
}

void
IceStorm::TopicLink::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceStorm::TopicLink was not generated with stream support";
    throw ex;
}

void 
IceStorm::__patch__TopicLinkPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceStorm::TopicLinkPtr* p = static_cast< ::IceStorm::TopicLinkPtr*>(__addr);
    assert(p);
    *p = ::IceStorm::TopicLinkPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceStorm::TopicLink::ice_staticId(), v->ice_id());
    }
}

bool
IceStorm::operator==(const ::IceStorm::TopicLink& l, const ::IceStorm::TopicLink& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceStorm::operator<(const ::IceStorm::TopicLink& l, const ::IceStorm::TopicLink& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
IceStorm::TopicInternal::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceStorm__TopicInternal_ids[3] =
{
    "::Ice::Object",
    "::IceStorm::Topic",
    "::IceStorm::TopicInternal"
};

bool
IceStorm::TopicInternal::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceStorm__TopicInternal_ids, __IceStorm__TopicInternal_ids + 3, _s);
}

::std::vector< ::std::string>
IceStorm::TopicInternal::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceStorm__TopicInternal_ids[0], &__IceStorm__TopicInternal_ids[3]);
}

const ::std::string&
IceStorm::TopicInternal::ice_id(const ::Ice::Current&) const
{
    return __IceStorm__TopicInternal_ids[2];
}

const ::std::string&
IceStorm::TopicInternal::ice_staticId()
{
    return __IceStorm__TopicInternal_ids[2];
}

::Ice::DispatchStatus
IceStorm::TopicInternal::___getLinkProxy(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::IceStorm::TopicLinkPrx __ret = getLinkProxy(__current);
    __os->write(::Ice::ObjectPrx(::IceInternal::upCast(__ret.get())));
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceStorm::TopicInternal::___reap(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Ice::IdentitySeq id;
    ::Ice::__readIdentitySeq(__is, id);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        reap(id, __current);
    }
    catch(const ::IceStorm::ReapWouldBlock& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

static ::std::string __IceStorm__TopicInternal_all[] =
{
    "destroy",
    "getLinkInfoSeq",
    "getLinkProxy",
    "getName",
    "getNonReplicatedPublisher",
    "getPublisher",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "link",
    "reap",
    "subscribe",
    "subscribeAndGetPublisher",
    "unlink",
    "unsubscribe"
};

::Ice::DispatchStatus
IceStorm::TopicInternal::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceStorm__TopicInternal_all, __IceStorm__TopicInternal_all + 16, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __IceStorm__TopicInternal_all)
    {
        case 0:
        {
            return ___destroy(in, current);
        }
        case 1:
        {
            return ___getLinkInfoSeq(in, current);
        }
        case 2:
        {
            return ___getLinkProxy(in, current);
        }
        case 3:
        {
            return ___getName(in, current);
        }
        case 4:
        {
            return ___getNonReplicatedPublisher(in, current);
        }
        case 5:
        {
            return ___getPublisher(in, current);
        }
        case 6:
        {
            return ___ice_id(in, current);
        }
        case 7:
        {
            return ___ice_ids(in, current);
        }
        case 8:
        {
            return ___ice_isA(in, current);
        }
        case 9:
        {
            return ___ice_ping(in, current);
        }
        case 10:
        {
            return ___link(in, current);
        }
        case 11:
        {
            return ___reap(in, current);
        }
        case 12:
        {
            return ___subscribe(in, current);
        }
        case 13:
        {
            return ___subscribeAndGetPublisher(in, current);
        }
        case 14:
        {
            return ___unlink(in, current);
        }
        case 15:
        {
            return ___unsubscribe(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
IceStorm::TopicInternal::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceStorm::TopicInternal::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceStorm::TopicInternal::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceStorm::TopicInternal was not generated with stream support";
    throw ex;
}

void
IceStorm::TopicInternal::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceStorm::TopicInternal was not generated with stream support";
    throw ex;
}

void 
IceStorm::__patch__TopicInternalPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceStorm::TopicInternalPtr* p = static_cast< ::IceStorm::TopicInternalPtr*>(__addr);
    assert(p);
    *p = ::IceStorm::TopicInternalPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceStorm::TopicInternal::ice_staticId(), v->ice_id());
    }
}

bool
IceStorm::operator==(const ::IceStorm::TopicInternal& l, const ::IceStorm::TopicInternal& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceStorm::operator<(const ::IceStorm::TopicInternal& l, const ::IceStorm::TopicInternal& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
IceStorm::TopicManagerInternal::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceStorm__TopicManagerInternal_ids[3] =
{
    "::Ice::Object",
    "::IceStorm::TopicManager",
    "::IceStorm::TopicManagerInternal"
};

bool
IceStorm::TopicManagerInternal::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceStorm__TopicManagerInternal_ids, __IceStorm__TopicManagerInternal_ids + 3, _s);
}

::std::vector< ::std::string>
IceStorm::TopicManagerInternal::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceStorm__TopicManagerInternal_ids[0], &__IceStorm__TopicManagerInternal_ids[3]);
}

const ::std::string&
IceStorm::TopicManagerInternal::ice_id(const ::Ice::Current&) const
{
    return __IceStorm__TopicManagerInternal_ids[2];
}

const ::std::string&
IceStorm::TopicManagerInternal::ice_staticId()
{
    return __IceStorm__TopicManagerInternal_ids[2];
}

::Ice::DispatchStatus
IceStorm::TopicManagerInternal::___getReplicaNode(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::IceStormElection::NodePrx __ret = getReplicaNode(__current);
    __os->write(::Ice::ObjectPrx(::IceInternal::upCast(__ret.get())));
    return ::Ice::DispatchOK;
}

static ::std::string __IceStorm__TopicManagerInternal_all[] =
{
    "create",
    "getReplicaNode",
    "getSliceChecksums",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "retrieve",
    "retrieveAll"
};

::Ice::DispatchStatus
IceStorm::TopicManagerInternal::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceStorm__TopicManagerInternal_all, __IceStorm__TopicManagerInternal_all + 9, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __IceStorm__TopicManagerInternal_all)
    {
        case 0:
        {
            return ___create(in, current);
        }
        case 1:
        {
            return ___getReplicaNode(in, current);
        }
        case 2:
        {
            return ___getSliceChecksums(in, current);
        }
        case 3:
        {
            return ___ice_id(in, current);
        }
        case 4:
        {
            return ___ice_ids(in, current);
        }
        case 5:
        {
            return ___ice_isA(in, current);
        }
        case 6:
        {
            return ___ice_ping(in, current);
        }
        case 7:
        {
            return ___retrieve(in, current);
        }
        case 8:
        {
            return ___retrieveAll(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
IceStorm::TopicManagerInternal::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceStorm::TopicManagerInternal::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceStorm::TopicManagerInternal::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceStorm::TopicManagerInternal was not generated with stream support";
    throw ex;
}

void
IceStorm::TopicManagerInternal::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceStorm::TopicManagerInternal was not generated with stream support";
    throw ex;
}

void 
IceStorm::__patch__TopicManagerInternalPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceStorm::TopicManagerInternalPtr* p = static_cast< ::IceStorm::TopicManagerInternalPtr*>(__addr);
    assert(p);
    *p = ::IceStorm::TopicManagerInternalPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceStorm::TopicManagerInternal::ice_staticId(), v->ice_id());
    }
}

bool
IceStorm::operator==(const ::IceStorm::TopicManagerInternal& l, const ::IceStorm::TopicManagerInternal& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceStorm::operator<(const ::IceStorm::TopicManagerInternal& l, const ::IceStorm::TopicManagerInternal& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}
