// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1

// Freeze types in this file:
// name="IceStorm::LLUMap", key="string", value="IceStormElection::LogUpdate"

#ifndef __LLUMap_h__
#define __LLUMap_h__

#include <Freeze/Map.h>
#include <IceStorm/Election.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

namespace IceStorm
{

class LLUMapKeyCodec
{
public:

    static void write(const ::std::string&, Freeze::Key&, const ::Ice::CommunicatorPtr&);
    static void read(::std::string&, const Freeze::Key&, const ::Ice::CommunicatorPtr&);
    static const std::string& typeId();
};

class LLUMapValueCodec
{
public:

    static void write(const ::IceStormElection::LogUpdate&, Freeze::Value&, const ::Ice::CommunicatorPtr&);
    static void read(::IceStormElection::LogUpdate&, const Freeze::Value&, const ::Ice::CommunicatorPtr&);
    static const std::string& typeId();
};

typedef Freeze::Map< ::std::string, ::IceStormElection::LogUpdate, LLUMapKeyCodec, LLUMapValueCodec, Freeze::IceEncodingCompare > LLUMap;

}

#endif
