// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `LinkRecord.ice'

#include <IceStorm/LinkRecord.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

bool
IceStorm::LinkRecord::operator==(const LinkRecord& __rhs) const
{
    if(this == &__rhs)
    {
        return true;
    }
    if(obj != __rhs.obj)
    {
        return false;
    }
    if(cost != __rhs.cost)
    {
        return false;
    }
    if(theTopic != __rhs.theTopic)
    {
        return false;
    }
    return true;
}

bool
IceStorm::LinkRecord::operator<(const LinkRecord& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(obj < __rhs.obj)
    {
        return true;
    }
    else if(__rhs.obj < obj)
    {
        return false;
    }
    if(cost < __rhs.cost)
    {
        return true;
    }
    else if(__rhs.cost < cost)
    {
        return false;
    }
    if(theTopic < __rhs.theTopic)
    {
        return true;
    }
    else if(__rhs.theTopic < theTopic)
    {
        return false;
    }
    return false;
}

void
IceStorm::LinkRecord::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::Ice::ObjectPrx(::IceInternal::upCast(obj.get())));
    __os->write(cost);
    __os->write(::Ice::ObjectPrx(::IceInternal::upCast(theTopic.get())));
}

void
IceStorm::LinkRecord::__read(::IceInternal::BasicStream* __is)
{
    ::IceStorm::__read(__is, obj);
    __is->read(cost);
    ::IceStorm::__read(__is, theTopic);
}
