// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `SubscriberRecord.ice'

#include <IceStorm/SubscriberRecord.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

bool
IceStorm::SubscriberRecordKey::operator==(const SubscriberRecordKey& __rhs) const
{
    if(this == &__rhs)
    {
        return true;
    }
    if(topic != __rhs.topic)
    {
        return false;
    }
    if(id != __rhs.id)
    {
        return false;
    }
    return true;
}

bool
IceStorm::SubscriberRecordKey::operator<(const SubscriberRecordKey& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(topic < __rhs.topic)
    {
        return true;
    }
    else if(__rhs.topic < topic)
    {
        return false;
    }
    if(id < __rhs.id)
    {
        return true;
    }
    else if(__rhs.id < id)
    {
        return false;
    }
    return false;
}

void
IceStorm::SubscriberRecordKey::__write(::IceInternal::BasicStream* __os) const
{
    topic.__write(__os);
    id.__write(__os);
}

void
IceStorm::SubscriberRecordKey::__read(::IceInternal::BasicStream* __is)
{
    topic.__read(__is);
    id.__read(__is);
}

bool
IceStorm::SubscriberRecord::operator==(const SubscriberRecord& __rhs) const
{
    if(this == &__rhs)
    {
        return true;
    }
    if(topicName != __rhs.topicName)
    {
        return false;
    }
    if(id != __rhs.id)
    {
        return false;
    }
    if(link != __rhs.link)
    {
        return false;
    }
    if(obj != __rhs.obj)
    {
        return false;
    }
    if(theQoS != __rhs.theQoS)
    {
        return false;
    }
    if(cost != __rhs.cost)
    {
        return false;
    }
    if(theTopic != __rhs.theTopic)
    {
        return false;
    }
    return true;
}

bool
IceStorm::SubscriberRecord::operator<(const SubscriberRecord& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(topicName < __rhs.topicName)
    {
        return true;
    }
    else if(__rhs.topicName < topicName)
    {
        return false;
    }
    if(id < __rhs.id)
    {
        return true;
    }
    else if(__rhs.id < id)
    {
        return false;
    }
    if(link < __rhs.link)
    {
        return true;
    }
    else if(__rhs.link < link)
    {
        return false;
    }
    if(obj < __rhs.obj)
    {
        return true;
    }
    else if(__rhs.obj < obj)
    {
        return false;
    }
    if(theQoS < __rhs.theQoS)
    {
        return true;
    }
    else if(__rhs.theQoS < theQoS)
    {
        return false;
    }
    if(cost < __rhs.cost)
    {
        return true;
    }
    else if(__rhs.cost < cost)
    {
        return false;
    }
    if(theTopic < __rhs.theTopic)
    {
        return true;
    }
    else if(__rhs.theTopic < theTopic)
    {
        return false;
    }
    return false;
}

void
IceStorm::SubscriberRecord::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(topicName);
    id.__write(__os);
    __os->write(link);
    __os->write(obj);
    ::IceStorm::__writeQoS(__os, theQoS);
    __os->write(cost);
    __os->write(::Ice::ObjectPrx(::IceInternal::upCast(theTopic.get())));
}

void
IceStorm::SubscriberRecord::__read(::IceInternal::BasicStream* __is)
{
    __is->read(topicName);
    id.__read(__is);
    __is->read(link);
    __is->read(obj);
    ::IceStorm::__readQoS(__is, theQoS);
    __is->read(cost);
    ::IceStorm::__read(__is, theTopic);
}

void
IceStorm::__writeSubscriberRecordSeq(::IceInternal::BasicStream* __os, const ::IceStorm::SubscriberRecord* begin, const ::IceStorm::SubscriberRecord* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        begin[i].__write(__os);
    }
}

void
IceStorm::__readSubscriberRecordSeq(::IceInternal::BasicStream* __is, ::IceStorm::SubscriberRecordSeq& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 13);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        v[i].__read(__is);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}
