// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `V31Format.ice'

#include <IceStorm/V31Format.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

void
IceStorm::__writeLinkRecordDict(::IceInternal::BasicStream* __os, const ::IceStorm::LinkRecordDict& v)
{
    __os->writeSize(::Ice::Int(v.size()));
    ::IceStorm::LinkRecordDict::const_iterator p;
    for(p = v.begin(); p != v.end(); ++p)
    {
        __os->write(p->first);
        p->second.__write(__os);
    }
}

void
IceStorm::__readLinkRecordDict(::IceInternal::BasicStream* __is, ::IceStorm::LinkRecordDict& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    while(sz--)
    {
        ::std::pair<const  ::std::string, ::IceStorm::LinkRecord> pair;
        __is->read(const_cast< ::std::string&>(pair.first));
        ::IceStorm::LinkRecordDict::iterator __i = v.insert(v.end(), pair);
        __i->second.__read(__is);
    }
}
