// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1

// Freeze types in this file:
// name="IceStorm::V31Format", key="string", value="IceStorm::LinkRecordDict"

#ifndef __V31FormatDB_h__
#define __V31FormatDB_h__

#include <Freeze/Map.h>
#include <IceStorm/V31Format.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

namespace IceStorm
{

class V31FormatKeyCodec
{
public:

    static void write(const ::std::string&, Freeze::Key&, const ::Ice::CommunicatorPtr&);
    static void read(::std::string&, const Freeze::Key&, const ::Ice::CommunicatorPtr&);
    static const std::string& typeId();
};

class V31FormatValueCodec
{
public:

    static void write(const ::IceStorm::LinkRecordDict&, Freeze::Value&, const ::Ice::CommunicatorPtr&);
    static void read(::IceStorm::LinkRecordDict&, const Freeze::Value&, const ::Ice::CommunicatorPtr&);
    static const std::string& typeId();
};

typedef Freeze::Map< ::std::string, ::IceStorm::LinkRecordDict, V31FormatKeyCodec, V31FormatValueCodec, Freeze::IceEncodingCompare > V31Format;

}

#endif
