// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1

// Freeze types in this file:
// name="IceStorm::V32Format", key="Ice::Identity", value="IceStorm::LinkRecordSeq"

#ifndef __V32FormatDB_h__
#define __V32FormatDB_h__

#include <Freeze/Map.h>
#include <IceStorm/V32Format.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

namespace IceStorm
{

class V32FormatKeyCodec
{
public:

    static void write(const ::Ice::Identity&, Freeze::Key&, const ::Ice::CommunicatorPtr&);
    static void read(::Ice::Identity&, const Freeze::Key&, const ::Ice::CommunicatorPtr&);
    static const std::string& typeId();
};

class V32FormatValueCodec
{
public:

    static void write(const ::IceStorm::LinkRecordSeq&, Freeze::Value&, const ::Ice::CommunicatorPtr&);
    static void read(::IceStorm::LinkRecordSeq&, const Freeze::Value&, const ::Ice::CommunicatorPtr&);
    static const std::string& typeId();
};

typedef Freeze::Map< ::Ice::Identity, ::IceStorm::LinkRecordSeq, V32FormatKeyCodec, V32FormatValueCodec, Freeze::IceEncodingCompare > V32Format;

}

#endif
