// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `Internal.ice'

#include <IceGrid/Internal.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <Ice/SliceChecksums.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __IceGrid__Adapter__activate_name = "activate";

static const ::std::string __IceGrid__Adapter__getDirectProxy_name = "getDirectProxy";

static const ::std::string __IceGrid__Adapter__setDirectProxy_name = "setDirectProxy";

static const ::std::string __IceGrid__FileReader__getOffsetFromEnd_name = "getOffsetFromEnd";

static const ::std::string __IceGrid__FileReader__read_name = "read";

static const ::std::string __IceGrid__Server__start_name = "start";

static const ::std::string __IceGrid__Server__stop_name = "stop";

static const ::std::string __IceGrid__Server__setEnabled_name = "setEnabled";

static const ::std::string __IceGrid__Server__isEnabled_name = "isEnabled";

static const ::std::string __IceGrid__Server__sendSignal_name = "sendSignal";

static const ::std::string __IceGrid__Server__writeMessage_name = "writeMessage";

static const ::std::string __IceGrid__Server__getState_name = "getState";

static const ::std::string __IceGrid__Server__getPid_name = "getPid";

static const ::std::string __IceGrid__Server__setProcess_name = "setProcess";

static const ::std::string __IceGrid__ReplicaObserver__replicaInit_name = "replicaInit";

static const ::std::string __IceGrid__ReplicaObserver__replicaAdded_name = "replicaAdded";

static const ::std::string __IceGrid__ReplicaObserver__replicaRemoved_name = "replicaRemoved";

static const ::std::string __IceGrid__PatcherFeedback__finished_name = "finished";

static const ::std::string __IceGrid__PatcherFeedback__failed_name = "failed";

static const ::std::string __IceGrid__Node__loadServer_name = "loadServer";

static const ::std::string __IceGrid__Node__destroyServer_name = "destroyServer";

static const ::std::string __IceGrid__Node__patch_name = "patch";

static const ::std::string __IceGrid__Node__registerWithReplica_name = "registerWithReplica";

static const ::std::string __IceGrid__Node__getName_name = "getName";

static const ::std::string __IceGrid__Node__getHostname_name = "getHostname";

static const ::std::string __IceGrid__Node__getLoad_name = "getLoad";

static const ::std::string __IceGrid__Node__shutdown_name = "shutdown";

static const ::std::string __IceGrid__NodeSession__keepAlive_name = "keepAlive";

static const ::std::string __IceGrid__NodeSession__setReplicaObserver_name = "setReplicaObserver";

static const ::std::string __IceGrid__NodeSession__getTimeout_name = "getTimeout";

static const ::std::string __IceGrid__NodeSession__getObserver_name = "getObserver";

static const ::std::string __IceGrid__NodeSession__loadServers_name = "loadServers";

static const ::std::string __IceGrid__NodeSession__getServers_name = "getServers";

static const ::std::string __IceGrid__NodeSession__waitForApplicationUpdate_name = "waitForApplicationUpdate";

static const ::std::string __IceGrid__NodeSession__destroy_name = "destroy";

static const ::std::string __IceGrid__ReplicaSession__keepAlive_name = "keepAlive";

static const ::std::string __IceGrid__ReplicaSession__getTimeout_name = "getTimeout";

static const ::std::string __IceGrid__ReplicaSession__setDatabaseObserver_name = "setDatabaseObserver";

static const ::std::string __IceGrid__ReplicaSession__setEndpoints_name = "setEndpoints";

static const ::std::string __IceGrid__ReplicaSession__registerWellKnownObjects_name = "registerWellKnownObjects";

static const ::std::string __IceGrid__ReplicaSession__setAdapterDirectProxy_name = "setAdapterDirectProxy";

static const ::std::string __IceGrid__ReplicaSession__receivedUpdate_name = "receivedUpdate";

static const ::std::string __IceGrid__ReplicaSession__destroy_name = "destroy";

static const ::std::string __IceGrid__InternalRegistry__registerNode_name = "registerNode";

static const ::std::string __IceGrid__InternalRegistry__registerReplica_name = "registerReplica";

static const ::std::string __IceGrid__InternalRegistry__registerWithReplica_name = "registerWithReplica";

static const ::std::string __IceGrid__InternalRegistry__getNodes_name = "getNodes";

static const ::std::string __IceGrid__InternalRegistry__getReplicas_name = "getReplicas";

static const ::std::string __IceGrid__InternalRegistry__shutdown_name = "shutdown";

::Ice::Object* IceInternal::upCast(::IceGrid::InternalDbEnvDescriptor* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceGrid::InternalDbEnvDescriptor* p) { return p; }

::Ice::Object* IceInternal::upCast(::IceGrid::InternalAdapterDescriptor* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceGrid::InternalAdapterDescriptor* p) { return p; }

::Ice::Object* IceInternal::upCast(::IceGrid::InternalDistributionDescriptor* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceGrid::InternalDistributionDescriptor* p) { return p; }

::Ice::Object* IceInternal::upCast(::IceGrid::InternalServerDescriptor* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceGrid::InternalServerDescriptor* p) { return p; }

::Ice::Object* IceInternal::upCast(::IceGrid::Adapter* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceGrid::Adapter* p) { return p; }

::Ice::Object* IceInternal::upCast(::IceGrid::FileReader* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceGrid::FileReader* p) { return p; }

::Ice::Object* IceInternal::upCast(::IceGrid::Server* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceGrid::Server* p) { return p; }

::Ice::Object* IceInternal::upCast(::IceGrid::ReplicaObserver* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceGrid::ReplicaObserver* p) { return p; }

::Ice::Object* IceInternal::upCast(::IceGrid::PatcherFeedback* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceGrid::PatcherFeedback* p) { return p; }

::Ice::Object* IceInternal::upCast(::IceGrid::Node* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceGrid::Node* p) { return p; }

::Ice::Object* IceInternal::upCast(::IceGrid::NodeSession* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceGrid::NodeSession* p) { return p; }

::Ice::Object* IceInternal::upCast(::IceGrid::DatabaseObserver* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceGrid::DatabaseObserver* p) { return p; }

::Ice::Object* IceInternal::upCast(::IceGrid::ReplicaSession* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceGrid::ReplicaSession* p) { return p; }

::Ice::Object* IceInternal::upCast(::IceGrid::InternalNodeInfo* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceGrid::InternalNodeInfo* p) { return p; }

::Ice::Object* IceInternal::upCast(::IceGrid::InternalReplicaInfo* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceGrid::InternalReplicaInfo* p) { return p; }

::Ice::Object* IceInternal::upCast(::IceGrid::InternalRegistry* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::IceGrid::InternalRegistry* p) { return p; }

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::InternalDbEnvDescriptorPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::InternalDbEnvDescriptor;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::InternalAdapterDescriptorPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::InternalAdapterDescriptor;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::InternalDistributionDescriptorPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::InternalDistributionDescriptor;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::InternalServerDescriptorPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::InternalServerDescriptor;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::AdapterPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::Adapter;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::FileReaderPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::FileReader;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::ServerPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::Server;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::ReplicaObserverPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::ReplicaObserver;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::PatcherFeedbackPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::PatcherFeedback;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::NodePrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::Node;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::NodeSessionPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::NodeSession;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::DatabaseObserverPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::DatabaseObserver;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::ReplicaSessionPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::ReplicaSession;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::InternalNodeInfoPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::InternalNodeInfo;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::InternalReplicaInfoPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::InternalReplicaInfo;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::InternalRegistryPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::InternalRegistry;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__writeInternalDbEnvDescriptorSeq(::IceInternal::BasicStream* __os, const ::IceGrid::InternalDbEnvDescriptorPtr* begin, const ::IceGrid::InternalDbEnvDescriptorPtr* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        __os->write(::Ice::ObjectPtr(::IceInternal::upCast(begin[i].get())));
    }
}

void
IceGrid::__readInternalDbEnvDescriptorSeq(::IceInternal::BasicStream* __is, ::IceGrid::InternalDbEnvDescriptorSeq& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 4);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        __is->read(::IceGrid::__patch__InternalDbEnvDescriptorPtr, &v[i]);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

void
IceGrid::__writeInternalAdapterDescriptorSeq(::IceInternal::BasicStream* __os, const ::IceGrid::InternalAdapterDescriptorPtr* begin, const ::IceGrid::InternalAdapterDescriptorPtr* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        __os->write(::Ice::ObjectPtr(::IceInternal::upCast(begin[i].get())));
    }
}

void
IceGrid::__readInternalAdapterDescriptorSeq(::IceInternal::BasicStream* __is, ::IceGrid::InternalAdapterDescriptorSeq& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 4);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        __is->read(::IceGrid::__patch__InternalAdapterDescriptorPtr, &v[i]);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

void
IceGrid::__writePropertyDescriptorSeqDict(::IceInternal::BasicStream* __os, const ::IceGrid::PropertyDescriptorSeqDict& v)
{
    __os->writeSize(::Ice::Int(v.size()));
    ::IceGrid::PropertyDescriptorSeqDict::const_iterator p;
    for(p = v.begin(); p != v.end(); ++p)
    {
        __os->write(p->first);
        if(p->second.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceGrid::__writePropertyDescriptorSeq(__os, &p->second[0], &p->second[0] + p->second.size());
        }
    }
}

void
IceGrid::__readPropertyDescriptorSeqDict(::IceInternal::BasicStream* __is, ::IceGrid::PropertyDescriptorSeqDict& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    while(sz--)
    {
        ::std::pair<const  ::std::string, ::IceGrid::PropertyDescriptorSeq> pair;
        __is->read(const_cast< ::std::string&>(pair.first));
        ::IceGrid::PropertyDescriptorSeqDict::iterator __i = v.insert(v.end(), pair);
        ::IceGrid::__readPropertyDescriptorSeq(__is, __i->second);
    }
}

IceGrid::AdapterActiveException::~AdapterActiveException() throw()
{
}

static const char* __IceGrid__AdapterActiveException_name = "IceGrid::AdapterActiveException";

::std::string
IceGrid::AdapterActiveException::ice_name() const
{
    return __IceGrid__AdapterActiveException_name;
}

::Ice::Exception*
IceGrid::AdapterActiveException::ice_clone() const
{
    return new AdapterActiveException(*this);
}

void
IceGrid::AdapterActiveException::ice_throw() const
{
    throw *this;
}

void
IceGrid::AdapterActiveException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::AdapterActiveException"), false);
    __os->startWriteSlice();
    __os->endWriteSlice();
}

void
IceGrid::AdapterActiveException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->endReadSlice();
}

void
IceGrid::AdapterActiveException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::AdapterActiveException was not generated with stream support";
    throw ex;
}

void
IceGrid::AdapterActiveException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::AdapterActiveException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__AdapterActiveException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::AdapterActiveException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__AdapterActiveException__Ptr = new __F__IceGrid__AdapterActiveException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::AdapterActiveException::ice_factory()
{
    return __F__IceGrid__AdapterActiveException__Ptr;
}

class __F__IceGrid__AdapterActiveException__Init
{
public:

    __F__IceGrid__AdapterActiveException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::AdapterActiveException", ::IceGrid::AdapterActiveException::ice_factory());
    }

    ~__F__IceGrid__AdapterActiveException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::AdapterActiveException");
    }
};

static __F__IceGrid__AdapterActiveException__Init __F__IceGrid__AdapterActiveException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__AdapterActiveException__initializer() {} }
#endif

IceGrid::AdapterNotActiveException::AdapterNotActiveException(bool __ice_activatable) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    activatable(__ice_activatable)
{
}

IceGrid::AdapterNotActiveException::~AdapterNotActiveException() throw()
{
}

static const char* __IceGrid__AdapterNotActiveException_name = "IceGrid::AdapterNotActiveException";

::std::string
IceGrid::AdapterNotActiveException::ice_name() const
{
    return __IceGrid__AdapterNotActiveException_name;
}

::Ice::Exception*
IceGrid::AdapterNotActiveException::ice_clone() const
{
    return new AdapterNotActiveException(*this);
}

void
IceGrid::AdapterNotActiveException::ice_throw() const
{
    throw *this;
}

void
IceGrid::AdapterNotActiveException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::AdapterNotActiveException"), false);
    __os->startWriteSlice();
    __os->write(activatable);
    __os->endWriteSlice();
}

void
IceGrid::AdapterNotActiveException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(activatable);
    __is->endReadSlice();
}

void
IceGrid::AdapterNotActiveException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::AdapterNotActiveException was not generated with stream support";
    throw ex;
}

void
IceGrid::AdapterNotActiveException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::AdapterNotActiveException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__AdapterNotActiveException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::AdapterNotActiveException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__AdapterNotActiveException__Ptr = new __F__IceGrid__AdapterNotActiveException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::AdapterNotActiveException::ice_factory()
{
    return __F__IceGrid__AdapterNotActiveException__Ptr;
}

class __F__IceGrid__AdapterNotActiveException__Init
{
public:

    __F__IceGrid__AdapterNotActiveException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::AdapterNotActiveException", ::IceGrid::AdapterNotActiveException::ice_factory());
    }

    ~__F__IceGrid__AdapterNotActiveException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::AdapterNotActiveException");
    }
};

static __F__IceGrid__AdapterNotActiveException__Init __F__IceGrid__AdapterNotActiveException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__AdapterNotActiveException__initializer() {} }
#endif

IceGrid::AdapterExistsException::AdapterExistsException(const ::std::string& __ice_id) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    id(__ice_id)
{
}

IceGrid::AdapterExistsException::~AdapterExistsException() throw()
{
}

static const char* __IceGrid__AdapterExistsException_name = "IceGrid::AdapterExistsException";

::std::string
IceGrid::AdapterExistsException::ice_name() const
{
    return __IceGrid__AdapterExistsException_name;
}

::Ice::Exception*
IceGrid::AdapterExistsException::ice_clone() const
{
    return new AdapterExistsException(*this);
}

void
IceGrid::AdapterExistsException::ice_throw() const
{
    throw *this;
}

void
IceGrid::AdapterExistsException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::AdapterExistsException"), false);
    __os->startWriteSlice();
    __os->write(id);
    __os->endWriteSlice();
}

void
IceGrid::AdapterExistsException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(id);
    __is->endReadSlice();
}

void
IceGrid::AdapterExistsException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::AdapterExistsException was not generated with stream support";
    throw ex;
}

void
IceGrid::AdapterExistsException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::AdapterExistsException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__AdapterExistsException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::AdapterExistsException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__AdapterExistsException__Ptr = new __F__IceGrid__AdapterExistsException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::AdapterExistsException::ice_factory()
{
    return __F__IceGrid__AdapterExistsException__Ptr;
}

class __F__IceGrid__AdapterExistsException__Init
{
public:

    __F__IceGrid__AdapterExistsException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::AdapterExistsException", ::IceGrid::AdapterExistsException::ice_factory());
    }

    ~__F__IceGrid__AdapterExistsException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::AdapterExistsException");
    }
};

static __F__IceGrid__AdapterExistsException__Init __F__IceGrid__AdapterExistsException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__AdapterExistsException__initializer() {} }
#endif

void
IceGrid::__writeAdapterPrxDict(::IceInternal::BasicStream* __os, const ::IceGrid::AdapterPrxDict& v)
{
    __os->writeSize(::Ice::Int(v.size()));
    ::IceGrid::AdapterPrxDict::const_iterator p;
    for(p = v.begin(); p != v.end(); ++p)
    {
        __os->write(p->first);
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(p->second.get())));
    }
}

void
IceGrid::__readAdapterPrxDict(::IceInternal::BasicStream* __is, ::IceGrid::AdapterPrxDict& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    while(sz--)
    {
        ::std::pair<const  ::std::string, ::IceGrid::AdapterPrx> pair;
        __is->read(const_cast< ::std::string&>(pair.first));
        ::IceGrid::AdapterPrxDict::iterator __i = v.insert(v.end(), pair);
        ::IceGrid::__read(__is, __i->second);
    }
}

void
IceGrid::__writeInternalRegistryPrxSeq(::IceInternal::BasicStream* __os, const ::IceGrid::InternalRegistryPrx* begin, const ::IceGrid::InternalRegistryPrx* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(begin[i].get())));
    }
}

void
IceGrid::__readInternalRegistryPrxSeq(::IceInternal::BasicStream* __is, ::IceGrid::InternalRegistryPrxSeq& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 2);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        ::IceGrid::__read(__is, v[i]);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

void
IceGrid::__writeNodePrxSeq(::IceInternal::BasicStream* __os, const ::IceGrid::NodePrx* begin, const ::IceGrid::NodePrx* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(begin[i].get())));
    }
}

void
IceGrid::__readNodePrxSeq(::IceInternal::BasicStream* __is, ::IceGrid::NodePrxSeq& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 2);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        ::IceGrid::__read(__is, v[i]);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

IceGrid::NodeActiveException::~NodeActiveException() throw()
{
}

static const char* __IceGrid__NodeActiveException_name = "IceGrid::NodeActiveException";

::std::string
IceGrid::NodeActiveException::ice_name() const
{
    return __IceGrid__NodeActiveException_name;
}

::Ice::Exception*
IceGrid::NodeActiveException::ice_clone() const
{
    return new NodeActiveException(*this);
}

void
IceGrid::NodeActiveException::ice_throw() const
{
    throw *this;
}

void
IceGrid::NodeActiveException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::NodeActiveException"), false);
    __os->startWriteSlice();
    __os->endWriteSlice();
}

void
IceGrid::NodeActiveException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->endReadSlice();
}

void
IceGrid::NodeActiveException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::NodeActiveException was not generated with stream support";
    throw ex;
}

void
IceGrid::NodeActiveException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::NodeActiveException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__NodeActiveException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::NodeActiveException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__NodeActiveException__Ptr = new __F__IceGrid__NodeActiveException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::NodeActiveException::ice_factory()
{
    return __F__IceGrid__NodeActiveException__Ptr;
}

class __F__IceGrid__NodeActiveException__Init
{
public:

    __F__IceGrid__NodeActiveException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::NodeActiveException", ::IceGrid::NodeActiveException::ice_factory());
    }

    ~__F__IceGrid__NodeActiveException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::NodeActiveException");
    }
};

static __F__IceGrid__NodeActiveException__Init __F__IceGrid__NodeActiveException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__NodeActiveException__initializer() {} }
#endif

IceGrid::ReplicaActiveException::~ReplicaActiveException() throw()
{
}

static const char* __IceGrid__ReplicaActiveException_name = "IceGrid::ReplicaActiveException";

::std::string
IceGrid::ReplicaActiveException::ice_name() const
{
    return __IceGrid__ReplicaActiveException_name;
}

::Ice::Exception*
IceGrid::ReplicaActiveException::ice_clone() const
{
    return new ReplicaActiveException(*this);
}

void
IceGrid::ReplicaActiveException::ice_throw() const
{
    throw *this;
}

void
IceGrid::ReplicaActiveException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::ReplicaActiveException"), false);
    __os->startWriteSlice();
    __os->endWriteSlice();
}

void
IceGrid::ReplicaActiveException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->endReadSlice();
}

void
IceGrid::ReplicaActiveException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::ReplicaActiveException was not generated with stream support";
    throw ex;
}

void
IceGrid::ReplicaActiveException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::ReplicaActiveException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__ReplicaActiveException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::ReplicaActiveException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__ReplicaActiveException__Ptr = new __F__IceGrid__ReplicaActiveException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::ReplicaActiveException::ice_factory()
{
    return __F__IceGrid__ReplicaActiveException__Ptr;
}

class __F__IceGrid__ReplicaActiveException__Init
{
public:

    __F__IceGrid__ReplicaActiveException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::ReplicaActiveException", ::IceGrid::ReplicaActiveException::ice_factory());
    }

    ~__F__IceGrid__ReplicaActiveException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::ReplicaActiveException");
    }
};

static __F__IceGrid__ReplicaActiveException__Init __F__IceGrid__ReplicaActiveException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__ReplicaActiveException__initializer() {} }
#endif

void
IceGrid::__write(::IceInternal::BasicStream* __os, ::IceGrid::TopicName v)
{
    __os->write(static_cast< ::Ice::Byte>(v), 5);
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::TopicName& v)
{
    ::Ice::Byte val;
    __is->read(val, 5);
    v = static_cast< ::IceGrid::TopicName>(val);
}

bool
IceGrid::AMI_Adapter_activate::__invoke(const ::IceGrid::AdapterPrx& __prx, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prx->__checkTwowayOnly(__IceGrid__Adapter__activate_name);
        __prepare(__prx, __IceGrid__Adapter__activate_name, ::Ice::Normal, __ctx);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceGrid::AMI_Adapter_activate::__response(bool __ok)
{
    ::Ice::ObjectPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response(__ret);
    __releaseCallback();
}

bool
IceGrid::AMI_Adapter_getDirectProxy::__invoke(const ::IceGrid::AdapterPrx& __prx, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prx->__checkTwowayOnly(__IceGrid__Adapter__getDirectProxy_name);
        __prepare(__prx, __IceGrid__Adapter__getDirectProxy_name, ::Ice::Nonmutating, __ctx);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceGrid::AMI_Adapter_getDirectProxy::__response(bool __ok)
{
    ::Ice::ObjectPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::IceGrid::AdapterNotActiveException& __ex)
            {
                __exception(__ex);
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response(__ret);
    __releaseCallback();
}

bool
IceGrid::AMI_Adapter_setDirectProxy::__invoke(const ::IceGrid::AdapterPrx& __prx, const ::Ice::ObjectPrx& proxy, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prx->__checkTwowayOnly(__IceGrid__Adapter__setDirectProxy_name);
        __prepare(__prx, __IceGrid__Adapter__setDirectProxy_name, ::Ice::Normal, __ctx);
        __os->write(proxy);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceGrid::AMI_Adapter_setDirectProxy::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::IceGrid::AdapterActiveException& __ex)
            {
                __exception(__ex);
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}

bool
IceGrid::AMI_Server_start::__invoke(const ::IceGrid::ServerPrx& __prx, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prx->__checkTwowayOnly(__IceGrid__Server__start_name);
        __prepare(__prx, __IceGrid__Server__start_name, ::Ice::Normal, __ctx);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceGrid::AMI_Server_start::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::IceGrid::ServerStartException& __ex)
            {
                __exception(__ex);
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}

bool
IceGrid::AMI_Server_stop::__invoke(const ::IceGrid::ServerPrx& __prx, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prx->__checkTwowayOnly(__IceGrid__Server__stop_name);
        __prepare(__prx, __IceGrid__Server__stop_name, ::Ice::Normal, __ctx);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceGrid::AMI_Server_stop::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::IceGrid::ServerStopException& __ex)
            {
                __exception(__ex);
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}

bool
IceGrid::AMI_Server_setProcess::__invoke(const ::IceGrid::ServerPrx& __prx, const ::Ice::ProcessPrx& proc, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prepare(__prx, __IceGrid__Server__setProcess_name, ::Ice::Normal, __ctx);
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(proc.get())));
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceGrid::AMI_Server_setProcess::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}

bool
IceGrid::AMI_Node_loadServer::__invoke(const ::IceGrid::NodePrx& __prx, const ::IceGrid::InternalServerDescriptorPtr& svr, const ::std::string& replicaName, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prx->__checkTwowayOnly(__IceGrid__Node__loadServer_name);
        __prepare(__prx, __IceGrid__Node__loadServer_name, ::Ice::Idempotent, __ctx);
        __os->write(::Ice::ObjectPtr(::IceInternal::upCast(svr.get())));
        __os->write(replicaName);
        __os->writePendingObjects();
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceGrid::AMI_Node_loadServer::__response(bool __ok)
{
    ::IceGrid::AdapterPrxDict adapters;
    ::Ice::Int actTimeout;
    ::Ice::Int deactTimeout;
    ::IceGrid::ServerPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::IceGrid::DeploymentException& __ex)
            {
                __exception(__ex);
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->startReadEncaps();
        ::IceGrid::__readAdapterPrxDict(__is, adapters);
        __is->read(actTimeout);
        __is->read(deactTimeout);
        ::IceGrid::__read(__is, __ret);
        __is->endReadEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response(__ret, adapters, actTimeout, deactTimeout);
    __releaseCallback();
}

bool
IceGrid::AMI_Node_destroyServer::__invoke(const ::IceGrid::NodePrx& __prx, const ::std::string& name, const ::std::string& uuid, ::Ice::Int revision, const ::std::string& replicaName, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prx->__checkTwowayOnly(__IceGrid__Node__destroyServer_name);
        __prepare(__prx, __IceGrid__Node__destroyServer_name, ::Ice::Idempotent, __ctx);
        __os->write(name);
        __os->write(uuid);
        __os->write(revision);
        __os->write(replicaName);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceGrid::AMI_Node_destroyServer::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::IceGrid::DeploymentException& __ex)
            {
                __exception(__ex);
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}

bool
IceGrid::AMI_Node_registerWithReplica::__invoke(const ::IceGrid::NodePrx& __prx, const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prepare(__prx, __IceGrid__Node__registerWithReplica_name, ::Ice::Normal, __ctx);
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(replica.get())));
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceGrid::AMI_Node_registerWithReplica::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}

bool
IceGrid::AMI_NodeSession_waitForApplicationUpdate::__invoke(const ::IceGrid::NodeSessionPrx& __prx, const ::std::string& application, ::Ice::Int revision, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prepare(__prx, __IceGrid__NodeSession__waitForApplicationUpdate_name, ::Ice::Normal, __ctx);
        __os->write(application);
        __os->write(revision);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceGrid::AMI_NodeSession_waitForApplicationUpdate::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}

bool
IceGrid::AMI_ReplicaSession_setAdapterDirectProxy::__invoke(const ::IceGrid::ReplicaSessionPrx& __prx, const ::std::string& adapterId, const ::std::string& replicaGroupId, const ::Ice::ObjectPrx& proxy, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prx->__checkTwowayOnly(__IceGrid__ReplicaSession__setAdapterDirectProxy_name);
        __prepare(__prx, __IceGrid__ReplicaSession__setAdapterDirectProxy_name, ::Ice::Idempotent, __ctx);
        __os->write(adapterId);
        __os->write(replicaGroupId);
        __os->write(proxy);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
IceGrid::AMI_ReplicaSession_setAdapterDirectProxy::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::IceGrid::AdapterExistsException& __ex)
            {
                __exception(__ex);
            }
            catch(const ::IceGrid::AdapterNotExistException& __ex)
            {
                __exception(__ex);
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}

IceAsync::IceGrid::AMD_Adapter_activate::AMD_Adapter_activate(::IceInternal::Incoming& in) :
    ::IceInternal::IncomingAsync(in)
{
}

void
IceAsync::IceGrid::AMD_Adapter_activate::ice_response(const ::Ice::ObjectPrx& __ret)
{
    if(__validateResponse(true))
    {
        try
        {
            ::IceInternal::BasicStream* __os = this->__os();
            __os->write(__ret);
        }
        catch(const ::Ice::Exception& __ex)
        {
            __exception(__ex);
            return;
        }
        __response(true);
    }
}

void
IceAsync::IceGrid::AMD_Adapter_activate::ice_exception(const ::std::exception& ex)
{
    if(__validateException(ex))
    {
        __exception(ex);
    }
}

void
IceAsync::IceGrid::AMD_Adapter_activate::ice_exception()
{
    if(__validateException())
    {
        __exception();
    }
}

IceAsync::IceGrid::AMD_Server_start::AMD_Server_start(::IceInternal::Incoming& in) :
    ::IceInternal::IncomingAsync(in)
{
}

void
IceAsync::IceGrid::AMD_Server_start::ice_response()
{
    if(__validateResponse(true))
    {
        __response(true);
    }
}

void
IceAsync::IceGrid::AMD_Server_start::ice_exception(const ::std::exception& ex)
{
    if(const ::IceGrid::ServerStartException* __ex = dynamic_cast<const ::IceGrid::ServerStartException*>(&ex))
    {
        if(__validateResponse(false))
        {
            __os()->write(*__ex);
            __response(false);
        }
    }
    else
    {
        if(__validateException(ex))
        {
            __exception(ex);
        }
    }
}

void
IceAsync::IceGrid::AMD_Server_start::ice_exception()
{
    if(__validateException())
    {
        __exception();
    }
}

IceAsync::IceGrid::AMD_Server_stop::AMD_Server_stop(::IceInternal::Incoming& in) :
    ::IceInternal::IncomingAsync(in)
{
}

void
IceAsync::IceGrid::AMD_Server_stop::ice_response()
{
    if(__validateResponse(true))
    {
        __response(true);
    }
}

void
IceAsync::IceGrid::AMD_Server_stop::ice_exception(const ::std::exception& ex)
{
    if(const ::IceGrid::ServerStopException* __ex = dynamic_cast<const ::IceGrid::ServerStopException*>(&ex))
    {
        if(__validateResponse(false))
        {
            __os()->write(*__ex);
            __response(false);
        }
    }
    else
    {
        if(__validateException(ex))
        {
            __exception(ex);
        }
    }
}

void
IceAsync::IceGrid::AMD_Server_stop::ice_exception()
{
    if(__validateException())
    {
        __exception();
    }
}

IceAsync::IceGrid::AMD_Server_setProcess::AMD_Server_setProcess(::IceInternal::Incoming& in) :
    ::IceInternal::IncomingAsync(in)
{
}

void
IceAsync::IceGrid::AMD_Server_setProcess::ice_response()
{
    if(__validateResponse(true))
    {
        __response(true);
    }
}

void
IceAsync::IceGrid::AMD_Server_setProcess::ice_exception(const ::std::exception& ex)
{
    if(__validateException(ex))
    {
        __exception(ex);
    }
}

void
IceAsync::IceGrid::AMD_Server_setProcess::ice_exception()
{
    if(__validateException())
    {
        __exception();
    }
}

IceAsync::IceGrid::AMD_Node_loadServer::AMD_Node_loadServer(::IceInternal::Incoming& in) :
    ::IceInternal::IncomingAsync(in)
{
}

void
IceAsync::IceGrid::AMD_Node_loadServer::ice_response(const ::IceGrid::ServerPrx& __ret, const ::IceGrid::AdapterPrxDict& adapters, ::Ice::Int actTimeout, ::Ice::Int deactTimeout)
{
    if(__validateResponse(true))
    {
        try
        {
            ::IceInternal::BasicStream* __os = this->__os();
            ::IceGrid::__writeAdapterPrxDict(__os, adapters);
            __os->write(actTimeout);
            __os->write(deactTimeout);
            __os->write(::Ice::ObjectPrx(::IceInternal::upCast(__ret.get())));
        }
        catch(const ::Ice::Exception& __ex)
        {
            __exception(__ex);
            return;
        }
        __response(true);
    }
}

void
IceAsync::IceGrid::AMD_Node_loadServer::ice_exception(const ::std::exception& ex)
{
    if(const ::IceGrid::DeploymentException* __ex = dynamic_cast<const ::IceGrid::DeploymentException*>(&ex))
    {
        if(__validateResponse(false))
        {
            __os()->write(*__ex);
            __response(false);
        }
    }
    else
    {
        if(__validateException(ex))
        {
            __exception(ex);
        }
    }
}

void
IceAsync::IceGrid::AMD_Node_loadServer::ice_exception()
{
    if(__validateException())
    {
        __exception();
    }
}

IceAsync::IceGrid::AMD_Node_destroyServer::AMD_Node_destroyServer(::IceInternal::Incoming& in) :
    ::IceInternal::IncomingAsync(in)
{
}

void
IceAsync::IceGrid::AMD_Node_destroyServer::ice_response()
{
    if(__validateResponse(true))
    {
        __response(true);
    }
}

void
IceAsync::IceGrid::AMD_Node_destroyServer::ice_exception(const ::std::exception& ex)
{
    if(const ::IceGrid::DeploymentException* __ex = dynamic_cast<const ::IceGrid::DeploymentException*>(&ex))
    {
        if(__validateResponse(false))
        {
            __os()->write(*__ex);
            __response(false);
        }
    }
    else
    {
        if(__validateException(ex))
        {
            __exception(ex);
        }
    }
}

void
IceAsync::IceGrid::AMD_Node_destroyServer::ice_exception()
{
    if(__validateException())
    {
        __exception();
    }
}

IceAsync::IceGrid::AMD_Node_patch::AMD_Node_patch(::IceInternal::Incoming& in) :
    ::IceInternal::IncomingAsync(in)
{
}

void
IceAsync::IceGrid::AMD_Node_patch::ice_response()
{
    if(__validateResponse(true))
    {
        __response(true);
    }
}

void
IceAsync::IceGrid::AMD_Node_patch::ice_exception(const ::std::exception& ex)
{
    if(__validateException(ex))
    {
        __exception(ex);
    }
}

void
IceAsync::IceGrid::AMD_Node_patch::ice_exception()
{
    if(__validateException())
    {
        __exception();
    }
}

IceAsync::IceGrid::AMD_NodeSession_loadServers::AMD_NodeSession_loadServers(::IceInternal::Incoming& in) :
    ::IceInternal::IncomingAsync(in)
{
}

void
IceAsync::IceGrid::AMD_NodeSession_loadServers::ice_response()
{
    if(__validateResponse(true))
    {
        __response(true);
    }
}

void
IceAsync::IceGrid::AMD_NodeSession_loadServers::ice_exception(const ::std::exception& ex)
{
    if(__validateException(ex))
    {
        __exception(ex);
    }
}

void
IceAsync::IceGrid::AMD_NodeSession_loadServers::ice_exception()
{
    if(__validateException())
    {
        __exception();
    }
}

IceAsync::IceGrid::AMD_NodeSession_waitForApplicationUpdate::AMD_NodeSession_waitForApplicationUpdate(::IceInternal::Incoming& in) :
    ::IceInternal::IncomingAsync(in)
{
}

void
IceAsync::IceGrid::AMD_NodeSession_waitForApplicationUpdate::ice_response()
{
    if(__validateResponse(true))
    {
        __response(true);
    }
}

void
IceAsync::IceGrid::AMD_NodeSession_waitForApplicationUpdate::ice_exception(const ::std::exception& ex)
{
    if(__validateException(ex))
    {
        __exception(ex);
    }
}

void
IceAsync::IceGrid::AMD_NodeSession_waitForApplicationUpdate::ice_exception()
{
    if(__validateException())
    {
        __exception();
    }
}

const ::std::string&
IceProxy::IceGrid::InternalDbEnvDescriptor::ice_staticId()
{
    return ::IceGrid::InternalDbEnvDescriptor::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::InternalDbEnvDescriptor::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::InternalDbEnvDescriptor);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::InternalDbEnvDescriptor::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::InternalDbEnvDescriptor);
}

::IceProxy::Ice::Object*
IceProxy::IceGrid::InternalDbEnvDescriptor::__newInstance() const
{
    return new InternalDbEnvDescriptor;
}

const ::std::string&
IceProxy::IceGrid::InternalAdapterDescriptor::ice_staticId()
{
    return ::IceGrid::InternalAdapterDescriptor::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::InternalAdapterDescriptor::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::InternalAdapterDescriptor);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::InternalAdapterDescriptor::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::InternalAdapterDescriptor);
}

::IceProxy::Ice::Object*
IceProxy::IceGrid::InternalAdapterDescriptor::__newInstance() const
{
    return new InternalAdapterDescriptor;
}

const ::std::string&
IceProxy::IceGrid::InternalDistributionDescriptor::ice_staticId()
{
    return ::IceGrid::InternalDistributionDescriptor::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::InternalDistributionDescriptor::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::InternalDistributionDescriptor);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::InternalDistributionDescriptor::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::InternalDistributionDescriptor);
}

::IceProxy::Ice::Object*
IceProxy::IceGrid::InternalDistributionDescriptor::__newInstance() const
{
    return new InternalDistributionDescriptor;
}

const ::std::string&
IceProxy::IceGrid::InternalServerDescriptor::ice_staticId()
{
    return ::IceGrid::InternalServerDescriptor::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::InternalServerDescriptor::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::InternalServerDescriptor);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::InternalServerDescriptor::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::InternalServerDescriptor);
}

::IceProxy::Ice::Object*
IceProxy::IceGrid::InternalServerDescriptor::__newInstance() const
{
    return new InternalServerDescriptor;
}

::Ice::ObjectPrx
IceProxy::IceGrid::Adapter::activate(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__Adapter__activate_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::Adapter* __del = dynamic_cast< ::IceDelegate::IceGrid::Adapter*>(__delBase.get());
            return __del->activate(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::Adapter::activate_async(const ::IceGrid::AMI_Adapter_activatePtr& __cb)
{
    return __cb->__invoke(this, 0);
}

bool
IceProxy::IceGrid::Adapter::activate_async(const ::IceGrid::AMI_Adapter_activatePtr& __cb, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, &__ctx);
}

::Ice::ObjectPrx
IceProxy::IceGrid::Adapter::getDirectProxy(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__Adapter__getDirectProxy_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::Adapter* __del = dynamic_cast< ::IceDelegate::IceGrid::Adapter*>(__delBase.get());
            return __del->getDirectProxy(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::Adapter::getDirectProxy_async(const ::IceGrid::AMI_Adapter_getDirectProxyPtr& __cb)
{
    return __cb->__invoke(this, 0);
}

bool
IceProxy::IceGrid::Adapter::getDirectProxy_async(const ::IceGrid::AMI_Adapter_getDirectProxyPtr& __cb, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, &__ctx);
}

void
IceProxy::IceGrid::Adapter::setDirectProxy(const ::Ice::ObjectPrx& proxy, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__Adapter__setDirectProxy_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::Adapter* __del = dynamic_cast< ::IceDelegate::IceGrid::Adapter*>(__delBase.get());
            __del->setDirectProxy(proxy, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::Adapter::setDirectProxy_async(const ::IceGrid::AMI_Adapter_setDirectProxyPtr& __cb, const ::Ice::ObjectPrx& proxy)
{
    return __cb->__invoke(this, proxy, 0);
}

bool
IceProxy::IceGrid::Adapter::setDirectProxy_async(const ::IceGrid::AMI_Adapter_setDirectProxyPtr& __cb, const ::Ice::ObjectPrx& proxy, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, proxy, &__ctx);
}

const ::std::string&
IceProxy::IceGrid::Adapter::ice_staticId()
{
    return ::IceGrid::Adapter::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::Adapter::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::Adapter);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::Adapter::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::Adapter);
}

::IceProxy::Ice::Object*
IceProxy::IceGrid::Adapter::__newInstance() const
{
    return new Adapter;
}

::Ice::Long
IceProxy::IceGrid::FileReader::getOffsetFromEnd(const ::std::string& filename, ::Ice::Int lines, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__FileReader__getOffsetFromEnd_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::FileReader* __del = dynamic_cast< ::IceDelegate::IceGrid::FileReader*>(__delBase.get());
            return __del->getOffsetFromEnd(filename, lines, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::FileReader::read(const ::std::string& filename, ::Ice::Long pos, ::Ice::Int size, ::Ice::Long& newPos, ::Ice::StringSeq& lines, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__FileReader__read_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::FileReader* __del = dynamic_cast< ::IceDelegate::IceGrid::FileReader*>(__delBase.get());
            return __del->read(filename, pos, size, newPos, lines, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::FileReader::ice_staticId()
{
    return ::IceGrid::FileReader::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::FileReader::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::FileReader);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::FileReader::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::FileReader);
}

::IceProxy::Ice::Object*
IceProxy::IceGrid::FileReader::__newInstance() const
{
    return new FileReader;
}

void
IceProxy::IceGrid::Server::start(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__Server__start_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::Server* __del = dynamic_cast< ::IceDelegate::IceGrid::Server*>(__delBase.get());
            __del->start(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::Server::start_async(const ::IceGrid::AMI_Server_startPtr& __cb)
{
    return __cb->__invoke(this, 0);
}

bool
IceProxy::IceGrid::Server::start_async(const ::IceGrid::AMI_Server_startPtr& __cb, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, &__ctx);
}

void
IceProxy::IceGrid::Server::stop(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__Server__stop_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::Server* __del = dynamic_cast< ::IceDelegate::IceGrid::Server*>(__delBase.get());
            __del->stop(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::Server::stop_async(const ::IceGrid::AMI_Server_stopPtr& __cb)
{
    return __cb->__invoke(this, 0);
}

bool
IceProxy::IceGrid::Server::stop_async(const ::IceGrid::AMI_Server_stopPtr& __cb, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, &__ctx);
}

void
IceProxy::IceGrid::Server::setEnabled(bool enable, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::Server* __del = dynamic_cast< ::IceDelegate::IceGrid::Server*>(__delBase.get());
            __del->setEnabled(enable, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::Server::isEnabled(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__Server__isEnabled_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::Server* __del = dynamic_cast< ::IceDelegate::IceGrid::Server*>(__delBase.get());
            return __del->isEnabled(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceGrid::Server::sendSignal(const ::std::string& signal, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__Server__sendSignal_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::Server* __del = dynamic_cast< ::IceDelegate::IceGrid::Server*>(__delBase.get());
            __del->sendSignal(signal, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceGrid::Server::writeMessage(const ::std::string& message, ::Ice::Int fd, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::Server* __del = dynamic_cast< ::IceDelegate::IceGrid::Server*>(__delBase.get());
            __del->writeMessage(message, fd, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::IceGrid::ServerState
IceProxy::IceGrid::Server::getState(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__Server__getState_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::Server* __del = dynamic_cast< ::IceDelegate::IceGrid::Server*>(__delBase.get());
            return __del->getState(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::Ice::Int
IceProxy::IceGrid::Server::getPid(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__Server__getPid_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::Server* __del = dynamic_cast< ::IceDelegate::IceGrid::Server*>(__delBase.get());
            return __del->getPid(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceGrid::Server::setProcess(const ::Ice::ProcessPrx& proc, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::Server* __del = dynamic_cast< ::IceDelegate::IceGrid::Server*>(__delBase.get());
            __del->setProcess(proc, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::Server::setProcess_async(const ::IceGrid::AMI_Server_setProcessPtr& __cb, const ::Ice::ProcessPrx& proc)
{
    return __cb->__invoke(this, proc, 0);
}

bool
IceProxy::IceGrid::Server::setProcess_async(const ::IceGrid::AMI_Server_setProcessPtr& __cb, const ::Ice::ProcessPrx& proc, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, proc, &__ctx);
}

const ::std::string&
IceProxy::IceGrid::Server::ice_staticId()
{
    return ::IceGrid::Server::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::Server::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::Server);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::Server::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::Server);
}

::IceProxy::Ice::Object*
IceProxy::IceGrid::Server::__newInstance() const
{
    return new Server;
}

void
IceProxy::IceGrid::ReplicaObserver::replicaInit(const ::IceGrid::InternalRegistryPrxSeq& replicas, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::ReplicaObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::ReplicaObserver*>(__delBase.get());
            __del->replicaInit(replicas, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceGrid::ReplicaObserver::replicaAdded(const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::ReplicaObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::ReplicaObserver*>(__delBase.get());
            __del->replicaAdded(replica, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceGrid::ReplicaObserver::replicaRemoved(const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::ReplicaObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::ReplicaObserver*>(__delBase.get());
            __del->replicaRemoved(replica, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::ReplicaObserver::ice_staticId()
{
    return ::IceGrid::ReplicaObserver::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::ReplicaObserver::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::ReplicaObserver);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::ReplicaObserver::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::ReplicaObserver);
}

::IceProxy::Ice::Object*
IceProxy::IceGrid::ReplicaObserver::__newInstance() const
{
    return new ReplicaObserver;
}

void
IceProxy::IceGrid::PatcherFeedback::finished(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::PatcherFeedback* __del = dynamic_cast< ::IceDelegate::IceGrid::PatcherFeedback*>(__delBase.get());
            __del->finished(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceGrid::PatcherFeedback::failed(const ::std::string& reason, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::PatcherFeedback* __del = dynamic_cast< ::IceDelegate::IceGrid::PatcherFeedback*>(__delBase.get());
            __del->failed(reason, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::PatcherFeedback::ice_staticId()
{
    return ::IceGrid::PatcherFeedback::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::PatcherFeedback::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::PatcherFeedback);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::PatcherFeedback::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::PatcherFeedback);
}

::IceProxy::Ice::Object*
IceProxy::IceGrid::PatcherFeedback::__newInstance() const
{
    return new PatcherFeedback;
}

::IceGrid::ServerPrx
IceProxy::IceGrid::Node::loadServer(const ::IceGrid::InternalServerDescriptorPtr& svr, const ::std::string& replicaName, ::IceGrid::AdapterPrxDict& adapters, ::Ice::Int& actTimeout, ::Ice::Int& deactTimeout, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__Node__loadServer_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::Node* __del = dynamic_cast< ::IceDelegate::IceGrid::Node*>(__delBase.get());
            return __del->loadServer(svr, replicaName, adapters, actTimeout, deactTimeout, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::Node::loadServer_async(const ::IceGrid::AMI_Node_loadServerPtr& __cb, const ::IceGrid::InternalServerDescriptorPtr& svr, const ::std::string& replicaName)
{
    return __cb->__invoke(this, svr, replicaName, 0);
}

bool
IceProxy::IceGrid::Node::loadServer_async(const ::IceGrid::AMI_Node_loadServerPtr& __cb, const ::IceGrid::InternalServerDescriptorPtr& svr, const ::std::string& replicaName, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, svr, replicaName, &__ctx);
}

void
IceProxy::IceGrid::Node::destroyServer(const ::std::string& name, const ::std::string& uuid, ::Ice::Int revision, const ::std::string& replicaName, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__Node__destroyServer_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::Node* __del = dynamic_cast< ::IceDelegate::IceGrid::Node*>(__delBase.get());
            __del->destroyServer(name, uuid, revision, replicaName, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::Node::destroyServer_async(const ::IceGrid::AMI_Node_destroyServerPtr& __cb, const ::std::string& name, const ::std::string& uuid, ::Ice::Int revision, const ::std::string& replicaName)
{
    return __cb->__invoke(this, name, uuid, revision, replicaName, 0);
}

bool
IceProxy::IceGrid::Node::destroyServer_async(const ::IceGrid::AMI_Node_destroyServerPtr& __cb, const ::std::string& name, const ::std::string& uuid, ::Ice::Int revision, const ::std::string& replicaName, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, name, uuid, revision, replicaName, &__ctx);
}

void
IceProxy::IceGrid::Node::patch(const ::IceGrid::PatcherFeedbackPrx& feedback, const ::std::string& application, const ::std::string& server, const ::IceGrid::InternalDistributionDescriptorPtr& appDistrib, bool shutdown, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::Node* __del = dynamic_cast< ::IceDelegate::IceGrid::Node*>(__delBase.get());
            __del->patch(feedback, application, server, appDistrib, shutdown, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceGrid::Node::registerWithReplica(const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::Node* __del = dynamic_cast< ::IceDelegate::IceGrid::Node*>(__delBase.get());
            __del->registerWithReplica(replica, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::Node::registerWithReplica_async(const ::IceGrid::AMI_Node_registerWithReplicaPtr& __cb, const ::IceGrid::InternalRegistryPrx& replica)
{
    return __cb->__invoke(this, replica, 0);
}

bool
IceProxy::IceGrid::Node::registerWithReplica_async(const ::IceGrid::AMI_Node_registerWithReplicaPtr& __cb, const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, replica, &__ctx);
}

::std::string
IceProxy::IceGrid::Node::getName(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__Node__getName_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::Node* __del = dynamic_cast< ::IceDelegate::IceGrid::Node*>(__delBase.get());
            return __del->getName(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::std::string
IceProxy::IceGrid::Node::getHostname(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__Node__getHostname_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::Node* __del = dynamic_cast< ::IceDelegate::IceGrid::Node*>(__delBase.get());
            return __del->getHostname(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::IceGrid::LoadInfo
IceProxy::IceGrid::Node::getLoad(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__Node__getLoad_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::Node* __del = dynamic_cast< ::IceDelegate::IceGrid::Node*>(__delBase.get());
            return __del->getLoad(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceGrid::Node::shutdown(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::Node* __del = dynamic_cast< ::IceDelegate::IceGrid::Node*>(__delBase.get());
            __del->shutdown(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::Node::ice_staticId()
{
    return ::IceGrid::Node::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::Node::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::Node);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::Node::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::Node);
}

::IceProxy::Ice::Object*
IceProxy::IceGrid::Node::__newInstance() const
{
    return new Node;
}

void
IceProxy::IceGrid::NodeSession::keepAlive(const ::IceGrid::LoadInfo& load, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::NodeSession* __del = dynamic_cast< ::IceDelegate::IceGrid::NodeSession*>(__delBase.get());
            __del->keepAlive(load, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceGrid::NodeSession::setReplicaObserver(const ::IceGrid::ReplicaObserverPrx& observer, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::NodeSession* __del = dynamic_cast< ::IceDelegate::IceGrid::NodeSession*>(__delBase.get());
            __del->setReplicaObserver(observer, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::Ice::Int
IceProxy::IceGrid::NodeSession::getTimeout(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__NodeSession__getTimeout_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::NodeSession* __del = dynamic_cast< ::IceDelegate::IceGrid::NodeSession*>(__delBase.get());
            return __del->getTimeout(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::IceGrid::NodeObserverPrx
IceProxy::IceGrid::NodeSession::getObserver(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__NodeSession__getObserver_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::NodeSession* __del = dynamic_cast< ::IceDelegate::IceGrid::NodeSession*>(__delBase.get());
            return __del->getObserver(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceGrid::NodeSession::loadServers(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::NodeSession* __del = dynamic_cast< ::IceDelegate::IceGrid::NodeSession*>(__delBase.get());
            __del->loadServers(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::Ice::StringSeq
IceProxy::IceGrid::NodeSession::getServers(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__NodeSession__getServers_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::NodeSession* __del = dynamic_cast< ::IceDelegate::IceGrid::NodeSession*>(__delBase.get());
            return __del->getServers(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceGrid::NodeSession::waitForApplicationUpdate(const ::std::string& application, ::Ice::Int revision, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::NodeSession* __del = dynamic_cast< ::IceDelegate::IceGrid::NodeSession*>(__delBase.get());
            __del->waitForApplicationUpdate(application, revision, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::NodeSession::waitForApplicationUpdate_async(const ::IceGrid::AMI_NodeSession_waitForApplicationUpdatePtr& __cb, const ::std::string& application, ::Ice::Int revision)
{
    return __cb->__invoke(this, application, revision, 0);
}

bool
IceProxy::IceGrid::NodeSession::waitForApplicationUpdate_async(const ::IceGrid::AMI_NodeSession_waitForApplicationUpdatePtr& __cb, const ::std::string& application, ::Ice::Int revision, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, application, revision, &__ctx);
}

void
IceProxy::IceGrid::NodeSession::destroy(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::NodeSession* __del = dynamic_cast< ::IceDelegate::IceGrid::NodeSession*>(__delBase.get());
            __del->destroy(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::NodeSession::ice_staticId()
{
    return ::IceGrid::NodeSession::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::NodeSession::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::NodeSession);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::NodeSession::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::NodeSession);
}

::IceProxy::Ice::Object*
IceProxy::IceGrid::NodeSession::__newInstance() const
{
    return new NodeSession;
}

const ::std::string&
IceProxy::IceGrid::DatabaseObserver::ice_staticId()
{
    return ::IceGrid::DatabaseObserver::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::DatabaseObserver::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::DatabaseObserver);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::DatabaseObserver::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::DatabaseObserver);
}

::IceProxy::Ice::Object*
IceProxy::IceGrid::DatabaseObserver::__newInstance() const
{
    return new DatabaseObserver;
}

void
IceProxy::IceGrid::ReplicaSession::keepAlive(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::ReplicaSession* __del = dynamic_cast< ::IceDelegate::IceGrid::ReplicaSession*>(__delBase.get());
            __del->keepAlive(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::Ice::Int
IceProxy::IceGrid::ReplicaSession::getTimeout(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__ReplicaSession__getTimeout_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::ReplicaSession* __del = dynamic_cast< ::IceDelegate::IceGrid::ReplicaSession*>(__delBase.get());
            return __del->getTimeout(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceGrid::ReplicaSession::setDatabaseObserver(const ::IceGrid::DatabaseObserverPrx& dbObs, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::ReplicaSession* __del = dynamic_cast< ::IceDelegate::IceGrid::ReplicaSession*>(__delBase.get());
            __del->setDatabaseObserver(dbObs, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceGrid::ReplicaSession::setEndpoints(const ::IceGrid::StringObjectProxyDict& endpoints, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::ReplicaSession* __del = dynamic_cast< ::IceDelegate::IceGrid::ReplicaSession*>(__delBase.get());
            __del->setEndpoints(endpoints, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceGrid::ReplicaSession::registerWellKnownObjects(const ::IceGrid::ObjectInfoSeq& objects, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::ReplicaSession* __del = dynamic_cast< ::IceDelegate::IceGrid::ReplicaSession*>(__delBase.get());
            __del->registerWellKnownObjects(objects, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceGrid::ReplicaSession::setAdapterDirectProxy(const ::std::string& adapterId, const ::std::string& replicaGroupId, const ::Ice::ObjectPrx& proxy, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__ReplicaSession__setAdapterDirectProxy_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::ReplicaSession* __del = dynamic_cast< ::IceDelegate::IceGrid::ReplicaSession*>(__delBase.get());
            __del->setAdapterDirectProxy(adapterId, replicaGroupId, proxy, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::ReplicaSession::setAdapterDirectProxy_async(const ::IceGrid::AMI_ReplicaSession_setAdapterDirectProxyPtr& __cb, const ::std::string& adapterId, const ::std::string& replicaGroupId, const ::Ice::ObjectPrx& proxy)
{
    return __cb->__invoke(this, adapterId, replicaGroupId, proxy, 0);
}

bool
IceProxy::IceGrid::ReplicaSession::setAdapterDirectProxy_async(const ::IceGrid::AMI_ReplicaSession_setAdapterDirectProxyPtr& __cb, const ::std::string& adapterId, const ::std::string& replicaGroupId, const ::Ice::ObjectPrx& proxy, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, adapterId, replicaGroupId, proxy, &__ctx);
}

void
IceProxy::IceGrid::ReplicaSession::receivedUpdate(::IceGrid::TopicName name, ::Ice::Int serial, const ::std::string& failure, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::ReplicaSession* __del = dynamic_cast< ::IceDelegate::IceGrid::ReplicaSession*>(__delBase.get());
            __del->receivedUpdate(name, serial, failure, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceGrid::ReplicaSession::destroy(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::ReplicaSession* __del = dynamic_cast< ::IceDelegate::IceGrid::ReplicaSession*>(__delBase.get());
            __del->destroy(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::ReplicaSession::ice_staticId()
{
    return ::IceGrid::ReplicaSession::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::ReplicaSession::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::ReplicaSession);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::ReplicaSession::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::ReplicaSession);
}

::IceProxy::Ice::Object*
IceProxy::IceGrid::ReplicaSession::__newInstance() const
{
    return new ReplicaSession;
}

const ::std::string&
IceProxy::IceGrid::InternalNodeInfo::ice_staticId()
{
    return ::IceGrid::InternalNodeInfo::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::InternalNodeInfo::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::InternalNodeInfo);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::InternalNodeInfo::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::InternalNodeInfo);
}

::IceProxy::Ice::Object*
IceProxy::IceGrid::InternalNodeInfo::__newInstance() const
{
    return new InternalNodeInfo;
}

const ::std::string&
IceProxy::IceGrid::InternalReplicaInfo::ice_staticId()
{
    return ::IceGrid::InternalReplicaInfo::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::InternalReplicaInfo::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::InternalReplicaInfo);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::InternalReplicaInfo::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::InternalReplicaInfo);
}

::IceProxy::Ice::Object*
IceProxy::IceGrid::InternalReplicaInfo::__newInstance() const
{
    return new InternalReplicaInfo;
}

::IceGrid::NodeSessionPrx
IceProxy::IceGrid::InternalRegistry::registerNode(const ::IceGrid::InternalNodeInfoPtr& info, const ::IceGrid::NodePrx& prx, const ::IceGrid::LoadInfo& loadInf, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__InternalRegistry__registerNode_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::InternalRegistry* __del = dynamic_cast< ::IceDelegate::IceGrid::InternalRegistry*>(__delBase.get());
            return __del->registerNode(info, prx, loadInf, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::IceGrid::ReplicaSessionPrx
IceProxy::IceGrid::InternalRegistry::registerReplica(const ::IceGrid::InternalReplicaInfoPtr& info, const ::IceGrid::InternalRegistryPrx& prx, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__InternalRegistry__registerReplica_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::InternalRegistry* __del = dynamic_cast< ::IceDelegate::IceGrid::InternalRegistry*>(__delBase.get());
            return __del->registerReplica(info, prx, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceGrid::InternalRegistry::registerWithReplica(const ::IceGrid::InternalRegistryPrx& prx, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::InternalRegistry* __del = dynamic_cast< ::IceDelegate::IceGrid::InternalRegistry*>(__delBase.get());
            __del->registerWithReplica(prx, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::IceGrid::NodePrxSeq
IceProxy::IceGrid::InternalRegistry::getNodes(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__InternalRegistry__getNodes_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::InternalRegistry* __del = dynamic_cast< ::IceDelegate::IceGrid::InternalRegistry*>(__delBase.get());
            return __del->getNodes(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::IceGrid::InternalRegistryPrxSeq
IceProxy::IceGrid::InternalRegistry::getReplicas(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__IceGrid__InternalRegistry__getReplicas_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::InternalRegistry* __del = dynamic_cast< ::IceDelegate::IceGrid::InternalRegistry*>(__delBase.get());
            return __del->getReplicas(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::IceGrid::InternalRegistry::shutdown(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::IceGrid::InternalRegistry* __del = dynamic_cast< ::IceDelegate::IceGrid::InternalRegistry*>(__delBase.get());
            __del->shutdown(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::InternalRegistry::ice_staticId()
{
    return ::IceGrid::InternalRegistry::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::InternalRegistry::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::InternalRegistry);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::InternalRegistry::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::InternalRegistry);
}

::IceProxy::Ice::Object*
IceProxy::IceGrid::InternalRegistry::__newInstance() const
{
    return new InternalRegistry;
}

::Ice::ObjectPrx
IceDelegateM::IceGrid::Adapter::activate(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__Adapter__activate_name, ::Ice::Normal, __context);
    bool __ok = __og.invoke();
    ::Ice::ObjectPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::ObjectPrx
IceDelegateM::IceGrid::Adapter::getDirectProxy(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__Adapter__getDirectProxy_name, ::Ice::Nonmutating, __context);
    bool __ok = __og.invoke();
    ::Ice::ObjectPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::IceGrid::AdapterNotActiveException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::Adapter::setDirectProxy(const ::Ice::ObjectPrx& proxy, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__Adapter__setDirectProxy_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(proxy);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::IceGrid::AdapterActiveException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        __og.is()->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::Long
IceDelegateM::IceGrid::FileReader::getOffsetFromEnd(const ::std::string& filename, ::Ice::Int lines, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__FileReader__getOffsetFromEnd_name, ::Ice::Idempotent, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(filename);
        __os->write(lines);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    ::Ice::Long __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::IceGrid::FileNotAvailableException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

bool
IceDelegateM::IceGrid::FileReader::read(const ::std::string& filename, ::Ice::Long pos, ::Ice::Int size, ::Ice::Long& newPos, ::Ice::StringSeq& lines, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__FileReader__read_name, ::Ice::Idempotent, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(filename);
        __os->write(pos);
        __os->write(size);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    bool __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::IceGrid::FileNotAvailableException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(newPos);
        __is->read(lines);
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::Server::start(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__Server__start_name, ::Ice::Normal, __context);
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::IceGrid::ServerStartException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        __og.is()->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::Server::stop(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__Server__stop_name, ::Ice::Normal, __context);
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::IceGrid::ServerStopException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        __og.is()->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::Server::setEnabled(bool enable, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__Server__setEnabled_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(enable);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

bool
IceDelegateM::IceGrid::Server::isEnabled(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__Server__isEnabled_name, ::Ice::Nonmutating, __context);
    bool __ok = __og.invoke();
    bool __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::Server::sendSignal(const ::std::string& signal, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__Server__sendSignal_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(signal);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::IceGrid::BadSignalException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        __og.is()->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::Server::writeMessage(const ::std::string& message, ::Ice::Int fd, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__Server__writeMessage_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(message);
        __os->write(fd);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

::IceGrid::ServerState
IceDelegateM::IceGrid::Server::getState(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__Server__getState_name, ::Ice::Nonmutating, __context);
    bool __ok = __og.invoke();
    ::IceGrid::ServerState __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::IceGrid::__read(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::Int
IceDelegateM::IceGrid::Server::getPid(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__Server__getPid_name, ::Ice::Nonmutating, __context);
    bool __ok = __og.invoke();
    ::Ice::Int __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::Server::setProcess(const ::Ice::ProcessPrx& proc, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__Server__setProcess_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(proc.get())));
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::ReplicaObserver::replicaInit(const ::IceGrid::InternalRegistryPrxSeq& replicas, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__ReplicaObserver__replicaInit_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(replicas.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceGrid::__writeInternalRegistryPrxSeq(__os, &replicas[0], &replicas[0] + replicas.size());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::ReplicaObserver::replicaAdded(const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__ReplicaObserver__replicaAdded_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(replica.get())));
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::ReplicaObserver::replicaRemoved(const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__ReplicaObserver__replicaRemoved_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(replica.get())));
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::PatcherFeedback::finished(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__PatcherFeedback__finished_name, ::Ice::Normal, __context);
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::PatcherFeedback::failed(const ::std::string& reason, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__PatcherFeedback__failed_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(reason);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

::IceGrid::ServerPrx
IceDelegateM::IceGrid::Node::loadServer(const ::IceGrid::InternalServerDescriptorPtr& svr, const ::std::string& replicaName, ::IceGrid::AdapterPrxDict& adapters, ::Ice::Int& actTimeout, ::Ice::Int& deactTimeout, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__Node__loadServer_name, ::Ice::Idempotent, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(::Ice::ObjectPtr(::IceInternal::upCast(svr.get())));
        __os->write(replicaName);
        __os->writePendingObjects();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    ::IceGrid::ServerPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::IceGrid::DeploymentException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::IceGrid::__readAdapterPrxDict(__is, adapters);
        __is->read(actTimeout);
        __is->read(deactTimeout);
        ::IceGrid::__read(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::Node::destroyServer(const ::std::string& name, const ::std::string& uuid, ::Ice::Int revision, const ::std::string& replicaName, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__Node__destroyServer_name, ::Ice::Idempotent, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(name);
        __os->write(uuid);
        __os->write(revision);
        __os->write(replicaName);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::IceGrid::DeploymentException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        __og.is()->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::Node::patch(const ::IceGrid::PatcherFeedbackPrx& feedback, const ::std::string& application, const ::std::string& server, const ::IceGrid::InternalDistributionDescriptorPtr& appDistrib, bool shutdown, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__Node__patch_name, ::Ice::Idempotent, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(feedback.get())));
        __os->write(application);
        __os->write(server);
        __os->write(::Ice::ObjectPtr(::IceInternal::upCast(appDistrib.get())));
        __os->write(shutdown);
        __os->writePendingObjects();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::Node::registerWithReplica(const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__Node__registerWithReplica_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(replica.get())));
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

::std::string
IceDelegateM::IceGrid::Node::getName(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__Node__getName_name, ::Ice::Nonmutating, __context);
    bool __ok = __og.invoke();
    ::std::string __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::std::string
IceDelegateM::IceGrid::Node::getHostname(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__Node__getHostname_name, ::Ice::Nonmutating, __context);
    bool __ok = __og.invoke();
    ::std::string __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceGrid::LoadInfo
IceDelegateM::IceGrid::Node::getLoad(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__Node__getLoad_name, ::Ice::Nonmutating, __context);
    bool __ok = __og.invoke();
    ::IceGrid::LoadInfo __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __ret.__read(__is);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::Node::shutdown(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__Node__shutdown_name, ::Ice::Nonmutating, __context);
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::NodeSession::keepAlive(const ::IceGrid::LoadInfo& load, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__NodeSession__keepAlive_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        load.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::NodeSession::setReplicaObserver(const ::IceGrid::ReplicaObserverPrx& observer, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__NodeSession__setReplicaObserver_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(observer.get())));
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

::Ice::Int
IceDelegateM::IceGrid::NodeSession::getTimeout(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__NodeSession__getTimeout_name, ::Ice::Nonmutating, __context);
    bool __ok = __og.invoke();
    ::Ice::Int __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceGrid::NodeObserverPrx
IceDelegateM::IceGrid::NodeSession::getObserver(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__NodeSession__getObserver_name, ::Ice::Nonmutating, __context);
    bool __ok = __og.invoke();
    ::IceGrid::NodeObserverPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::IceGrid::__read(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::NodeSession::loadServers(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__NodeSession__loadServers_name, ::Ice::Nonmutating, __context);
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

::Ice::StringSeq
IceDelegateM::IceGrid::NodeSession::getServers(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__NodeSession__getServers_name, ::Ice::Nonmutating, __context);
    bool __ok = __og.invoke();
    ::Ice::StringSeq __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::NodeSession::waitForApplicationUpdate(const ::std::string& application, ::Ice::Int revision, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__NodeSession__waitForApplicationUpdate_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(application);
        __os->write(revision);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::NodeSession::destroy(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__NodeSession__destroy_name, ::Ice::Normal, __context);
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::ReplicaSession::keepAlive(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__ReplicaSession__keepAlive_name, ::Ice::Normal, __context);
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

::Ice::Int
IceDelegateM::IceGrid::ReplicaSession::getTimeout(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__ReplicaSession__getTimeout_name, ::Ice::Idempotent, __context);
    bool __ok = __og.invoke();
    ::Ice::Int __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::ReplicaSession::setDatabaseObserver(const ::IceGrid::DatabaseObserverPrx& dbObs, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__ReplicaSession__setDatabaseObserver_name, ::Ice::Idempotent, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(dbObs.get())));
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::ReplicaSession::setEndpoints(const ::IceGrid::StringObjectProxyDict& endpoints, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__ReplicaSession__setEndpoints_name, ::Ice::Idempotent, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        ::IceGrid::__writeStringObjectProxyDict(__os, endpoints);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::ReplicaSession::registerWellKnownObjects(const ::IceGrid::ObjectInfoSeq& objects, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__ReplicaSession__registerWellKnownObjects_name, ::Ice::Idempotent, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(objects.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceGrid::__writeObjectInfoSeq(__os, &objects[0], &objects[0] + objects.size());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::ReplicaSession::setAdapterDirectProxy(const ::std::string& adapterId, const ::std::string& replicaGroupId, const ::Ice::ObjectPrx& proxy, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__ReplicaSession__setAdapterDirectProxy_name, ::Ice::Idempotent, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(adapterId);
        __os->write(replicaGroupId);
        __os->write(proxy);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::IceGrid::AdapterExistsException&)
            {
                throw;
            }
            catch(const ::IceGrid::AdapterNotExistException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        __og.is()->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::ReplicaSession::receivedUpdate(::IceGrid::TopicName name, ::Ice::Int serial, const ::std::string& failure, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__ReplicaSession__receivedUpdate_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        ::IceGrid::__write(__os, name);
        __os->write(serial);
        __os->write(failure);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::IceGrid::ReplicaSession::destroy(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__ReplicaSession__destroy_name, ::Ice::Normal, __context);
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

::IceGrid::NodeSessionPrx
IceDelegateM::IceGrid::InternalRegistry::registerNode(const ::IceGrid::InternalNodeInfoPtr& info, const ::IceGrid::NodePrx& prx, const ::IceGrid::LoadInfo& loadInf, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__InternalRegistry__registerNode_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(::Ice::ObjectPtr(::IceInternal::upCast(info.get())));
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(prx.get())));
        loadInf.__write(__os);
        __os->writePendingObjects();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    ::IceGrid::NodeSessionPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::IceGrid::NodeActiveException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::IceGrid::__read(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceGrid::ReplicaSessionPrx
IceDelegateM::IceGrid::InternalRegistry::registerReplica(const ::IceGrid::InternalReplicaInfoPtr& info, const ::IceGrid::InternalRegistryPrx& prx, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__InternalRegistry__registerReplica_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(::Ice::ObjectPtr(::IceInternal::upCast(info.get())));
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(prx.get())));
        __os->writePendingObjects();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    ::IceGrid::ReplicaSessionPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::IceGrid::ReplicaActiveException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::IceGrid::__read(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::InternalRegistry::registerWithReplica(const ::IceGrid::InternalRegistryPrx& prx, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__InternalRegistry__registerWithReplica_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(prx.get())));
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

::IceGrid::NodePrxSeq
IceDelegateM::IceGrid::InternalRegistry::getNodes(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__InternalRegistry__getNodes_name, ::Ice::Idempotent, __context);
    bool __ok = __og.invoke();
    ::IceGrid::NodePrxSeq __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::IceGrid::__readNodePrxSeq(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceGrid::InternalRegistryPrxSeq
IceDelegateM::IceGrid::InternalRegistry::getReplicas(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__InternalRegistry__getReplicas_name, ::Ice::Idempotent, __context);
    bool __ok = __og.invoke();
    ::IceGrid::InternalRegistryPrxSeq __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::IceGrid::__readInternalRegistryPrxSeq(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::InternalRegistry::shutdown(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __IceGrid__InternalRegistry__shutdown_name, ::Ice::Idempotent, __context);
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

::Ice::ObjectPrx
IceDelegateD::IceGrid::Adapter::activate(const ::Ice::Context*)
{
    throw ::Ice::CollocationOptimizationException(__FILE__, __LINE__);
    return ::Ice::ObjectPrx(); // to avoid a warning with some compilers;
}

::Ice::ObjectPrx
IceDelegateD::IceGrid::Adapter::getDirectProxy(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Ice::ObjectPrx& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::Adapter* servant = dynamic_cast< ::IceGrid::Adapter*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                _result = servant->getDirectProxy(_current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        ::Ice::ObjectPrx& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Adapter__getDirectProxy_name, ::Ice::Nonmutating, __context);
    ::Ice::ObjectPrx __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::IceGrid::AdapterNotActiveException&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

void
IceDelegateD::IceGrid::Adapter::setDirectProxy(const ::Ice::ObjectPrx& proxy, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Ice::ObjectPrx& proxy, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_proxy(proxy)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::Adapter* servant = dynamic_cast< ::IceGrid::Adapter*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                servant->setDirectProxy(_m_proxy, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        const ::Ice::ObjectPrx& _m_proxy;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Adapter__setDirectProxy_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(proxy, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::IceGrid::AdapterActiveException&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

::Ice::Long
IceDelegateD::IceGrid::FileReader::getOffsetFromEnd(const ::std::string& filename, ::Ice::Int lines, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Ice::Long& __result, const ::std::string& filename, ::Ice::Int lines, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_filename(filename),
            _m_lines(lines)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::FileReader* servant = dynamic_cast< ::IceGrid::FileReader*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                _result = servant->getOffsetFromEnd(_m_filename, _m_lines, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        ::Ice::Long& _result;
        const ::std::string& _m_filename;
        ::Ice::Int _m_lines;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__FileReader__getOffsetFromEnd_name, ::Ice::Idempotent, __context);
    ::Ice::Long __result;
    try
    {
        _DirectI __direct(__result, filename, lines, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::IceGrid::FileNotAvailableException&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

bool
IceDelegateD::IceGrid::FileReader::read(const ::std::string& filename, ::Ice::Long pos, ::Ice::Int size, ::Ice::Long& newPos, ::Ice::StringSeq& lines, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(bool& __result, const ::std::string& filename, ::Ice::Long pos, ::Ice::Int size, ::Ice::Long& newPos, ::Ice::StringSeq& lines, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_filename(filename),
            _m_pos(pos),
            _m_size(size),
            _m_newPos(newPos),
            _m_lines(lines)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::FileReader* servant = dynamic_cast< ::IceGrid::FileReader*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                _result = servant->read(_m_filename, _m_pos, _m_size, _m_newPos, _m_lines, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        bool& _result;
        const ::std::string& _m_filename;
        ::Ice::Long _m_pos;
        ::Ice::Int _m_size;
        ::Ice::Long& _m_newPos;
        ::Ice::StringSeq& _m_lines;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__FileReader__read_name, ::Ice::Idempotent, __context);
    bool __result;
    try
    {
        _DirectI __direct(__result, filename, pos, size, newPos, lines, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::IceGrid::FileNotAvailableException&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

void
IceDelegateD::IceGrid::Server::start(const ::Ice::Context*)
{
    throw ::Ice::CollocationOptimizationException(__FILE__, __LINE__);
}

void
IceDelegateD::IceGrid::Server::stop(const ::Ice::Context*)
{
    throw ::Ice::CollocationOptimizationException(__FILE__, __LINE__);
}

void
IceDelegateD::IceGrid::Server::setEnabled(bool enable, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(bool enable, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_enable(enable)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::Server* servant = dynamic_cast< ::IceGrid::Server*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->setEnabled(_m_enable, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        bool _m_enable;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Server__setEnabled_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(enable, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

bool
IceDelegateD::IceGrid::Server::isEnabled(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(bool& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::Server* servant = dynamic_cast< ::IceGrid::Server*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->isEnabled(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        bool& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Server__isEnabled_name, ::Ice::Nonmutating, __context);
    bool __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

void
IceDelegateD::IceGrid::Server::sendSignal(const ::std::string& signal, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::std::string& signal, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_signal(signal)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::Server* servant = dynamic_cast< ::IceGrid::Server*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                servant->sendSignal(_m_signal, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        const ::std::string& _m_signal;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Server__sendSignal_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(signal, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::IceGrid::BadSignalException&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::Server::writeMessage(const ::std::string& message, ::Ice::Int fd, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::std::string& message, ::Ice::Int fd, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_message(message),
            _m_fd(fd)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::Server* servant = dynamic_cast< ::IceGrid::Server*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->writeMessage(_m_message, _m_fd, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::std::string& _m_message;
        ::Ice::Int _m_fd;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Server__writeMessage_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(message, fd, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

::IceGrid::ServerState
IceDelegateD::IceGrid::Server::getState(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::IceGrid::ServerState& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::Server* servant = dynamic_cast< ::IceGrid::Server*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->getState(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::IceGrid::ServerState& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Server__getState_name, ::Ice::Nonmutating, __context);
    ::IceGrid::ServerState __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Ice::Int
IceDelegateD::IceGrid::Server::getPid(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Ice::Int& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::Server* servant = dynamic_cast< ::IceGrid::Server*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->getPid(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::Ice::Int& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Server__getPid_name, ::Ice::Nonmutating, __context);
    ::Ice::Int __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

void
IceDelegateD::IceGrid::Server::setProcess(const ::Ice::ProcessPrx&, const ::Ice::Context*)
{
    throw ::Ice::CollocationOptimizationException(__FILE__, __LINE__);
}

void
IceDelegateD::IceGrid::ReplicaObserver::replicaInit(const ::IceGrid::InternalRegistryPrxSeq& replicas, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::IceGrid::InternalRegistryPrxSeq& replicas, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_replicas(replicas)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::ReplicaObserver* servant = dynamic_cast< ::IceGrid::ReplicaObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->replicaInit(_m_replicas, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::IceGrid::InternalRegistryPrxSeq& _m_replicas;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ReplicaObserver__replicaInit_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(replicas, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::ReplicaObserver::replicaAdded(const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_replica(replica)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::ReplicaObserver* servant = dynamic_cast< ::IceGrid::ReplicaObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->replicaAdded(_m_replica, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::IceGrid::InternalRegistryPrx& _m_replica;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ReplicaObserver__replicaAdded_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(replica, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::ReplicaObserver::replicaRemoved(const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_replica(replica)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::ReplicaObserver* servant = dynamic_cast< ::IceGrid::ReplicaObserver*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->replicaRemoved(_m_replica, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::IceGrid::InternalRegistryPrx& _m_replica;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ReplicaObserver__replicaRemoved_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(replica, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::PatcherFeedback::finished(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::PatcherFeedback* servant = dynamic_cast< ::IceGrid::PatcherFeedback*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->finished(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__PatcherFeedback__finished_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(__current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::PatcherFeedback::failed(const ::std::string& reason, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::std::string& reason, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_reason(reason)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::PatcherFeedback* servant = dynamic_cast< ::IceGrid::PatcherFeedback*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->failed(_m_reason, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::std::string& _m_reason;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__PatcherFeedback__failed_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(reason, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

::IceGrid::ServerPrx
IceDelegateD::IceGrid::Node::loadServer(const ::IceGrid::InternalServerDescriptorPtr&, const ::std::string&, ::IceGrid::AdapterPrxDict&, ::Ice::Int&, ::Ice::Int&, const ::Ice::Context*)
{
    throw ::Ice::CollocationOptimizationException(__FILE__, __LINE__);
    return ::IceGrid::ServerPrx(); // to avoid a warning with some compilers;
}

void
IceDelegateD::IceGrid::Node::destroyServer(const ::std::string&, const ::std::string&, ::Ice::Int, const ::std::string&, const ::Ice::Context*)
{
    throw ::Ice::CollocationOptimizationException(__FILE__, __LINE__);
}

void
IceDelegateD::IceGrid::Node::patch(const ::IceGrid::PatcherFeedbackPrx&, const ::std::string&, const ::std::string&, const ::IceGrid::InternalDistributionDescriptorPtr&, bool, const ::Ice::Context*)
{
    throw ::Ice::CollocationOptimizationException(__FILE__, __LINE__);
}

void
IceDelegateD::IceGrid::Node::registerWithReplica(const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_replica(replica)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::Node* servant = dynamic_cast< ::IceGrid::Node*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->registerWithReplica(_m_replica, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::IceGrid::InternalRegistryPrx& _m_replica;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Node__registerWithReplica_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(replica, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

::std::string
IceDelegateD::IceGrid::Node::getName(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::std::string& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::Node* servant = dynamic_cast< ::IceGrid::Node*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->getName(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::std::string& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Node__getName_name, ::Ice::Nonmutating, __context);
    ::std::string __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::std::string
IceDelegateD::IceGrid::Node::getHostname(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::std::string& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::Node* servant = dynamic_cast< ::IceGrid::Node*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->getHostname(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::std::string& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Node__getHostname_name, ::Ice::Nonmutating, __context);
    ::std::string __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::IceGrid::LoadInfo
IceDelegateD::IceGrid::Node::getLoad(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::IceGrid::LoadInfo& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::Node* servant = dynamic_cast< ::IceGrid::Node*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->getLoad(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::IceGrid::LoadInfo& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Node__getLoad_name, ::Ice::Nonmutating, __context);
    ::IceGrid::LoadInfo __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

void
IceDelegateD::IceGrid::Node::shutdown(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::Node* servant = dynamic_cast< ::IceGrid::Node*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->shutdown(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Node__shutdown_name, ::Ice::Nonmutating, __context);
    try
    {
        _DirectI __direct(__current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::NodeSession::keepAlive(const ::IceGrid::LoadInfo& load, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::IceGrid::LoadInfo& load, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_load(load)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::NodeSession* servant = dynamic_cast< ::IceGrid::NodeSession*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->keepAlive(_m_load, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::IceGrid::LoadInfo& _m_load;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__NodeSession__keepAlive_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(load, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::NodeSession::setReplicaObserver(const ::IceGrid::ReplicaObserverPrx& observer, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::IceGrid::ReplicaObserverPrx& observer, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_observer(observer)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::NodeSession* servant = dynamic_cast< ::IceGrid::NodeSession*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->setReplicaObserver(_m_observer, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::IceGrid::ReplicaObserverPrx& _m_observer;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__NodeSession__setReplicaObserver_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(observer, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

::Ice::Int
IceDelegateD::IceGrid::NodeSession::getTimeout(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Ice::Int& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::NodeSession* servant = dynamic_cast< ::IceGrid::NodeSession*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->getTimeout(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::Ice::Int& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__NodeSession__getTimeout_name, ::Ice::Nonmutating, __context);
    ::Ice::Int __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::IceGrid::NodeObserverPrx
IceDelegateD::IceGrid::NodeSession::getObserver(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::IceGrid::NodeObserverPrx& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::NodeSession* servant = dynamic_cast< ::IceGrid::NodeSession*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->getObserver(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::IceGrid::NodeObserverPrx& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__NodeSession__getObserver_name, ::Ice::Nonmutating, __context);
    ::IceGrid::NodeObserverPrx __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

void
IceDelegateD::IceGrid::NodeSession::loadServers(const ::Ice::Context*)
{
    throw ::Ice::CollocationOptimizationException(__FILE__, __LINE__);
}

::Ice::StringSeq
IceDelegateD::IceGrid::NodeSession::getServers(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Ice::StringSeq& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::NodeSession* servant = dynamic_cast< ::IceGrid::NodeSession*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->getServers(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::Ice::StringSeq& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__NodeSession__getServers_name, ::Ice::Nonmutating, __context);
    ::Ice::StringSeq __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

void
IceDelegateD::IceGrid::NodeSession::waitForApplicationUpdate(const ::std::string&, ::Ice::Int, const ::Ice::Context*)
{
    throw ::Ice::CollocationOptimizationException(__FILE__, __LINE__);
}

void
IceDelegateD::IceGrid::NodeSession::destroy(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::NodeSession* servant = dynamic_cast< ::IceGrid::NodeSession*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->destroy(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__NodeSession__destroy_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(__current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::ReplicaSession::keepAlive(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::ReplicaSession* servant = dynamic_cast< ::IceGrid::ReplicaSession*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->keepAlive(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ReplicaSession__keepAlive_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(__current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

::Ice::Int
IceDelegateD::IceGrid::ReplicaSession::getTimeout(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Ice::Int& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::ReplicaSession* servant = dynamic_cast< ::IceGrid::ReplicaSession*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->getTimeout(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::Ice::Int& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ReplicaSession__getTimeout_name, ::Ice::Idempotent, __context);
    ::Ice::Int __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

void
IceDelegateD::IceGrid::ReplicaSession::setDatabaseObserver(const ::IceGrid::DatabaseObserverPrx& dbObs, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::IceGrid::DatabaseObserverPrx& dbObs, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_dbObs(dbObs)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::ReplicaSession* servant = dynamic_cast< ::IceGrid::ReplicaSession*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->setDatabaseObserver(_m_dbObs, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::IceGrid::DatabaseObserverPrx& _m_dbObs;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ReplicaSession__setDatabaseObserver_name, ::Ice::Idempotent, __context);
    try
    {
        _DirectI __direct(dbObs, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::ReplicaSession::setEndpoints(const ::IceGrid::StringObjectProxyDict& endpoints, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::IceGrid::StringObjectProxyDict& endpoints, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_endpoints(endpoints)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::ReplicaSession* servant = dynamic_cast< ::IceGrid::ReplicaSession*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->setEndpoints(_m_endpoints, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::IceGrid::StringObjectProxyDict& _m_endpoints;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ReplicaSession__setEndpoints_name, ::Ice::Idempotent, __context);
    try
    {
        _DirectI __direct(endpoints, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::ReplicaSession::registerWellKnownObjects(const ::IceGrid::ObjectInfoSeq& objects, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::IceGrid::ObjectInfoSeq& objects, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_objects(objects)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::ReplicaSession* servant = dynamic_cast< ::IceGrid::ReplicaSession*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->registerWellKnownObjects(_m_objects, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::IceGrid::ObjectInfoSeq& _m_objects;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ReplicaSession__registerWellKnownObjects_name, ::Ice::Idempotent, __context);
    try
    {
        _DirectI __direct(objects, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::ReplicaSession::setAdapterDirectProxy(const ::std::string& adapterId, const ::std::string& replicaGroupId, const ::Ice::ObjectPrx& proxy, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::std::string& adapterId, const ::std::string& replicaGroupId, const ::Ice::ObjectPrx& proxy, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_adapterId(adapterId),
            _m_replicaGroupId(replicaGroupId),
            _m_proxy(proxy)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::ReplicaSession* servant = dynamic_cast< ::IceGrid::ReplicaSession*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                servant->setAdapterDirectProxy(_m_adapterId, _m_replicaGroupId, _m_proxy, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        const ::std::string& _m_adapterId;
        const ::std::string& _m_replicaGroupId;
        const ::Ice::ObjectPrx& _m_proxy;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ReplicaSession__setAdapterDirectProxy_name, ::Ice::Idempotent, __context);
    try
    {
        _DirectI __direct(adapterId, replicaGroupId, proxy, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::IceGrid::AdapterExistsException&)
    {
        throw;
    }
    catch(const ::IceGrid::AdapterNotExistException&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::ReplicaSession::receivedUpdate(::IceGrid::TopicName name, ::Ice::Int serial, const ::std::string& failure, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::IceGrid::TopicName name, ::Ice::Int serial, const ::std::string& failure, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_name(name),
            _m_serial(serial),
            _m_failure(failure)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::ReplicaSession* servant = dynamic_cast< ::IceGrid::ReplicaSession*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->receivedUpdate(_m_name, _m_serial, _m_failure, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::IceGrid::TopicName _m_name;
        ::Ice::Int _m_serial;
        const ::std::string& _m_failure;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ReplicaSession__receivedUpdate_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(name, serial, failure, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::IceGrid::ReplicaSession::destroy(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::ReplicaSession* servant = dynamic_cast< ::IceGrid::ReplicaSession*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->destroy(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ReplicaSession__destroy_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(__current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

::IceGrid::NodeSessionPrx
IceDelegateD::IceGrid::InternalRegistry::registerNode(const ::IceGrid::InternalNodeInfoPtr& info, const ::IceGrid::NodePrx& prx, const ::IceGrid::LoadInfo& loadInf, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::IceGrid::NodeSessionPrx& __result, const ::IceGrid::InternalNodeInfoPtr& info, const ::IceGrid::NodePrx& prx, const ::IceGrid::LoadInfo& loadInf, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_info(info),
            _m_prx(prx),
            _m_loadInf(loadInf)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::InternalRegistry* servant = dynamic_cast< ::IceGrid::InternalRegistry*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                _result = servant->registerNode(_m_info, _m_prx, _m_loadInf, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        ::IceGrid::NodeSessionPrx& _result;
        const ::IceGrid::InternalNodeInfoPtr& _m_info;
        const ::IceGrid::NodePrx& _m_prx;
        const ::IceGrid::LoadInfo& _m_loadInf;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__InternalRegistry__registerNode_name, ::Ice::Normal, __context);
    ::IceGrid::NodeSessionPrx __result;
    try
    {
        _DirectI __direct(__result, info, prx, loadInf, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::IceGrid::NodeActiveException&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::IceGrid::ReplicaSessionPrx
IceDelegateD::IceGrid::InternalRegistry::registerReplica(const ::IceGrid::InternalReplicaInfoPtr& info, const ::IceGrid::InternalRegistryPrx& prx, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::IceGrid::ReplicaSessionPrx& __result, const ::IceGrid::InternalReplicaInfoPtr& info, const ::IceGrid::InternalRegistryPrx& prx, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_info(info),
            _m_prx(prx)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::InternalRegistry* servant = dynamic_cast< ::IceGrid::InternalRegistry*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                _result = servant->registerReplica(_m_info, _m_prx, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        ::IceGrid::ReplicaSessionPrx& _result;
        const ::IceGrid::InternalReplicaInfoPtr& _m_info;
        const ::IceGrid::InternalRegistryPrx& _m_prx;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__InternalRegistry__registerReplica_name, ::Ice::Normal, __context);
    ::IceGrid::ReplicaSessionPrx __result;
    try
    {
        _DirectI __direct(__result, info, prx, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::IceGrid::ReplicaActiveException&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

void
IceDelegateD::IceGrid::InternalRegistry::registerWithReplica(const ::IceGrid::InternalRegistryPrx& prx, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::IceGrid::InternalRegistryPrx& prx, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_prx(prx)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::InternalRegistry* servant = dynamic_cast< ::IceGrid::InternalRegistry*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->registerWithReplica(_m_prx, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::IceGrid::InternalRegistryPrx& _m_prx;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__InternalRegistry__registerWithReplica_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(prx, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

::IceGrid::NodePrxSeq
IceDelegateD::IceGrid::InternalRegistry::getNodes(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::IceGrid::NodePrxSeq& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::InternalRegistry* servant = dynamic_cast< ::IceGrid::InternalRegistry*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->getNodes(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::IceGrid::NodePrxSeq& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__InternalRegistry__getNodes_name, ::Ice::Idempotent, __context);
    ::IceGrid::NodePrxSeq __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::IceGrid::InternalRegistryPrxSeq
IceDelegateD::IceGrid::InternalRegistry::getReplicas(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::IceGrid::InternalRegistryPrxSeq& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::InternalRegistry* servant = dynamic_cast< ::IceGrid::InternalRegistry*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->getReplicas(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::IceGrid::InternalRegistryPrxSeq& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__InternalRegistry__getReplicas_name, ::Ice::Idempotent, __context);
    ::IceGrid::InternalRegistryPrxSeq __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

void
IceDelegateD::IceGrid::InternalRegistry::shutdown(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::IceGrid::InternalRegistry* servant = dynamic_cast< ::IceGrid::InternalRegistry*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->shutdown(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__InternalRegistry__shutdown_name, ::Ice::Idempotent, __context);
    try
    {
        _DirectI __direct(__current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

IceGrid::InternalDbEnvDescriptor::InternalDbEnvDescriptor(const ::std::string& __ice_name, const ::IceGrid::PropertyDescriptorSeq& __ice_properties) :
    name(__ice_name),
    properties(__ice_properties)
{
}

::Ice::ObjectPtr
IceGrid::InternalDbEnvDescriptor::ice_clone() const
{
    ::IceGrid::InternalDbEnvDescriptorPtr __p = new ::IceGrid::InternalDbEnvDescriptor(*this);
    return __p;
}

static const ::std::string __IceGrid__InternalDbEnvDescriptor_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::InternalDbEnvDescriptor"
};

bool
IceGrid::InternalDbEnvDescriptor::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__InternalDbEnvDescriptor_ids, __IceGrid__InternalDbEnvDescriptor_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::InternalDbEnvDescriptor::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__InternalDbEnvDescriptor_ids[0], &__IceGrid__InternalDbEnvDescriptor_ids[2]);
}

const ::std::string&
IceGrid::InternalDbEnvDescriptor::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__InternalDbEnvDescriptor_ids[1];
}

const ::std::string&
IceGrid::InternalDbEnvDescriptor::ice_staticId()
{
    return __IceGrid__InternalDbEnvDescriptor_ids[1];
}

void
IceGrid::InternalDbEnvDescriptor::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->write(name);
    if(properties.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::IceGrid::__writePropertyDescriptorSeq(__os, &properties[0], &properties[0] + properties.size());
    }
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::InternalDbEnvDescriptor::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->read(name);
    ::IceGrid::__readPropertyDescriptorSeq(__is, properties);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::InternalDbEnvDescriptor::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalDbEnvDescriptor was not generated with stream support";
    throw ex;
}

void
IceGrid::InternalDbEnvDescriptor::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalDbEnvDescriptor was not generated with stream support";
    throw ex;
}

class __F__IceGrid__InternalDbEnvDescriptor : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::IceGrid::InternalDbEnvDescriptor::ice_staticId());
        return new ::IceGrid::InternalDbEnvDescriptor;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__IceGrid__InternalDbEnvDescriptor_Ptr = new __F__IceGrid__InternalDbEnvDescriptor;

const ::Ice::ObjectFactoryPtr&
IceGrid::InternalDbEnvDescriptor::ice_factory()
{
    return __F__IceGrid__InternalDbEnvDescriptor_Ptr;
}

class __F__IceGrid__InternalDbEnvDescriptor__Init
{
public:

    __F__IceGrid__InternalDbEnvDescriptor__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::IceGrid::InternalDbEnvDescriptor::ice_staticId(), ::IceGrid::InternalDbEnvDescriptor::ice_factory());
    }

    ~__F__IceGrid__InternalDbEnvDescriptor__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::IceGrid::InternalDbEnvDescriptor::ice_staticId());
    }
};

static __F__IceGrid__InternalDbEnvDescriptor__Init __F__IceGrid__InternalDbEnvDescriptor__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__InternalDbEnvDescriptor__initializer() {} }
#endif

void 
IceGrid::__patch__InternalDbEnvDescriptorPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::InternalDbEnvDescriptorPtr* p = static_cast< ::IceGrid::InternalDbEnvDescriptorPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::InternalDbEnvDescriptorPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceGrid::InternalDbEnvDescriptor::ice_staticId(), v->ice_id());
    }
}

bool
IceGrid::operator==(const ::IceGrid::InternalDbEnvDescriptor& l, const ::IceGrid::InternalDbEnvDescriptor& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::InternalDbEnvDescriptor& l, const ::IceGrid::InternalDbEnvDescriptor& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

IceGrid::InternalAdapterDescriptor::InternalAdapterDescriptor(const ::std::string& __ice_id, bool __ice_serverLifetime) :
    id(__ice_id),
    serverLifetime(__ice_serverLifetime)
{
}

::Ice::ObjectPtr
IceGrid::InternalAdapterDescriptor::ice_clone() const
{
    ::IceGrid::InternalAdapterDescriptorPtr __p = new ::IceGrid::InternalAdapterDescriptor(*this);
    return __p;
}

static const ::std::string __IceGrid__InternalAdapterDescriptor_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::InternalAdapterDescriptor"
};

bool
IceGrid::InternalAdapterDescriptor::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__InternalAdapterDescriptor_ids, __IceGrid__InternalAdapterDescriptor_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::InternalAdapterDescriptor::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__InternalAdapterDescriptor_ids[0], &__IceGrid__InternalAdapterDescriptor_ids[2]);
}

const ::std::string&
IceGrid::InternalAdapterDescriptor::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__InternalAdapterDescriptor_ids[1];
}

const ::std::string&
IceGrid::InternalAdapterDescriptor::ice_staticId()
{
    return __IceGrid__InternalAdapterDescriptor_ids[1];
}

void
IceGrid::InternalAdapterDescriptor::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->write(id);
    __os->write(serverLifetime);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::InternalAdapterDescriptor::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->read(id);
    __is->read(serverLifetime);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::InternalAdapterDescriptor::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalAdapterDescriptor was not generated with stream support";
    throw ex;
}

void
IceGrid::InternalAdapterDescriptor::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalAdapterDescriptor was not generated with stream support";
    throw ex;
}

class __F__IceGrid__InternalAdapterDescriptor : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::IceGrid::InternalAdapterDescriptor::ice_staticId());
        return new ::IceGrid::InternalAdapterDescriptor;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__IceGrid__InternalAdapterDescriptor_Ptr = new __F__IceGrid__InternalAdapterDescriptor;

const ::Ice::ObjectFactoryPtr&
IceGrid::InternalAdapterDescriptor::ice_factory()
{
    return __F__IceGrid__InternalAdapterDescriptor_Ptr;
}

class __F__IceGrid__InternalAdapterDescriptor__Init
{
public:

    __F__IceGrid__InternalAdapterDescriptor__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::IceGrid::InternalAdapterDescriptor::ice_staticId(), ::IceGrid::InternalAdapterDescriptor::ice_factory());
    }

    ~__F__IceGrid__InternalAdapterDescriptor__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::IceGrid::InternalAdapterDescriptor::ice_staticId());
    }
};

static __F__IceGrid__InternalAdapterDescriptor__Init __F__IceGrid__InternalAdapterDescriptor__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__InternalAdapterDescriptor__initializer() {} }
#endif

void 
IceGrid::__patch__InternalAdapterDescriptorPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::InternalAdapterDescriptorPtr* p = static_cast< ::IceGrid::InternalAdapterDescriptorPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::InternalAdapterDescriptorPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceGrid::InternalAdapterDescriptor::ice_staticId(), v->ice_id());
    }
}

bool
IceGrid::operator==(const ::IceGrid::InternalAdapterDescriptor& l, const ::IceGrid::InternalAdapterDescriptor& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::InternalAdapterDescriptor& l, const ::IceGrid::InternalAdapterDescriptor& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

IceGrid::InternalDistributionDescriptor::InternalDistributionDescriptor(const ::std::string& __ice_icepatch, const ::Ice::StringSeq& __ice_directories) :
    icepatch(__ice_icepatch),
    directories(__ice_directories)
{
}

::Ice::ObjectPtr
IceGrid::InternalDistributionDescriptor::ice_clone() const
{
    ::IceGrid::InternalDistributionDescriptorPtr __p = new ::IceGrid::InternalDistributionDescriptor(*this);
    return __p;
}

static const ::std::string __IceGrid__InternalDistributionDescriptor_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::InternalDistributionDescriptor"
};

bool
IceGrid::InternalDistributionDescriptor::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__InternalDistributionDescriptor_ids, __IceGrid__InternalDistributionDescriptor_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::InternalDistributionDescriptor::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__InternalDistributionDescriptor_ids[0], &__IceGrid__InternalDistributionDescriptor_ids[2]);
}

const ::std::string&
IceGrid::InternalDistributionDescriptor::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__InternalDistributionDescriptor_ids[1];
}

const ::std::string&
IceGrid::InternalDistributionDescriptor::ice_staticId()
{
    return __IceGrid__InternalDistributionDescriptor_ids[1];
}

void
IceGrid::InternalDistributionDescriptor::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->write(icepatch);
    if(directories.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        __os->write(&directories[0], &directories[0] + directories.size());
    }
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::InternalDistributionDescriptor::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->read(icepatch);
    __is->read(directories);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::InternalDistributionDescriptor::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalDistributionDescriptor was not generated with stream support";
    throw ex;
}

void
IceGrid::InternalDistributionDescriptor::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalDistributionDescriptor was not generated with stream support";
    throw ex;
}

class __F__IceGrid__InternalDistributionDescriptor : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::IceGrid::InternalDistributionDescriptor::ice_staticId());
        return new ::IceGrid::InternalDistributionDescriptor;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__IceGrid__InternalDistributionDescriptor_Ptr = new __F__IceGrid__InternalDistributionDescriptor;

const ::Ice::ObjectFactoryPtr&
IceGrid::InternalDistributionDescriptor::ice_factory()
{
    return __F__IceGrid__InternalDistributionDescriptor_Ptr;
}

class __F__IceGrid__InternalDistributionDescriptor__Init
{
public:

    __F__IceGrid__InternalDistributionDescriptor__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::IceGrid::InternalDistributionDescriptor::ice_staticId(), ::IceGrid::InternalDistributionDescriptor::ice_factory());
    }

    ~__F__IceGrid__InternalDistributionDescriptor__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::IceGrid::InternalDistributionDescriptor::ice_staticId());
    }
};

static __F__IceGrid__InternalDistributionDescriptor__Init __F__IceGrid__InternalDistributionDescriptor__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__InternalDistributionDescriptor__initializer() {} }
#endif

void 
IceGrid::__patch__InternalDistributionDescriptorPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::InternalDistributionDescriptorPtr* p = static_cast< ::IceGrid::InternalDistributionDescriptorPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::InternalDistributionDescriptorPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceGrid::InternalDistributionDescriptor::ice_staticId(), v->ice_id());
    }
}

bool
IceGrid::operator==(const ::IceGrid::InternalDistributionDescriptor& l, const ::IceGrid::InternalDistributionDescriptor& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::InternalDistributionDescriptor& l, const ::IceGrid::InternalDistributionDescriptor& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

IceGrid::InternalServerDescriptor::InternalServerDescriptor(const ::std::string& __ice_id, const ::std::string& __ice_application, const ::std::string& __ice_uuid, ::Ice::Int __ice_revision, const ::std::string& __ice_sessionId, const ::std::string& __ice_exe, const ::std::string& __ice_pwd, const ::std::string& __ice_user, const ::std::string& __ice_activation, const ::std::string& __ice_activationTimeout, const ::std::string& __ice_deactivationTimeout, bool __ice_applicationDistrib, const ::IceGrid::InternalDistributionDescriptorPtr& __ice_distrib, bool __ice_processRegistered, const ::Ice::StringSeq& __ice_options, const ::Ice::StringSeq& __ice_envs, const ::Ice::StringSeq& __ice_logs, const ::IceGrid::InternalAdapterDescriptorSeq& __ice_adapters, const ::IceGrid::InternalDbEnvDescriptorSeq& __ice_dbEnvs, const ::IceGrid::PropertyDescriptorSeqDict& __ice_properties) :
    id(__ice_id),
    application(__ice_application),
    uuid(__ice_uuid),
    revision(__ice_revision),
    sessionId(__ice_sessionId),
    exe(__ice_exe),
    pwd(__ice_pwd),
    user(__ice_user),
    activation(__ice_activation),
    activationTimeout(__ice_activationTimeout),
    deactivationTimeout(__ice_deactivationTimeout),
    applicationDistrib(__ice_applicationDistrib),
    distrib(__ice_distrib),
    processRegistered(__ice_processRegistered),
    options(__ice_options),
    envs(__ice_envs),
    logs(__ice_logs),
    adapters(__ice_adapters),
    dbEnvs(__ice_dbEnvs),
    properties(__ice_properties)
{
}

::Ice::ObjectPtr
IceGrid::InternalServerDescriptor::ice_clone() const
{
    ::IceGrid::InternalServerDescriptorPtr __p = new ::IceGrid::InternalServerDescriptor(*this);
    return __p;
}

static const ::std::string __IceGrid__InternalServerDescriptor_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::InternalServerDescriptor"
};

bool
IceGrid::InternalServerDescriptor::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__InternalServerDescriptor_ids, __IceGrid__InternalServerDescriptor_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::InternalServerDescriptor::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__InternalServerDescriptor_ids[0], &__IceGrid__InternalServerDescriptor_ids[2]);
}

const ::std::string&
IceGrid::InternalServerDescriptor::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__InternalServerDescriptor_ids[1];
}

const ::std::string&
IceGrid::InternalServerDescriptor::ice_staticId()
{
    return __IceGrid__InternalServerDescriptor_ids[1];
}

void
IceGrid::InternalServerDescriptor::__incRef()
{
    __gcIncRef();
}

void
IceGrid::InternalServerDescriptor::__decRef()
{
    __gcDecRef();
}

void
IceGrid::InternalServerDescriptor::__addObject(::IceInternal::GCCountMap& _c)
{
    ::IceInternal::GCCountMap::iterator pos = _c.find(this);
    if(pos == _c.end())
    {
        _c[this] = 1;
    }
    else
    {
        ++pos->second;
    }
}

bool
IceGrid::InternalServerDescriptor::__usesClasses()
{
    return true;
}

void
IceGrid::InternalServerDescriptor::__gcReachable(::IceInternal::GCCountMap& _c) const
{
    if(distrib)
    {
        ::IceInternal::upCast(distrib.get())->__addObject(_c);
    }
    {
        for(::IceGrid::InternalAdapterDescriptorSeq::const_iterator _i0 = adapters.begin(); _i0 != adapters.end(); ++_i0)
        {
            if((*_i0))
            {
                ::IceInternal::upCast((*_i0).get())->__addObject(_c);
            }
        }
    }
    {
        for(::IceGrid::InternalDbEnvDescriptorSeq::const_iterator _i0 = dbEnvs.begin(); _i0 != dbEnvs.end(); ++_i0)
        {
            if((*_i0))
            {
                ::IceInternal::upCast((*_i0).get())->__addObject(_c);
            }
        }
    }
}

void
IceGrid::InternalServerDescriptor::__gcClear()
{
    if(distrib)
    {
        if(::IceInternal::upCast(distrib.get())->__usesClasses())
        {
            ::IceInternal::upCast(distrib.get())->__decRefUnsafe();
            distrib.__clearHandleUnsafe();
        }
        else
        {
            distrib = 0;
        }
    }
    {
        for(::IceGrid::InternalAdapterDescriptorSeq::iterator _i0 = adapters.begin(); _i0 != adapters.end(); ++_i0)
        {
            if((*_i0))
            {
                if(::IceInternal::upCast((*_i0).get())->__usesClasses())
                {
                    ::IceInternal::upCast((*_i0).get())->__decRefUnsafe();
                    (*_i0).__clearHandleUnsafe();
                }
                else
                {
                    (*_i0) = 0;
                }
            }
        }
    }
    {
        for(::IceGrid::InternalDbEnvDescriptorSeq::iterator _i0 = dbEnvs.begin(); _i0 != dbEnvs.end(); ++_i0)
        {
            if((*_i0))
            {
                if(::IceInternal::upCast((*_i0).get())->__usesClasses())
                {
                    ::IceInternal::upCast((*_i0).get())->__decRefUnsafe();
                    (*_i0).__clearHandleUnsafe();
                }
                else
                {
                    (*_i0) = 0;
                }
            }
        }
    }
}

void
IceGrid::InternalServerDescriptor::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->write(id);
    __os->write(application);
    __os->write(uuid);
    __os->write(revision);
    __os->write(sessionId);
    __os->write(exe);
    __os->write(pwd);
    __os->write(user);
    __os->write(activation);
    __os->write(activationTimeout);
    __os->write(deactivationTimeout);
    __os->write(applicationDistrib);
    __os->write(::Ice::ObjectPtr(::IceInternal::upCast(distrib.get())));
    __os->write(processRegistered);
    if(options.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        __os->write(&options[0], &options[0] + options.size());
    }
    if(envs.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        __os->write(&envs[0], &envs[0] + envs.size());
    }
    if(logs.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        __os->write(&logs[0], &logs[0] + logs.size());
    }
    if(adapters.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::IceGrid::__writeInternalAdapterDescriptorSeq(__os, &adapters[0], &adapters[0] + adapters.size());
    }
    if(dbEnvs.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::IceGrid::__writeInternalDbEnvDescriptorSeq(__os, &dbEnvs[0], &dbEnvs[0] + dbEnvs.size());
    }
    ::IceGrid::__writePropertyDescriptorSeqDict(__os, properties);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::InternalServerDescriptor::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->read(id);
    __is->read(application);
    __is->read(uuid);
    __is->read(revision);
    __is->read(sessionId);
    __is->read(exe);
    __is->read(pwd);
    __is->read(user);
    __is->read(activation);
    __is->read(activationTimeout);
    __is->read(deactivationTimeout);
    __is->read(applicationDistrib);
    __is->read(::IceGrid::__patch__InternalDistributionDescriptorPtr, &distrib);
    __is->read(processRegistered);
    __is->read(options);
    __is->read(envs);
    __is->read(logs);
    ::IceGrid::__readInternalAdapterDescriptorSeq(__is, adapters);
    ::IceGrid::__readInternalDbEnvDescriptorSeq(__is, dbEnvs);
    ::IceGrid::__readPropertyDescriptorSeqDict(__is, properties);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::InternalServerDescriptor::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalServerDescriptor was not generated with stream support";
    throw ex;
}

void
IceGrid::InternalServerDescriptor::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalServerDescriptor was not generated with stream support";
    throw ex;
}

class __F__IceGrid__InternalServerDescriptor : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::IceGrid::InternalServerDescriptor::ice_staticId());
        return new ::IceGrid::InternalServerDescriptor;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__IceGrid__InternalServerDescriptor_Ptr = new __F__IceGrid__InternalServerDescriptor;

const ::Ice::ObjectFactoryPtr&
IceGrid::InternalServerDescriptor::ice_factory()
{
    return __F__IceGrid__InternalServerDescriptor_Ptr;
}

class __F__IceGrid__InternalServerDescriptor__Init
{
public:

    __F__IceGrid__InternalServerDescriptor__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::IceGrid::InternalServerDescriptor::ice_staticId(), ::IceGrid::InternalServerDescriptor::ice_factory());
    }

    ~__F__IceGrid__InternalServerDescriptor__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::IceGrid::InternalServerDescriptor::ice_staticId());
    }
};

static __F__IceGrid__InternalServerDescriptor__Init __F__IceGrid__InternalServerDescriptor__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__InternalServerDescriptor__initializer() {} }
#endif

void 
IceGrid::__patch__InternalServerDescriptorPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::InternalServerDescriptorPtr* p = static_cast< ::IceGrid::InternalServerDescriptorPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::InternalServerDescriptorPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceGrid::InternalServerDescriptor::ice_staticId(), v->ice_id());
    }
}

bool
IceGrid::operator==(const ::IceGrid::InternalServerDescriptor& l, const ::IceGrid::InternalServerDescriptor& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::InternalServerDescriptor& l, const ::IceGrid::InternalServerDescriptor& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
IceGrid::Adapter::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__Adapter_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::Adapter"
};

bool
IceGrid::Adapter::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__Adapter_ids, __IceGrid__Adapter_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::Adapter::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__Adapter_ids[0], &__IceGrid__Adapter_ids[2]);
}

const ::std::string&
IceGrid::Adapter::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__Adapter_ids[1];
}

const ::std::string&
IceGrid::Adapter::ice_staticId()
{
    return __IceGrid__Adapter_ids[1];
}

::Ice::DispatchStatus
IceGrid::Adapter::___activate(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceGrid::AMD_Adapter_activatePtr __cb = new IceAsync::IceGrid::AMD_Adapter_activate(__inS);
    try
    {
        activate_async(__cb, __current);
    }
    catch(const ::std::exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(...)
    {
        __cb->ice_exception();
    }
    return ::Ice::DispatchAsync;
}

::Ice::DispatchStatus
IceGrid::Adapter::___getDirectProxy(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        ::Ice::ObjectPrx __ret = getDirectProxy(__current);
        __os->write(__ret);
    }
    catch(const ::IceGrid::AdapterNotActiveException& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::Adapter::___setDirectProxy(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        setDirectProxy(proxy, __current);
    }
    catch(const ::IceGrid::AdapterActiveException& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

static ::std::string __IceGrid__Adapter_all[] =
{
    "activate",
    "getDirectProxy",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "setDirectProxy"
};

::Ice::DispatchStatus
IceGrid::Adapter::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__Adapter_all, __IceGrid__Adapter_all + 7, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __IceGrid__Adapter_all)
    {
        case 0:
        {
            return ___activate(in, current);
        }
        case 1:
        {
            return ___getDirectProxy(in, current);
        }
        case 2:
        {
            return ___ice_id(in, current);
        }
        case 3:
        {
            return ___ice_ids(in, current);
        }
        case 4:
        {
            return ___ice_isA(in, current);
        }
        case 5:
        {
            return ___ice_ping(in, current);
        }
        case 6:
        {
            return ___setDirectProxy(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
IceGrid::Adapter::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::Adapter::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::Adapter::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::Adapter was not generated with stream support";
    throw ex;
}

void
IceGrid::Adapter::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::Adapter was not generated with stream support";
    throw ex;
}

void 
IceGrid::__patch__AdapterPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::AdapterPtr* p = static_cast< ::IceGrid::AdapterPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::AdapterPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceGrid::Adapter::ice_staticId(), v->ice_id());
    }
}

bool
IceGrid::operator==(const ::IceGrid::Adapter& l, const ::IceGrid::Adapter& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::Adapter& l, const ::IceGrid::Adapter& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
IceGrid::FileReader::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__FileReader_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::FileReader"
};

bool
IceGrid::FileReader::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__FileReader_ids, __IceGrid__FileReader_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::FileReader::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__FileReader_ids[0], &__IceGrid__FileReader_ids[2]);
}

const ::std::string&
IceGrid::FileReader::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__FileReader_ids[1];
}

const ::std::string&
IceGrid::FileReader::ice_staticId()
{
    return __IceGrid__FileReader_ids[1];
}

::Ice::DispatchStatus
IceGrid::FileReader::___getOffsetFromEnd(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string filename;
    ::Ice::Int lines;
    __is->read(filename);
    __is->read(lines);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        ::Ice::Long __ret = getOffsetFromEnd(filename, lines, __current);
        __os->write(__ret);
    }
    catch(const ::IceGrid::FileNotAvailableException& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::FileReader::___read(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string filename;
    ::Ice::Long pos;
    ::Ice::Int size;
    __is->read(filename);
    __is->read(pos);
    __is->read(size);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::Long newPos;
    ::Ice::StringSeq lines;
    try
    {
        bool __ret = read(filename, pos, size, newPos, lines, __current);
        __os->write(newPos);
        if(lines.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            __os->write(&lines[0], &lines[0] + lines.size());
        }
        __os->write(__ret);
    }
    catch(const ::IceGrid::FileNotAvailableException& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

static ::std::string __IceGrid__FileReader_all[] =
{
    "getOffsetFromEnd",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "read"
};

::Ice::DispatchStatus
IceGrid::FileReader::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__FileReader_all, __IceGrid__FileReader_all + 6, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __IceGrid__FileReader_all)
    {
        case 0:
        {
            return ___getOffsetFromEnd(in, current);
        }
        case 1:
        {
            return ___ice_id(in, current);
        }
        case 2:
        {
            return ___ice_ids(in, current);
        }
        case 3:
        {
            return ___ice_isA(in, current);
        }
        case 4:
        {
            return ___ice_ping(in, current);
        }
        case 5:
        {
            return ___read(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
IceGrid::FileReader::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::FileReader::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::FileReader::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::FileReader was not generated with stream support";
    throw ex;
}

void
IceGrid::FileReader::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::FileReader was not generated with stream support";
    throw ex;
}

void 
IceGrid::__patch__FileReaderPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::FileReaderPtr* p = static_cast< ::IceGrid::FileReaderPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::FileReaderPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceGrid::FileReader::ice_staticId(), v->ice_id());
    }
}

bool
IceGrid::operator==(const ::IceGrid::FileReader& l, const ::IceGrid::FileReader& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::FileReader& l, const ::IceGrid::FileReader& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
IceGrid::Server::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__Server_ids[3] =
{
    "::Ice::Object",
    "::IceGrid::FileReader",
    "::IceGrid::Server"
};

bool
IceGrid::Server::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__Server_ids, __IceGrid__Server_ids + 3, _s);
}

::std::vector< ::std::string>
IceGrid::Server::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__Server_ids[0], &__IceGrid__Server_ids[3]);
}

const ::std::string&
IceGrid::Server::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__Server_ids[2];
}

const ::std::string&
IceGrid::Server::ice_staticId()
{
    return __IceGrid__Server_ids[2];
}

::Ice::DispatchStatus
IceGrid::Server::___start(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceGrid::AMD_Server_startPtr __cb = new IceAsync::IceGrid::AMD_Server_start(__inS);
    try
    {
        start_async(__cb, __current);
    }
    catch(const ::std::exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(...)
    {
        __cb->ice_exception();
    }
    return ::Ice::DispatchAsync;
}

::Ice::DispatchStatus
IceGrid::Server::___stop(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceGrid::AMD_Server_stopPtr __cb = new IceAsync::IceGrid::AMD_Server_stop(__inS);
    try
    {
        stop_async(__cb, __current);
    }
    catch(const ::std::exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(...)
    {
        __cb->ice_exception();
    }
    return ::Ice::DispatchAsync;
}

::Ice::DispatchStatus
IceGrid::Server::___setEnabled(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    bool enable;
    __is->read(enable);
    __is->endReadEncaps();
    setEnabled(enable, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::Server::___isEnabled(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    bool __ret = isEnabled(__current);
    __os->write(__ret);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::Server::___sendSignal(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string signal;
    __is->read(signal);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        sendSignal(signal, __current);
    }
    catch(const ::IceGrid::BadSignalException& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::Server::___writeMessage(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string message;
    ::Ice::Int fd;
    __is->read(message);
    __is->read(fd);
    __is->endReadEncaps();
    writeMessage(message, fd, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::Server::___getState(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::IceGrid::ServerState __ret = getState(__current);
    ::IceGrid::__write(__os, __ret);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::Server::___getPid(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::Int __ret = getPid(__current);
    __os->write(__ret);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::Server::___setProcess(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Ice::ProcessPrx proc;
    ::Ice::__read(__is, proc);
    __is->endReadEncaps();
    ::IceGrid::AMD_Server_setProcessPtr __cb = new IceAsync::IceGrid::AMD_Server_setProcess(__inS);
    try
    {
        setProcess_async(__cb, proc, __current);
    }
    catch(const ::std::exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(...)
    {
        __cb->ice_exception();
    }
    return ::Ice::DispatchAsync;
}

static ::std::string __IceGrid__Server_all[] =
{
    "getOffsetFromEnd",
    "getPid",
    "getState",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "isEnabled",
    "read",
    "sendSignal",
    "setEnabled",
    "setProcess",
    "start",
    "stop",
    "writeMessage"
};

::Ice::DispatchStatus
IceGrid::Server::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__Server_all, __IceGrid__Server_all + 15, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __IceGrid__Server_all)
    {
        case 0:
        {
            return ___getOffsetFromEnd(in, current);
        }
        case 1:
        {
            return ___getPid(in, current);
        }
        case 2:
        {
            return ___getState(in, current);
        }
        case 3:
        {
            return ___ice_id(in, current);
        }
        case 4:
        {
            return ___ice_ids(in, current);
        }
        case 5:
        {
            return ___ice_isA(in, current);
        }
        case 6:
        {
            return ___ice_ping(in, current);
        }
        case 7:
        {
            return ___isEnabled(in, current);
        }
        case 8:
        {
            return ___read(in, current);
        }
        case 9:
        {
            return ___sendSignal(in, current);
        }
        case 10:
        {
            return ___setEnabled(in, current);
        }
        case 11:
        {
            return ___setProcess(in, current);
        }
        case 12:
        {
            return ___start(in, current);
        }
        case 13:
        {
            return ___stop(in, current);
        }
        case 14:
        {
            return ___writeMessage(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
IceGrid::Server::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::Server::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::Server::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::Server was not generated with stream support";
    throw ex;
}

void
IceGrid::Server::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::Server was not generated with stream support";
    throw ex;
}

void 
IceGrid::__patch__ServerPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::ServerPtr* p = static_cast< ::IceGrid::ServerPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::ServerPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceGrid::Server::ice_staticId(), v->ice_id());
    }
}

bool
IceGrid::operator==(const ::IceGrid::Server& l, const ::IceGrid::Server& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::Server& l, const ::IceGrid::Server& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
IceGrid::ReplicaObserver::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__ReplicaObserver_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::ReplicaObserver"
};

bool
IceGrid::ReplicaObserver::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__ReplicaObserver_ids, __IceGrid__ReplicaObserver_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::ReplicaObserver::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__ReplicaObserver_ids[0], &__IceGrid__ReplicaObserver_ids[2]);
}

const ::std::string&
IceGrid::ReplicaObserver::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__ReplicaObserver_ids[1];
}

const ::std::string&
IceGrid::ReplicaObserver::ice_staticId()
{
    return __IceGrid__ReplicaObserver_ids[1];
}

::Ice::DispatchStatus
IceGrid::ReplicaObserver::___replicaInit(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceGrid::InternalRegistryPrxSeq replicas;
    ::IceGrid::__readInternalRegistryPrxSeq(__is, replicas);
    __is->endReadEncaps();
    replicaInit(replicas, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::ReplicaObserver::___replicaAdded(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceGrid::InternalRegistryPrx replica;
    ::IceGrid::__read(__is, replica);
    __is->endReadEncaps();
    replicaAdded(replica, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::ReplicaObserver::___replicaRemoved(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceGrid::InternalRegistryPrx replica;
    ::IceGrid::__read(__is, replica);
    __is->endReadEncaps();
    replicaRemoved(replica, __current);
    return ::Ice::DispatchOK;
}

static ::std::string __IceGrid__ReplicaObserver_all[] =
{
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "replicaAdded",
    "replicaInit",
    "replicaRemoved"
};

::Ice::DispatchStatus
IceGrid::ReplicaObserver::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__ReplicaObserver_all, __IceGrid__ReplicaObserver_all + 7, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __IceGrid__ReplicaObserver_all)
    {
        case 0:
        {
            return ___ice_id(in, current);
        }
        case 1:
        {
            return ___ice_ids(in, current);
        }
        case 2:
        {
            return ___ice_isA(in, current);
        }
        case 3:
        {
            return ___ice_ping(in, current);
        }
        case 4:
        {
            return ___replicaAdded(in, current);
        }
        case 5:
        {
            return ___replicaInit(in, current);
        }
        case 6:
        {
            return ___replicaRemoved(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
IceGrid::ReplicaObserver::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::ReplicaObserver::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::ReplicaObserver::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::ReplicaObserver was not generated with stream support";
    throw ex;
}

void
IceGrid::ReplicaObserver::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::ReplicaObserver was not generated with stream support";
    throw ex;
}

void 
IceGrid::__patch__ReplicaObserverPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::ReplicaObserverPtr* p = static_cast< ::IceGrid::ReplicaObserverPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::ReplicaObserverPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceGrid::ReplicaObserver::ice_staticId(), v->ice_id());
    }
}

bool
IceGrid::operator==(const ::IceGrid::ReplicaObserver& l, const ::IceGrid::ReplicaObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::ReplicaObserver& l, const ::IceGrid::ReplicaObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
IceGrid::PatcherFeedback::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__PatcherFeedback_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::PatcherFeedback"
};

bool
IceGrid::PatcherFeedback::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__PatcherFeedback_ids, __IceGrid__PatcherFeedback_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::PatcherFeedback::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__PatcherFeedback_ids[0], &__IceGrid__PatcherFeedback_ids[2]);
}

const ::std::string&
IceGrid::PatcherFeedback::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__PatcherFeedback_ids[1];
}

const ::std::string&
IceGrid::PatcherFeedback::ice_staticId()
{
    return __IceGrid__PatcherFeedback_ids[1];
}

::Ice::DispatchStatus
IceGrid::PatcherFeedback::___finished(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    __inS.is()->skipEmptyEncaps();
    finished(__current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::PatcherFeedback::___failed(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string reason;
    __is->read(reason);
    __is->endReadEncaps();
    failed(reason, __current);
    return ::Ice::DispatchOK;
}

static ::std::string __IceGrid__PatcherFeedback_all[] =
{
    "failed",
    "finished",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::Ice::DispatchStatus
IceGrid::PatcherFeedback::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__PatcherFeedback_all, __IceGrid__PatcherFeedback_all + 6, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __IceGrid__PatcherFeedback_all)
    {
        case 0:
        {
            return ___failed(in, current);
        }
        case 1:
        {
            return ___finished(in, current);
        }
        case 2:
        {
            return ___ice_id(in, current);
        }
        case 3:
        {
            return ___ice_ids(in, current);
        }
        case 4:
        {
            return ___ice_isA(in, current);
        }
        case 5:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
IceGrid::PatcherFeedback::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::PatcherFeedback::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::PatcherFeedback::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::PatcherFeedback was not generated with stream support";
    throw ex;
}

void
IceGrid::PatcherFeedback::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::PatcherFeedback was not generated with stream support";
    throw ex;
}

void 
IceGrid::__patch__PatcherFeedbackPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::PatcherFeedbackPtr* p = static_cast< ::IceGrid::PatcherFeedbackPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::PatcherFeedbackPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceGrid::PatcherFeedback::ice_staticId(), v->ice_id());
    }
}

bool
IceGrid::operator==(const ::IceGrid::PatcherFeedback& l, const ::IceGrid::PatcherFeedback& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::PatcherFeedback& l, const ::IceGrid::PatcherFeedback& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
IceGrid::Node::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__Node_ids[4] =
{
    "::Ice::Object",
    "::IceGrid::FileReader",
    "::IceGrid::Node",
    "::IceGrid::ReplicaObserver"
};

bool
IceGrid::Node::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__Node_ids, __IceGrid__Node_ids + 4, _s);
}

::std::vector< ::std::string>
IceGrid::Node::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__Node_ids[0], &__IceGrid__Node_ids[4]);
}

const ::std::string&
IceGrid::Node::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__Node_ids[2];
}

const ::std::string&
IceGrid::Node::ice_staticId()
{
    return __IceGrid__Node_ids[2];
}

::Ice::DispatchStatus
IceGrid::Node::___loadServer(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceGrid::InternalServerDescriptorPtr svr;
    ::std::string replicaName;
    __is->read(::IceGrid::__patch__InternalServerDescriptorPtr, &svr);
    __is->read(replicaName);
    __is->readPendingObjects();
    __is->endReadEncaps();
    ::IceGrid::AMD_Node_loadServerPtr __cb = new IceAsync::IceGrid::AMD_Node_loadServer(__inS);
    try
    {
        loadServer_async(__cb, svr, replicaName, __current);
    }
    catch(const ::std::exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(...)
    {
        __cb->ice_exception();
    }
    return ::Ice::DispatchAsync;
}

::Ice::DispatchStatus
IceGrid::Node::___destroyServer(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string name;
    ::std::string uuid;
    ::Ice::Int revision;
    ::std::string replicaName;
    __is->read(name);
    __is->read(uuid);
    __is->read(revision);
    __is->read(replicaName);
    __is->endReadEncaps();
    ::IceGrid::AMD_Node_destroyServerPtr __cb = new IceAsync::IceGrid::AMD_Node_destroyServer(__inS);
    try
    {
        destroyServer_async(__cb, name, uuid, revision, replicaName, __current);
    }
    catch(const ::std::exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(...)
    {
        __cb->ice_exception();
    }
    return ::Ice::DispatchAsync;
}

::Ice::DispatchStatus
IceGrid::Node::___patch(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceGrid::PatcherFeedbackPrx feedback;
    ::std::string application;
    ::std::string server;
    ::IceGrid::InternalDistributionDescriptorPtr appDistrib;
    bool shutdown;
    ::IceGrid::__read(__is, feedback);
    __is->read(application);
    __is->read(server);
    __is->read(::IceGrid::__patch__InternalDistributionDescriptorPtr, &appDistrib);
    __is->read(shutdown);
    __is->readPendingObjects();
    __is->endReadEncaps();
    ::IceGrid::AMD_Node_patchPtr __cb = new IceAsync::IceGrid::AMD_Node_patch(__inS);
    try
    {
        patch_async(__cb, feedback, application, server, appDistrib, shutdown, __current);
    }
    catch(const ::std::exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(...)
    {
        __cb->ice_exception();
    }
    return ::Ice::DispatchAsync;
}

::Ice::DispatchStatus
IceGrid::Node::___registerWithReplica(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceGrid::InternalRegistryPrx replica;
    ::IceGrid::__read(__is, replica);
    __is->endReadEncaps();
    registerWithReplica(replica, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::Node::___getName(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string __ret = getName(__current);
    __os->write(__ret);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::Node::___getHostname(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string __ret = getHostname(__current);
    __os->write(__ret);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::Node::___getLoad(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::IceGrid::LoadInfo __ret = getLoad(__current);
    __ret.__write(__os);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::Node::___shutdown(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    shutdown(__current);
    return ::Ice::DispatchOK;
}

static ::std::string __IceGrid__Node_all[] =
{
    "destroyServer",
    "getHostname",
    "getLoad",
    "getName",
    "getOffsetFromEnd",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "loadServer",
    "patch",
    "read",
    "registerWithReplica",
    "replicaAdded",
    "replicaInit",
    "replicaRemoved",
    "shutdown"
};

::Ice::DispatchStatus
IceGrid::Node::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__Node_all, __IceGrid__Node_all + 17, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __IceGrid__Node_all)
    {
        case 0:
        {
            return ___destroyServer(in, current);
        }
        case 1:
        {
            return ___getHostname(in, current);
        }
        case 2:
        {
            return ___getLoad(in, current);
        }
        case 3:
        {
            return ___getName(in, current);
        }
        case 4:
        {
            return ___getOffsetFromEnd(in, current);
        }
        case 5:
        {
            return ___ice_id(in, current);
        }
        case 6:
        {
            return ___ice_ids(in, current);
        }
        case 7:
        {
            return ___ice_isA(in, current);
        }
        case 8:
        {
            return ___ice_ping(in, current);
        }
        case 9:
        {
            return ___loadServer(in, current);
        }
        case 10:
        {
            return ___patch(in, current);
        }
        case 11:
        {
            return ___read(in, current);
        }
        case 12:
        {
            return ___registerWithReplica(in, current);
        }
        case 13:
        {
            return ___replicaAdded(in, current);
        }
        case 14:
        {
            return ___replicaInit(in, current);
        }
        case 15:
        {
            return ___replicaRemoved(in, current);
        }
        case 16:
        {
            return ___shutdown(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
IceGrid::Node::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::Node::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::Node::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::Node was not generated with stream support";
    throw ex;
}

void
IceGrid::Node::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::Node was not generated with stream support";
    throw ex;
}

void 
IceGrid::__patch__NodePtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::NodePtr* p = static_cast< ::IceGrid::NodePtr*>(__addr);
    assert(p);
    *p = ::IceGrid::NodePtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceGrid::Node::ice_staticId(), v->ice_id());
    }
}

bool
IceGrid::operator==(const ::IceGrid::Node& l, const ::IceGrid::Node& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::Node& l, const ::IceGrid::Node& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
IceGrid::NodeSession::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__NodeSession_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::NodeSession"
};

bool
IceGrid::NodeSession::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__NodeSession_ids, __IceGrid__NodeSession_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::NodeSession::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__NodeSession_ids[0], &__IceGrid__NodeSession_ids[2]);
}

const ::std::string&
IceGrid::NodeSession::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__NodeSession_ids[1];
}

const ::std::string&
IceGrid::NodeSession::ice_staticId()
{
    return __IceGrid__NodeSession_ids[1];
}

::Ice::DispatchStatus
IceGrid::NodeSession::___keepAlive(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceGrid::LoadInfo load;
    load.__read(__is);
    __is->endReadEncaps();
    keepAlive(load, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::NodeSession::___setReplicaObserver(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceGrid::ReplicaObserverPrx observer;
    ::IceGrid::__read(__is, observer);
    __is->endReadEncaps();
    setReplicaObserver(observer, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::NodeSession::___getTimeout(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::Int __ret = getTimeout(__current);
    __os->write(__ret);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::NodeSession::___getObserver(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::IceGrid::NodeObserverPrx __ret = getObserver(__current);
    __os->write(::Ice::ObjectPrx(::IceInternal::upCast(__ret.get())));
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::NodeSession::___loadServers(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceGrid::AMD_NodeSession_loadServersPtr __cb = new IceAsync::IceGrid::AMD_NodeSession_loadServers(__inS);
    try
    {
        loadServers_async(__cb, __current);
    }
    catch(const ::std::exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(...)
    {
        __cb->ice_exception();
    }
    return ::Ice::DispatchAsync;
}

::Ice::DispatchStatus
IceGrid::NodeSession::___getServers(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::StringSeq __ret = getServers(__current);
    if(__ret.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        __os->write(&__ret[0], &__ret[0] + __ret.size());
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::NodeSession::___waitForApplicationUpdate(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string application;
    ::Ice::Int revision;
    __is->read(application);
    __is->read(revision);
    __is->endReadEncaps();
    ::IceGrid::AMD_NodeSession_waitForApplicationUpdatePtr __cb = new IceAsync::IceGrid::AMD_NodeSession_waitForApplicationUpdate(__inS);
    try
    {
        waitForApplicationUpdate_async(__cb, application, revision, __current);
    }
    catch(const ::std::exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(...)
    {
        __cb->ice_exception();
    }
    return ::Ice::DispatchAsync;
}

::Ice::DispatchStatus
IceGrid::NodeSession::___destroy(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    __inS.is()->skipEmptyEncaps();
    destroy(__current);
    return ::Ice::DispatchOK;
}

static ::std::string __IceGrid__NodeSession_all[] =
{
    "destroy",
    "getObserver",
    "getServers",
    "getTimeout",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "keepAlive",
    "loadServers",
    "setReplicaObserver",
    "waitForApplicationUpdate"
};

::Ice::DispatchStatus
IceGrid::NodeSession::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__NodeSession_all, __IceGrid__NodeSession_all + 12, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __IceGrid__NodeSession_all)
    {
        case 0:
        {
            return ___destroy(in, current);
        }
        case 1:
        {
            return ___getObserver(in, current);
        }
        case 2:
        {
            return ___getServers(in, current);
        }
        case 3:
        {
            return ___getTimeout(in, current);
        }
        case 4:
        {
            return ___ice_id(in, current);
        }
        case 5:
        {
            return ___ice_ids(in, current);
        }
        case 6:
        {
            return ___ice_isA(in, current);
        }
        case 7:
        {
            return ___ice_ping(in, current);
        }
        case 8:
        {
            return ___keepAlive(in, current);
        }
        case 9:
        {
            return ___loadServers(in, current);
        }
        case 10:
        {
            return ___setReplicaObserver(in, current);
        }
        case 11:
        {
            return ___waitForApplicationUpdate(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
IceGrid::NodeSession::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::NodeSession::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::NodeSession::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::NodeSession was not generated with stream support";
    throw ex;
}

void
IceGrid::NodeSession::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::NodeSession was not generated with stream support";
    throw ex;
}

void 
IceGrid::__patch__NodeSessionPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::NodeSessionPtr* p = static_cast< ::IceGrid::NodeSessionPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::NodeSessionPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceGrid::NodeSession::ice_staticId(), v->ice_id());
    }
}

bool
IceGrid::operator==(const ::IceGrid::NodeSession& l, const ::IceGrid::NodeSession& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::NodeSession& l, const ::IceGrid::NodeSession& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
IceGrid::DatabaseObserver::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__DatabaseObserver_ids[5] =
{
    "::Ice::Object",
    "::IceGrid::AdapterObserver",
    "::IceGrid::ApplicationObserver",
    "::IceGrid::DatabaseObserver",
    "::IceGrid::ObjectObserver"
};

bool
IceGrid::DatabaseObserver::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__DatabaseObserver_ids, __IceGrid__DatabaseObserver_ids + 5, _s);
}

::std::vector< ::std::string>
IceGrid::DatabaseObserver::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__DatabaseObserver_ids[0], &__IceGrid__DatabaseObserver_ids[5]);
}

const ::std::string&
IceGrid::DatabaseObserver::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__DatabaseObserver_ids[3];
}

const ::std::string&
IceGrid::DatabaseObserver::ice_staticId()
{
    return __IceGrid__DatabaseObserver_ids[3];
}

static ::std::string __IceGrid__DatabaseObserver_all[] =
{
    "adapterAdded",
    "adapterInit",
    "adapterRemoved",
    "adapterUpdated",
    "applicationAdded",
    "applicationInit",
    "applicationRemoved",
    "applicationUpdated",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "objectAdded",
    "objectInit",
    "objectRemoved",
    "objectUpdated"
};

::Ice::DispatchStatus
IceGrid::DatabaseObserver::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__DatabaseObserver_all, __IceGrid__DatabaseObserver_all + 16, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __IceGrid__DatabaseObserver_all)
    {
        case 0:
        {
            return ___adapterAdded(in, current);
        }
        case 1:
        {
            return ___adapterInit(in, current);
        }
        case 2:
        {
            return ___adapterRemoved(in, current);
        }
        case 3:
        {
            return ___adapterUpdated(in, current);
        }
        case 4:
        {
            return ___applicationAdded(in, current);
        }
        case 5:
        {
            return ___applicationInit(in, current);
        }
        case 6:
        {
            return ___applicationRemoved(in, current);
        }
        case 7:
        {
            return ___applicationUpdated(in, current);
        }
        case 8:
        {
            return ___ice_id(in, current);
        }
        case 9:
        {
            return ___ice_ids(in, current);
        }
        case 10:
        {
            return ___ice_isA(in, current);
        }
        case 11:
        {
            return ___ice_ping(in, current);
        }
        case 12:
        {
            return ___objectAdded(in, current);
        }
        case 13:
        {
            return ___objectInit(in, current);
        }
        case 14:
        {
            return ___objectRemoved(in, current);
        }
        case 15:
        {
            return ___objectUpdated(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
IceGrid::DatabaseObserver::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::DatabaseObserver::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::DatabaseObserver::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::DatabaseObserver was not generated with stream support";
    throw ex;
}

void
IceGrid::DatabaseObserver::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::DatabaseObserver was not generated with stream support";
    throw ex;
}

void 
IceGrid::__patch__DatabaseObserverPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::DatabaseObserverPtr* p = static_cast< ::IceGrid::DatabaseObserverPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::DatabaseObserverPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceGrid::DatabaseObserver::ice_staticId(), v->ice_id());
    }
}

bool
IceGrid::operator==(const ::IceGrid::DatabaseObserver& l, const ::IceGrid::DatabaseObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::DatabaseObserver& l, const ::IceGrid::DatabaseObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
IceGrid::ReplicaSession::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__ReplicaSession_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::ReplicaSession"
};

bool
IceGrid::ReplicaSession::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__ReplicaSession_ids, __IceGrid__ReplicaSession_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::ReplicaSession::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__ReplicaSession_ids[0], &__IceGrid__ReplicaSession_ids[2]);
}

const ::std::string&
IceGrid::ReplicaSession::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__ReplicaSession_ids[1];
}

const ::std::string&
IceGrid::ReplicaSession::ice_staticId()
{
    return __IceGrid__ReplicaSession_ids[1];
}

::Ice::DispatchStatus
IceGrid::ReplicaSession::___keepAlive(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    __inS.is()->skipEmptyEncaps();
    keepAlive(__current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::ReplicaSession::___getTimeout(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::Int __ret = getTimeout(__current);
    __os->write(__ret);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::ReplicaSession::___setDatabaseObserver(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceGrid::DatabaseObserverPrx dbObs;
    ::IceGrid::__read(__is, dbObs);
    __is->endReadEncaps();
    setDatabaseObserver(dbObs, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::ReplicaSession::___setEndpoints(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceGrid::StringObjectProxyDict endpoints;
    ::IceGrid::__readStringObjectProxyDict(__is, endpoints);
    __is->endReadEncaps();
    setEndpoints(endpoints, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::ReplicaSession::___registerWellKnownObjects(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceGrid::ObjectInfoSeq objects;
    ::IceGrid::__readObjectInfoSeq(__is, objects);
    __is->endReadEncaps();
    registerWellKnownObjects(objects, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::ReplicaSession::___setAdapterDirectProxy(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string adapterId;
    ::std::string replicaGroupId;
    ::Ice::ObjectPrx proxy;
    __is->read(adapterId);
    __is->read(replicaGroupId);
    __is->read(proxy);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        setAdapterDirectProxy(adapterId, replicaGroupId, proxy, __current);
    }
    catch(const ::IceGrid::AdapterExistsException& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    catch(const ::IceGrid::AdapterNotExistException& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::ReplicaSession::___receivedUpdate(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceGrid::TopicName name;
    ::Ice::Int serial;
    ::std::string failure;
    ::IceGrid::__read(__is, name);
    __is->read(serial);
    __is->read(failure);
    __is->endReadEncaps();
    receivedUpdate(name, serial, failure, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::ReplicaSession::___destroy(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    __inS.is()->skipEmptyEncaps();
    destroy(__current);
    return ::Ice::DispatchOK;
}

static ::std::string __IceGrid__ReplicaSession_all[] =
{
    "destroy",
    "getTimeout",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "keepAlive",
    "receivedUpdate",
    "registerWellKnownObjects",
    "setAdapterDirectProxy",
    "setDatabaseObserver",
    "setEndpoints"
};

::Ice::DispatchStatus
IceGrid::ReplicaSession::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__ReplicaSession_all, __IceGrid__ReplicaSession_all + 12, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __IceGrid__ReplicaSession_all)
    {
        case 0:
        {
            return ___destroy(in, current);
        }
        case 1:
        {
            return ___getTimeout(in, current);
        }
        case 2:
        {
            return ___ice_id(in, current);
        }
        case 3:
        {
            return ___ice_ids(in, current);
        }
        case 4:
        {
            return ___ice_isA(in, current);
        }
        case 5:
        {
            return ___ice_ping(in, current);
        }
        case 6:
        {
            return ___keepAlive(in, current);
        }
        case 7:
        {
            return ___receivedUpdate(in, current);
        }
        case 8:
        {
            return ___registerWellKnownObjects(in, current);
        }
        case 9:
        {
            return ___setAdapterDirectProxy(in, current);
        }
        case 10:
        {
            return ___setDatabaseObserver(in, current);
        }
        case 11:
        {
            return ___setEndpoints(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
IceGrid::ReplicaSession::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::ReplicaSession::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::ReplicaSession::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::ReplicaSession was not generated with stream support";
    throw ex;
}

void
IceGrid::ReplicaSession::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::ReplicaSession was not generated with stream support";
    throw ex;
}

void 
IceGrid::__patch__ReplicaSessionPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::ReplicaSessionPtr* p = static_cast< ::IceGrid::ReplicaSessionPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::ReplicaSessionPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceGrid::ReplicaSession::ice_staticId(), v->ice_id());
    }
}

bool
IceGrid::operator==(const ::IceGrid::ReplicaSession& l, const ::IceGrid::ReplicaSession& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::ReplicaSession& l, const ::IceGrid::ReplicaSession& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

IceGrid::InternalNodeInfo::InternalNodeInfo(const ::std::string& __ice_name, const ::std::string& __ice_os, const ::std::string& __ice_hostname, const ::std::string& __ice_release, const ::std::string& __ice_version, const ::std::string& __ice_machine, ::Ice::Int __ice_nProcessors, const ::std::string& __ice_dataDir) :
    name(__ice_name),
    os(__ice_os),
    hostname(__ice_hostname),
    release(__ice_release),
    version(__ice_version),
    machine(__ice_machine),
    nProcessors(__ice_nProcessors),
    dataDir(__ice_dataDir)
{
}

::Ice::ObjectPtr
IceGrid::InternalNodeInfo::ice_clone() const
{
    ::IceGrid::InternalNodeInfoPtr __p = new ::IceGrid::InternalNodeInfo(*this);
    return __p;
}

static const ::std::string __IceGrid__InternalNodeInfo_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::InternalNodeInfo"
};

bool
IceGrid::InternalNodeInfo::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__InternalNodeInfo_ids, __IceGrid__InternalNodeInfo_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::InternalNodeInfo::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__InternalNodeInfo_ids[0], &__IceGrid__InternalNodeInfo_ids[2]);
}

const ::std::string&
IceGrid::InternalNodeInfo::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__InternalNodeInfo_ids[1];
}

const ::std::string&
IceGrid::InternalNodeInfo::ice_staticId()
{
    return __IceGrid__InternalNodeInfo_ids[1];
}

void
IceGrid::InternalNodeInfo::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->write(name);
    __os->write(os);
    __os->write(hostname);
    __os->write(release);
    __os->write(version);
    __os->write(machine);
    __os->write(nProcessors);
    __os->write(dataDir);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::InternalNodeInfo::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->read(name);
    __is->read(os);
    __is->read(hostname);
    __is->read(release);
    __is->read(version);
    __is->read(machine);
    __is->read(nProcessors);
    __is->read(dataDir);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::InternalNodeInfo::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalNodeInfo was not generated with stream support";
    throw ex;
}

void
IceGrid::InternalNodeInfo::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalNodeInfo was not generated with stream support";
    throw ex;
}

class __F__IceGrid__InternalNodeInfo : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::IceGrid::InternalNodeInfo::ice_staticId());
        return new ::IceGrid::InternalNodeInfo;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__IceGrid__InternalNodeInfo_Ptr = new __F__IceGrid__InternalNodeInfo;

const ::Ice::ObjectFactoryPtr&
IceGrid::InternalNodeInfo::ice_factory()
{
    return __F__IceGrid__InternalNodeInfo_Ptr;
}

class __F__IceGrid__InternalNodeInfo__Init
{
public:

    __F__IceGrid__InternalNodeInfo__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::IceGrid::InternalNodeInfo::ice_staticId(), ::IceGrid::InternalNodeInfo::ice_factory());
    }

    ~__F__IceGrid__InternalNodeInfo__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::IceGrid::InternalNodeInfo::ice_staticId());
    }
};

static __F__IceGrid__InternalNodeInfo__Init __F__IceGrid__InternalNodeInfo__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__InternalNodeInfo__initializer() {} }
#endif

void 
IceGrid::__patch__InternalNodeInfoPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::InternalNodeInfoPtr* p = static_cast< ::IceGrid::InternalNodeInfoPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::InternalNodeInfoPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceGrid::InternalNodeInfo::ice_staticId(), v->ice_id());
    }
}

bool
IceGrid::operator==(const ::IceGrid::InternalNodeInfo& l, const ::IceGrid::InternalNodeInfo& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::InternalNodeInfo& l, const ::IceGrid::InternalNodeInfo& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

IceGrid::InternalReplicaInfo::InternalReplicaInfo(const ::std::string& __ice_name, const ::std::string& __ice_hostname) :
    name(__ice_name),
    hostname(__ice_hostname)
{
}

::Ice::ObjectPtr
IceGrid::InternalReplicaInfo::ice_clone() const
{
    ::IceGrid::InternalReplicaInfoPtr __p = new ::IceGrid::InternalReplicaInfo(*this);
    return __p;
}

static const ::std::string __IceGrid__InternalReplicaInfo_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::InternalReplicaInfo"
};

bool
IceGrid::InternalReplicaInfo::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__InternalReplicaInfo_ids, __IceGrid__InternalReplicaInfo_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::InternalReplicaInfo::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__InternalReplicaInfo_ids[0], &__IceGrid__InternalReplicaInfo_ids[2]);
}

const ::std::string&
IceGrid::InternalReplicaInfo::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__InternalReplicaInfo_ids[1];
}

const ::std::string&
IceGrid::InternalReplicaInfo::ice_staticId()
{
    return __IceGrid__InternalReplicaInfo_ids[1];
}

void
IceGrid::InternalReplicaInfo::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->write(name);
    __os->write(hostname);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::InternalReplicaInfo::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->read(name);
    __is->read(hostname);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::InternalReplicaInfo::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalReplicaInfo was not generated with stream support";
    throw ex;
}

void
IceGrid::InternalReplicaInfo::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalReplicaInfo was not generated with stream support";
    throw ex;
}

class __F__IceGrid__InternalReplicaInfo : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::IceGrid::InternalReplicaInfo::ice_staticId());
        return new ::IceGrid::InternalReplicaInfo;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__IceGrid__InternalReplicaInfo_Ptr = new __F__IceGrid__InternalReplicaInfo;

const ::Ice::ObjectFactoryPtr&
IceGrid::InternalReplicaInfo::ice_factory()
{
    return __F__IceGrid__InternalReplicaInfo_Ptr;
}

class __F__IceGrid__InternalReplicaInfo__Init
{
public:

    __F__IceGrid__InternalReplicaInfo__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::IceGrid::InternalReplicaInfo::ice_staticId(), ::IceGrid::InternalReplicaInfo::ice_factory());
    }

    ~__F__IceGrid__InternalReplicaInfo__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::IceGrid::InternalReplicaInfo::ice_staticId());
    }
};

static __F__IceGrid__InternalReplicaInfo__Init __F__IceGrid__InternalReplicaInfo__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__InternalReplicaInfo__initializer() {} }
#endif

void 
IceGrid::__patch__InternalReplicaInfoPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::InternalReplicaInfoPtr* p = static_cast< ::IceGrid::InternalReplicaInfoPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::InternalReplicaInfoPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceGrid::InternalReplicaInfo::ice_staticId(), v->ice_id());
    }
}

bool
IceGrid::operator==(const ::IceGrid::InternalReplicaInfo& l, const ::IceGrid::InternalReplicaInfo& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::InternalReplicaInfo& l, const ::IceGrid::InternalReplicaInfo& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
IceGrid::InternalRegistry::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__InternalRegistry_ids[3] =
{
    "::Ice::Object",
    "::IceGrid::FileReader",
    "::IceGrid::InternalRegistry"
};

bool
IceGrid::InternalRegistry::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__InternalRegistry_ids, __IceGrid__InternalRegistry_ids + 3, _s);
}

::std::vector< ::std::string>
IceGrid::InternalRegistry::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__InternalRegistry_ids[0], &__IceGrid__InternalRegistry_ids[3]);
}

const ::std::string&
IceGrid::InternalRegistry::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__InternalRegistry_ids[2];
}

const ::std::string&
IceGrid::InternalRegistry::ice_staticId()
{
    return __IceGrid__InternalRegistry_ids[2];
}

::Ice::DispatchStatus
IceGrid::InternalRegistry::___registerNode(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceGrid::InternalNodeInfoPtr info;
    ::IceGrid::NodePrx prx;
    ::IceGrid::LoadInfo loadInf;
    __is->read(::IceGrid::__patch__InternalNodeInfoPtr, &info);
    ::IceGrid::__read(__is, prx);
    loadInf.__read(__is);
    __is->readPendingObjects();
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        ::IceGrid::NodeSessionPrx __ret = registerNode(info, prx, loadInf, __current);
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(__ret.get())));
    }
    catch(const ::IceGrid::NodeActiveException& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::InternalRegistry::___registerReplica(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceGrid::InternalReplicaInfoPtr info;
    ::IceGrid::InternalRegistryPrx prx;
    __is->read(::IceGrid::__patch__InternalReplicaInfoPtr, &info);
    ::IceGrid::__read(__is, prx);
    __is->readPendingObjects();
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        ::IceGrid::ReplicaSessionPrx __ret = registerReplica(info, prx, __current);
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(__ret.get())));
    }
    catch(const ::IceGrid::ReplicaActiveException& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::InternalRegistry::___registerWithReplica(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::IceGrid::InternalRegistryPrx prx;
    ::IceGrid::__read(__is, prx);
    __is->endReadEncaps();
    registerWithReplica(prx, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::InternalRegistry::___getNodes(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::IceGrid::NodePrxSeq __ret = getNodes(__current);
    if(__ret.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::IceGrid::__writeNodePrxSeq(__os, &__ret[0], &__ret[0] + __ret.size());
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::InternalRegistry::___getReplicas(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::IceGrid::InternalRegistryPrxSeq __ret = getReplicas(__current);
    if(__ret.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::IceGrid::__writeInternalRegistryPrxSeq(__os, &__ret[0], &__ret[0] + __ret.size());
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
IceGrid::InternalRegistry::___shutdown(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    shutdown(__current);
    return ::Ice::DispatchOK;
}

static ::std::string __IceGrid__InternalRegistry_all[] =
{
    "getNodes",
    "getOffsetFromEnd",
    "getReplicas",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "read",
    "registerNode",
    "registerReplica",
    "registerWithReplica",
    "shutdown"
};

::Ice::DispatchStatus
IceGrid::InternalRegistry::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__InternalRegistry_all, __IceGrid__InternalRegistry_all + 12, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __IceGrid__InternalRegistry_all)
    {
        case 0:
        {
            return ___getNodes(in, current);
        }
        case 1:
        {
            return ___getOffsetFromEnd(in, current);
        }
        case 2:
        {
            return ___getReplicas(in, current);
        }
        case 3:
        {
            return ___ice_id(in, current);
        }
        case 4:
        {
            return ___ice_ids(in, current);
        }
        case 5:
        {
            return ___ice_isA(in, current);
        }
        case 6:
        {
            return ___ice_ping(in, current);
        }
        case 7:
        {
            return ___read(in, current);
        }
        case 8:
        {
            return ___registerNode(in, current);
        }
        case 9:
        {
            return ___registerReplica(in, current);
        }
        case 10:
        {
            return ___registerWithReplica(in, current);
        }
        case 11:
        {
            return ___shutdown(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
IceGrid::InternalRegistry::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::InternalRegistry::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::InternalRegistry::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalRegistry was not generated with stream support";
    throw ex;
}

void
IceGrid::InternalRegistry::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalRegistry was not generated with stream support";
    throw ex;
}

void 
IceGrid::__patch__InternalRegistryPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::InternalRegistryPtr* p = static_cast< ::IceGrid::InternalRegistryPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::InternalRegistryPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::IceGrid::InternalRegistry::ice_staticId(), v->ice_id());
    }
}

bool
IceGrid::operator==(const ::IceGrid::InternalRegistry& l, const ::IceGrid::InternalRegistry& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::InternalRegistry& l, const ::IceGrid::InternalRegistry& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

static const char* __sliceChecksums[] =
{
    "::IceGrid::Adapter", "cdcea08d3ac862a3f37b45e93d3516cf",
    "::IceGrid::AdapterActiveException", "9e82c6f52ae5b9b3dded4da03c1e68e8",
    "::IceGrid::AdapterExistsException", "103296618e9b935090172ac4b2a3cd6",
    "::IceGrid::AdapterNotActiveException", "7632b297a062f716b967442ccdeb1d5",
    "::IceGrid::AdapterPrxDict", "b1ad556aafdb114dc2761db172cf99a",
    "::IceGrid::DatabaseObserver", "53301c4475ff93212867232dc1dc3279",
    "::IceGrid::FileReader", "34d7c15576824a7bb03f3a9bdebe9d3e",
    "::IceGrid::InternalAdapterDescriptor", "4f5dff85cb69f8828588d994955b9",
    "::IceGrid::InternalAdapterDescriptorSeq", "c8e25d41d9125509ce869edc97951ea",
    "::IceGrid::InternalDbEnvDescriptor", "43b063bd2ede5da688de887658298f6d",
    "::IceGrid::InternalDbEnvDescriptorSeq", "0c74f576958516b314146ab4522f90",
    "::IceGrid::InternalDistributionDescriptor", "6993cce3aedd64cff0c1be09f51663d",
    "::IceGrid::InternalNodeInfo", "f4c1cad7a934c6a5405e542f5597a6f",
    "::IceGrid::InternalRegistry", "14d2efbd9b5fa23d33f6efb89307d20",
    "::IceGrid::InternalRegistryPrxSeq", "58708c5e95bc51953e8aa915ef989f7a",
    "::IceGrid::InternalReplicaInfo", "83a38a194bb3a225b57fa7d3232c4f6",
    "::IceGrid::InternalServerDescriptor", "59ac3e29239c6da932b4d6d222a759",
    "::IceGrid::Node", "1f3cc38ffdecb75cfd2a32febf50a7",
    "::IceGrid::NodeActiveException", "ab256cead26199fac7d4cbaac2a372d",
    "::IceGrid::NodePrxSeq", "613421b8e9538ceadd9baeb198c83716",
    "::IceGrid::NodeSession", "b5106acfb96f34efc3f872265f179a7",
    "::IceGrid::PatcherFeedback", "b89b6c26e96a271336302120d3abb5b1",
    "::IceGrid::PropertyDescriptorSeqDict", "ff2c8d165b85af94f3869734b1477b0",
    "::IceGrid::ReplicaActiveException", "9a58f1c394a8e4356971cbb8c9aa27e6",
    "::IceGrid::ReplicaObserver", "282c75598b4b27f617e712d4c82610bf",
    "::IceGrid::ReplicaSession", "d8e4954160aa713ecaebe52b47de3fe",
    "::IceGrid::Server", "ba99f1c9bc43f2b99c6285e18aa27e10",
    "::IceGrid::TopicName", "81b0c4d6778ad5390ac9867409d486",
    0
};
static IceInternal::SliceChecksumInit __sliceChecksumInit(__sliceChecksums);
