// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `Internal.ice'

#ifndef __IceGrid_Internal_h__
#define __IceGrid_Internal_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/OutgoingAsync.h>
#include <Ice/Incoming.h>
#include <Ice/IncomingAsync.h>
#include <Ice/Direct.h>
#include <Ice/UserExceptionFactory.h>
#include <Ice/FactoryTable.h>
#include <Ice/StreamF.h>
#include <Ice/Identity.h>
#include <Ice/BuiltinSequences.h>
#include <Ice/ProcessF.h>
#include <Ice/Locator.h>
#include <Ice/Properties.h>
#include <Glacier2/Session.h>
#include <IceGrid/Admin.h>
#include <IceGrid/Observer.h>
#include <IceGrid/Registry.h>
#include <Ice/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

namespace IceProxy
{

namespace IceGrid
{

class InternalDbEnvDescriptor;

class InternalAdapterDescriptor;

class InternalDistributionDescriptor;

class InternalServerDescriptor;

class Adapter;

class FileReader;

class Server;

class InternalRegistry;

class ReplicaObserver;

class PatcherFeedback;

class Node;

class NodeSession;

class DatabaseObserver;

class ReplicaSession;

class InternalNodeInfo;

class InternalReplicaInfo;

}

}

namespace IceGrid
{

class InternalDbEnvDescriptor;
bool operator==(const InternalDbEnvDescriptor&, const InternalDbEnvDescriptor&);
bool operator<(const InternalDbEnvDescriptor&, const InternalDbEnvDescriptor&);

class InternalAdapterDescriptor;
bool operator==(const InternalAdapterDescriptor&, const InternalAdapterDescriptor&);
bool operator<(const InternalAdapterDescriptor&, const InternalAdapterDescriptor&);

class InternalDistributionDescriptor;
bool operator==(const InternalDistributionDescriptor&, const InternalDistributionDescriptor&);
bool operator<(const InternalDistributionDescriptor&, const InternalDistributionDescriptor&);

class InternalServerDescriptor;
bool operator==(const InternalServerDescriptor&, const InternalServerDescriptor&);
bool operator<(const InternalServerDescriptor&, const InternalServerDescriptor&);

class Adapter;
bool operator==(const Adapter&, const Adapter&);
bool operator<(const Adapter&, const Adapter&);

class FileReader;
bool operator==(const FileReader&, const FileReader&);
bool operator<(const FileReader&, const FileReader&);

class Server;
bool operator==(const Server&, const Server&);
bool operator<(const Server&, const Server&);

class InternalRegistry;
bool operator==(const InternalRegistry&, const InternalRegistry&);
bool operator<(const InternalRegistry&, const InternalRegistry&);

class ReplicaObserver;
bool operator==(const ReplicaObserver&, const ReplicaObserver&);
bool operator<(const ReplicaObserver&, const ReplicaObserver&);

class PatcherFeedback;
bool operator==(const PatcherFeedback&, const PatcherFeedback&);
bool operator<(const PatcherFeedback&, const PatcherFeedback&);

class Node;
bool operator==(const Node&, const Node&);
bool operator<(const Node&, const Node&);

class NodeSession;
bool operator==(const NodeSession&, const NodeSession&);
bool operator<(const NodeSession&, const NodeSession&);

class DatabaseObserver;
bool operator==(const DatabaseObserver&, const DatabaseObserver&);
bool operator<(const DatabaseObserver&, const DatabaseObserver&);

class ReplicaSession;
bool operator==(const ReplicaSession&, const ReplicaSession&);
bool operator<(const ReplicaSession&, const ReplicaSession&);

class InternalNodeInfo;
bool operator==(const InternalNodeInfo&, const InternalNodeInfo&);
bool operator<(const InternalNodeInfo&, const InternalNodeInfo&);

class InternalReplicaInfo;
bool operator==(const InternalReplicaInfo&, const InternalReplicaInfo&);
bool operator<(const InternalReplicaInfo&, const InternalReplicaInfo&);

}

namespace IceInternal
{

::Ice::Object* upCast(::IceGrid::InternalDbEnvDescriptor*);
::IceProxy::Ice::Object* upCast(::IceProxy::IceGrid::InternalDbEnvDescriptor*);

::Ice::Object* upCast(::IceGrid::InternalAdapterDescriptor*);
::IceProxy::Ice::Object* upCast(::IceProxy::IceGrid::InternalAdapterDescriptor*);

::Ice::Object* upCast(::IceGrid::InternalDistributionDescriptor*);
::IceProxy::Ice::Object* upCast(::IceProxy::IceGrid::InternalDistributionDescriptor*);

::Ice::Object* upCast(::IceGrid::InternalServerDescriptor*);
::IceProxy::Ice::Object* upCast(::IceProxy::IceGrid::InternalServerDescriptor*);

::Ice::Object* upCast(::IceGrid::Adapter*);
::IceProxy::Ice::Object* upCast(::IceProxy::IceGrid::Adapter*);

::Ice::Object* upCast(::IceGrid::FileReader*);
::IceProxy::Ice::Object* upCast(::IceProxy::IceGrid::FileReader*);

::Ice::Object* upCast(::IceGrid::Server*);
::IceProxy::Ice::Object* upCast(::IceProxy::IceGrid::Server*);

::Ice::Object* upCast(::IceGrid::InternalRegistry*);
::IceProxy::Ice::Object* upCast(::IceProxy::IceGrid::InternalRegistry*);

::Ice::Object* upCast(::IceGrid::ReplicaObserver*);
::IceProxy::Ice::Object* upCast(::IceProxy::IceGrid::ReplicaObserver*);

::Ice::Object* upCast(::IceGrid::PatcherFeedback*);
::IceProxy::Ice::Object* upCast(::IceProxy::IceGrid::PatcherFeedback*);

::Ice::Object* upCast(::IceGrid::Node*);
::IceProxy::Ice::Object* upCast(::IceProxy::IceGrid::Node*);

::Ice::Object* upCast(::IceGrid::NodeSession*);
::IceProxy::Ice::Object* upCast(::IceProxy::IceGrid::NodeSession*);

::Ice::Object* upCast(::IceGrid::DatabaseObserver*);
::IceProxy::Ice::Object* upCast(::IceProxy::IceGrid::DatabaseObserver*);

::Ice::Object* upCast(::IceGrid::ReplicaSession*);
::IceProxy::Ice::Object* upCast(::IceProxy::IceGrid::ReplicaSession*);

::Ice::Object* upCast(::IceGrid::InternalNodeInfo*);
::IceProxy::Ice::Object* upCast(::IceProxy::IceGrid::InternalNodeInfo*);

::Ice::Object* upCast(::IceGrid::InternalReplicaInfo*);
::IceProxy::Ice::Object* upCast(::IceProxy::IceGrid::InternalReplicaInfo*);

}

namespace IceGrid
{

typedef ::IceInternal::Handle< ::IceGrid::InternalDbEnvDescriptor> InternalDbEnvDescriptorPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::InternalDbEnvDescriptor> InternalDbEnvDescriptorPrx;

void __read(::IceInternal::BasicStream*, InternalDbEnvDescriptorPrx&);
void __patch__InternalDbEnvDescriptorPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IceGrid::InternalAdapterDescriptor> InternalAdapterDescriptorPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::InternalAdapterDescriptor> InternalAdapterDescriptorPrx;

void __read(::IceInternal::BasicStream*, InternalAdapterDescriptorPrx&);
void __patch__InternalAdapterDescriptorPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IceGrid::InternalDistributionDescriptor> InternalDistributionDescriptorPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::InternalDistributionDescriptor> InternalDistributionDescriptorPrx;

void __read(::IceInternal::BasicStream*, InternalDistributionDescriptorPrx&);
void __patch__InternalDistributionDescriptorPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IceGrid::InternalServerDescriptor> InternalServerDescriptorPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::InternalServerDescriptor> InternalServerDescriptorPrx;

void __read(::IceInternal::BasicStream*, InternalServerDescriptorPrx&);
void __patch__InternalServerDescriptorPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IceGrid::Adapter> AdapterPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::Adapter> AdapterPrx;

void __read(::IceInternal::BasicStream*, AdapterPrx&);
void __patch__AdapterPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IceGrid::FileReader> FileReaderPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::FileReader> FileReaderPrx;

void __read(::IceInternal::BasicStream*, FileReaderPrx&);
void __patch__FileReaderPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IceGrid::Server> ServerPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::Server> ServerPrx;

void __read(::IceInternal::BasicStream*, ServerPrx&);
void __patch__ServerPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IceGrid::InternalRegistry> InternalRegistryPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::InternalRegistry> InternalRegistryPrx;

void __read(::IceInternal::BasicStream*, InternalRegistryPrx&);
void __patch__InternalRegistryPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IceGrid::ReplicaObserver> ReplicaObserverPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::ReplicaObserver> ReplicaObserverPrx;

void __read(::IceInternal::BasicStream*, ReplicaObserverPrx&);
void __patch__ReplicaObserverPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IceGrid::PatcherFeedback> PatcherFeedbackPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::PatcherFeedback> PatcherFeedbackPrx;

void __read(::IceInternal::BasicStream*, PatcherFeedbackPrx&);
void __patch__PatcherFeedbackPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IceGrid::Node> NodePtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::Node> NodePrx;

void __read(::IceInternal::BasicStream*, NodePrx&);
void __patch__NodePtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IceGrid::NodeSession> NodeSessionPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::NodeSession> NodeSessionPrx;

void __read(::IceInternal::BasicStream*, NodeSessionPrx&);
void __patch__NodeSessionPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IceGrid::DatabaseObserver> DatabaseObserverPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::DatabaseObserver> DatabaseObserverPrx;

void __read(::IceInternal::BasicStream*, DatabaseObserverPrx&);
void __patch__DatabaseObserverPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IceGrid::ReplicaSession> ReplicaSessionPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::ReplicaSession> ReplicaSessionPrx;

void __read(::IceInternal::BasicStream*, ReplicaSessionPrx&);
void __patch__ReplicaSessionPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IceGrid::InternalNodeInfo> InternalNodeInfoPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::InternalNodeInfo> InternalNodeInfoPrx;

void __read(::IceInternal::BasicStream*, InternalNodeInfoPrx&);
void __patch__InternalNodeInfoPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IceGrid::InternalReplicaInfo> InternalReplicaInfoPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::InternalReplicaInfo> InternalReplicaInfoPrx;

void __read(::IceInternal::BasicStream*, InternalReplicaInfoPrx&);
void __patch__InternalReplicaInfoPtr(void*, ::Ice::ObjectPtr&);

}

namespace IceGrid
{

typedef ::std::vector< ::IceGrid::InternalDbEnvDescriptorPtr> InternalDbEnvDescriptorSeq;
void __writeInternalDbEnvDescriptorSeq(::IceInternal::BasicStream*, const ::IceGrid::InternalDbEnvDescriptorPtr*, const ::IceGrid::InternalDbEnvDescriptorPtr*);
void __readInternalDbEnvDescriptorSeq(::IceInternal::BasicStream*, InternalDbEnvDescriptorSeq&);

typedef ::std::vector< ::IceGrid::InternalAdapterDescriptorPtr> InternalAdapterDescriptorSeq;
void __writeInternalAdapterDescriptorSeq(::IceInternal::BasicStream*, const ::IceGrid::InternalAdapterDescriptorPtr*, const ::IceGrid::InternalAdapterDescriptorPtr*);
void __readInternalAdapterDescriptorSeq(::IceInternal::BasicStream*, InternalAdapterDescriptorSeq&);

typedef ::std::map< ::std::string, ::IceGrid::PropertyDescriptorSeq> PropertyDescriptorSeqDict;
void __writePropertyDescriptorSeqDict(::IceInternal::BasicStream*, const PropertyDescriptorSeqDict&);
void __readPropertyDescriptorSeqDict(::IceInternal::BasicStream*, PropertyDescriptorSeqDict&);

class AdapterActiveException : public ::Ice::UserException
{
public:

    AdapterActiveException() {}
    virtual ~AdapterActiveException() throw();

    virtual ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

static AdapterActiveException __AdapterActiveException_init;

class AdapterNotActiveException : public ::Ice::UserException
{
public:

    AdapterNotActiveException() {}
    explicit AdapterNotActiveException(bool);
    virtual ~AdapterNotActiveException() throw();

    virtual ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    bool activatable;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class AdapterExistsException : public ::Ice::UserException
{
public:

    AdapterExistsException() {}
    explicit AdapterExistsException(const ::std::string&);
    virtual ~AdapterExistsException() throw();

    virtual ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    ::std::string id;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

typedef ::std::map< ::std::string, ::IceGrid::AdapterPrx> AdapterPrxDict;
void __writeAdapterPrxDict(::IceInternal::BasicStream*, const AdapterPrxDict&);
void __readAdapterPrxDict(::IceInternal::BasicStream*, AdapterPrxDict&);

typedef ::std::vector< ::IceGrid::InternalRegistryPrx> InternalRegistryPrxSeq;
void __writeInternalRegistryPrxSeq(::IceInternal::BasicStream*, const ::IceGrid::InternalRegistryPrx*, const ::IceGrid::InternalRegistryPrx*);
void __readInternalRegistryPrxSeq(::IceInternal::BasicStream*, InternalRegistryPrxSeq&);

typedef ::std::vector< ::IceGrid::NodePrx> NodePrxSeq;
void __writeNodePrxSeq(::IceInternal::BasicStream*, const ::IceGrid::NodePrx*, const ::IceGrid::NodePrx*);
void __readNodePrxSeq(::IceInternal::BasicStream*, NodePrxSeq&);

class NodeActiveException : public ::Ice::UserException
{
public:

    NodeActiveException() {}
    virtual ~NodeActiveException() throw();

    virtual ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class ReplicaActiveException : public ::Ice::UserException
{
public:

    ReplicaActiveException() {}
    virtual ~ReplicaActiveException() throw();

    virtual ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

enum TopicName
{
    RegistryObserverTopicName,
    NodeObserverTopicName,
    ApplicationObserverTopicName,
    AdapterObserverTopicName,
    ObjectObserverTopicName
};

void __write(::IceInternal::BasicStream*, TopicName);
void __read(::IceInternal::BasicStream*, TopicName&);

}

namespace IceGrid
{

class AMI_Adapter_activate : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response(const ::Ice::ObjectPrx&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    bool __invoke(const ::IceGrid::AdapterPrx&, const ::Ice::Context*);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceGrid::AMI_Adapter_activate> AMI_Adapter_activatePtr;

class AMD_Adapter_activate : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(const ::Ice::ObjectPrx&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::IceGrid::AMD_Adapter_activate> AMD_Adapter_activatePtr;

class AMI_Adapter_getDirectProxy : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response(const ::Ice::ObjectPrx&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    bool __invoke(const ::IceGrid::AdapterPrx&, const ::Ice::Context*);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceGrid::AMI_Adapter_getDirectProxy> AMI_Adapter_getDirectProxyPtr;

class AMI_Adapter_setDirectProxy : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    bool __invoke(const ::IceGrid::AdapterPrx&, const ::Ice::ObjectPrx&, const ::Ice::Context*);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceGrid::AMI_Adapter_setDirectProxy> AMI_Adapter_setDirectProxyPtr;

class AMI_Server_start : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    bool __invoke(const ::IceGrid::ServerPrx&, const ::Ice::Context*);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceGrid::AMI_Server_start> AMI_Server_startPtr;

class AMD_Server_start : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::IceGrid::AMD_Server_start> AMD_Server_startPtr;

class AMI_Server_stop : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    bool __invoke(const ::IceGrid::ServerPrx&, const ::Ice::Context*);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceGrid::AMI_Server_stop> AMI_Server_stopPtr;

class AMD_Server_stop : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::IceGrid::AMD_Server_stop> AMD_Server_stopPtr;

class AMI_Server_setProcess : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    bool __invoke(const ::IceGrid::ServerPrx&, const ::Ice::ProcessPrx&, const ::Ice::Context*);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceGrid::AMI_Server_setProcess> AMI_Server_setProcessPtr;

class AMD_Server_setProcess : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::IceGrid::AMD_Server_setProcess> AMD_Server_setProcessPtr;

class AMI_Node_loadServer : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response(const ::IceGrid::ServerPrx&, const ::IceGrid::AdapterPrxDict&, ::Ice::Int, ::Ice::Int) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    bool __invoke(const ::IceGrid::NodePrx&, const ::IceGrid::InternalServerDescriptorPtr&, const ::std::string&, const ::Ice::Context*);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceGrid::AMI_Node_loadServer> AMI_Node_loadServerPtr;

class AMD_Node_loadServer : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(const ::IceGrid::ServerPrx&, const ::IceGrid::AdapterPrxDict&, ::Ice::Int, ::Ice::Int) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::IceGrid::AMD_Node_loadServer> AMD_Node_loadServerPtr;

class AMI_Node_destroyServer : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    bool __invoke(const ::IceGrid::NodePrx&, const ::std::string&, const ::std::string&, ::Ice::Int, const ::std::string&, const ::Ice::Context*);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceGrid::AMI_Node_destroyServer> AMI_Node_destroyServerPtr;

class AMD_Node_destroyServer : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::IceGrid::AMD_Node_destroyServer> AMD_Node_destroyServerPtr;

class AMD_Node_patch : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::IceGrid::AMD_Node_patch> AMD_Node_patchPtr;

class AMI_Node_registerWithReplica : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    bool __invoke(const ::IceGrid::NodePrx&, const ::IceGrid::InternalRegistryPrx&, const ::Ice::Context*);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceGrid::AMI_Node_registerWithReplica> AMI_Node_registerWithReplicaPtr;

class AMD_NodeSession_loadServers : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::IceGrid::AMD_NodeSession_loadServers> AMD_NodeSession_loadServersPtr;

class AMI_NodeSession_waitForApplicationUpdate : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    bool __invoke(const ::IceGrid::NodeSessionPrx&, const ::std::string&, ::Ice::Int, const ::Ice::Context*);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceGrid::AMI_NodeSession_waitForApplicationUpdate> AMI_NodeSession_waitForApplicationUpdatePtr;

class AMD_NodeSession_waitForApplicationUpdate : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::IceGrid::AMD_NodeSession_waitForApplicationUpdate> AMD_NodeSession_waitForApplicationUpdatePtr;

class AMI_ReplicaSession_setAdapterDirectProxy : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    bool __invoke(const ::IceGrid::ReplicaSessionPrx&, const ::std::string&, const ::std::string&, const ::Ice::ObjectPrx&, const ::Ice::Context*);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceGrid::AMI_ReplicaSession_setAdapterDirectProxy> AMI_ReplicaSession_setAdapterDirectProxyPtr;

}

namespace IceAsync
{

namespace IceGrid
{

class AMD_Adapter_activate : public ::IceGrid::AMD_Adapter_activate, public ::IceInternal::IncomingAsync
{
public:

    AMD_Adapter_activate(::IceInternal::Incoming&);

    virtual void ice_response(const ::Ice::ObjectPrx&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_Server_start : public ::IceGrid::AMD_Server_start, public ::IceInternal::IncomingAsync
{
public:

    AMD_Server_start(::IceInternal::Incoming&);

    virtual void ice_response();
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_Server_stop : public ::IceGrid::AMD_Server_stop, public ::IceInternal::IncomingAsync
{
public:

    AMD_Server_stop(::IceInternal::Incoming&);

    virtual void ice_response();
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_Server_setProcess : public ::IceGrid::AMD_Server_setProcess, public ::IceInternal::IncomingAsync
{
public:

    AMD_Server_setProcess(::IceInternal::Incoming&);

    virtual void ice_response();
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_Node_loadServer : public ::IceGrid::AMD_Node_loadServer, public ::IceInternal::IncomingAsync
{
public:

    AMD_Node_loadServer(::IceInternal::Incoming&);

    virtual void ice_response(const ::IceGrid::ServerPrx&, const ::IceGrid::AdapterPrxDict&, ::Ice::Int, ::Ice::Int);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_Node_destroyServer : public ::IceGrid::AMD_Node_destroyServer, public ::IceInternal::IncomingAsync
{
public:

    AMD_Node_destroyServer(::IceInternal::Incoming&);

    virtual void ice_response();
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_Node_patch : public ::IceGrid::AMD_Node_patch, public ::IceInternal::IncomingAsync
{
public:

    AMD_Node_patch(::IceInternal::Incoming&);

    virtual void ice_response();
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_NodeSession_loadServers : public ::IceGrid::AMD_NodeSession_loadServers, public ::IceInternal::IncomingAsync
{
public:

    AMD_NodeSession_loadServers(::IceInternal::Incoming&);

    virtual void ice_response();
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_NodeSession_waitForApplicationUpdate : public ::IceGrid::AMD_NodeSession_waitForApplicationUpdate, public ::IceInternal::IncomingAsync
{
public:

    AMD_NodeSession_waitForApplicationUpdate(::IceInternal::Incoming&);

    virtual void ice_response();
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

}

}

namespace IceProxy
{

namespace IceGrid
{

class InternalDbEnvDescriptor : virtual public ::IceProxy::Ice::Object
{
public:
    
    ::IceInternal::ProxyHandle<InternalDbEnvDescriptor> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDbEnvDescriptor*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<InternalDbEnvDescriptor*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDbEnvDescriptor> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDbEnvDescriptor*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<InternalDbEnvDescriptor*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDbEnvDescriptor> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDbEnvDescriptor*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<InternalDbEnvDescriptor*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDbEnvDescriptor> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDbEnvDescriptor*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<InternalDbEnvDescriptor*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDbEnvDescriptor> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDbEnvDescriptor*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<InternalDbEnvDescriptor*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDbEnvDescriptor> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDbEnvDescriptor*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<InternalDbEnvDescriptor*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDbEnvDescriptor> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDbEnvDescriptor*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<InternalDbEnvDescriptor*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDbEnvDescriptor> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDbEnvDescriptor*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<InternalDbEnvDescriptor*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDbEnvDescriptor> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDbEnvDescriptor*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<InternalDbEnvDescriptor*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDbEnvDescriptor> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDbEnvDescriptor*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<InternalDbEnvDescriptor*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDbEnvDescriptor> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDbEnvDescriptor*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<InternalDbEnvDescriptor*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDbEnvDescriptor> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDbEnvDescriptor*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<InternalDbEnvDescriptor*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDbEnvDescriptor> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDbEnvDescriptor*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<InternalDbEnvDescriptor*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDbEnvDescriptor> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDbEnvDescriptor*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<InternalDbEnvDescriptor*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDbEnvDescriptor> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDbEnvDescriptor*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<InternalDbEnvDescriptor*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDbEnvDescriptor> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDbEnvDescriptor*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<InternalDbEnvDescriptor*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDbEnvDescriptor> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDbEnvDescriptor*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<InternalDbEnvDescriptor*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDbEnvDescriptor> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDbEnvDescriptor*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<InternalDbEnvDescriptor*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDbEnvDescriptor> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDbEnvDescriptor*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<InternalDbEnvDescriptor*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class InternalAdapterDescriptor : virtual public ::IceProxy::Ice::Object
{
public:
    
    ::IceInternal::ProxyHandle<InternalAdapterDescriptor> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalAdapterDescriptor*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<InternalAdapterDescriptor*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalAdapterDescriptor> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalAdapterDescriptor*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<InternalAdapterDescriptor*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalAdapterDescriptor> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalAdapterDescriptor*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<InternalAdapterDescriptor*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalAdapterDescriptor> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalAdapterDescriptor*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<InternalAdapterDescriptor*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalAdapterDescriptor> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalAdapterDescriptor*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<InternalAdapterDescriptor*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalAdapterDescriptor> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalAdapterDescriptor*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<InternalAdapterDescriptor*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalAdapterDescriptor> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalAdapterDescriptor*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<InternalAdapterDescriptor*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalAdapterDescriptor> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalAdapterDescriptor*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<InternalAdapterDescriptor*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalAdapterDescriptor> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalAdapterDescriptor*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<InternalAdapterDescriptor*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalAdapterDescriptor> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalAdapterDescriptor*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<InternalAdapterDescriptor*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalAdapterDescriptor> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalAdapterDescriptor*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<InternalAdapterDescriptor*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalAdapterDescriptor> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalAdapterDescriptor*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<InternalAdapterDescriptor*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalAdapterDescriptor> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalAdapterDescriptor*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<InternalAdapterDescriptor*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalAdapterDescriptor> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalAdapterDescriptor*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<InternalAdapterDescriptor*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalAdapterDescriptor> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalAdapterDescriptor*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<InternalAdapterDescriptor*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalAdapterDescriptor> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalAdapterDescriptor*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<InternalAdapterDescriptor*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalAdapterDescriptor> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalAdapterDescriptor*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<InternalAdapterDescriptor*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalAdapterDescriptor> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalAdapterDescriptor*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<InternalAdapterDescriptor*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalAdapterDescriptor> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalAdapterDescriptor*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<InternalAdapterDescriptor*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class InternalDistributionDescriptor : virtual public ::IceProxy::Ice::Object
{
public:
    
    ::IceInternal::ProxyHandle<InternalDistributionDescriptor> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDistributionDescriptor*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<InternalDistributionDescriptor*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDistributionDescriptor> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDistributionDescriptor*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<InternalDistributionDescriptor*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDistributionDescriptor> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDistributionDescriptor*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<InternalDistributionDescriptor*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDistributionDescriptor> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDistributionDescriptor*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<InternalDistributionDescriptor*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDistributionDescriptor> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDistributionDescriptor*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<InternalDistributionDescriptor*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDistributionDescriptor> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDistributionDescriptor*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<InternalDistributionDescriptor*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDistributionDescriptor> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDistributionDescriptor*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<InternalDistributionDescriptor*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDistributionDescriptor> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDistributionDescriptor*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<InternalDistributionDescriptor*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDistributionDescriptor> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDistributionDescriptor*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<InternalDistributionDescriptor*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDistributionDescriptor> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDistributionDescriptor*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<InternalDistributionDescriptor*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDistributionDescriptor> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDistributionDescriptor*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<InternalDistributionDescriptor*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDistributionDescriptor> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDistributionDescriptor*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<InternalDistributionDescriptor*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDistributionDescriptor> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDistributionDescriptor*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<InternalDistributionDescriptor*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDistributionDescriptor> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDistributionDescriptor*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<InternalDistributionDescriptor*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDistributionDescriptor> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDistributionDescriptor*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<InternalDistributionDescriptor*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDistributionDescriptor> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDistributionDescriptor*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<InternalDistributionDescriptor*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDistributionDescriptor> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDistributionDescriptor*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<InternalDistributionDescriptor*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDistributionDescriptor> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDistributionDescriptor*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<InternalDistributionDescriptor*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalDistributionDescriptor> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalDistributionDescriptor*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<InternalDistributionDescriptor*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class InternalServerDescriptor : virtual public ::IceProxy::Ice::Object
{
public:
    
    ::IceInternal::ProxyHandle<InternalServerDescriptor> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalServerDescriptor*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<InternalServerDescriptor*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalServerDescriptor> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalServerDescriptor*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<InternalServerDescriptor*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalServerDescriptor> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalServerDescriptor*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<InternalServerDescriptor*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalServerDescriptor> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalServerDescriptor*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<InternalServerDescriptor*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalServerDescriptor> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalServerDescriptor*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<InternalServerDescriptor*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalServerDescriptor> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalServerDescriptor*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<InternalServerDescriptor*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalServerDescriptor> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalServerDescriptor*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<InternalServerDescriptor*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalServerDescriptor> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalServerDescriptor*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<InternalServerDescriptor*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalServerDescriptor> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalServerDescriptor*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<InternalServerDescriptor*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalServerDescriptor> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalServerDescriptor*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<InternalServerDescriptor*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalServerDescriptor> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalServerDescriptor*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<InternalServerDescriptor*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalServerDescriptor> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalServerDescriptor*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<InternalServerDescriptor*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalServerDescriptor> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalServerDescriptor*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<InternalServerDescriptor*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalServerDescriptor> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalServerDescriptor*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<InternalServerDescriptor*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalServerDescriptor> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalServerDescriptor*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<InternalServerDescriptor*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalServerDescriptor> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalServerDescriptor*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<InternalServerDescriptor*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalServerDescriptor> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalServerDescriptor*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<InternalServerDescriptor*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalServerDescriptor> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalServerDescriptor*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<InternalServerDescriptor*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalServerDescriptor> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalServerDescriptor*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<InternalServerDescriptor*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class Adapter : virtual public ::IceProxy::Ice::Object
{
public:

    ::Ice::ObjectPrx activate()
    {
        return activate(0);
    }
    ::Ice::ObjectPrx activate(const ::Ice::Context& __ctx)
    {
        return activate(&__ctx);
    }
    
private:

    ::Ice::ObjectPrx activate(const ::Ice::Context*);
    
public:
    bool activate_async(const ::IceGrid::AMI_Adapter_activatePtr&);
    bool activate_async(const ::IceGrid::AMI_Adapter_activatePtr&, const ::Ice::Context&);

    ::Ice::ObjectPrx getDirectProxy()
    {
        return getDirectProxy(0);
    }
    ::Ice::ObjectPrx getDirectProxy(const ::Ice::Context& __ctx)
    {
        return getDirectProxy(&__ctx);
    }
    
private:

    ::Ice::ObjectPrx getDirectProxy(const ::Ice::Context*);
    
public:
    bool getDirectProxy_async(const ::IceGrid::AMI_Adapter_getDirectProxyPtr&);
    bool getDirectProxy_async(const ::IceGrid::AMI_Adapter_getDirectProxyPtr&, const ::Ice::Context&);

    void setDirectProxy(const ::Ice::ObjectPrx& proxy)
    {
        setDirectProxy(proxy, 0);
    }
    void setDirectProxy(const ::Ice::ObjectPrx& proxy, const ::Ice::Context& __ctx)
    {
        setDirectProxy(proxy, &__ctx);
    }
    
private:

    void setDirectProxy(const ::Ice::ObjectPrx&, const ::Ice::Context*);
    
public:
    bool setDirectProxy_async(const ::IceGrid::AMI_Adapter_setDirectProxyPtr&, const ::Ice::ObjectPrx&);
    bool setDirectProxy_async(const ::IceGrid::AMI_Adapter_setDirectProxyPtr&, const ::Ice::ObjectPrx&, const ::Ice::Context&);
    
    ::IceInternal::ProxyHandle<Adapter> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Adapter*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<Adapter*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Adapter> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Adapter*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<Adapter*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Adapter> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Adapter*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<Adapter*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Adapter> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Adapter*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<Adapter*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Adapter> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Adapter*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<Adapter*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Adapter> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Adapter*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<Adapter*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Adapter> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Adapter*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<Adapter*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Adapter> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Adapter*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<Adapter*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Adapter> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Adapter*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<Adapter*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Adapter> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Adapter*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<Adapter*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Adapter> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Adapter*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<Adapter*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Adapter> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Adapter*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<Adapter*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Adapter> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Adapter*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<Adapter*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Adapter> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Adapter*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<Adapter*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Adapter> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Adapter*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<Adapter*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Adapter> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Adapter*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<Adapter*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Adapter> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Adapter*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<Adapter*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Adapter> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Adapter*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<Adapter*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Adapter> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Adapter*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<Adapter*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class FileReader : virtual public ::IceProxy::Ice::Object
{
public:

    ::Ice::Long getOffsetFromEnd(const ::std::string& filename, ::Ice::Int lines)
    {
        return getOffsetFromEnd(filename, lines, 0);
    }
    ::Ice::Long getOffsetFromEnd(const ::std::string& filename, ::Ice::Int lines, const ::Ice::Context& __ctx)
    {
        return getOffsetFromEnd(filename, lines, &__ctx);
    }
    
private:

    ::Ice::Long getOffsetFromEnd(const ::std::string&, ::Ice::Int, const ::Ice::Context*);
    
public:

    bool read(const ::std::string& filename, ::Ice::Long pos, ::Ice::Int size, ::Ice::Long& newPos, ::Ice::StringSeq& lines)
    {
        return read(filename, pos, size, newPos, lines, 0);
    }
    bool read(const ::std::string& filename, ::Ice::Long pos, ::Ice::Int size, ::Ice::Long& newPos, ::Ice::StringSeq& lines, const ::Ice::Context& __ctx)
    {
        return read(filename, pos, size, newPos, lines, &__ctx);
    }
    
private:

    bool read(const ::std::string&, ::Ice::Long, ::Ice::Int, ::Ice::Long&, ::Ice::StringSeq&, const ::Ice::Context*);
    
public:
    
    ::IceInternal::ProxyHandle<FileReader> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileReader*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<FileReader*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileReader> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileReader*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<FileReader*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileReader> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileReader*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<FileReader*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileReader> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileReader*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<FileReader*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileReader> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileReader*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<FileReader*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileReader> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileReader*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<FileReader*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileReader> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileReader*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<FileReader*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileReader> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileReader*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<FileReader*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileReader> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileReader*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<FileReader*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileReader> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileReader*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<FileReader*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileReader> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileReader*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<FileReader*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileReader> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileReader*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<FileReader*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileReader> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileReader*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<FileReader*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileReader> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileReader*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<FileReader*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileReader> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileReader*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<FileReader*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileReader> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileReader*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<FileReader*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileReader> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileReader*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<FileReader*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileReader> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileReader*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<FileReader*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileReader> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileReader*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<FileReader*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class Server : virtual public ::IceProxy::IceGrid::FileReader
{
public:

    void start()
    {
        start(0);
    }
    void start(const ::Ice::Context& __ctx)
    {
        start(&__ctx);
    }
    
private:

    void start(const ::Ice::Context*);
    
public:
    bool start_async(const ::IceGrid::AMI_Server_startPtr&);
    bool start_async(const ::IceGrid::AMI_Server_startPtr&, const ::Ice::Context&);

    void stop()
    {
        stop(0);
    }
    void stop(const ::Ice::Context& __ctx)
    {
        stop(&__ctx);
    }
    
private:

    void stop(const ::Ice::Context*);
    
public:
    bool stop_async(const ::IceGrid::AMI_Server_stopPtr&);
    bool stop_async(const ::IceGrid::AMI_Server_stopPtr&, const ::Ice::Context&);

    void setEnabled(bool enable)
    {
        setEnabled(enable, 0);
    }
    void setEnabled(bool enable, const ::Ice::Context& __ctx)
    {
        setEnabled(enable, &__ctx);
    }
    
private:

    void setEnabled(bool, const ::Ice::Context*);
    
public:

    bool isEnabled()
    {
        return isEnabled(0);
    }
    bool isEnabled(const ::Ice::Context& __ctx)
    {
        return isEnabled(&__ctx);
    }
    
private:

    bool isEnabled(const ::Ice::Context*);
    
public:

    void sendSignal(const ::std::string& signal)
    {
        sendSignal(signal, 0);
    }
    void sendSignal(const ::std::string& signal, const ::Ice::Context& __ctx)
    {
        sendSignal(signal, &__ctx);
    }
    
private:

    void sendSignal(const ::std::string&, const ::Ice::Context*);
    
public:

    void writeMessage(const ::std::string& message, ::Ice::Int fd)
    {
        writeMessage(message, fd, 0);
    }
    void writeMessage(const ::std::string& message, ::Ice::Int fd, const ::Ice::Context& __ctx)
    {
        writeMessage(message, fd, &__ctx);
    }
    
private:

    void writeMessage(const ::std::string&, ::Ice::Int, const ::Ice::Context*);
    
public:

    ::IceGrid::ServerState getState()
    {
        return getState(0);
    }
    ::IceGrid::ServerState getState(const ::Ice::Context& __ctx)
    {
        return getState(&__ctx);
    }
    
private:

    ::IceGrid::ServerState getState(const ::Ice::Context*);
    
public:

    ::Ice::Int getPid()
    {
        return getPid(0);
    }
    ::Ice::Int getPid(const ::Ice::Context& __ctx)
    {
        return getPid(&__ctx);
    }
    
private:

    ::Ice::Int getPid(const ::Ice::Context*);
    
public:

    void setProcess(const ::Ice::ProcessPrx& proc)
    {
        setProcess(proc, 0);
    }
    void setProcess(const ::Ice::ProcessPrx& proc, const ::Ice::Context& __ctx)
    {
        setProcess(proc, &__ctx);
    }
    
private:

    void setProcess(const ::Ice::ProcessPrx&, const ::Ice::Context*);
    
public:
    bool setProcess_async(const ::IceGrid::AMI_Server_setProcessPtr&, const ::Ice::ProcessPrx&);
    bool setProcess_async(const ::IceGrid::AMI_Server_setProcessPtr&, const ::Ice::ProcessPrx&, const ::Ice::Context&);
    
    ::IceInternal::ProxyHandle<Server> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class ReplicaObserver : virtual public ::IceProxy::Ice::Object
{
public:

    void replicaInit(const ::IceGrid::InternalRegistryPrxSeq& replicas)
    {
        replicaInit(replicas, 0);
    }
    void replicaInit(const ::IceGrid::InternalRegistryPrxSeq& replicas, const ::Ice::Context& __ctx)
    {
        replicaInit(replicas, &__ctx);
    }
    
private:

    void replicaInit(const ::IceGrid::InternalRegistryPrxSeq&, const ::Ice::Context*);
    
public:

    void replicaAdded(const ::IceGrid::InternalRegistryPrx& replica)
    {
        replicaAdded(replica, 0);
    }
    void replicaAdded(const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Context& __ctx)
    {
        replicaAdded(replica, &__ctx);
    }
    
private:

    void replicaAdded(const ::IceGrid::InternalRegistryPrx&, const ::Ice::Context*);
    
public:

    void replicaRemoved(const ::IceGrid::InternalRegistryPrx& replica)
    {
        replicaRemoved(replica, 0);
    }
    void replicaRemoved(const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Context& __ctx)
    {
        replicaRemoved(replica, &__ctx);
    }
    
private:

    void replicaRemoved(const ::IceGrid::InternalRegistryPrx&, const ::Ice::Context*);
    
public:
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class PatcherFeedback : virtual public ::IceProxy::Ice::Object
{
public:

    void finished()
    {
        finished(0);
    }
    void finished(const ::Ice::Context& __ctx)
    {
        finished(&__ctx);
    }
    
private:

    void finished(const ::Ice::Context*);
    
public:

    void failed(const ::std::string& reason)
    {
        failed(reason, 0);
    }
    void failed(const ::std::string& reason, const ::Ice::Context& __ctx)
    {
        failed(reason, &__ctx);
    }
    
private:

    void failed(const ::std::string&, const ::Ice::Context*);
    
public:
    
    ::IceInternal::ProxyHandle<PatcherFeedback> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<PatcherFeedback*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<PatcherFeedback*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<PatcherFeedback> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<PatcherFeedback*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<PatcherFeedback*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<PatcherFeedback> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<PatcherFeedback*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<PatcherFeedback*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<PatcherFeedback> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<PatcherFeedback*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<PatcherFeedback*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<PatcherFeedback> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<PatcherFeedback*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<PatcherFeedback*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<PatcherFeedback> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<PatcherFeedback*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<PatcherFeedback*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<PatcherFeedback> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<PatcherFeedback*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<PatcherFeedback*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<PatcherFeedback> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<PatcherFeedback*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<PatcherFeedback*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<PatcherFeedback> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<PatcherFeedback*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<PatcherFeedback*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<PatcherFeedback> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<PatcherFeedback*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<PatcherFeedback*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<PatcherFeedback> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<PatcherFeedback*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<PatcherFeedback*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<PatcherFeedback> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<PatcherFeedback*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<PatcherFeedback*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<PatcherFeedback> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<PatcherFeedback*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<PatcherFeedback*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<PatcherFeedback> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<PatcherFeedback*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<PatcherFeedback*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<PatcherFeedback> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<PatcherFeedback*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<PatcherFeedback*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<PatcherFeedback> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<PatcherFeedback*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<PatcherFeedback*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<PatcherFeedback> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<PatcherFeedback*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<PatcherFeedback*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<PatcherFeedback> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<PatcherFeedback*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<PatcherFeedback*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<PatcherFeedback> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<PatcherFeedback*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<PatcherFeedback*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class Node : virtual public ::IceProxy::IceGrid::FileReader,
             virtual public ::IceProxy::IceGrid::ReplicaObserver
{
public:

    ::IceGrid::ServerPrx loadServer(const ::IceGrid::InternalServerDescriptorPtr& svr, const ::std::string& replicaName, ::IceGrid::AdapterPrxDict& adapters, ::Ice::Int& actTimeout, ::Ice::Int& deactTimeout)
    {
        return loadServer(svr, replicaName, adapters, actTimeout, deactTimeout, 0);
    }
    ::IceGrid::ServerPrx loadServer(const ::IceGrid::InternalServerDescriptorPtr& svr, const ::std::string& replicaName, ::IceGrid::AdapterPrxDict& adapters, ::Ice::Int& actTimeout, ::Ice::Int& deactTimeout, const ::Ice::Context& __ctx)
    {
        return loadServer(svr, replicaName, adapters, actTimeout, deactTimeout, &__ctx);
    }
    
private:

    ::IceGrid::ServerPrx loadServer(const ::IceGrid::InternalServerDescriptorPtr&, const ::std::string&, ::IceGrid::AdapterPrxDict&, ::Ice::Int&, ::Ice::Int&, const ::Ice::Context*);
    
public:
    bool loadServer_async(const ::IceGrid::AMI_Node_loadServerPtr&, const ::IceGrid::InternalServerDescriptorPtr&, const ::std::string&);
    bool loadServer_async(const ::IceGrid::AMI_Node_loadServerPtr&, const ::IceGrid::InternalServerDescriptorPtr&, const ::std::string&, const ::Ice::Context&);

    void destroyServer(const ::std::string& name, const ::std::string& uuid, ::Ice::Int revision, const ::std::string& replicaName)
    {
        destroyServer(name, uuid, revision, replicaName, 0);
    }
    void destroyServer(const ::std::string& name, const ::std::string& uuid, ::Ice::Int revision, const ::std::string& replicaName, const ::Ice::Context& __ctx)
    {
        destroyServer(name, uuid, revision, replicaName, &__ctx);
    }
    
private:

    void destroyServer(const ::std::string&, const ::std::string&, ::Ice::Int, const ::std::string&, const ::Ice::Context*);
    
public:
    bool destroyServer_async(const ::IceGrid::AMI_Node_destroyServerPtr&, const ::std::string&, const ::std::string&, ::Ice::Int, const ::std::string&);
    bool destroyServer_async(const ::IceGrid::AMI_Node_destroyServerPtr&, const ::std::string&, const ::std::string&, ::Ice::Int, const ::std::string&, const ::Ice::Context&);

    void patch(const ::IceGrid::PatcherFeedbackPrx& feedback, const ::std::string& application, const ::std::string& server, const ::IceGrid::InternalDistributionDescriptorPtr& appDistrib, bool shutdown)
    {
        patch(feedback, application, server, appDistrib, shutdown, 0);
    }
    void patch(const ::IceGrid::PatcherFeedbackPrx& feedback, const ::std::string& application, const ::std::string& server, const ::IceGrid::InternalDistributionDescriptorPtr& appDistrib, bool shutdown, const ::Ice::Context& __ctx)
    {
        patch(feedback, application, server, appDistrib, shutdown, &__ctx);
    }
    
private:

    void patch(const ::IceGrid::PatcherFeedbackPrx&, const ::std::string&, const ::std::string&, const ::IceGrid::InternalDistributionDescriptorPtr&, bool, const ::Ice::Context*);
    
public:

    void registerWithReplica(const ::IceGrid::InternalRegistryPrx& replica)
    {
        registerWithReplica(replica, 0);
    }
    void registerWithReplica(const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Context& __ctx)
    {
        registerWithReplica(replica, &__ctx);
    }
    
private:

    void registerWithReplica(const ::IceGrid::InternalRegistryPrx&, const ::Ice::Context*);
    
public:
    bool registerWithReplica_async(const ::IceGrid::AMI_Node_registerWithReplicaPtr&, const ::IceGrid::InternalRegistryPrx&);
    bool registerWithReplica_async(const ::IceGrid::AMI_Node_registerWithReplicaPtr&, const ::IceGrid::InternalRegistryPrx&, const ::Ice::Context&);

    ::std::string getName()
    {
        return getName(0);
    }
    ::std::string getName(const ::Ice::Context& __ctx)
    {
        return getName(&__ctx);
    }
    
private:

    ::std::string getName(const ::Ice::Context*);
    
public:

    ::std::string getHostname()
    {
        return getHostname(0);
    }
    ::std::string getHostname(const ::Ice::Context& __ctx)
    {
        return getHostname(&__ctx);
    }
    
private:

    ::std::string getHostname(const ::Ice::Context*);
    
public:

    ::IceGrid::LoadInfo getLoad()
    {
        return getLoad(0);
    }
    ::IceGrid::LoadInfo getLoad(const ::Ice::Context& __ctx)
    {
        return getLoad(&__ctx);
    }
    
private:

    ::IceGrid::LoadInfo getLoad(const ::Ice::Context*);
    
public:

    void shutdown()
    {
        shutdown(0);
    }
    void shutdown(const ::Ice::Context& __ctx)
    {
        shutdown(&__ctx);
    }
    
private:

    void shutdown(const ::Ice::Context*);
    
public:
    
    ::IceInternal::ProxyHandle<Node> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class NodeSession : virtual public ::IceProxy::Ice::Object
{
public:

    void keepAlive(const ::IceGrid::LoadInfo& load)
    {
        keepAlive(load, 0);
    }
    void keepAlive(const ::IceGrid::LoadInfo& load, const ::Ice::Context& __ctx)
    {
        keepAlive(load, &__ctx);
    }
    
private:

    void keepAlive(const ::IceGrid::LoadInfo&, const ::Ice::Context*);
    
public:

    void setReplicaObserver(const ::IceGrid::ReplicaObserverPrx& observer)
    {
        setReplicaObserver(observer, 0);
    }
    void setReplicaObserver(const ::IceGrid::ReplicaObserverPrx& observer, const ::Ice::Context& __ctx)
    {
        setReplicaObserver(observer, &__ctx);
    }
    
private:

    void setReplicaObserver(const ::IceGrid::ReplicaObserverPrx&, const ::Ice::Context*);
    
public:

    ::Ice::Int getTimeout()
    {
        return getTimeout(0);
    }
    ::Ice::Int getTimeout(const ::Ice::Context& __ctx)
    {
        return getTimeout(&__ctx);
    }
    
private:

    ::Ice::Int getTimeout(const ::Ice::Context*);
    
public:

    ::IceGrid::NodeObserverPrx getObserver()
    {
        return getObserver(0);
    }
    ::IceGrid::NodeObserverPrx getObserver(const ::Ice::Context& __ctx)
    {
        return getObserver(&__ctx);
    }
    
private:

    ::IceGrid::NodeObserverPrx getObserver(const ::Ice::Context*);
    
public:

    void loadServers()
    {
        loadServers(0);
    }
    void loadServers(const ::Ice::Context& __ctx)
    {
        loadServers(&__ctx);
    }
    
private:

    void loadServers(const ::Ice::Context*);
    
public:

    ::Ice::StringSeq getServers()
    {
        return getServers(0);
    }
    ::Ice::StringSeq getServers(const ::Ice::Context& __ctx)
    {
        return getServers(&__ctx);
    }
    
private:

    ::Ice::StringSeq getServers(const ::Ice::Context*);
    
public:

    void waitForApplicationUpdate(const ::std::string& application, ::Ice::Int revision)
    {
        waitForApplicationUpdate(application, revision, 0);
    }
    void waitForApplicationUpdate(const ::std::string& application, ::Ice::Int revision, const ::Ice::Context& __ctx)
    {
        waitForApplicationUpdate(application, revision, &__ctx);
    }
    
private:

    void waitForApplicationUpdate(const ::std::string&, ::Ice::Int, const ::Ice::Context*);
    
public:
    bool waitForApplicationUpdate_async(const ::IceGrid::AMI_NodeSession_waitForApplicationUpdatePtr&, const ::std::string&, ::Ice::Int);
    bool waitForApplicationUpdate_async(const ::IceGrid::AMI_NodeSession_waitForApplicationUpdatePtr&, const ::std::string&, ::Ice::Int, const ::Ice::Context&);

    void destroy()
    {
        destroy(0);
    }
    void destroy(const ::Ice::Context& __ctx)
    {
        destroy(&__ctx);
    }
    
private:

    void destroy(const ::Ice::Context*);
    
public:
    
    ::IceInternal::ProxyHandle<NodeSession> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<NodeSession*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<NodeSession*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<NodeSession> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<NodeSession*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<NodeSession*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<NodeSession> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<NodeSession*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<NodeSession*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<NodeSession> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<NodeSession*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<NodeSession*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<NodeSession> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<NodeSession*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<NodeSession*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<NodeSession> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<NodeSession*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<NodeSession*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<NodeSession> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<NodeSession*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<NodeSession*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<NodeSession> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<NodeSession*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<NodeSession*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<NodeSession> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<NodeSession*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<NodeSession*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<NodeSession> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<NodeSession*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<NodeSession*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<NodeSession> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<NodeSession*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<NodeSession*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<NodeSession> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<NodeSession*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<NodeSession*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<NodeSession> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<NodeSession*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<NodeSession*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<NodeSession> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<NodeSession*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<NodeSession*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<NodeSession> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<NodeSession*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<NodeSession*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<NodeSession> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<NodeSession*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<NodeSession*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<NodeSession> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<NodeSession*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<NodeSession*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<NodeSession> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<NodeSession*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<NodeSession*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<NodeSession> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<NodeSession*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<NodeSession*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class DatabaseObserver : virtual public ::IceProxy::IceGrid::ApplicationObserver,
                         virtual public ::IceProxy::IceGrid::ObjectObserver,
                         virtual public ::IceProxy::IceGrid::AdapterObserver
{
public:
    
    ::IceInternal::ProxyHandle<DatabaseObserver> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<DatabaseObserver*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<DatabaseObserver*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<DatabaseObserver> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<DatabaseObserver*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<DatabaseObserver*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<DatabaseObserver> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<DatabaseObserver*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<DatabaseObserver*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<DatabaseObserver> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<DatabaseObserver*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<DatabaseObserver*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<DatabaseObserver> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<DatabaseObserver*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<DatabaseObserver*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<DatabaseObserver> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<DatabaseObserver*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<DatabaseObserver*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<DatabaseObserver> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<DatabaseObserver*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<DatabaseObserver*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<DatabaseObserver> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<DatabaseObserver*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<DatabaseObserver*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<DatabaseObserver> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<DatabaseObserver*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<DatabaseObserver*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<DatabaseObserver> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<DatabaseObserver*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<DatabaseObserver*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<DatabaseObserver> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<DatabaseObserver*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<DatabaseObserver*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<DatabaseObserver> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<DatabaseObserver*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<DatabaseObserver*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<DatabaseObserver> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<DatabaseObserver*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<DatabaseObserver*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<DatabaseObserver> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<DatabaseObserver*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<DatabaseObserver*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<DatabaseObserver> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<DatabaseObserver*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<DatabaseObserver*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<DatabaseObserver> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<DatabaseObserver*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<DatabaseObserver*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<DatabaseObserver> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<DatabaseObserver*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<DatabaseObserver*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<DatabaseObserver> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<DatabaseObserver*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<DatabaseObserver*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<DatabaseObserver> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<DatabaseObserver*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<DatabaseObserver*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class ReplicaSession : virtual public ::IceProxy::Ice::Object
{
public:

    void keepAlive()
    {
        keepAlive(0);
    }
    void keepAlive(const ::Ice::Context& __ctx)
    {
        keepAlive(&__ctx);
    }
    
private:

    void keepAlive(const ::Ice::Context*);
    
public:

    ::Ice::Int getTimeout()
    {
        return getTimeout(0);
    }
    ::Ice::Int getTimeout(const ::Ice::Context& __ctx)
    {
        return getTimeout(&__ctx);
    }
    
private:

    ::Ice::Int getTimeout(const ::Ice::Context*);
    
public:

    void setDatabaseObserver(const ::IceGrid::DatabaseObserverPrx& dbObs)
    {
        setDatabaseObserver(dbObs, 0);
    }
    void setDatabaseObserver(const ::IceGrid::DatabaseObserverPrx& dbObs, const ::Ice::Context& __ctx)
    {
        setDatabaseObserver(dbObs, &__ctx);
    }
    
private:

    void setDatabaseObserver(const ::IceGrid::DatabaseObserverPrx&, const ::Ice::Context*);
    
public:

    void setEndpoints(const ::IceGrid::StringObjectProxyDict& endpoints)
    {
        setEndpoints(endpoints, 0);
    }
    void setEndpoints(const ::IceGrid::StringObjectProxyDict& endpoints, const ::Ice::Context& __ctx)
    {
        setEndpoints(endpoints, &__ctx);
    }
    
private:

    void setEndpoints(const ::IceGrid::StringObjectProxyDict&, const ::Ice::Context*);
    
public:

    void registerWellKnownObjects(const ::IceGrid::ObjectInfoSeq& objects)
    {
        registerWellKnownObjects(objects, 0);
    }
    void registerWellKnownObjects(const ::IceGrid::ObjectInfoSeq& objects, const ::Ice::Context& __ctx)
    {
        registerWellKnownObjects(objects, &__ctx);
    }
    
private:

    void registerWellKnownObjects(const ::IceGrid::ObjectInfoSeq&, const ::Ice::Context*);
    
public:

    void setAdapterDirectProxy(const ::std::string& adapterId, const ::std::string& replicaGroupId, const ::Ice::ObjectPrx& proxy)
    {
        setAdapterDirectProxy(adapterId, replicaGroupId, proxy, 0);
    }
    void setAdapterDirectProxy(const ::std::string& adapterId, const ::std::string& replicaGroupId, const ::Ice::ObjectPrx& proxy, const ::Ice::Context& __ctx)
    {
        setAdapterDirectProxy(adapterId, replicaGroupId, proxy, &__ctx);
    }
    
private:

    void setAdapterDirectProxy(const ::std::string&, const ::std::string&, const ::Ice::ObjectPrx&, const ::Ice::Context*);
    
public:
    bool setAdapterDirectProxy_async(const ::IceGrid::AMI_ReplicaSession_setAdapterDirectProxyPtr&, const ::std::string&, const ::std::string&, const ::Ice::ObjectPrx&);
    bool setAdapterDirectProxy_async(const ::IceGrid::AMI_ReplicaSession_setAdapterDirectProxyPtr&, const ::std::string&, const ::std::string&, const ::Ice::ObjectPrx&, const ::Ice::Context&);

    void receivedUpdate(::IceGrid::TopicName name, ::Ice::Int serial, const ::std::string& failure)
    {
        receivedUpdate(name, serial, failure, 0);
    }
    void receivedUpdate(::IceGrid::TopicName name, ::Ice::Int serial, const ::std::string& failure, const ::Ice::Context& __ctx)
    {
        receivedUpdate(name, serial, failure, &__ctx);
    }
    
private:

    void receivedUpdate(::IceGrid::TopicName, ::Ice::Int, const ::std::string&, const ::Ice::Context*);
    
public:

    void destroy()
    {
        destroy(0);
    }
    void destroy(const ::Ice::Context& __ctx)
    {
        destroy(&__ctx);
    }
    
private:

    void destroy(const ::Ice::Context*);
    
public:
    
    ::IceInternal::ProxyHandle<ReplicaSession> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaSession*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<ReplicaSession*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaSession> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaSession*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<ReplicaSession*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaSession> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaSession*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<ReplicaSession*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaSession> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaSession*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<ReplicaSession*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaSession> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaSession*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<ReplicaSession*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaSession> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaSession*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<ReplicaSession*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaSession> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaSession*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<ReplicaSession*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaSession> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaSession*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<ReplicaSession*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaSession> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaSession*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<ReplicaSession*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaSession> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaSession*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<ReplicaSession*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaSession> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaSession*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<ReplicaSession*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaSession> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaSession*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<ReplicaSession*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaSession> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaSession*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<ReplicaSession*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaSession> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaSession*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<ReplicaSession*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaSession> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaSession*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<ReplicaSession*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaSession> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaSession*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<ReplicaSession*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaSession> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaSession*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<ReplicaSession*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaSession> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaSession*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<ReplicaSession*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaSession> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaSession*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<ReplicaSession*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class InternalNodeInfo : virtual public ::IceProxy::Ice::Object
{
public:
    
    ::IceInternal::ProxyHandle<InternalNodeInfo> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalNodeInfo*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<InternalNodeInfo*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalNodeInfo> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalNodeInfo*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<InternalNodeInfo*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalNodeInfo> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalNodeInfo*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<InternalNodeInfo*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalNodeInfo> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalNodeInfo*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<InternalNodeInfo*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalNodeInfo> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalNodeInfo*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<InternalNodeInfo*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalNodeInfo> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalNodeInfo*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<InternalNodeInfo*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalNodeInfo> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalNodeInfo*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<InternalNodeInfo*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalNodeInfo> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalNodeInfo*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<InternalNodeInfo*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalNodeInfo> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalNodeInfo*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<InternalNodeInfo*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalNodeInfo> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalNodeInfo*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<InternalNodeInfo*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalNodeInfo> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalNodeInfo*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<InternalNodeInfo*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalNodeInfo> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalNodeInfo*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<InternalNodeInfo*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalNodeInfo> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalNodeInfo*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<InternalNodeInfo*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalNodeInfo> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalNodeInfo*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<InternalNodeInfo*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalNodeInfo> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalNodeInfo*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<InternalNodeInfo*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalNodeInfo> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalNodeInfo*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<InternalNodeInfo*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalNodeInfo> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalNodeInfo*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<InternalNodeInfo*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalNodeInfo> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalNodeInfo*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<InternalNodeInfo*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalNodeInfo> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalNodeInfo*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<InternalNodeInfo*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class InternalReplicaInfo : virtual public ::IceProxy::Ice::Object
{
public:
    
    ::IceInternal::ProxyHandle<InternalReplicaInfo> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalReplicaInfo*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<InternalReplicaInfo*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalReplicaInfo> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalReplicaInfo*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<InternalReplicaInfo*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalReplicaInfo> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalReplicaInfo*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<InternalReplicaInfo*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalReplicaInfo> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalReplicaInfo*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<InternalReplicaInfo*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalReplicaInfo> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalReplicaInfo*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<InternalReplicaInfo*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalReplicaInfo> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalReplicaInfo*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<InternalReplicaInfo*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalReplicaInfo> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalReplicaInfo*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<InternalReplicaInfo*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalReplicaInfo> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalReplicaInfo*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<InternalReplicaInfo*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalReplicaInfo> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalReplicaInfo*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<InternalReplicaInfo*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalReplicaInfo> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalReplicaInfo*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<InternalReplicaInfo*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalReplicaInfo> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalReplicaInfo*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<InternalReplicaInfo*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalReplicaInfo> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalReplicaInfo*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<InternalReplicaInfo*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalReplicaInfo> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalReplicaInfo*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<InternalReplicaInfo*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalReplicaInfo> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalReplicaInfo*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<InternalReplicaInfo*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalReplicaInfo> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalReplicaInfo*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<InternalReplicaInfo*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalReplicaInfo> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalReplicaInfo*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<InternalReplicaInfo*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalReplicaInfo> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalReplicaInfo*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<InternalReplicaInfo*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalReplicaInfo> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalReplicaInfo*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<InternalReplicaInfo*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalReplicaInfo> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalReplicaInfo*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<InternalReplicaInfo*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class InternalRegistry : virtual public ::IceProxy::IceGrid::FileReader
{
public:

    ::IceGrid::NodeSessionPrx registerNode(const ::IceGrid::InternalNodeInfoPtr& info, const ::IceGrid::NodePrx& prx, const ::IceGrid::LoadInfo& loadInf)
    {
        return registerNode(info, prx, loadInf, 0);
    }
    ::IceGrid::NodeSessionPrx registerNode(const ::IceGrid::InternalNodeInfoPtr& info, const ::IceGrid::NodePrx& prx, const ::IceGrid::LoadInfo& loadInf, const ::Ice::Context& __ctx)
    {
        return registerNode(info, prx, loadInf, &__ctx);
    }
    
private:

    ::IceGrid::NodeSessionPrx registerNode(const ::IceGrid::InternalNodeInfoPtr&, const ::IceGrid::NodePrx&, const ::IceGrid::LoadInfo&, const ::Ice::Context*);
    
public:

    ::IceGrid::ReplicaSessionPrx registerReplica(const ::IceGrid::InternalReplicaInfoPtr& info, const ::IceGrid::InternalRegistryPrx& prx)
    {
        return registerReplica(info, prx, 0);
    }
    ::IceGrid::ReplicaSessionPrx registerReplica(const ::IceGrid::InternalReplicaInfoPtr& info, const ::IceGrid::InternalRegistryPrx& prx, const ::Ice::Context& __ctx)
    {
        return registerReplica(info, prx, &__ctx);
    }
    
private:

    ::IceGrid::ReplicaSessionPrx registerReplica(const ::IceGrid::InternalReplicaInfoPtr&, const ::IceGrid::InternalRegistryPrx&, const ::Ice::Context*);
    
public:

    void registerWithReplica(const ::IceGrid::InternalRegistryPrx& prx)
    {
        registerWithReplica(prx, 0);
    }
    void registerWithReplica(const ::IceGrid::InternalRegistryPrx& prx, const ::Ice::Context& __ctx)
    {
        registerWithReplica(prx, &__ctx);
    }
    
private:

    void registerWithReplica(const ::IceGrid::InternalRegistryPrx&, const ::Ice::Context*);
    
public:

    ::IceGrid::NodePrxSeq getNodes()
    {
        return getNodes(0);
    }
    ::IceGrid::NodePrxSeq getNodes(const ::Ice::Context& __ctx)
    {
        return getNodes(&__ctx);
    }
    
private:

    ::IceGrid::NodePrxSeq getNodes(const ::Ice::Context*);
    
public:

    ::IceGrid::InternalRegistryPrxSeq getReplicas()
    {
        return getReplicas(0);
    }
    ::IceGrid::InternalRegistryPrxSeq getReplicas(const ::Ice::Context& __ctx)
    {
        return getReplicas(&__ctx);
    }
    
private:

    ::IceGrid::InternalRegistryPrxSeq getReplicas(const ::Ice::Context*);
    
public:

    void shutdown()
    {
        shutdown(0);
    }
    void shutdown(const ::Ice::Context& __ctx)
    {
        shutdown(&__ctx);
    }
    
private:

    void shutdown(const ::Ice::Context*);
    
public:
    
    ::IceInternal::ProxyHandle<InternalRegistry> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalRegistry*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<InternalRegistry*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalRegistry> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalRegistry*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<InternalRegistry*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalRegistry> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalRegistry*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<InternalRegistry*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalRegistry> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalRegistry*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<InternalRegistry*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalRegistry> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalRegistry*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<InternalRegistry*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalRegistry> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalRegistry*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<InternalRegistry*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalRegistry> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalRegistry*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<InternalRegistry*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalRegistry> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalRegistry*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<InternalRegistry*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalRegistry> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalRegistry*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<InternalRegistry*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalRegistry> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalRegistry*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<InternalRegistry*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalRegistry> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalRegistry*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<InternalRegistry*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalRegistry> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalRegistry*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<InternalRegistry*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalRegistry> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalRegistry*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<InternalRegistry*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalRegistry> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalRegistry*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<InternalRegistry*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalRegistry> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalRegistry*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<InternalRegistry*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalRegistry> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalRegistry*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<InternalRegistry*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalRegistry> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalRegistry*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<InternalRegistry*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalRegistry> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalRegistry*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<InternalRegistry*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<InternalRegistry> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<InternalRegistry*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<InternalRegistry*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

}

}

namespace IceDelegate
{

namespace IceGrid
{

class InternalDbEnvDescriptor : virtual public ::IceDelegate::Ice::Object
{
public:
};

class InternalAdapterDescriptor : virtual public ::IceDelegate::Ice::Object
{
public:
};

class InternalDistributionDescriptor : virtual public ::IceDelegate::Ice::Object
{
public:
};

class InternalServerDescriptor : virtual public ::IceDelegate::Ice::Object
{
public:
};

class Adapter : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual ::Ice::ObjectPrx activate(const ::Ice::Context*) = 0;

    virtual ::Ice::ObjectPrx getDirectProxy(const ::Ice::Context*) = 0;

    virtual void setDirectProxy(const ::Ice::ObjectPrx&, const ::Ice::Context*) = 0;
};

class FileReader : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual ::Ice::Long getOffsetFromEnd(const ::std::string&, ::Ice::Int, const ::Ice::Context*) = 0;

    virtual bool read(const ::std::string&, ::Ice::Long, ::Ice::Int, ::Ice::Long&, ::Ice::StringSeq&, const ::Ice::Context*) = 0;
};

class Server : virtual public ::IceDelegate::IceGrid::FileReader
{
public:

    virtual void start(const ::Ice::Context*) = 0;

    virtual void stop(const ::Ice::Context*) = 0;

    virtual void setEnabled(bool, const ::Ice::Context*) = 0;

    virtual bool isEnabled(const ::Ice::Context*) = 0;

    virtual void sendSignal(const ::std::string&, const ::Ice::Context*) = 0;

    virtual void writeMessage(const ::std::string&, ::Ice::Int, const ::Ice::Context*) = 0;

    virtual ::IceGrid::ServerState getState(const ::Ice::Context*) = 0;

    virtual ::Ice::Int getPid(const ::Ice::Context*) = 0;

    virtual void setProcess(const ::Ice::ProcessPrx&, const ::Ice::Context*) = 0;
};

class ReplicaObserver : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual void replicaInit(const ::IceGrid::InternalRegistryPrxSeq&, const ::Ice::Context*) = 0;

    virtual void replicaAdded(const ::IceGrid::InternalRegistryPrx&, const ::Ice::Context*) = 0;

    virtual void replicaRemoved(const ::IceGrid::InternalRegistryPrx&, const ::Ice::Context*) = 0;
};

class PatcherFeedback : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual void finished(const ::Ice::Context*) = 0;

    virtual void failed(const ::std::string&, const ::Ice::Context*) = 0;
};

class Node : virtual public ::IceDelegate::IceGrid::FileReader,
             virtual public ::IceDelegate::IceGrid::ReplicaObserver
{
public:

    virtual ::IceGrid::ServerPrx loadServer(const ::IceGrid::InternalServerDescriptorPtr&, const ::std::string&, ::IceGrid::AdapterPrxDict&, ::Ice::Int&, ::Ice::Int&, const ::Ice::Context*) = 0;

    virtual void destroyServer(const ::std::string&, const ::std::string&, ::Ice::Int, const ::std::string&, const ::Ice::Context*) = 0;

    virtual void patch(const ::IceGrid::PatcherFeedbackPrx&, const ::std::string&, const ::std::string&, const ::IceGrid::InternalDistributionDescriptorPtr&, bool, const ::Ice::Context*) = 0;

    virtual void registerWithReplica(const ::IceGrid::InternalRegistryPrx&, const ::Ice::Context*) = 0;

    virtual ::std::string getName(const ::Ice::Context*) = 0;

    virtual ::std::string getHostname(const ::Ice::Context*) = 0;

    virtual ::IceGrid::LoadInfo getLoad(const ::Ice::Context*) = 0;

    virtual void shutdown(const ::Ice::Context*) = 0;
};

class NodeSession : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual void keepAlive(const ::IceGrid::LoadInfo&, const ::Ice::Context*) = 0;

    virtual void setReplicaObserver(const ::IceGrid::ReplicaObserverPrx&, const ::Ice::Context*) = 0;

    virtual ::Ice::Int getTimeout(const ::Ice::Context*) = 0;

    virtual ::IceGrid::NodeObserverPrx getObserver(const ::Ice::Context*) = 0;

    virtual void loadServers(const ::Ice::Context*) = 0;

    virtual ::Ice::StringSeq getServers(const ::Ice::Context*) = 0;

    virtual void waitForApplicationUpdate(const ::std::string&, ::Ice::Int, const ::Ice::Context*) = 0;

    virtual void destroy(const ::Ice::Context*) = 0;
};

class DatabaseObserver : virtual public ::IceDelegate::IceGrid::ApplicationObserver,
                         virtual public ::IceDelegate::IceGrid::ObjectObserver,
                         virtual public ::IceDelegate::IceGrid::AdapterObserver
{
public:
};

class ReplicaSession : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual void keepAlive(const ::Ice::Context*) = 0;

    virtual ::Ice::Int getTimeout(const ::Ice::Context*) = 0;

    virtual void setDatabaseObserver(const ::IceGrid::DatabaseObserverPrx&, const ::Ice::Context*) = 0;

    virtual void setEndpoints(const ::IceGrid::StringObjectProxyDict&, const ::Ice::Context*) = 0;

    virtual void registerWellKnownObjects(const ::IceGrid::ObjectInfoSeq&, const ::Ice::Context*) = 0;

    virtual void setAdapterDirectProxy(const ::std::string&, const ::std::string&, const ::Ice::ObjectPrx&, const ::Ice::Context*) = 0;

    virtual void receivedUpdate(::IceGrid::TopicName, ::Ice::Int, const ::std::string&, const ::Ice::Context*) = 0;

    virtual void destroy(const ::Ice::Context*) = 0;
};

class InternalNodeInfo : virtual public ::IceDelegate::Ice::Object
{
public:
};

class InternalReplicaInfo : virtual public ::IceDelegate::Ice::Object
{
public:
};

class InternalRegistry : virtual public ::IceDelegate::IceGrid::FileReader
{
public:

    virtual ::IceGrid::NodeSessionPrx registerNode(const ::IceGrid::InternalNodeInfoPtr&, const ::IceGrid::NodePrx&, const ::IceGrid::LoadInfo&, const ::Ice::Context*) = 0;

    virtual ::IceGrid::ReplicaSessionPrx registerReplica(const ::IceGrid::InternalReplicaInfoPtr&, const ::IceGrid::InternalRegistryPrx&, const ::Ice::Context*) = 0;

    virtual void registerWithReplica(const ::IceGrid::InternalRegistryPrx&, const ::Ice::Context*) = 0;

    virtual ::IceGrid::NodePrxSeq getNodes(const ::Ice::Context*) = 0;

    virtual ::IceGrid::InternalRegistryPrxSeq getReplicas(const ::Ice::Context*) = 0;

    virtual void shutdown(const ::Ice::Context*) = 0;
};

}

}

namespace IceDelegateM
{

namespace IceGrid
{

class InternalDbEnvDescriptor : virtual public ::IceDelegate::IceGrid::InternalDbEnvDescriptor,
                                virtual public ::IceDelegateM::Ice::Object
{
public:
};

class InternalAdapterDescriptor : virtual public ::IceDelegate::IceGrid::InternalAdapterDescriptor,
                                  virtual public ::IceDelegateM::Ice::Object
{
public:
};

class InternalDistributionDescriptor : virtual public ::IceDelegate::IceGrid::InternalDistributionDescriptor,
                                       virtual public ::IceDelegateM::Ice::Object
{
public:
};

class InternalServerDescriptor : virtual public ::IceDelegate::IceGrid::InternalServerDescriptor,
                                 virtual public ::IceDelegateM::Ice::Object
{
public:
};

class Adapter : virtual public ::IceDelegate::IceGrid::Adapter,
                virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual ::Ice::ObjectPrx activate(const ::Ice::Context*);

    virtual ::Ice::ObjectPrx getDirectProxy(const ::Ice::Context*);

    virtual void setDirectProxy(const ::Ice::ObjectPrx&, const ::Ice::Context*);
};

class FileReader : virtual public ::IceDelegate::IceGrid::FileReader,
                   virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual ::Ice::Long getOffsetFromEnd(const ::std::string&, ::Ice::Int, const ::Ice::Context*);

    virtual bool read(const ::std::string&, ::Ice::Long, ::Ice::Int, ::Ice::Long&, ::Ice::StringSeq&, const ::Ice::Context*);
};

class Server : virtual public ::IceDelegate::IceGrid::Server,
               virtual public ::IceDelegateM::IceGrid::FileReader
{
public:

    virtual void start(const ::Ice::Context*);

    virtual void stop(const ::Ice::Context*);

    virtual void setEnabled(bool, const ::Ice::Context*);

    virtual bool isEnabled(const ::Ice::Context*);

    virtual void sendSignal(const ::std::string&, const ::Ice::Context*);

    virtual void writeMessage(const ::std::string&, ::Ice::Int, const ::Ice::Context*);

    virtual ::IceGrid::ServerState getState(const ::Ice::Context*);

    virtual ::Ice::Int getPid(const ::Ice::Context*);

    virtual void setProcess(const ::Ice::ProcessPrx&, const ::Ice::Context*);
};

class ReplicaObserver : virtual public ::IceDelegate::IceGrid::ReplicaObserver,
                        virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual void replicaInit(const ::IceGrid::InternalRegistryPrxSeq&, const ::Ice::Context*);

    virtual void replicaAdded(const ::IceGrid::InternalRegistryPrx&, const ::Ice::Context*);

    virtual void replicaRemoved(const ::IceGrid::InternalRegistryPrx&, const ::Ice::Context*);
};

class PatcherFeedback : virtual public ::IceDelegate::IceGrid::PatcherFeedback,
                        virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual void finished(const ::Ice::Context*);

    virtual void failed(const ::std::string&, const ::Ice::Context*);
};

class Node : virtual public ::IceDelegate::IceGrid::Node,
             virtual public ::IceDelegateM::IceGrid::FileReader,
             virtual public ::IceDelegateM::IceGrid::ReplicaObserver
{
public:

    virtual ::IceGrid::ServerPrx loadServer(const ::IceGrid::InternalServerDescriptorPtr&, const ::std::string&, ::IceGrid::AdapterPrxDict&, ::Ice::Int&, ::Ice::Int&, const ::Ice::Context*);

    virtual void destroyServer(const ::std::string&, const ::std::string&, ::Ice::Int, const ::std::string&, const ::Ice::Context*);

    virtual void patch(const ::IceGrid::PatcherFeedbackPrx&, const ::std::string&, const ::std::string&, const ::IceGrid::InternalDistributionDescriptorPtr&, bool, const ::Ice::Context*);

    virtual void registerWithReplica(const ::IceGrid::InternalRegistryPrx&, const ::Ice::Context*);

    virtual ::std::string getName(const ::Ice::Context*);

    virtual ::std::string getHostname(const ::Ice::Context*);

    virtual ::IceGrid::LoadInfo getLoad(const ::Ice::Context*);

    virtual void shutdown(const ::Ice::Context*);
};

class NodeSession : virtual public ::IceDelegate::IceGrid::NodeSession,
                    virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual void keepAlive(const ::IceGrid::LoadInfo&, const ::Ice::Context*);

    virtual void setReplicaObserver(const ::IceGrid::ReplicaObserverPrx&, const ::Ice::Context*);

    virtual ::Ice::Int getTimeout(const ::Ice::Context*);

    virtual ::IceGrid::NodeObserverPrx getObserver(const ::Ice::Context*);

    virtual void loadServers(const ::Ice::Context*);

    virtual ::Ice::StringSeq getServers(const ::Ice::Context*);

    virtual void waitForApplicationUpdate(const ::std::string&, ::Ice::Int, const ::Ice::Context*);

    virtual void destroy(const ::Ice::Context*);
};

class DatabaseObserver : virtual public ::IceDelegate::IceGrid::DatabaseObserver,
                         virtual public ::IceDelegateM::IceGrid::ApplicationObserver,
                         virtual public ::IceDelegateM::IceGrid::ObjectObserver,
                         virtual public ::IceDelegateM::IceGrid::AdapterObserver
{
public:
};

class ReplicaSession : virtual public ::IceDelegate::IceGrid::ReplicaSession,
                       virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual void keepAlive(const ::Ice::Context*);

    virtual ::Ice::Int getTimeout(const ::Ice::Context*);

    virtual void setDatabaseObserver(const ::IceGrid::DatabaseObserverPrx&, const ::Ice::Context*);

    virtual void setEndpoints(const ::IceGrid::StringObjectProxyDict&, const ::Ice::Context*);

    virtual void registerWellKnownObjects(const ::IceGrid::ObjectInfoSeq&, const ::Ice::Context*);

    virtual void setAdapterDirectProxy(const ::std::string&, const ::std::string&, const ::Ice::ObjectPrx&, const ::Ice::Context*);

    virtual void receivedUpdate(::IceGrid::TopicName, ::Ice::Int, const ::std::string&, const ::Ice::Context*);

    virtual void destroy(const ::Ice::Context*);
};

class InternalNodeInfo : virtual public ::IceDelegate::IceGrid::InternalNodeInfo,
                         virtual public ::IceDelegateM::Ice::Object
{
public:
};

class InternalReplicaInfo : virtual public ::IceDelegate::IceGrid::InternalReplicaInfo,
                            virtual public ::IceDelegateM::Ice::Object
{
public:
};

class InternalRegistry : virtual public ::IceDelegate::IceGrid::InternalRegistry,
                         virtual public ::IceDelegateM::IceGrid::FileReader
{
public:

    virtual ::IceGrid::NodeSessionPrx registerNode(const ::IceGrid::InternalNodeInfoPtr&, const ::IceGrid::NodePrx&, const ::IceGrid::LoadInfo&, const ::Ice::Context*);

    virtual ::IceGrid::ReplicaSessionPrx registerReplica(const ::IceGrid::InternalReplicaInfoPtr&, const ::IceGrid::InternalRegistryPrx&, const ::Ice::Context*);

    virtual void registerWithReplica(const ::IceGrid::InternalRegistryPrx&, const ::Ice::Context*);

    virtual ::IceGrid::NodePrxSeq getNodes(const ::Ice::Context*);

    virtual ::IceGrid::InternalRegistryPrxSeq getReplicas(const ::Ice::Context*);

    virtual void shutdown(const ::Ice::Context*);
};

}

}

namespace IceDelegateD
{

namespace IceGrid
{

class InternalDbEnvDescriptor : virtual public ::IceDelegate::IceGrid::InternalDbEnvDescriptor,
                                virtual public ::IceDelegateD::Ice::Object
{
public:
};

class InternalAdapterDescriptor : virtual public ::IceDelegate::IceGrid::InternalAdapterDescriptor,
                                  virtual public ::IceDelegateD::Ice::Object
{
public:
};

class InternalDistributionDescriptor : virtual public ::IceDelegate::IceGrid::InternalDistributionDescriptor,
                                       virtual public ::IceDelegateD::Ice::Object
{
public:
};

class InternalServerDescriptor : virtual public ::IceDelegate::IceGrid::InternalServerDescriptor,
                                 virtual public ::IceDelegateD::Ice::Object
{
public:
};

class Adapter : virtual public ::IceDelegate::IceGrid::Adapter,
                virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual ::Ice::ObjectPrx activate(const ::Ice::Context*);

    virtual ::Ice::ObjectPrx getDirectProxy(const ::Ice::Context*);

    virtual void setDirectProxy(const ::Ice::ObjectPrx&, const ::Ice::Context*);
};

class FileReader : virtual public ::IceDelegate::IceGrid::FileReader,
                   virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual ::Ice::Long getOffsetFromEnd(const ::std::string&, ::Ice::Int, const ::Ice::Context*);

    virtual bool read(const ::std::string&, ::Ice::Long, ::Ice::Int, ::Ice::Long&, ::Ice::StringSeq&, const ::Ice::Context*);
};

class Server : virtual public ::IceDelegate::IceGrid::Server,
               virtual public ::IceDelegateD::IceGrid::FileReader
{
public:

    virtual void start(const ::Ice::Context*);

    virtual void stop(const ::Ice::Context*);

    virtual void setEnabled(bool, const ::Ice::Context*);

    virtual bool isEnabled(const ::Ice::Context*);

    virtual void sendSignal(const ::std::string&, const ::Ice::Context*);

    virtual void writeMessage(const ::std::string&, ::Ice::Int, const ::Ice::Context*);

    virtual ::IceGrid::ServerState getState(const ::Ice::Context*);

    virtual ::Ice::Int getPid(const ::Ice::Context*);

    virtual void setProcess(const ::Ice::ProcessPrx&, const ::Ice::Context*);
};

class ReplicaObserver : virtual public ::IceDelegate::IceGrid::ReplicaObserver,
                        virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual void replicaInit(const ::IceGrid::InternalRegistryPrxSeq&, const ::Ice::Context*);

    virtual void replicaAdded(const ::IceGrid::InternalRegistryPrx&, const ::Ice::Context*);

    virtual void replicaRemoved(const ::IceGrid::InternalRegistryPrx&, const ::Ice::Context*);
};

class PatcherFeedback : virtual public ::IceDelegate::IceGrid::PatcherFeedback,
                        virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual void finished(const ::Ice::Context*);

    virtual void failed(const ::std::string&, const ::Ice::Context*);
};

class Node : virtual public ::IceDelegate::IceGrid::Node,
             virtual public ::IceDelegateD::IceGrid::FileReader,
             virtual public ::IceDelegateD::IceGrid::ReplicaObserver
{
public:

    virtual ::IceGrid::ServerPrx loadServer(const ::IceGrid::InternalServerDescriptorPtr&, const ::std::string&, ::IceGrid::AdapterPrxDict&, ::Ice::Int&, ::Ice::Int&, const ::Ice::Context*);

    virtual void destroyServer(const ::std::string&, const ::std::string&, ::Ice::Int, const ::std::string&, const ::Ice::Context*);

    virtual void patch(const ::IceGrid::PatcherFeedbackPrx&, const ::std::string&, const ::std::string&, const ::IceGrid::InternalDistributionDescriptorPtr&, bool, const ::Ice::Context*);

    virtual void registerWithReplica(const ::IceGrid::InternalRegistryPrx&, const ::Ice::Context*);

    virtual ::std::string getName(const ::Ice::Context*);

    virtual ::std::string getHostname(const ::Ice::Context*);

    virtual ::IceGrid::LoadInfo getLoad(const ::Ice::Context*);

    virtual void shutdown(const ::Ice::Context*);
};

class NodeSession : virtual public ::IceDelegate::IceGrid::NodeSession,
                    virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual void keepAlive(const ::IceGrid::LoadInfo&, const ::Ice::Context*);

    virtual void setReplicaObserver(const ::IceGrid::ReplicaObserverPrx&, const ::Ice::Context*);

    virtual ::Ice::Int getTimeout(const ::Ice::Context*);

    virtual ::IceGrid::NodeObserverPrx getObserver(const ::Ice::Context*);

    virtual void loadServers(const ::Ice::Context*);

    virtual ::Ice::StringSeq getServers(const ::Ice::Context*);

    virtual void waitForApplicationUpdate(const ::std::string&, ::Ice::Int, const ::Ice::Context*);

    virtual void destroy(const ::Ice::Context*);
};

class DatabaseObserver : virtual public ::IceDelegate::IceGrid::DatabaseObserver,
                         virtual public ::IceDelegateD::IceGrid::ApplicationObserver,
                         virtual public ::IceDelegateD::IceGrid::ObjectObserver,
                         virtual public ::IceDelegateD::IceGrid::AdapterObserver
{
public:
};

class ReplicaSession : virtual public ::IceDelegate::IceGrid::ReplicaSession,
                       virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual void keepAlive(const ::Ice::Context*);

    virtual ::Ice::Int getTimeout(const ::Ice::Context*);

    virtual void setDatabaseObserver(const ::IceGrid::DatabaseObserverPrx&, const ::Ice::Context*);

    virtual void setEndpoints(const ::IceGrid::StringObjectProxyDict&, const ::Ice::Context*);

    virtual void registerWellKnownObjects(const ::IceGrid::ObjectInfoSeq&, const ::Ice::Context*);

    virtual void setAdapterDirectProxy(const ::std::string&, const ::std::string&, const ::Ice::ObjectPrx&, const ::Ice::Context*);

    virtual void receivedUpdate(::IceGrid::TopicName, ::Ice::Int, const ::std::string&, const ::Ice::Context*);

    virtual void destroy(const ::Ice::Context*);
};

class InternalNodeInfo : virtual public ::IceDelegate::IceGrid::InternalNodeInfo,
                         virtual public ::IceDelegateD::Ice::Object
{
public:
};

class InternalReplicaInfo : virtual public ::IceDelegate::IceGrid::InternalReplicaInfo,
                            virtual public ::IceDelegateD::Ice::Object
{
public:
};

class InternalRegistry : virtual public ::IceDelegate::IceGrid::InternalRegistry,
                         virtual public ::IceDelegateD::IceGrid::FileReader
{
public:

    virtual ::IceGrid::NodeSessionPrx registerNode(const ::IceGrid::InternalNodeInfoPtr&, const ::IceGrid::NodePrx&, const ::IceGrid::LoadInfo&, const ::Ice::Context*);

    virtual ::IceGrid::ReplicaSessionPrx registerReplica(const ::IceGrid::InternalReplicaInfoPtr&, const ::IceGrid::InternalRegistryPrx&, const ::Ice::Context*);

    virtual void registerWithReplica(const ::IceGrid::InternalRegistryPrx&, const ::Ice::Context*);

    virtual ::IceGrid::NodePrxSeq getNodes(const ::Ice::Context*);

    virtual ::IceGrid::InternalRegistryPrxSeq getReplicas(const ::Ice::Context*);

    virtual void shutdown(const ::Ice::Context*);
};

}

}

namespace IceGrid
{

class InternalDbEnvDescriptor : virtual public ::Ice::Object
{
public:

    typedef InternalDbEnvDescriptorPrx ProxyType;
    typedef InternalDbEnvDescriptorPtr PointerType;
    
    InternalDbEnvDescriptor() {}
    InternalDbEnvDescriptor(const ::std::string&, const ::IceGrid::PropertyDescriptorSeq&);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();


    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);

    static const ::Ice::ObjectFactoryPtr& ice_factory();

protected:

    virtual ~InternalDbEnvDescriptor() {}

    friend class InternalDbEnvDescriptor__staticInit;

public:

    ::std::string name;

    ::IceGrid::PropertyDescriptorSeq properties;
};

class InternalDbEnvDescriptor__staticInit
{
public:

    ::IceGrid::InternalDbEnvDescriptor _init;
};

static InternalDbEnvDescriptor__staticInit _InternalDbEnvDescriptor_init;

class InternalAdapterDescriptor : virtual public ::Ice::Object
{
public:

    typedef InternalAdapterDescriptorPrx ProxyType;
    typedef InternalAdapterDescriptorPtr PointerType;
    
    InternalAdapterDescriptor() {}
    InternalAdapterDescriptor(const ::std::string&, bool);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();


    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);

    static const ::Ice::ObjectFactoryPtr& ice_factory();

protected:

    virtual ~InternalAdapterDescriptor() {}

public:

    ::std::string id;

    bool serverLifetime;
};

class InternalDistributionDescriptor : virtual public ::Ice::Object
{
public:

    typedef InternalDistributionDescriptorPrx ProxyType;
    typedef InternalDistributionDescriptorPtr PointerType;
    
    InternalDistributionDescriptor() {}
    InternalDistributionDescriptor(const ::std::string&, const ::Ice::StringSeq&);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();


    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);

    static const ::Ice::ObjectFactoryPtr& ice_factory();

protected:

    virtual ~InternalDistributionDescriptor() {}

public:

    ::std::string icepatch;

    ::Ice::StringSeq directories;
};

class InternalServerDescriptor : virtual public ::Ice::Object
{
public:

    typedef InternalServerDescriptorPrx ProxyType;
    typedef InternalServerDescriptorPtr PointerType;
    
    InternalServerDescriptor() {}
    InternalServerDescriptor(const ::std::string&, const ::std::string&, const ::std::string&, ::Ice::Int, const ::std::string&, const ::std::string&, const ::std::string&, const ::std::string&, const ::std::string&, const ::std::string&, const ::std::string&, bool, const ::IceGrid::InternalDistributionDescriptorPtr&, bool, const ::Ice::StringSeq&, const ::Ice::StringSeq&, const ::Ice::StringSeq&, const ::IceGrid::InternalAdapterDescriptorSeq&, const ::IceGrid::InternalDbEnvDescriptorSeq&, const ::IceGrid::PropertyDescriptorSeqDict&);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void __incRef();
    virtual void __decRef();
    virtual void __addObject(::IceInternal::GCCountMap&);
    virtual bool __usesClasses();
    virtual void __gcReachable(::IceInternal::GCCountMap&) const;
    virtual void __gcClear();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);

    static const ::Ice::ObjectFactoryPtr& ice_factory();

protected:

    virtual ~InternalServerDescriptor() {}

public:

    ::std::string id;

    ::std::string application;

    ::std::string uuid;

    ::Ice::Int revision;

    ::std::string sessionId;

    ::std::string exe;

    ::std::string pwd;

    ::std::string user;

    ::std::string activation;

    ::std::string activationTimeout;

    ::std::string deactivationTimeout;

    bool applicationDistrib;

    ::IceGrid::InternalDistributionDescriptorPtr distrib;

    bool processRegistered;

    ::Ice::StringSeq options;

    ::Ice::StringSeq envs;

    ::Ice::StringSeq logs;

    ::IceGrid::InternalAdapterDescriptorSeq adapters;

    ::IceGrid::InternalDbEnvDescriptorSeq dbEnvs;

    ::IceGrid::PropertyDescriptorSeqDict properties;
};

class Adapter : virtual public ::Ice::Object
{
public:

    typedef AdapterPrx ProxyType;
    typedef AdapterPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void activate_async(const ::IceGrid::AMD_Adapter_activatePtr&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___activate(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::ObjectPrx getDirectProxy(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::Ice::DispatchStatus ___getDirectProxy(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual void setDirectProxy(const ::Ice::ObjectPrx&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___setDirectProxy(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class FileReader : virtual public ::Ice::Object
{
public:

    typedef FileReaderPrx ProxyType;
    typedef FileReaderPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::Ice::Long getOffsetFromEnd(const ::std::string&, ::Ice::Int, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::Ice::DispatchStatus ___getOffsetFromEnd(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual bool read(const ::std::string&, ::Ice::Long, ::Ice::Int, ::Ice::Long&, ::Ice::StringSeq&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::Ice::DispatchStatus ___read(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class Server : virtual public ::IceGrid::FileReader
{
public:

    typedef ServerPrx ProxyType;
    typedef ServerPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void start_async(const ::IceGrid::AMD_Server_startPtr&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___start(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void stop_async(const ::IceGrid::AMD_Server_stopPtr&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___stop(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void setEnabled(bool, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___setEnabled(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual bool isEnabled(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::Ice::DispatchStatus ___isEnabled(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual void sendSignal(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___sendSignal(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void writeMessage(const ::std::string&, ::Ice::Int, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___writeMessage(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceGrid::ServerState getState(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::Ice::DispatchStatus ___getState(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::Ice::Int getPid(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::Ice::DispatchStatus ___getPid(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual void setProcess_async(const ::IceGrid::AMD_Server_setProcessPtr&, const ::Ice::ProcessPrx&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___setProcess(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class ReplicaObserver : virtual public ::Ice::Object
{
public:

    typedef ReplicaObserverPrx ProxyType;
    typedef ReplicaObserverPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void replicaInit(const ::IceGrid::InternalRegistryPrxSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___replicaInit(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void replicaAdded(const ::IceGrid::InternalRegistryPrx&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___replicaAdded(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void replicaRemoved(const ::IceGrid::InternalRegistryPrx&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___replicaRemoved(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class PatcherFeedback : virtual public ::Ice::Object
{
public:

    typedef PatcherFeedbackPrx ProxyType;
    typedef PatcherFeedbackPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void finished(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___finished(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void failed(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___failed(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class Node : virtual public ::IceGrid::FileReader,
             virtual public ::IceGrid::ReplicaObserver
{
public:

    typedef NodePrx ProxyType;
    typedef NodePtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void loadServer_async(const ::IceGrid::AMD_Node_loadServerPtr&, const ::IceGrid::InternalServerDescriptorPtr&, const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___loadServer(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void destroyServer_async(const ::IceGrid::AMD_Node_destroyServerPtr&, const ::std::string&, const ::std::string&, ::Ice::Int, const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___destroyServer(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void patch_async(const ::IceGrid::AMD_Node_patchPtr&, const ::IceGrid::PatcherFeedbackPrx&, const ::std::string&, const ::std::string&, const ::IceGrid::InternalDistributionDescriptorPtr&, bool, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___patch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void registerWithReplica(const ::IceGrid::InternalRegistryPrx&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___registerWithReplica(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::std::string getName(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::Ice::DispatchStatus ___getName(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::std::string getHostname(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::Ice::DispatchStatus ___getHostname(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::IceGrid::LoadInfo getLoad(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::Ice::DispatchStatus ___getLoad(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual void shutdown(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::Ice::DispatchStatus ___shutdown(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class NodeSession : virtual public ::Ice::Object
{
public:

    typedef NodeSessionPrx ProxyType;
    typedef NodeSessionPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void keepAlive(const ::IceGrid::LoadInfo&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___keepAlive(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void setReplicaObserver(const ::IceGrid::ReplicaObserverPrx&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___setReplicaObserver(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::Int getTimeout(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::Ice::DispatchStatus ___getTimeout(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::IceGrid::NodeObserverPrx getObserver(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::Ice::DispatchStatus ___getObserver(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual void loadServers_async(const ::IceGrid::AMD_NodeSession_loadServersPtr&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::Ice::DispatchStatus ___loadServers(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::Ice::StringSeq getServers(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::Ice::DispatchStatus ___getServers(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual void waitForApplicationUpdate_async(const ::IceGrid::AMD_NodeSession_waitForApplicationUpdatePtr&, const ::std::string&, ::Ice::Int, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::Ice::DispatchStatus ___waitForApplicationUpdate(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual void destroy(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___destroy(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class DatabaseObserver : virtual public ::IceGrid::ApplicationObserver,
                         virtual public ::IceGrid::ObjectObserver,
                         virtual public ::IceGrid::AdapterObserver
{
public:

    typedef DatabaseObserverPrx ProxyType;
    typedef DatabaseObserverPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class ReplicaSession : virtual public ::Ice::Object
{
public:

    typedef ReplicaSessionPrx ProxyType;
    typedef ReplicaSessionPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void keepAlive(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___keepAlive(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::Int getTimeout(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::Ice::DispatchStatus ___getTimeout(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual void setDatabaseObserver(const ::IceGrid::DatabaseObserverPrx&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___setDatabaseObserver(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void setEndpoints(const ::IceGrid::StringObjectProxyDict&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___setEndpoints(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void registerWellKnownObjects(const ::IceGrid::ObjectInfoSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___registerWellKnownObjects(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void setAdapterDirectProxy(const ::std::string&, const ::std::string&, const ::Ice::ObjectPrx&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___setAdapterDirectProxy(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void receivedUpdate(::IceGrid::TopicName, ::Ice::Int, const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___receivedUpdate(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void destroy(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___destroy(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class InternalNodeInfo : virtual public ::Ice::Object
{
public:

    typedef InternalNodeInfoPrx ProxyType;
    typedef InternalNodeInfoPtr PointerType;
    
    InternalNodeInfo() {}
    InternalNodeInfo(const ::std::string&, const ::std::string&, const ::std::string&, const ::std::string&, const ::std::string&, const ::std::string&, ::Ice::Int, const ::std::string&);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();


    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);

    static const ::Ice::ObjectFactoryPtr& ice_factory();

protected:

    virtual ~InternalNodeInfo() {}

public:

    ::std::string name;

    ::std::string os;

    ::std::string hostname;

    ::std::string release;

    ::std::string version;

    ::std::string machine;

    ::Ice::Int nProcessors;

    ::std::string dataDir;
};

class InternalReplicaInfo : virtual public ::Ice::Object
{
public:

    typedef InternalReplicaInfoPrx ProxyType;
    typedef InternalReplicaInfoPtr PointerType;
    
    InternalReplicaInfo() {}
    InternalReplicaInfo(const ::std::string&, const ::std::string&);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();


    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);

    static const ::Ice::ObjectFactoryPtr& ice_factory();

protected:

    virtual ~InternalReplicaInfo() {}

public:

    ::std::string name;

    ::std::string hostname;
};

class InternalRegistry : virtual public ::IceGrid::FileReader
{
public:

    typedef InternalRegistryPrx ProxyType;
    typedef InternalRegistryPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::IceGrid::NodeSessionPrx registerNode(const ::IceGrid::InternalNodeInfoPtr&, const ::IceGrid::NodePrx&, const ::IceGrid::LoadInfo&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___registerNode(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceGrid::ReplicaSessionPrx registerReplica(const ::IceGrid::InternalReplicaInfoPtr&, const ::IceGrid::InternalRegistryPrx&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___registerReplica(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void registerWithReplica(const ::IceGrid::InternalRegistryPrx&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___registerWithReplica(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceGrid::NodePrxSeq getNodes(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::Ice::DispatchStatus ___getNodes(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::IceGrid::InternalRegistryPrxSeq getReplicas(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::Ice::DispatchStatus ___getReplicas(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual void shutdown(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::Ice::DispatchStatus ___shutdown(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

}

#endif
