// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `Election.ice'

#ifndef __IceStorm_Election_h__
#define __IceStorm_Election_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/OutgoingAsync.h>
#include <Ice/Incoming.h>
#include <Ice/Direct.h>
#include <Ice/UserExceptionFactory.h>
#include <Ice/FactoryTable.h>
#include <Ice/StreamF.h>
#include <Ice/Identity.h>
#include <Ice/BuiltinSequences.h>
#include <IceStorm/SubscriberRecord.h>
#include <Ice/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

namespace IceProxy
{

namespace IceStormElection
{

class ReplicaObserver;

class TopicManagerSync;

class Node;

}

}

namespace IceStormElection
{

class ReplicaObserver;
bool operator==(const ReplicaObserver&, const ReplicaObserver&);
bool operator<(const ReplicaObserver&, const ReplicaObserver&);

class TopicManagerSync;
bool operator==(const TopicManagerSync&, const TopicManagerSync&);
bool operator<(const TopicManagerSync&, const TopicManagerSync&);

class Node;
bool operator==(const Node&, const Node&);
bool operator<(const Node&, const Node&);

}

namespace IceInternal
{

::Ice::Object* upCast(::IceStormElection::ReplicaObserver*);
::IceProxy::Ice::Object* upCast(::IceProxy::IceStormElection::ReplicaObserver*);

::Ice::Object* upCast(::IceStormElection::TopicManagerSync*);
::IceProxy::Ice::Object* upCast(::IceProxy::IceStormElection::TopicManagerSync*);

::Ice::Object* upCast(::IceStormElection::Node*);
::IceProxy::Ice::Object* upCast(::IceProxy::IceStormElection::Node*);

}

namespace IceStormElection
{

typedef ::IceInternal::Handle< ::IceStormElection::ReplicaObserver> ReplicaObserverPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceStormElection::ReplicaObserver> ReplicaObserverPrx;

void __read(::IceInternal::BasicStream*, ReplicaObserverPrx&);
void __patch__ReplicaObserverPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IceStormElection::TopicManagerSync> TopicManagerSyncPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceStormElection::TopicManagerSync> TopicManagerSyncPrx;

void __read(::IceInternal::BasicStream*, TopicManagerSyncPrx&);
void __patch__TopicManagerSyncPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IceStormElection::Node> NodePtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceStormElection::Node> NodePrx;

void __read(::IceInternal::BasicStream*, NodePrx&);
void __patch__NodePtr(void*, ::Ice::ObjectPtr&);

}

namespace IceStormElection
{

struct LogUpdate
{
    ::Ice::Long generation;
    ::Ice::Long iteration;

    bool operator==(const LogUpdate&) const;
    bool operator<(const LogUpdate&) const;
    bool operator!=(const LogUpdate& __rhs) const
    {
        return !operator==(__rhs);
    }
    bool operator<=(const LogUpdate& __rhs) const
    {
        return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const LogUpdate& __rhs) const
    {
        return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const LogUpdate& __rhs) const
    {
        return !operator<(__rhs);
    }

    void __write(::IceInternal::BasicStream*) const;
    void __read(::IceInternal::BasicStream*);
};

struct TopicContent
{
    ::Ice::Identity id;
    ::IceStorm::SubscriberRecordSeq records;

    bool operator==(const TopicContent&) const;
    bool operator<(const TopicContent&) const;
    bool operator!=(const TopicContent& __rhs) const
    {
        return !operator==(__rhs);
    }
    bool operator<=(const TopicContent& __rhs) const
    {
        return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const TopicContent& __rhs) const
    {
        return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const TopicContent& __rhs) const
    {
        return !operator<(__rhs);
    }

    void __write(::IceInternal::BasicStream*) const;
    void __read(::IceInternal::BasicStream*);
};

typedef ::std::vector< ::IceStormElection::TopicContent> TopicContentSeq;
void __writeTopicContentSeq(::IceInternal::BasicStream*, const ::IceStormElection::TopicContent*, const ::IceStormElection::TopicContent*);
void __readTopicContentSeq(::IceInternal::BasicStream*, TopicContentSeq&);

class ObserverInconsistencyException : public ::Ice::UserException
{
public:

    ObserverInconsistencyException() {}
    explicit ObserverInconsistencyException(const ::std::string&);
    virtual ~ObserverInconsistencyException() throw();

    virtual ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    ::std::string reason;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

static ObserverInconsistencyException __ObserverInconsistencyException_init;

enum NodeState
{
    NodeStateInactive,
    NodeStateElection,
    NodeStateReorganization,
    NodeStateNormal
};

void __write(::IceInternal::BasicStream*, NodeState);
void __read(::IceInternal::BasicStream*, NodeState&);

struct NodeInfo
{
    ::Ice::Int id;
    ::IceStormElection::NodePrx n;

    bool operator==(const NodeInfo&) const;
    bool operator<(const NodeInfo&) const;
    bool operator!=(const NodeInfo& __rhs) const
    {
        return !operator==(__rhs);
    }
    bool operator<=(const NodeInfo& __rhs) const
    {
        return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const NodeInfo& __rhs) const
    {
        return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const NodeInfo& __rhs) const
    {
        return !operator<(__rhs);
    }

    void __write(::IceInternal::BasicStream*) const;
    void __read(::IceInternal::BasicStream*);
};

typedef ::std::vector< ::IceStormElection::NodeInfo> NodeInfoSeq;
void __writeNodeInfoSeq(::IceInternal::BasicStream*, const ::IceStormElection::NodeInfo*, const ::IceStormElection::NodeInfo*);
void __readNodeInfoSeq(::IceInternal::BasicStream*, NodeInfoSeq&);

struct GroupInfo
{
    ::Ice::Int id;
    ::IceStormElection::LogUpdate llu;

    bool operator==(const GroupInfo&) const;
    bool operator<(const GroupInfo&) const;
    bool operator!=(const GroupInfo& __rhs) const
    {
        return !operator==(__rhs);
    }
    bool operator<=(const GroupInfo& __rhs) const
    {
        return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const GroupInfo& __rhs) const
    {
        return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const GroupInfo& __rhs) const
    {
        return !operator<(__rhs);
    }

    void __write(::IceInternal::BasicStream*) const;
    void __read(::IceInternal::BasicStream*);
};

typedef ::std::vector< ::IceStormElection::GroupInfo> GroupInfoSeq;
void __writeGroupInfoSeq(::IceInternal::BasicStream*, const ::IceStormElection::GroupInfo*, const ::IceStormElection::GroupInfo*);
void __readGroupInfoSeq(::IceInternal::BasicStream*, GroupInfoSeq&);

struct QueryInfo
{
    ::Ice::Int id;
    ::Ice::Int coord;
    ::std::string group;
    ::Ice::ObjectPrx replica;
    ::IceStormElection::NodeState state;
    ::IceStormElection::GroupInfoSeq up;
    ::Ice::Int max;

    bool operator==(const QueryInfo&) const;
    bool operator<(const QueryInfo&) const;
    bool operator!=(const QueryInfo& __rhs) const
    {
        return !operator==(__rhs);
    }
    bool operator<=(const QueryInfo& __rhs) const
    {
        return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const QueryInfo& __rhs) const
    {
        return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const QueryInfo& __rhs) const
    {
        return !operator<(__rhs);
    }

    void __write(::IceInternal::BasicStream*) const;
    void __read(::IceInternal::BasicStream*);
};

}

namespace IceStormElection
{

class AMI_ReplicaObserver_createTopic : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    bool __invoke(const ::IceStormElection::ReplicaObserverPrx&, const ::IceStormElection::LogUpdate&, const ::std::string&, const ::Ice::Context*);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceStormElection::AMI_ReplicaObserver_createTopic> AMI_ReplicaObserver_createTopicPtr;

class AMI_ReplicaObserver_destroyTopic : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    bool __invoke(const ::IceStormElection::ReplicaObserverPrx&, const ::IceStormElection::LogUpdate&, const ::std::string&, const ::Ice::Context*);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceStormElection::AMI_ReplicaObserver_destroyTopic> AMI_ReplicaObserver_destroyTopicPtr;

class AMI_ReplicaObserver_addSubscriber : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    bool __invoke(const ::IceStormElection::ReplicaObserverPrx&, const ::IceStormElection::LogUpdate&, const ::std::string&, const ::IceStorm::SubscriberRecord&, const ::Ice::Context*);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceStormElection::AMI_ReplicaObserver_addSubscriber> AMI_ReplicaObserver_addSubscriberPtr;

class AMI_ReplicaObserver_removeSubscriber : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    bool __invoke(const ::IceStormElection::ReplicaObserverPrx&, const ::IceStormElection::LogUpdate&, const ::std::string&, const ::Ice::IdentitySeq&, const ::Ice::Context*);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceStormElection::AMI_ReplicaObserver_removeSubscriber> AMI_ReplicaObserver_removeSubscriberPtr;

}

namespace IceProxy
{

namespace IceStormElection
{

class ReplicaObserver : virtual public ::IceProxy::Ice::Object
{
public:

    void init(const ::IceStormElection::LogUpdate& llu, const ::IceStormElection::TopicContentSeq& content)
    {
        init(llu, content, 0);
    }
    void init(const ::IceStormElection::LogUpdate& llu, const ::IceStormElection::TopicContentSeq& content, const ::Ice::Context& __ctx)
    {
        init(llu, content, &__ctx);
    }
    
private:

    void init(const ::IceStormElection::LogUpdate&, const ::IceStormElection::TopicContentSeq&, const ::Ice::Context*);
    
public:

    void createTopic(const ::IceStormElection::LogUpdate& llu, const ::std::string& name)
    {
        createTopic(llu, name, 0);
    }
    void createTopic(const ::IceStormElection::LogUpdate& llu, const ::std::string& name, const ::Ice::Context& __ctx)
    {
        createTopic(llu, name, &__ctx);
    }
    
private:

    void createTopic(const ::IceStormElection::LogUpdate&, const ::std::string&, const ::Ice::Context*);
    
public:
    bool createTopic_async(const ::IceStormElection::AMI_ReplicaObserver_createTopicPtr&, const ::IceStormElection::LogUpdate&, const ::std::string&);
    bool createTopic_async(const ::IceStormElection::AMI_ReplicaObserver_createTopicPtr&, const ::IceStormElection::LogUpdate&, const ::std::string&, const ::Ice::Context&);

    void destroyTopic(const ::IceStormElection::LogUpdate& llu, const ::std::string& name)
    {
        destroyTopic(llu, name, 0);
    }
    void destroyTopic(const ::IceStormElection::LogUpdate& llu, const ::std::string& name, const ::Ice::Context& __ctx)
    {
        destroyTopic(llu, name, &__ctx);
    }
    
private:

    void destroyTopic(const ::IceStormElection::LogUpdate&, const ::std::string&, const ::Ice::Context*);
    
public:
    bool destroyTopic_async(const ::IceStormElection::AMI_ReplicaObserver_destroyTopicPtr&, const ::IceStormElection::LogUpdate&, const ::std::string&);
    bool destroyTopic_async(const ::IceStormElection::AMI_ReplicaObserver_destroyTopicPtr&, const ::IceStormElection::LogUpdate&, const ::std::string&, const ::Ice::Context&);

    void addSubscriber(const ::IceStormElection::LogUpdate& llu, const ::std::string& topic, const ::IceStorm::SubscriberRecord& record)
    {
        addSubscriber(llu, topic, record, 0);
    }
    void addSubscriber(const ::IceStormElection::LogUpdate& llu, const ::std::string& topic, const ::IceStorm::SubscriberRecord& record, const ::Ice::Context& __ctx)
    {
        addSubscriber(llu, topic, record, &__ctx);
    }
    
private:

    void addSubscriber(const ::IceStormElection::LogUpdate&, const ::std::string&, const ::IceStorm::SubscriberRecord&, const ::Ice::Context*);
    
public:
    bool addSubscriber_async(const ::IceStormElection::AMI_ReplicaObserver_addSubscriberPtr&, const ::IceStormElection::LogUpdate&, const ::std::string&, const ::IceStorm::SubscriberRecord&);
    bool addSubscriber_async(const ::IceStormElection::AMI_ReplicaObserver_addSubscriberPtr&, const ::IceStormElection::LogUpdate&, const ::std::string&, const ::IceStorm::SubscriberRecord&, const ::Ice::Context&);

    void removeSubscriber(const ::IceStormElection::LogUpdate& llu, const ::std::string& topic, const ::Ice::IdentitySeq& subscribers)
    {
        removeSubscriber(llu, topic, subscribers, 0);
    }
    void removeSubscriber(const ::IceStormElection::LogUpdate& llu, const ::std::string& topic, const ::Ice::IdentitySeq& subscribers, const ::Ice::Context& __ctx)
    {
        removeSubscriber(llu, topic, subscribers, &__ctx);
    }
    
private:

    void removeSubscriber(const ::IceStormElection::LogUpdate&, const ::std::string&, const ::Ice::IdentitySeq&, const ::Ice::Context*);
    
public:
    bool removeSubscriber_async(const ::IceStormElection::AMI_ReplicaObserver_removeSubscriberPtr&, const ::IceStormElection::LogUpdate&, const ::std::string&, const ::Ice::IdentitySeq&);
    bool removeSubscriber_async(const ::IceStormElection::AMI_ReplicaObserver_removeSubscriberPtr&, const ::IceStormElection::LogUpdate&, const ::std::string&, const ::Ice::IdentitySeq&, const ::Ice::Context&);
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<ReplicaObserver> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<ReplicaObserver*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<ReplicaObserver*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class TopicManagerSync : virtual public ::IceProxy::Ice::Object
{
public:

    void getContent(::IceStormElection::LogUpdate& llu, ::IceStormElection::TopicContentSeq& content)
    {
        getContent(llu, content, 0);
    }
    void getContent(::IceStormElection::LogUpdate& llu, ::IceStormElection::TopicContentSeq& content, const ::Ice::Context& __ctx)
    {
        getContent(llu, content, &__ctx);
    }
    
private:

    void getContent(::IceStormElection::LogUpdate&, ::IceStormElection::TopicContentSeq&, const ::Ice::Context*);
    
public:
    
    ::IceInternal::ProxyHandle<TopicManagerSync> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerSync*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<TopicManagerSync*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerSync> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerSync*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<TopicManagerSync*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerSync> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerSync*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<TopicManagerSync*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerSync> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerSync*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<TopicManagerSync*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerSync> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerSync*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<TopicManagerSync*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerSync> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerSync*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<TopicManagerSync*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerSync> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerSync*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<TopicManagerSync*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerSync> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerSync*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<TopicManagerSync*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerSync> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerSync*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<TopicManagerSync*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerSync> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerSync*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<TopicManagerSync*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerSync> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerSync*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<TopicManagerSync*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerSync> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerSync*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<TopicManagerSync*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerSync> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerSync*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<TopicManagerSync*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerSync> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerSync*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<TopicManagerSync*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerSync> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerSync*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<TopicManagerSync*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerSync> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerSync*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<TopicManagerSync*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerSync> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerSync*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<TopicManagerSync*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerSync> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerSync*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<TopicManagerSync*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerSync> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerSync*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<TopicManagerSync*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class Node : virtual public ::IceProxy::Ice::Object
{
public:

    void invitation(::Ice::Int j, const ::std::string& gn)
    {
        invitation(j, gn, 0);
    }
    void invitation(::Ice::Int j, const ::std::string& gn, const ::Ice::Context& __ctx)
    {
        invitation(j, gn, &__ctx);
    }
    
private:

    void invitation(::Ice::Int, const ::std::string&, const ::Ice::Context*);
    
public:

    void ready(::Ice::Int j, const ::std::string& gn, const ::Ice::ObjectPrx& coordinator, ::Ice::Int max, ::Ice::Long generation)
    {
        ready(j, gn, coordinator, max, generation, 0);
    }
    void ready(::Ice::Int j, const ::std::string& gn, const ::Ice::ObjectPrx& coordinator, ::Ice::Int max, ::Ice::Long generation, const ::Ice::Context& __ctx)
    {
        ready(j, gn, coordinator, max, generation, &__ctx);
    }
    
private:

    void ready(::Ice::Int, const ::std::string&, const ::Ice::ObjectPrx&, ::Ice::Int, ::Ice::Long, const ::Ice::Context*);
    
public:

    void accept(::Ice::Int j, const ::std::string& gn, const ::Ice::IntSeq& forwardedInvites, const ::Ice::ObjectPrx& observer, const ::IceStormElection::LogUpdate& llu, ::Ice::Int max)
    {
        accept(j, gn, forwardedInvites, observer, llu, max, 0);
    }
    void accept(::Ice::Int j, const ::std::string& gn, const ::Ice::IntSeq& forwardedInvites, const ::Ice::ObjectPrx& observer, const ::IceStormElection::LogUpdate& llu, ::Ice::Int max, const ::Ice::Context& __ctx)
    {
        accept(j, gn, forwardedInvites, observer, llu, max, &__ctx);
    }
    
private:

    void accept(::Ice::Int, const ::std::string&, const ::Ice::IntSeq&, const ::Ice::ObjectPrx&, const ::IceStormElection::LogUpdate&, ::Ice::Int, const ::Ice::Context*);
    
public:

    bool areYouCoordinator()
    {
        return areYouCoordinator(0);
    }
    bool areYouCoordinator(const ::Ice::Context& __ctx)
    {
        return areYouCoordinator(&__ctx);
    }
    
private:

    bool areYouCoordinator(const ::Ice::Context*);
    
public:

    bool areYouThere(const ::std::string& gn, ::Ice::Int j)
    {
        return areYouThere(gn, j, 0);
    }
    bool areYouThere(const ::std::string& gn, ::Ice::Int j, const ::Ice::Context& __ctx)
    {
        return areYouThere(gn, j, &__ctx);
    }
    
private:

    bool areYouThere(const ::std::string&, ::Ice::Int, const ::Ice::Context*);
    
public:

    ::Ice::ObjectPrx sync()
    {
        return sync(0);
    }
    ::Ice::ObjectPrx sync(const ::Ice::Context& __ctx)
    {
        return sync(&__ctx);
    }
    
private:

    ::Ice::ObjectPrx sync(const ::Ice::Context*);
    
public:

    ::IceStormElection::NodeInfoSeq nodes()
    {
        return nodes(0);
    }
    ::IceStormElection::NodeInfoSeq nodes(const ::Ice::Context& __ctx)
    {
        return nodes(&__ctx);
    }
    
private:

    ::IceStormElection::NodeInfoSeq nodes(const ::Ice::Context*);
    
public:

    ::IceStormElection::QueryInfo query()
    {
        return query(0);
    }
    ::IceStormElection::QueryInfo query(const ::Ice::Context& __ctx)
    {
        return query(&__ctx);
    }
    
private:

    ::IceStormElection::QueryInfo query(const ::Ice::Context*);
    
public:
    
    ::IceInternal::ProxyHandle<Node> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Node> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Node*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<Node*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

}

}

namespace IceDelegate
{

namespace IceStormElection
{

class ReplicaObserver : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual void init(const ::IceStormElection::LogUpdate&, const ::IceStormElection::TopicContentSeq&, const ::Ice::Context*) = 0;

    virtual void createTopic(const ::IceStormElection::LogUpdate&, const ::std::string&, const ::Ice::Context*) = 0;

    virtual void destroyTopic(const ::IceStormElection::LogUpdate&, const ::std::string&, const ::Ice::Context*) = 0;

    virtual void addSubscriber(const ::IceStormElection::LogUpdate&, const ::std::string&, const ::IceStorm::SubscriberRecord&, const ::Ice::Context*) = 0;

    virtual void removeSubscriber(const ::IceStormElection::LogUpdate&, const ::std::string&, const ::Ice::IdentitySeq&, const ::Ice::Context*) = 0;
};

class TopicManagerSync : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual void getContent(::IceStormElection::LogUpdate&, ::IceStormElection::TopicContentSeq&, const ::Ice::Context*) = 0;
};

class Node : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual void invitation(::Ice::Int, const ::std::string&, const ::Ice::Context*) = 0;

    virtual void ready(::Ice::Int, const ::std::string&, const ::Ice::ObjectPrx&, ::Ice::Int, ::Ice::Long, const ::Ice::Context*) = 0;

    virtual void accept(::Ice::Int, const ::std::string&, const ::Ice::IntSeq&, const ::Ice::ObjectPrx&, const ::IceStormElection::LogUpdate&, ::Ice::Int, const ::Ice::Context*) = 0;

    virtual bool areYouCoordinator(const ::Ice::Context*) = 0;

    virtual bool areYouThere(const ::std::string&, ::Ice::Int, const ::Ice::Context*) = 0;

    virtual ::Ice::ObjectPrx sync(const ::Ice::Context*) = 0;

    virtual ::IceStormElection::NodeInfoSeq nodes(const ::Ice::Context*) = 0;

    virtual ::IceStormElection::QueryInfo query(const ::Ice::Context*) = 0;
};

}

}

namespace IceDelegateM
{

namespace IceStormElection
{

class ReplicaObserver : virtual public ::IceDelegate::IceStormElection::ReplicaObserver,
                        virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual void init(const ::IceStormElection::LogUpdate&, const ::IceStormElection::TopicContentSeq&, const ::Ice::Context*);

    virtual void createTopic(const ::IceStormElection::LogUpdate&, const ::std::string&, const ::Ice::Context*);

    virtual void destroyTopic(const ::IceStormElection::LogUpdate&, const ::std::string&, const ::Ice::Context*);

    virtual void addSubscriber(const ::IceStormElection::LogUpdate&, const ::std::string&, const ::IceStorm::SubscriberRecord&, const ::Ice::Context*);

    virtual void removeSubscriber(const ::IceStormElection::LogUpdate&, const ::std::string&, const ::Ice::IdentitySeq&, const ::Ice::Context*);
};

class TopicManagerSync : virtual public ::IceDelegate::IceStormElection::TopicManagerSync,
                         virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual void getContent(::IceStormElection::LogUpdate&, ::IceStormElection::TopicContentSeq&, const ::Ice::Context*);
};

class Node : virtual public ::IceDelegate::IceStormElection::Node,
             virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual void invitation(::Ice::Int, const ::std::string&, const ::Ice::Context*);

    virtual void ready(::Ice::Int, const ::std::string&, const ::Ice::ObjectPrx&, ::Ice::Int, ::Ice::Long, const ::Ice::Context*);

    virtual void accept(::Ice::Int, const ::std::string&, const ::Ice::IntSeq&, const ::Ice::ObjectPrx&, const ::IceStormElection::LogUpdate&, ::Ice::Int, const ::Ice::Context*);

    virtual bool areYouCoordinator(const ::Ice::Context*);

    virtual bool areYouThere(const ::std::string&, ::Ice::Int, const ::Ice::Context*);

    virtual ::Ice::ObjectPrx sync(const ::Ice::Context*);

    virtual ::IceStormElection::NodeInfoSeq nodes(const ::Ice::Context*);

    virtual ::IceStormElection::QueryInfo query(const ::Ice::Context*);
};

}

}

namespace IceDelegateD
{

namespace IceStormElection
{

class ReplicaObserver : virtual public ::IceDelegate::IceStormElection::ReplicaObserver,
                        virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual void init(const ::IceStormElection::LogUpdate&, const ::IceStormElection::TopicContentSeq&, const ::Ice::Context*);

    virtual void createTopic(const ::IceStormElection::LogUpdate&, const ::std::string&, const ::Ice::Context*);

    virtual void destroyTopic(const ::IceStormElection::LogUpdate&, const ::std::string&, const ::Ice::Context*);

    virtual void addSubscriber(const ::IceStormElection::LogUpdate&, const ::std::string&, const ::IceStorm::SubscriberRecord&, const ::Ice::Context*);

    virtual void removeSubscriber(const ::IceStormElection::LogUpdate&, const ::std::string&, const ::Ice::IdentitySeq&, const ::Ice::Context*);
};

class TopicManagerSync : virtual public ::IceDelegate::IceStormElection::TopicManagerSync,
                         virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual void getContent(::IceStormElection::LogUpdate&, ::IceStormElection::TopicContentSeq&, const ::Ice::Context*);
};

class Node : virtual public ::IceDelegate::IceStormElection::Node,
             virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual void invitation(::Ice::Int, const ::std::string&, const ::Ice::Context*);

    virtual void ready(::Ice::Int, const ::std::string&, const ::Ice::ObjectPrx&, ::Ice::Int, ::Ice::Long, const ::Ice::Context*);

    virtual void accept(::Ice::Int, const ::std::string&, const ::Ice::IntSeq&, const ::Ice::ObjectPrx&, const ::IceStormElection::LogUpdate&, ::Ice::Int, const ::Ice::Context*);

    virtual bool areYouCoordinator(const ::Ice::Context*);

    virtual bool areYouThere(const ::std::string&, ::Ice::Int, const ::Ice::Context*);

    virtual ::Ice::ObjectPrx sync(const ::Ice::Context*);

    virtual ::IceStormElection::NodeInfoSeq nodes(const ::Ice::Context*);

    virtual ::IceStormElection::QueryInfo query(const ::Ice::Context*);
};

}

}

namespace IceStormElection
{

class ReplicaObserver : virtual public ::Ice::Object
{
public:

    typedef ReplicaObserverPrx ProxyType;
    typedef ReplicaObserverPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void init(const ::IceStormElection::LogUpdate&, const ::IceStormElection::TopicContentSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___init(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void createTopic(const ::IceStormElection::LogUpdate&, const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___createTopic(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void destroyTopic(const ::IceStormElection::LogUpdate&, const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___destroyTopic(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void addSubscriber(const ::IceStormElection::LogUpdate&, const ::std::string&, const ::IceStorm::SubscriberRecord&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___addSubscriber(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void removeSubscriber(const ::IceStormElection::LogUpdate&, const ::std::string&, const ::Ice::IdentitySeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___removeSubscriber(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class TopicManagerSync : virtual public ::Ice::Object
{
public:

    typedef TopicManagerSyncPrx ProxyType;
    typedef TopicManagerSyncPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void getContent(::IceStormElection::LogUpdate&, ::IceStormElection::TopicContentSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getContent(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class Node : virtual public ::Ice::Object
{
public:

    typedef NodePrx ProxyType;
    typedef NodePtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void invitation(::Ice::Int, const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___invitation(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void ready(::Ice::Int, const ::std::string&, const ::Ice::ObjectPrx&, ::Ice::Int, ::Ice::Long, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___ready(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void accept(::Ice::Int, const ::std::string&, const ::Ice::IntSeq&, const ::Ice::ObjectPrx&, const ::IceStormElection::LogUpdate&, ::Ice::Int, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___accept(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual bool areYouCoordinator(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::Ice::DispatchStatus ___areYouCoordinator(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual bool areYouThere(const ::std::string&, ::Ice::Int, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::Ice::DispatchStatus ___areYouThere(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::Ice::ObjectPrx sync(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::Ice::DispatchStatus ___sync(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::IceStormElection::NodeInfoSeq nodes(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::Ice::DispatchStatus ___nodes(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::IceStormElection::QueryInfo query(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::Ice::DispatchStatus ___query(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

}

#endif
