// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `IceStormInternal.ice'

#ifndef __IceStorm_IceStormInternal_h__
#define __IceStorm_IceStormInternal_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/OutgoingAsync.h>
#include <Ice/Incoming.h>
#include <Ice/Direct.h>
#include <Ice/UserExceptionFactory.h>
#include <Ice/FactoryTable.h>
#include <Ice/StreamF.h>
#include <IceStorm/IceStorm.h>
#include <IceStorm/Election.h>
#include <Ice/Current.h>
#include <Ice/BuiltinSequences.h>
#include <Ice/Identity.h>
#include <Ice/UndefSysMacros.h>
#include <deque>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

namespace IceProxy
{

namespace IceStorm
{

class TopicLink;

class TopicInternal;

class TopicManagerInternal;

}

}

namespace IceStorm
{

class TopicLink;
bool operator==(const TopicLink&, const TopicLink&);
bool operator<(const TopicLink&, const TopicLink&);

class TopicInternal;
bool operator==(const TopicInternal&, const TopicInternal&);
bool operator<(const TopicInternal&, const TopicInternal&);

class TopicManagerInternal;
bool operator==(const TopicManagerInternal&, const TopicManagerInternal&);
bool operator<(const TopicManagerInternal&, const TopicManagerInternal&);

}

namespace IceInternal
{

::Ice::Object* upCast(::IceStorm::TopicLink*);
::IceProxy::Ice::Object* upCast(::IceProxy::IceStorm::TopicLink*);

::Ice::Object* upCast(::IceStorm::TopicInternal*);
::IceProxy::Ice::Object* upCast(::IceProxy::IceStorm::TopicInternal*);

::Ice::Object* upCast(::IceStorm::TopicManagerInternal*);
::IceProxy::Ice::Object* upCast(::IceProxy::IceStorm::TopicManagerInternal*);

}

namespace IceStorm
{

typedef ::IceInternal::Handle< ::IceStorm::TopicLink> TopicLinkPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceStorm::TopicLink> TopicLinkPrx;

void __read(::IceInternal::BasicStream*, TopicLinkPrx&);
void __patch__TopicLinkPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IceStorm::TopicInternal> TopicInternalPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceStorm::TopicInternal> TopicInternalPrx;

void __read(::IceInternal::BasicStream*, TopicInternalPrx&);
void __patch__TopicInternalPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IceStorm::TopicManagerInternal> TopicManagerInternalPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceStorm::TopicManagerInternal> TopicManagerInternalPrx;

void __read(::IceInternal::BasicStream*, TopicManagerInternalPrx&);
void __patch__TopicManagerInternalPtr(void*, ::Ice::ObjectPtr&);

}

namespace IceStorm
{

class EventData : public IceUtil::Shared
{
public:
    
    EventData() {}
    EventData(const ::std::string&, ::Ice::OperationMode, const ::Ice::ByteSeq&, const ::Ice::Context&);
    ::std::string op;
    ::Ice::OperationMode mode;
    ::Ice::ByteSeq data;
    ::Ice::Context context;

    bool operator==(const EventData&) const;
    bool operator<(const EventData&) const;
    bool operator!=(const EventData& __rhs) const
    {
        return !operator==(__rhs);
    }
    bool operator<=(const EventData& __rhs) const
    {
        return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const EventData& __rhs) const
    {
        return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const EventData& __rhs) const
    {
        return !operator<(__rhs);
    }

    void __write(::IceInternal::BasicStream*) const;
    void __read(::IceInternal::BasicStream*);
};

typedef ::IceUtil::Handle< ::IceStorm::EventData> EventDataPtr;

typedef std::deque< ::IceStorm::EventDataPtr> EventDataSeq;
void __writeEventDataSeq(::IceInternal::BasicStream*, const EventDataSeq&);
void __readEventDataSeq(::IceInternal::BasicStream*, EventDataSeq&);

class ReapWouldBlock : public ::Ice::UserException
{
public:

    ReapWouldBlock() {}
    virtual ~ReapWouldBlock() throw();

    virtual ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

static ReapWouldBlock __ReapWouldBlock_init;

}

namespace IceStorm
{

class AMI_TopicLink_forward : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    bool __invoke(const ::IceStorm::TopicLinkPrx&, const ::IceStorm::EventDataSeq&, const ::Ice::Context*);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceStorm::AMI_TopicLink_forward> AMI_TopicLink_forwardPtr;

class AMI_TopicInternal_reap : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    bool __invoke(const ::IceStorm::TopicInternalPrx&, const ::Ice::IdentitySeq&, const ::Ice::Context*);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceStorm::AMI_TopicInternal_reap> AMI_TopicInternal_reapPtr;

}

namespace IceProxy
{

namespace IceStorm
{

class TopicLink : virtual public ::IceProxy::Ice::Object
{
public:

    void forward(const ::IceStorm::EventDataSeq& events)
    {
        forward(events, 0);
    }
    void forward(const ::IceStorm::EventDataSeq& events, const ::Ice::Context& __ctx)
    {
        forward(events, &__ctx);
    }
    
private:

    void forward(const ::IceStorm::EventDataSeq&, const ::Ice::Context*);
    
public:
    bool forward_async(const ::IceStorm::AMI_TopicLink_forwardPtr&, const ::IceStorm::EventDataSeq&);
    bool forward_async(const ::IceStorm::AMI_TopicLink_forwardPtr&, const ::IceStorm::EventDataSeq&, const ::Ice::Context&);
    
    ::IceInternal::ProxyHandle<TopicLink> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicLink*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<TopicLink*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicLink> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicLink*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<TopicLink*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicLink> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicLink*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<TopicLink*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicLink> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicLink*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<TopicLink*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicLink> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicLink*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<TopicLink*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicLink> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicLink*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<TopicLink*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicLink> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicLink*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<TopicLink*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicLink> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicLink*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<TopicLink*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicLink> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicLink*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<TopicLink*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicLink> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicLink*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<TopicLink*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicLink> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicLink*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<TopicLink*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicLink> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicLink*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<TopicLink*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicLink> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicLink*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<TopicLink*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicLink> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicLink*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<TopicLink*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicLink> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicLink*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<TopicLink*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicLink> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicLink*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<TopicLink*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicLink> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicLink*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<TopicLink*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicLink> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicLink*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<TopicLink*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicLink> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicLink*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<TopicLink*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class TopicInternal : virtual public ::IceProxy::IceStorm::Topic
{
public:

    ::IceStorm::TopicLinkPrx getLinkProxy()
    {
        return getLinkProxy(0);
    }
    ::IceStorm::TopicLinkPrx getLinkProxy(const ::Ice::Context& __ctx)
    {
        return getLinkProxy(&__ctx);
    }
    
private:

    ::IceStorm::TopicLinkPrx getLinkProxy(const ::Ice::Context*);
    
public:

    void reap(const ::Ice::IdentitySeq& id)
    {
        reap(id, 0);
    }
    void reap(const ::Ice::IdentitySeq& id, const ::Ice::Context& __ctx)
    {
        reap(id, &__ctx);
    }
    
private:

    void reap(const ::Ice::IdentitySeq&, const ::Ice::Context*);
    
public:
    bool reap_async(const ::IceStorm::AMI_TopicInternal_reapPtr&, const ::Ice::IdentitySeq&);
    bool reap_async(const ::IceStorm::AMI_TopicInternal_reapPtr&, const ::Ice::IdentitySeq&, const ::Ice::Context&);
    
    ::IceInternal::ProxyHandle<TopicInternal> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicInternal*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<TopicInternal*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicInternal> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicInternal*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<TopicInternal*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicInternal> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicInternal*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<TopicInternal*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicInternal> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicInternal*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<TopicInternal*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicInternal> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicInternal*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<TopicInternal*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicInternal> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicInternal*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<TopicInternal*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicInternal> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicInternal*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<TopicInternal*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicInternal> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicInternal*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<TopicInternal*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicInternal> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicInternal*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<TopicInternal*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicInternal> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicInternal*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<TopicInternal*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicInternal> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicInternal*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<TopicInternal*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicInternal> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicInternal*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<TopicInternal*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicInternal> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicInternal*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<TopicInternal*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicInternal> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicInternal*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<TopicInternal*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicInternal> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicInternal*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<TopicInternal*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicInternal> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicInternal*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<TopicInternal*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicInternal> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicInternal*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<TopicInternal*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicInternal> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicInternal*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<TopicInternal*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicInternal> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicInternal*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<TopicInternal*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class TopicManagerInternal : virtual public ::IceProxy::IceStorm::TopicManager
{
public:

    ::IceStormElection::NodePrx getReplicaNode()
    {
        return getReplicaNode(0);
    }
    ::IceStormElection::NodePrx getReplicaNode(const ::Ice::Context& __ctx)
    {
        return getReplicaNode(&__ctx);
    }
    
private:

    ::IceStormElection::NodePrx getReplicaNode(const ::Ice::Context*);
    
public:
    
    ::IceInternal::ProxyHandle<TopicManagerInternal> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerInternal*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<TopicManagerInternal*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerInternal> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerInternal*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<TopicManagerInternal*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerInternal> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerInternal*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<TopicManagerInternal*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerInternal> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerInternal*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<TopicManagerInternal*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerInternal> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerInternal*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<TopicManagerInternal*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerInternal> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerInternal*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<TopicManagerInternal*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerInternal> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerInternal*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<TopicManagerInternal*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerInternal> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerInternal*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<TopicManagerInternal*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerInternal> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerInternal*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<TopicManagerInternal*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerInternal> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerInternal*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<TopicManagerInternal*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerInternal> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerInternal*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<TopicManagerInternal*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerInternal> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerInternal*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<TopicManagerInternal*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerInternal> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerInternal*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<TopicManagerInternal*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerInternal> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerInternal*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<TopicManagerInternal*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerInternal> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerInternal*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<TopicManagerInternal*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerInternal> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerInternal*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<TopicManagerInternal*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerInternal> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerInternal*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<TopicManagerInternal*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerInternal> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerInternal*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<TopicManagerInternal*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<TopicManagerInternal> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<TopicManagerInternal*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<TopicManagerInternal*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

}

}

namespace IceDelegate
{

namespace IceStorm
{

class TopicLink : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual void forward(const ::IceStorm::EventDataSeq&, const ::Ice::Context*) = 0;
};

class TopicInternal : virtual public ::IceDelegate::IceStorm::Topic
{
public:

    virtual ::IceStorm::TopicLinkPrx getLinkProxy(const ::Ice::Context*) = 0;

    virtual void reap(const ::Ice::IdentitySeq&, const ::Ice::Context*) = 0;
};

class TopicManagerInternal : virtual public ::IceDelegate::IceStorm::TopicManager
{
public:

    virtual ::IceStormElection::NodePrx getReplicaNode(const ::Ice::Context*) = 0;
};

}

}

namespace IceDelegateM
{

namespace IceStorm
{

class TopicLink : virtual public ::IceDelegate::IceStorm::TopicLink,
                  virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual void forward(const ::IceStorm::EventDataSeq&, const ::Ice::Context*);
};

class TopicInternal : virtual public ::IceDelegate::IceStorm::TopicInternal,
                      virtual public ::IceDelegateM::IceStorm::Topic
{
public:

    virtual ::IceStorm::TopicLinkPrx getLinkProxy(const ::Ice::Context*);

    virtual void reap(const ::Ice::IdentitySeq&, const ::Ice::Context*);
};

class TopicManagerInternal : virtual public ::IceDelegate::IceStorm::TopicManagerInternal,
                             virtual public ::IceDelegateM::IceStorm::TopicManager
{
public:

    virtual ::IceStormElection::NodePrx getReplicaNode(const ::Ice::Context*);
};

}

}

namespace IceDelegateD
{

namespace IceStorm
{

class TopicLink : virtual public ::IceDelegate::IceStorm::TopicLink,
                  virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual void forward(const ::IceStorm::EventDataSeq&, const ::Ice::Context*);
};

class TopicInternal : virtual public ::IceDelegate::IceStorm::TopicInternal,
                      virtual public ::IceDelegateD::IceStorm::Topic
{
public:

    virtual ::IceStorm::TopicLinkPrx getLinkProxy(const ::Ice::Context*);

    virtual void reap(const ::Ice::IdentitySeq&, const ::Ice::Context*);
};

class TopicManagerInternal : virtual public ::IceDelegate::IceStorm::TopicManagerInternal,
                             virtual public ::IceDelegateD::IceStorm::TopicManager
{
public:

    virtual ::IceStormElection::NodePrx getReplicaNode(const ::Ice::Context*);
};

}

}

namespace IceStorm
{

class TopicLink : virtual public ::Ice::Object
{
public:

    typedef TopicLinkPrx ProxyType;
    typedef TopicLinkPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void forward(const ::IceStorm::EventDataSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___forward(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class TopicInternal : virtual public ::IceStorm::Topic
{
public:

    typedef TopicInternalPrx ProxyType;
    typedef TopicInternalPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::IceStorm::TopicLinkPrx getLinkProxy(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getLinkProxy(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void reap(const ::Ice::IdentitySeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___reap(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class TopicManagerInternal : virtual public ::IceStorm::TopicManager
{
public:

    typedef TopicManagerInternalPrx ProxyType;
    typedef TopicManagerInternalPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::IceStormElection::NodePrx getReplicaNode(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::Ice::DispatchStatus ___getReplicaNode(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

}

#endif
